<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
$start=microtime();#Начало отсчета времени движка.
define('CMS',true);
require dirname(__file__).'/classes/mainclass.php';
$Mainclass=MainClass::getInstance();
$Mainclass->start_time=$start;
$Mainclass->service_id='3';#ID сервиса
$Mainclass->file_name=basename(__file__);
if(0<$t=strpos($Mainclass->site_path,$Mainclass->file_name))
	$Mainclass->site_path=$t==1 ? '' : substr($Mainclass->site_path,0,$t-1);
$Mainclass->error_callback='Error';
$Mainclass->LoadOptions(array('system','blocker','login','public'));
$Mainclass->LoadService();
$jscripts=array();
$Mainclass->LoadLanguage('langs','main','ajax-%');
$Mainclass->Cache->FilterLangVars(false);
if($Mainclass->services[$Mainclass->service_id]['login']==$Mainclass->services[1]['login'])
{
	$old_service=$Mainclass->service;
	$old_id=$Mainclass->service_id;
	$Mainclass->service='admin';
	$Mainclass->service_id='1';
}
$Mainclass->Login->IsUser();
if($Mainclass->vars['site_closed'] and !$Mainclass->Permission->IsAdmin())
	Error($Mainclass->lang['main']['site_closed']);
if(isset($old_service))
{
	$Mainclass->service=$old_service;
	$Mainclass->service_id=$old_id;
}
if($Mainclass->Permission->IsBanned())
	throw new EE(null,EE::BAN);
require $Mainclass->root_path.'classes/others/class_ajax.php';
$Mainclass->Ajax=new JsHttpRequest(ELEANOR_DISPLAYCHARSET);
$Mainclass->AJAX=new FilterArrays('_REQUEST');
if(empty($_REQUEST['module']))
{
	if(isset($_REQUEST['direct']) and is_string($_REQUEST['direct']) and is_file($f=$Mainclass->root_path.'addons/direct/'.preg_replace('#[^a-z0-9]+#i','',$_REQUEST['direct']).'.php'))
		include $f;
	else
		Error();
}
elseif($_REQUEST['module']==-1)
	SomeAjax();
else
{
	$where=ctype_digit((string)$_REQUEST['module']) ? '`id`='.(int)$_REQUEST['module'] : '(`name`=\''.($mid=$Mainclass->Db->EscapeString($_REQUEST['module'])).'\' OR `path` LIKE \'%'.$mid.'\')';
	unset($mid);
	$Mainclass->Db->Query('SELECT `id`,`services`,`name`,`title`,`path`,`multiservice`,`file`,`is_class`,`resources`,`image`,`user_groups` FROM `prefix_modules` WHERE '.$where.' AND `active`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		Error();
	$arr=$Mainclass->Db->Fetch_Assoc();
	$arr['user_groups']=Strings::CleanForExplode($arr['user_groups']);
	if($arr['user_groups'])
	{
		$groups=explode(',',$arr['user_groups']);
		$user_groups=$Mainclass->Account->GetUserGroups();
		if(count(array_intersect($groups,$user_groups))==0)
			Error($Mainclass->lang['main']['no_access']);
	}
	if(strpos($arr['services'],','.$Mainclass->service_id.',')===false and $arr['resources'])
	{
		$resources=explode('·',Strings::CleanForExplode($arr['resources']));
		foreach($resources as &$v)
		{
			$temp=explode('=',$v,2);
			if($Mainclass->service==$temp[0])
			{
				$arr['file']=$temp[1];
				break;
			}
		}
	}
	if(!$arr['file'])
		Error();
	$Mainclass->module['name']=$arr['name'];
	$Mainclass->module['title']=$arr['title'];
	$Mainclass->module['image']=$arr['image'];
	$Mainclass->module['path']=$arr['path'];
	$Mainclass->module['general']=false;
	$Mainclass->module['id']=$arr['id'];
	if(!$Mainclass->LoadModule($arr['path'],$arr['multiservice'],$arr['file'] ? $arr['file'] : 'index',$arr['is_class']))
		Error($Mainclass->lang['main']['unable_load_files']);
}

function Error($error='')
{global $_RESULT,$Mainclass;
	if(!$error)
		$error=$Mainclass->lang['main']['error_happened'];
	$_RESULT=array('status'=>'error','answer'=>strip_tags($error,'<b>'));
	exit;
}

function ExitPrefix()
{
	return Error();
}

function Result($arr,$d=true)
{global $_RESULT, $Mainclass;
	$_RESULT=$arr;
	if($d)
		die;
}

function ApplyLang()
{global $Mainclass;
	if($Mainclass->vars['multilang'])
	{
		if($Mainclass->Login->IsUser() and $lang=$Mainclass->Account->GetValue('lang') and isset($Mainclass->langs[$lang]))
			$Mainclass->lang_name=$lang;
		else
			$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
		if($Mainclass->lang_name!=ELEANOR_DEFAULT_LANGUAGE)
			$Mainclass->get_lang=substr($Mainclass->lang_name,0,3);
		$lang=$Mainclass->Url->ParseToValue('lang',false);
		$match=false;
		do
		{
			if(strlen($lang)!=3)
				break;
			foreach($Mainclass->langs as $k=>$v)
				if(stripos($k,$lang)===0)
				{
					$match=true;
					break;
				}
			if(!$match)
				break;
			if($Mainclass->lang_name!=$k)
				$Mainclass->Functions->SetLangCookie($k,$Mainclass->service.'_lang');
			if($k==ELEANOR_DEFAULT_LANGUAGE)
				$match=false;
			$Mainclass->Url->string=substr($Mainclass->Url->string,stripos($Mainclass->Url->string,$lang)+4);
		}
		while(false);
		if($match)
		{
			$Mainclass->lang_name=$k;
			$Mainclass->get_lang=$lang;
		}
	}
	$Mainclass->LoadLanguage('langs','main','ajax-%');
	$Mainclass->Cache->FilterLangVars(false);
	$Mainclass->Cache->langvars=array();#Clear
}

#Функция "Будь как", делает сервис AJAX похожим на другой сервис
function BeAs($idname='')
{global $Mainclass;
	if($Mainclass->service==$idname or $Mainclass->service_id==$idname)
		return;
	if(!$idname)
		$idname=2;
	foreach($Mainclass->services as &$arr)
		if($arr['id']==$idname or $arr['name']==$idname)
			break;
	$Mainclass->Permission->CleanAll();
	$id=$Mainclass->service_id;
	$name=$Mainclass->service;
	$Mainclass->service_id=$arr['id'];
	$Mainclass->service=$arr['name'];
	$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
	$Mainclass->LoadLanguage('langs','main',$arr['name'].'-%');
	$Mainclass->file_name=$arr['file'];
	if(!empty($arr['login']) and $Mainclass->services[$id]['login']!=$arr['login'])
	{
		$Mainclass->Account->LogOut(false);
		if(isset($Mainclass->Login) and ($Mainclass->Login instanceof LoginClass))
			unset($Mainclass->Login);
		$Mainclass->LoadLogin($arr['login']);
	}
	$Mainclass->Login->IsUser();
	ApplyLang();
	$Mainclass->service_id=$id;
	$Mainclass->service=$name;
	$Mainclass->Template->theme=$arr['theme'];
	$Mainclass->Url->furl=$arr['id']==2 ? $Mainclass->vars['furl'] : false;
	$Mainclass->service=$arr['name'];
}

#Функция проверки ключа, преимущественно для админки.
function CheckKey()
{global $Mainclass;
	return strcasecmp($Mainclass->Login->key,$_REQUEST['key'])==0;
}

#Функция проверки на "нашесть" юзера
function IsOurUser()
{global $Mainclass;
 static $is;
	if(!isset($is))
	{
		$Mainclass->Db->FQuery('SELECT `enter_time` FROM {"0"} WHERE `ip`={"1"}',array('t_sessions','s_'.$Mainclass->ip),__file__,__line__);
		$is=$Mainclass->Db->Num_rows()>0;
	}
	return $is;
}

#Какие-то странные участки AJAX, которые нельзя привязать к какому-нить модулю. Как предпросмотр в редакторе, например.

function SomeAjax()
{global $Mainclass;
	if(empty($_REQUEST['type']))
		return Error();
	switch($_REQUEST['type'])
	{
		case 'bbpreview':
			$Mainclass->LoadClass('classes/others/class_editor.php');
			BeAs(isset($_REQUEST['service']) ? (int)$_REQUEST['service'] : '');
			$Mainclass->Editor->type=1;
			$content=$Mainclass->Editor->GetHtml($_REQUEST['text'],true,false);
			$jscripts='';
			if(BaseOwnBbCode::$jscripts)
			{
				BaseOwnBbCode::$jscripts=array_unique(BaseOwnBbCode::$jscripts);
				foreach(BaseOwnBbCode::$jscripts as &$v)
					$jscripts.=Strings::AddJS($v);
			}
			Result($jscripts.$content.'<br /><div align="center">'.(isset($_REQUEST['key']) ? Template::Button($Mainclass->lang['main']['hide'],'button','onclick="'.$_REQUEST['key'].'.HidePrev()"') : '').'</div>');
		break;
		case 'files':
			if(isset($_REQUEST['s_id']))
				BeAs((int)$_REQUEST['s_id']);
			$Mainclass->Loadclass('classes/others/class_uploader.php');
			$Mainclass->Uploader->DoAjax();
		break;
		default:
			Error($Mainclass->lang['main']['unknown_event']);
	}
}
?>