<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');

class CacheMachine extends BaseClass implements CacheMachineInterface
{
	const NC='self_names_cache';
	private
		$id,
		$narr=array(self::NC);#Массив имен того, что у нас есть в кеше.

	public function __construct($id='')
	{
		$this->id=$id;
		$this->narr=$this->Get(self::NC);
		if (!$this->narr or !is_array($this->narr))
			$this->narr=array();
	}

	public function __destruct()
	{
		$this->Put(self::NC,$this->narr);
	}

	public function Put($key,$value,$time_to_expire=0)
	{
		$time_to_expire=(int)$time_to_expire;
		eaccelerator_lock($this->id.$key);
		$res=eaccelerator_put($this->id.$key,$value,$time_to_expire);
		eaccelerator_unlock($this->id.$key);
		if ($res)
			$this->narr[$key]=$time_to_expire+$this->Mainclass->MyTime();
		return $res;
	}

	public function Get($key)
	{
		if (!isset($this->narr[$key]))
			return false;
		$res=eaccelerator_get($this->id.$key);
		if ($res===false)
			unset($this->narr[$key]);
		return $res;
	}

	public function Delete($key)
	{
		unset($this->narr[$key]);
		return @eaccelerator_rm($this->id.$key);
	}

	public function CleanCache()
	{
		$t=$this->Mainclass->MyTime();
		foreach($this->narr as $k=>$v)
			if ($v<$t)
				unset($this->narr[$k]);
	}

	public function CleanCacheByTag($tag)
	{
		if($tag=='')
			return $this->narr=array();
		$tag.='_';
		foreach($this->narr as $k=>$v)
			if (strpos($k,$tag)!==false)
				unset($this->narr[$k]);
	}
}
?>