<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');

class CacheMachine extends BaseClass implements CacheMachineInterface
{
	public function __construct()
	{
		if(!is_writeable($this->Mainclass->root_path.'cache'))
			throw new EE('Folder "/cache" is write-protected!');
	}

	public function Put($key,$value,$time_to_expire=0)
	{
		$time_to_expire=(int)$time_to_expire;
		if ($time_to_expire>0)
			$time_to_expire+=$this->Mainclass->MyTime();
		$addon=array();
		$addon[]='$time_to_expire='.$time_to_expire.';';
		$addon[]='$value='.var_export($value,true).';';
		return file_put_contents($this->Mainclass->root_path.'cache/'.$key.'.php',Strings::MakePHPFile($addon));
	}

	public function Get($key)
	{
		$value=false;
		$time_to_expire=0;
		$no_log=$this->Mainclass->no_log;
		$this->Mainclass->no_log=true;
		include $this->Mainclass->root_path.'cache/'.$key.'.php';
		if($time_to_expire!=0 and $time_to_expire<$this->Mainclass->MyTime())
		{
			$this->Delete($key);
			return false;
		}
		$this->Mainclass->no_log=$no_log;
		return $value;
	}

	public function Delete($key)
	{
		if (file_exists($this->Mainclass->root_path.'cache/'.$key.'.php'))
		{
			$no_log=$this->Mainclass->no_log;
			$this->Mainclass->no_log=true;
			$res=unlink($this->Mainclass->root_path.'cache/'.$key.'.php');
			$this->Mainclass->no_log=$no_log;
			clearstatcache();
			return $res;
		}
		else
			return true;
	}

	public function CleanCache()
	{
		$no_log=$this->Mainclass->no_log;
		$files=glob($this->Mainclass->root_path.'cache/*.php');
		foreach($files as $f)
		{
			unset($time_to_expire);
			include $f;
			if ($time_to_expire<$this->Mainclass->MyTime() and $time_to_expire!=0)
				unlink($f);
		}
		$this->Mainclass->no_log=$no_log;
	}

	public function CleanCacheByTag($tag)
	{
		$no_log=$this->Mainclass->no_log;
		$tag=str_replace('..','',$tag).'_';
		if($tag)
			$tag.='*';
		if($files=glob($this->Mainclass->root_path.'cache/*'.$tag.'.php'))
			foreach($files as $f)
				unlink($f);
		$this->Mainclass->no_log=$no_log;
	}
}
?>