<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');

class CacheMachine extends BaseClass implements CacheMachineInterface
{
	const NC='self_names_cache';
	private
		$id,
		$narr=array(self::NC),#Массив имен того, что у нас есть в кеше.
		$link=false;

	public function __construct($id='')
	{
		$this->id=$id;
		$this->Connect();
		$this->narr=$this->Get(self::NC);
		if(!$this->narr or !is_array($this->narr))
			$this->narr=array();
	}

	public function __destruct()
	{
		if($this->link!==false)
			memcache_close($this->link);
		$this->Put(self::NC,$this->narr);
	}

	public function Connect()
	{
		#Поскольку данная кеш-машина весьма специфична, рекомендую прописать значения самостоятельно.
		$this->link=memcache_connect('localhost');
		#memcache_add_server($this->link, 'server', 'port');
		if(!$this->link)
			throw new EE('Подключение к MemCache не удалось. Пропишите данные для подключения в файле '.__file__.', либо удалите этот файл!');
		if(function_exists('memcache_set_compress_threshold'))
			memcache_set_compress_threshold($this->link, 20000, 0.2);
		return true;
	}

	public function Put($key,$value,$time_to_expire=0)
	{
		$time_to_expire=(int)$time_to_expire;
		$res=memcache_set($this->link,$this->id.$key,$value,MEMCACHE_COMPRESSED,$time_to_expire);
		if ($res)
			$this->narr[$key]=$time_to_expire+$this->Mainclass->MyTime();
		return $res;
	}

	public function Get($key)
	{
		if (!isset($this->narr[$key]))
			return false;
		$res=@memcache_get($this->link,$this->id.$key);
		if ($res===false)
			unset($this->narr[$key]);
		return $res;
	}

	public function Delete($key)
	{
		unset($this->narr[$key]);
		return @memcache_delete($this->link,$this->id.$key);
	}

	public function CleanCache()
	{
		$t=$this->Mainclass->MyTime();
		foreach($this->narr as $k=>$v)
			if ($v<$t)
				unset($this->narr[$k]);
	}

	public function CleanCacheByTag($tag)
	{
		if($tag=='')
			return $this->narr=array();
		$tag.='_';
		foreach($this->narr as $k=>$v)
			if (strpos($k,$tag)!==false)
				unset($this->narr[$k]);
	}
}
?>