<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
	This code based on KCAPTCHA PROJECT VERSION 1.2.6 http://captcha.ru
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class Captcha extends BaseClass
{
	const
		ALPHABET='0123456789abcdefghijklmnopqrstuvwxyz';#Алфавит. Не меняйте без изменения файлов шрифтов
	public
		$allowed_symbols='23456789abcdeghkmnpqsuvxyz', #Алвавит без подобных символов (o=0, 1=l, i=j, t=f)
		$length			=6,#Длина строки в капче
		$width			=120,#Ширина капчи-картинки
		$height			=60,#Высота капчи-картинки
		$fluctuation	=5,#Отклонение символов по вертикали
		$no_spaces		=true,#Обеспечивает большую безопасность, за счет удаления пробелов между символами
		$quality		=90,#Качество JPEG изображения. Чем больше цифра - тем больше вес изображения
		$disabled		=false,#Капча выключена?
		$keystring;

	public function __construct($Mainclass)
	{
		if(isset($Mainclass->vars['captcha_length']))
			$this->length=(int)$Mainclass->vars['captcha_length'];
		if(isset($Mainclass->vars['captcha_allowed_symbols']))
			$this->allowed_symbols=$Mainclass->vars['captcha_allowed_symbols'];
		if(isset($Mainclass->vars['captcha_width']))
			$this->width=(int)$Mainclass->vars['captcha_width'];
		if(isset($Mainclass->vars['captcha_height']))
			$this->height=(int)$Mainclass->vars['captcha_height'];
		if(isset($Mainclass->vars['captcha_no_spaces']))
			$this->no_spaces=$Mainclass->vars['captcha_no_spaces'];
		if(isset($Mainclass->vars['captcha_quality']))
			$this->quality=(int)$Mainclass->vars['captcha_quality'];
		$this->disabled=$Mainclass->vars['captcha_off'];
		$fonts=glob($Mainclass->root_path.'classes/captcha/fonts/*.png');
		if(!$fonts)
			throw new EE('No fonts in classes/captcha/fonts/!');
	}

	public function GetCode($url=array(),$name='captcha')
	{
		if($this->disabled)
			return '';
		$this->Mainclass->StartSession($name,isset($_POST['captcha_id']) ? $_POST['captcha_id'] : '');
		$_SESSION[$name.'_captcha_string']=$this->GenString();
		$_SESSION[$name.'_captcha_new']='';
		#Обновлять капчу можно только 1 раз.
		$_SESSION[$name.'_captcha_try']=1;
		$pr=true;
		if(isset($url['noprefix']))
		{
			$pr=false;
			unset($url['noprefix']);
			$pref=$this->Mainclass->services[5]['file'].'?';
		}
		else
			$pref='';
		return '<img id="'.$name.'_img" src="'.$pref.$this->Mainclass->Url->ConstructUrl(array_merge($url,array('imageid'=>session_id())),$pr,false,false)
			.'" style="cursor:pointer; width:'.$this->width.'px; height:'.$this->height.'px" alt="" title="'.$this->Mainclass->lang['main']['captcha_click'].'" onclick="this.a;if(!this.a)this.a=this.src; this.src=this.a+\'&amp;new=\'+Math.random();" />'
			.Template::Control($name.'_id','hidden',session_id(),'id="'.$name.'_id"');
	}

	public function Destroy($name='captcha')
	{
		if(isset($_SESSION))
			unset($_SESSION[$name.'_captcha_string']);
	}

	public function GetImage($id='',$name='captcha')
	{
		if(!$id)
			$id=isset($_GET['imageid']) ? $_GET['imageid'] : 0;
		$this->Mainclass->StartSession($name,$id);
		if(isset($_SESSION[$name.'_captcha_try']) and $_SESSION[$name.'_captcha_try']<1 or !isset($_SESSION[$name.'_captcha_string'][$this->length-1]) or !$id or (isset($_GET['new'],$_SESSION[$name.'_captcha_new']) and $_GET['new']!=$_SESSION[$name.'_captcha_new']))
		{
			$_SESSION[$name.'_captcha_string']=$this->GenString();
			$_SESSION[$name.'_captcha_new']=isset($_GET['new']) ? $_GET['new'] : '';
			#Обновлять капчу можно только 1 раз.
			$_SESSION[$name.'_captcha_try']=1;
		}
		else
		{
			$this->keystring=$_SESSION[$name.'_captcha_string'];
			$_SESSION[$name.'_captcha_try']--;
		}
		$this->ShowImage();
	}

	/*
		Эта функция полезна
	*/
	public function SetPost($name,$value,$s_id,$sess='captcha')
	{
		$_POST[$sess.'_id']=$s_id;
		$_POST[$name]=$value;
	}

	public function PostCheck($name,$sess='captcha')
	{
		if($this->disabled)
			return true;
		if(!isset($_POST[$sess.'_id']) or !isset($_POST[$name]))
			return false;
		$this->Mainclass->StartSession($sess,$_POST[$sess.'_id']);
		if(!isset($_SESSION[$sess.'_captcha_string']))
			return false;
		return strcasecmp($_SESSION[$sess.'_captcha_string'],(string)$_POST[$name])==0;
	}

	#Генерируем строку, которая будет показываться
	public function GenString()
	{
		$this->keystring='';
		for($i=0;$i<$this->length;$i++)
			$this->keystring.=$this->allowed_symbols[mt_rand(0,strlen($this->allowed_symbols)-1)];
		return $this->keystring;
	}

	public function ShowImage()
	{
		$foreground_color=array(mt_rand(0,100),mt_rand(0,100),mt_rand(0,100));
		$background_color=array(mt_rand(150,255),mt_rand(150,255),mt_rand(150,255));
		$alphabet_length=strlen(self::ALPHABET);
		$fonts=glob($this->Mainclass->root_path.'classes/captcha/fonts/*.png');
		$font=imagecreatefrompng($fonts[array_rand($fonts)]);
		unset($fonts);
		imagealphablending($font, true);
		$fontfile_width=imagesx($font);
		$fontfile_height=imagesy($font)-1;
		$font_metrics=array();
		$symbol=0;
		$reading_symbol=false;
		#Подготовим данные для нашего алфавита
		for($i=0;$i<$fontfile_width and $symbol<$alphabet_length;$i++)
		{
			$transparent=(imagecolorat($font,$i,0) >> 24)==127;
			if(!$reading_symbol and !$transparent)
			{
				$font_metrics[substr(self::ALPHABET,$symbol,1)]=array('start'=>$i);
				$reading_symbol=true;
			}
			elseif($reading_symbol and $transparent)
			{
				$font_metrics[substr(self::ALPHABET,$symbol,1)]['end']=$i;
				$reading_symbol=false;
				$symbol++;
			}
		}
		$img=imagecreatetruecolor($this->width,$this->height);
		imagealphablending($img, true);
		$white=imagecolorallocate($img,255,255,255);
		$black=imagecolorallocate($img,0,0,0);
		imagefilledrectangle($img,0,0,$this->width-1,$this->height-1,$white);
		$x=1;
		for($i=0;$i<$this->length;$i++)
		{
			$m=$font_metrics[$this->keystring[$i]];
			$y=mt_rand(-$this->fluctuation,$this->fluctuation)+($this->height-$fontfile_height)/2+2;

			if($this->no_spaces)
			{
				$shift=0;
				if($i>0)
				{
					$shift=10000;
					for($sy=7;$sy<$fontfile_height-20;$sy+=1)
						for($sx=$m['start']-1;$sx<$m['end'];$sx++)
						{
							$rgb=imagecolorat($font, $sx, $sy);
							$opacity=$rgb>>24;
							if($opacity<127)
							{
								$py=$sy+$y;
								if($py>$this->height)
									break;
								$left=$sx-$m['start']+$x;
								for($px=min($left,$this->width-1);$px>$left-12 and $px>=0;$px-=1)
								{
									$color=imagecolorat($img, $px, $py) & 0xff;
									if($color+$opacity<190)
									{
										if($shift>$left-$px)
											$shift=$left-$px;
										break;
									}
								}
								break;
							}
						}
					if($shift==10000)
						$shift=mt_rand(4,6);

				}
			}
			else
				$shift=1;
			imagecopy($img,$font,$x-$shift,$y,$m['start'],1,$m['end']-$m['start'],$fontfile_height);
			$x+=$m['end']-$m['start']-$shift;
		}
		$center=$x/2;
		$out_img=imagecreatetruecolor($this->width, $this->height);
		$foreground=imagecolorallocate($out_img,$foreground_color[0],$foreground_color[1],$foreground_color[2]);
		$background=imagecolorallocate($out_img,$background_color[0],$background_color[1],$background_color[2]);
		imagefilledrectangle($out_img,0,0,$this->width-1,$this->height-1,$background);
		imagefilledrectangle($out_img,0,$this->height,$this->width-1,$this->height+12,$foreground);

		$rand1=mt_rand(750000,1200000)/10000000;
		$rand2=mt_rand(750000,1200000)/10000000;
		$rand3=mt_rand(750000,1200000)/10000000;
		$rand4=mt_rand(750000,1200000)/10000000;

		$rand5=mt_rand(0,31415926)/10000000;
		$rand6=mt_rand(0,31415926)/10000000;
		$rand7=mt_rand(0,31415926)/10000000;
		$rand8=mt_rand(0,31415926)/10000000;

		$rand9=mt_rand(330,420)/110;
		$rand10=mt_rand(330,450)/110;

		#Искривление изображения
		for($x=0;$x<$this->width;$x++)
			for($y=0;$y<$this->height;$y++)
			{
				$sx=$x+(sin($x*$rand1+$rand5)+sin($y*$rand3+$rand6))*$rand9-$this->width/2+$center+1;
				$sy=$y+(sin($x*$rand2+$rand7)+sin($y*$rand4+$rand8))*$rand10;

				if($sx<0 or $sy<0 or $sx>=$this->width-1 or $sy>=$this->height-1)
					continue;
				else
				{
					$color=imagecolorat($img,$sx,$sy) & 0xFF;
					$color_x=imagecolorat($img,$sx+1,$sy) & 0xFF;
					$color_y=imagecolorat($img,$sx,$sy+1) & 0xFF;
					$color_xy=imagecolorat($img,$sx+1,$sy+1) & 0xFF;
				}

				if($color==255 and $color_x==255 and $color_y==255 and $color_xy==255)
					continue;
				elseif($color==0 and $color_x==0 and $color_y==0 and $color_xy==0)
				{
					$newred=$foreground_color[0];
					$newgreen=$foreground_color[1];
					$newblue=$foreground_color[2];
				}
				else
				{
					$frsx=$sx-floor($sx);
					$frsy=$sy-floor($sy);
					$frsx1=1-$frsx;
					$frsy1=1-$frsy;

					$newcolor=$color*$frsx1*$frsy1+
							  $color_x*$frsx*$frsy1+
							  $color_y*$frsx1*$frsy+
							  $color_xy*$frsx*$frsy;

					if($newcolor>255)
						$newcolor=255;
					$newcolor=$newcolor/255;
					$newcolor0=1-$newcolor;
					$newred=$newcolor0*$foreground_color[0]+$newcolor*$background_color[0];
					$newgreen=$newcolor0*$foreground_color[1]+$newcolor*$background_color[1];
					$newblue=$newcolor0*$foreground_color[2]+$newcolor*$background_color[2];
				}

				imagesetpixel($out_img,$x,$y,imagecolorallocate($out_img,$newred,$newgreen,$newblue));
			}
		header('Expires: 0');
		header('Cache-Control: no-store, no-cache, must-revalidate');
		header('Cache-Control: post-check=0, pre-check=0', false);
		header('Pragma: no-cache');

		if(function_exists('imagejpeg'))
		{
			header('Content-Type: image/jpeg');
			imagejpeg($out_img,null,$this->quality);
		}
		elseif(function_exists('imagegif'))
		{
			header('Content-Type: image/gif');
			imagegif($out_img);
		}
		elseif(function_exists('imagepng'))
		{
			header('Content-Type: image/x-png');
			imagepng($out_img);
		}
		else
			return false;
		die;
	}
}
?>