<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
#Класс содержит полезные и не очень функции
class Functions extends BaseClass
{
	private
		$votes;#Для функций PrepareVoting и CanVoting
	/*
		Функция похожа на array_unshift, только позволяет добавлять значения с ключами
		Возвращает новое количество элементов
	*/
	static function ArrayUnshiftAssoc(&$arr,$addons=array())
	{
		$arr=array_reverse($arr, true);
		foreach($addons as $k=>$v)
			if(is_int($k))
				$arr[]=$v;
			else
				$arr[$k]=$v;
		$arr=array_reverse($arr, true);
		return count($arr);
	}

	public static function Redirect($location)
	{
		header('HTTP/1.1 301 Moved Permanently');
		header('location: '.$location);
		die;
	}

	/*
		Функция возвращает Mime тип файла в зависимости от его расширения.
		http://www.w3schools.com/media/media_mimeref.asp
	*/
	static function FileMimeType($file_name,$def='application/octet-stream')
	{
		$type=strpos($file_name,'.')===false ? $file_name : strtolower(substr($file_name,strrpos($file_name,'.')+1));
		$mime_types=array(
							'323'		=>'text/h323',
							'acx'		=>'application/internet-property-stream',
							'ai'		=>'application/postscript',
							'aif'		=>'audio/x-aiff',
							'aifc'		=>'audio/x-aiff',
							'aiff'		=>'audio/x-aiff',
							'asf'		=>'video/x-ms-asf',
							'asr'		=>'video/x-ms-asf',
							'asx'		=>'video/x-ms-asf',
							'au'		=>'audio/basic',
							'avi'		=>'video/x-msvideo',
							'axs'		=>'application/olescript',
							'bas'		=>'text/plain',
							'bcpio'		=>'application/x-bcpio',
							'bin'		=>'application/octet-stream',
							'bmp'		=>'image/bmp',
							'c'			=>'text/plain',
							'cat'		=>'application/vnd.ms-pkiseccat',
							'cdf'		=>'application/x-cdf',
							'cer'		=>'application/x-x509-ca-cert',
							'class'		=>'application/octet-stream',
							'clp'		=>'application/x-msclip',
							'cmx'		=>'image/x-cmx',
							'cod'		=>'image/cis-cod',
							'cpio'		=>'application/x-cpio',
							'crd'		=>'application/x-mscardfile',
							'crl'		=>'application/pkix-crl',
							'crt'		=>'application/x-x509-ca-cert',
							'csh'		=>'application/x-csh',
							'css'		=>'text/css',
							'dcr'		=>'application/x-director',
							'der'		=>'application/x-x509-ca-cert',
							'dir'		=>'application/x-director',
							'dll'		=>'application/x-msdownload',
							'dms'		=>'application/octet-stream',
							'doc'		=>'application/msword',
							'docx'		=>'application/msword',
							'dot'		=>'application/msword',
							'dvi'		=>'application/x-dvi',
							'dxr'		=>'application/x-director',
							'eps'		=>'application/postscript',
							'etx'		=>'text/x-setext',
							'evy'		=>'application/envoy',
							'exe'		=>'application/octet-stream',
							'fif'		=>'application/fractals',
							'flr'		=>'x-world/x-vrml',
							'gif'		=>'image/gif',
							'gtar'		=>'application/x-gtar',
							'gz'		=>'application/x-gzip',
							'h'			=>'text/plain',
							'hdf'		=>'application/x-hdf',
							'hlp'		=>'application/winhlp',
							'hqx'		=>'application/mac-binhex40',
							'hta'		=>'application/hta',
							'htc'		=>'text/x-component',
							'htm'		=>'text/html',
							'html'		=>'text/html',
							'htt'		=>'text/webviewhtml',
							'ico'		=>'image/x-icon',
							'ief'		=>'image/ief',
							'iii'		=>'application/x-iphone',
							'ins'		=>'application/x-internet-signup',
							'isp'		=>'application/x-internet-signup',
							'jfif'		=>'image/pipeg',
							'jpe'		=>'image/jpeg',
							'jpeg'		=>'image/jpeg',
							'jpg'		=>'image/jpeg',
							'js'		=>'application/x-javascript',
							'latex'		=>'application/x-latex',
							'lha'		=>'application/octet-stream',
							'lsf'		=>'video/x-la-asf',
							'lsx'		=>'video/x-la-asf',
							'lzh'		=>'application/octet-stream',
							'm13'		=>'application/x-msmediaview',
							'm14'		=>'application/x-msmediaview',
							'm3u'		=>'audio/x-mpegurl',
							'man'		=>'application/x-troff-man',
							'mdb'		=>'application/x-msaccess',
							'me'		=>'application/x-troff-me',
							'mht'		=>'message/rfc822',
							'mhtml'		=>'message/rfc822',
							'mid'		=>'audio/mid',
							'mny'		=>'application/x-msmoney',
							'mov'		=>'video/quicktime',
							'movie'		=>'video/x-sgi-movie',
							'mp2'		=>'video/mpeg',
							'mp3'		=>'audio/mpeg',
							'mpa'		=>'video/mpeg',
							'mpe'		=>'video/mpeg',
							'mpeg'		=>'video/mpeg',
							'mpg'		=>'video/mpeg',
							'mpp'		=>'application/vnd.ms-project',
							'mpv2'		=>'video/mpeg',
							'ms'		=>'application/x-troff-ms',
							'mvb'		=>'application/x-msmediaview',
							'nws'		=>'message/rfc822',
							'oda'		=>'application/oda',
							'p10'		=>'application/pkcs10',
							'p12'		=>'application/x-pkcs12',
							'p7b'		=>'application/x-pkcs7-certificates',
							'p7c'		=>'application/x-pkcs7-mime',
							'p7m'		=>'application/x-pkcs7-mime',
							'p7r'		=>'application/x-pkcs7-certreqresp',
							'p7s'		=>'application/x-pkcs7-signature',
							'pbm'		=>'image/x-portable-bitmap',
							'pdf'		=>'application/pdf',
							'pfx'		=>'application/x-pkcs12',
							'pgm'		=>'image/x-portable-graymap',
							'php'		=>'text/plain',
							'pko'		=>'application/ynd.ms-pkipko',
							'pma'		=>'application/x-perfmon',
							'pmc'		=>'application/x-perfmon',
							'pml'		=>'application/x-perfmon',
							'pmr'		=>'application/x-perfmon',
							'pmw'		=>'application/x-perfmon',
							'png'		=>'image/png',
							'pnm'		=>'image/x-portable-anymap',
							'pot'		=>'application/vnd.ms-powerpoint',
							'ppm'		=>'image/x-portable-pixmap',
							'pps'		=>'application/vnd.ms-powerpoint',
							'ppt'		=>'application/vnd.ms-powerpoint',
							'prf'		=>'application/pics-rules',
							'ps'		=>'application/postscript',
							'pub'		=>'application/x-mspublisher',
							'qt'		=>'video/quicktime',
							'ra'		=>'audio/x-pn-realaudio',
							'ram'		=>'audio/x-pn-realaudio',
							'ras'		=>'image/x-cmu-raster',
							'rgb'		=>'image/x-rgb',
							'rmi'		=>'audio/mid',
							'roff'		=>'application/x-troff',
							'rtf'		=>'application/rtf',
							'rtx'		=>'text/richtext',
							'scd'		=>'application/x-msschedule',
							'sct'		=>'text/scriptlet',
							'setpay'	=>'application/set-payment-initiation',
							'setreg'	=>'application/set-registration-initiation',
							'sh'		=>'application/x-sh',
							'shar'		=>'application/x-shar',
							'sit'		=>'application/x-stuffit',
							'snd'		=>'audio/basic',
							'spc'		=>'application/x-pkcs7-certificates',
							'spl'		=>'application/futuresplash',
							'src'		=>'application/x-wais-source',
							'sst'		=>'application/vnd.ms-pkicertstore',
							'stl'		=>'application/vnd.ms-pkistl',
							'stm'		=>'text/html',
							'svg'		=>'image/svg+xml',
							'sv4cpio'	=>'application/x-sv4cpio',
							'sv4crc'	=>'application/x-sv4crc',
							'swf'		=>'application/x-shockwave-flash',
							't'			=>'application/x-troff',
							'tar'		=>'application/x-tar',
							'tcl'		=>'application/x-tcl',
							'tex'		=>'application/x-tex',
							'texi'		=>'application/x-texinfo',
							'texinfo'	=>'application/x-texinfo',
							'tgz'		=>'application/x-compressed',
							'tif'		=>'image/tiff',
							'tiff'		=>'image/tiff',
							'tr'		=>'application/x-troff',
							'trm'		=>'application/x-msterminal',
							'tsv'		=>'text/tab-separated-values',
							'txt'		=>'text/plain',
							'uls'		=>'text/iuls',
							'ustar'		=>'application/x-ustar',
							'vcf'		=>'text/x-vcard',
							'vrml'		=>'x-world/x-vrml',
							'wav'		=>'audio/x-wav',
							'wcm'		=>'application/vnd.ms-works',
							'wdb'		=>'application/vnd.ms-works',
							'wks'		=>'application/vnd.ms-works',
							'wmf'		=>'application/x-msmetafile',
							'wps'		=>'application/vnd.ms-works',
							'wri'		=>'application/x-mswrite',
							'wrl'		=>'x-world/x-vrml',
							'wrz'		=>'x-world/x-vrml',
							'xaf'		=>'x-world/x-vrml',
							'xbm'		=>'image/x-xbitmap',
							'xla'		=>'application/vnd.ms-excel',
							'xlc'		=>'application/vnd.ms-excel',
							'xlm'		=>'application/vnd.ms-excel',
							'xls'		=>'application/vnd.ms-excel',
							'xlt'		=>'application/vnd.ms-excel',
							'xlw'		=>'application/vnd.ms-excel',
							'xof'		=>'x-world/x-vrml',
							'xpm'		=>'image/x-xpixmap',
							'xwd'		=>'image/x-xwindowdump',
							'z'			=>'application/x-compress',
							'zip'		=>'application/zip'
		);
		return isset($mime_types[$type]) ? $mime_types[$type] : $def;
	}
	/*
		Простенькая функция для создания архива. Очень не рекомендуется для больших объемов данных.
	*/
	static function CompressFile($from,$to)
	{
		if(!is_file($from) or file_exists($to))
			return false;
		if(!is_writable(substr($to,0,strrpos($to,'/'))))
			return false;
		$data=file_get_contents($from);
		if(function_exists('bzopen'))
		{
			$hbz=bzopen($to.'.bz2','w');
			bzwrite($hbz, $data);
			bzclose($hbz);
		}
		elseif(function_exists('gzopen'))
		{
			$hgz=gzopen($to.'.gz','w9');
			gzwrite($hgz,$data);
			gzclose($hgz);
			return true;
		}
		unset($data);
		return false;
	}

	static function CheckEmail($s)
	{
		if(is_array($s))
		{
			foreach($s as &$v)
				if(!self::CheckEmail($v))
					return false;
			return true;
		}
		$s=trim($s);
		return ($s and preg_match('#^[_\-\.a-z0-9]+\@([a-z0-9](?:[\.\-a-z0-9][a-z0-9])*)+\.[a-z]{2,6}$#i', $s)>0);
	}

	/*
		Функция используються для определения "среднего" цвета.
	*/
	static function GetAverage($a,$b,$alpha)
	{
		return round($a*(1-$alpha)+$b*$alpha);
	}

	static function GetImageColor($im,$r,$g,$b,$a=0)
	{
		$c=imagecolorexactalpha($im,$r,$g,$b,$a);
		if($c!=-1)
			return $c;
		$c=imagecolorallocatealpha($im,$r,$g,$b,$a);
		if($c!=-1)
			return $c;
		return imagecolorclosestalpha($im,$r,$g,$b,$a);
	}

	static function CreateImage($path,$type=false)
	{
		if($type===false)
			$type=substr($path,strrpos($path,'.')+1);
		switch(strtolower($type))
		{
			case 'jpg':
			case 'jpeg':
				return @imagecreatefromjpeg($path);
			break;
			case 'png':
				return @imagecreatefrompng($path);
			break;
			case 'gif':
				return @imagecreatefromgif($path);
			break;
			case 'bmp':
				return @imagecreatefromwbmp($path);
			break;
			default:
				return false;
		}
	}

	static function IPMatchMask($ip,$mask)
	{
		$mask=trim($mask);
		/*IPv6
		if($ipv6=strpos($ip,':')!==false)
		{
			$n=substr_count($ip,':')-2;
			$rep=str_repeat(':0000',8-$n-2);
			$ip=str_replace('::',$rep.':',$ip);
		}*/
		if(strpos($mask,'-')===false)
		{
			/*if($ipv6 and false!==$p=strpos($mask,'::'))
			{
				$n=substr_count($mask,':')-2-($p==0);
				$rep=str_repeat(':0000',8-$n-2);
				$mask=trim(str_replace('::',$rep.':',$mask),':');
			}*/
			$mask=str_replace('\*','[a-f0-9]{1,4}',preg_quote($mask,'#'));
			return preg_match('#^'.$mask.'$#',$ip)>0;
		}
		else
		{
			$mask=explode('-',$mask,2);
			/*if($ipv6)
			{
				if(false!==$p=strpos($mask[1],'::'))
				{
					$n=substr_count($mask[1],':')-2-($p==0);
					$rep=str_repeat(':0000',8-$n-2);
					$mask[1]=trim(str_replace('::',$rep.':',$mask[1]),':');
				}
				if(false!==$p=strpos($mask[0],'::'))
				{
					$n=substr_count($mask[0],':')-2-($p==0);
					$rep=str_repeat(':0000',8-$n-2);
					$mask[0]=trim(str_replace('::',$rep.':',$mask[0]),':');
				}
				$maskto=explode(':',$mask[1],8);
				$mask=explode(':',$mask[0],8);
				$ip=explode(':',$ip,8);
				foreach($mask as &$v)
					$v=hexdec($v);
				$mask=join('',$mask);
				foreach($maskto as &$v)
					$v=hexdec($v);
				$maskto=join('',$maskto);
				foreach($ip as &$v)
					$v=hexdec($v);
				$ip=implode('',$ip);
			}
			else
			{*/
				$maskto=explode('.',str_replace('*',255,$mask[1]),4);
				$mask=explode('.',str_replace('*',0,$mask[0]),4);
				$ip=explode('.',$ip,4);
				foreach($mask as &$v)
					$v=str_pad($v,3,0,STR_PAD_LEFT);
				$mask=ltrim(join('',$mask),0);
				foreach($maskto as &$v)
					$v=str_pad($v,3,0,STR_PAD_LEFT);
				$maskto=ltrim(join('',$maskto),0);
				foreach($ip as &$v)
					$v=str_pad($v,3,0,STR_PAD_LEFT);
				$ip=ltrim(join('',$ip),0);
			/*}*/
			return (bccomp($ip,$mask)>=0 and bccomp($maskto,$ip)>=0);
		}
	}

	static function RmDir($path)
	{
		if(is_dir($path) and !is_link($path))
		{
			if($dh=opendir($path))
			{
				while($entry=readdir($dh))
				{
					if($entry=='.' or $entry=='..')
						continue;
					$f=__function__;
					if(!self::$f($path.'/'.$entry))
						return false;
				}
				closedir($dh);
			}
			return rmdir($path);
		}
		elseif(is_file($path))
			return unlink($path);
	}
	/*
		$dest - это путь к ПАПКЕ! Без закрывающего слеша.
	*/
	static function Copy($source,$dest)
	{
		if(!file_exists($source))
			return false;
		if(is_file($source))
		{
			$dirn=dirname($dest);
			if(!is_dir($dirn))
				mkdir($dirn);
			return copy($source,$dest);
		}
		if(is_link($source))
		{
			$link_dest=readlink($source);
			return symlink($link_dest,$dest);
		}
		if(!is_dir($dest))
			mkdir($dest);
		$Dir=dir($source);
		while ($entry=$Dir->read())
		{
			if($entry=='.' or $entry == '..')
				continue;
			$newdest=$source.DIRECTORY_SEPARATOR.$entry;
			$f=__function__;
			if($dest!=$newdest)
				self::$f($newdest,$dest.DIRECTORY_SEPARATOR.$entry);
		}
		$Dir->close();
		return true;
	}

	/*
		Функция возвращает календарь в виде $arr[week][day]
		Где week от 1 до 5 или 6, а  day от 1 до 7.
		При этом $prev_next может писать в начало и конец числа следующих месяцев, иначе - заменяет нулями.
	*/
	static function BuildCalendar($year, $month, $prev_next=true)
	{
		$time=mktime(0,0,0,$month,1,$year);
		$t=date('w',$time);
		if($t==0)
			$t=7;
		$print=$t>1 ? date('t',$time - 172800)-$t+2 : 1;
		$calendar=array();
		$t=date('t', $time);
		for($week=0;$week<6;$week++)
			for($day=0;$day<7;$day++)
			{
				$d = (($week==0 and $print>20 or $week>=4 and $print<10) and !$prev_next) ? 0 : $print;
				if($day==0 and $week>=4 and $d<10)
					break;
				$calendar[$week][] = $d;
				if($week==0 and $print==date('t',$time-172800) or $week>0 and $print==$t)
					$print = 0;
				$print++;
			}
		return $calendar;
	}

	/*
		Функция для скачивания строк в виде файлов. Вызывает die в конце, так что после нее нельзя ничего делать!
		Если $text - пустое, а $filename - путь к файлу на сервере - функция читает этот файл.
	*/
	static function OutputStream($text,$filename='text.txt')
	{
		if(headers_sent())
			return;
		$read=false;
		if(!$text and strpos($filename,DIRECTORY_SEPARATOR)!==false)
		{
			$filename=basename($path=$filename);
			$read=true;
			$len=filesize($path);
		}
		else
			$len=strlen($text);
		$etag=md5($filename);
		$etag=substr($etag,0,8).'-'.substr($etag,8,7).'-'.substr($etag,15,8);
		header('HTTP/1.1 200 Ok');
		header('ETag: "'.$etag.'"');
		header('Accept-Ranges: bytes');
		header('Content-Length: '.$len);
		header('Connection: close');
		header('Content-Type: '.self::FileMimeType($filename,'auto-detect').'; charset='.ELEANOR_DISPLAYCHARSET);
		header('Last-Modified: '.date('r'));
		header('Content-Disposition: attachment; filename="'.$filename.'";');
		if($read)
			readfile($path);
		else
			echo $text;
		flush();
		die;
	}

#Функции, обеспечивающие многоязычность
	/*
		Функция ставит языковую куку
		$value - языковое значение
		$c_name - имя куки
		$langs - массив поддерживаемых языков. Может быть любым
	*/
	public function SetLangCookie($value,$c_name='lang',array $langs=array())
	{
		if(!$langs)
			$langs=array_keys($this->Mainclass->langs);
		if(!in_array($value,$langs) and $value!==false)
			return false;
		return $this->Mainclass->SCookie($c_name,$value);
	}

	/*
		Функция читает языковую куку
		$set_sytem - устанавливает системный язык. Нет? - возвращает значение языка. false - в случае неудачи.
		$c_name - имя куки.
		$langs - массив поддерживаемых языков. Если $set_system==true, то этот массив урезается до массива системных языков.
	*/
	public function GetLangCookie($set_system=true,$c_name='lang',array $langs=array())
	{
		if(!$langs)
			$langs=array_keys($this->Mainclass->langs);
		elseif($set_system)
			$langs=array_intersect($langs,array_keys($this->Mainclass->langs));
		if(false===$value=$this->Mainclass->GCookie($c_name) or !in_array($value,$langs))
			return false;
		if($set_system)
			$this->Mainclass->lang_name=$value;
		else
			return $value;
	}

	/*
		Функция корректирует URL, добавляя в него параметр языка.
		http://eleanor-cms.ru => http://eleanor-cms.ru/eng/
		http://eleanor-cms.ru/index.php => http://eleanor-cms.ru/index.php?lang=eng
	*/
	public function CorrectLangUrl($url,$lang,$check_out_url=true)
	{
		$our_url=ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path;
		$our_len=strlen($our_url);
		if($check_out_url and strpos($url,$our_url)!==0)
			throw new EE('Incorrect URL!',EE::INFO);
		$url=ltrim(substr($url,$our_len),'\\/');
		if(strpos($url,$this->Mainclass->file_name)===0 or $url=='')
		{
			if($this->Mainclass->file_name==$url)
				$url='';
			if($lang=='')
				$url=preg_replace('/([\W\s])lang=[a-z]{3}&?/i','\1',$url);
			else
			{
				$lang='lang='.$lang;
				if($url=='')
					$url=$this->Mainclass->file_name.'?'.$lang;
				elseif(preg_match('/([\W\s])lang=[a-z]{3}(&?)/i',$url,$match)>0)
					$url=str_replace($match[0],$match[1].$lang.$match[2],$url);
				else
					$url=str_replace('?','?'.$lang.'&',$url);
			}
		}
		else
		{
			$langs=array();
			foreach($this->Mainclass->langs as $k=>$v)
				$langs[]=preg_quote(substr($k,0,3),'#');
			if(preg_match('#('.join('|',$langs).')/#',$url,$match)>0)
				$url=substr_replace($url,$lang,strpos($url,$match[0]),3);
			elseif($lang!='')
				$url=$lang.'/'.$url;
		}
		return ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/'.$url;
	}

#Конец функций, обеспечивающих многоязычность

	public function CreateImagePreview($path,$width=100)
	{
		$path=preg_replace('#^[a-z]{3,10}://[a-z0-9\-\._]+/(?='.Mainclass::UPLOADS_DIR.')#i','',$path);
		$im_link=substr_replace($path,'_preview',strrpos($path,'.'),0);
		$path=$this->Mainclass->FormatPath('',$path);
		$path=rtrim($path,'\\/');
		if(!is_file($path))
			throw new EE('File not found! ('.$path.')',EE::INFO);
		$dest_path=substr_replace($path,'_preview',strrpos($path,'.'),0);
		if(is_file($dest_path))
			return $im_link;
		if(!is_writable(dirname($dest_path)))
			throw new EE('Folder '.dirname($dest_path).' is write-protected!',EE::ENV);
		$sizes=getimagesize($path);
		#Очень часто создание изображение приводит к логируемым ошибкам. Это нам не надо совершенно.
		$no_log=$this->Mainclass->no_log;
		$this->Mainclass->no_log=true;
		if(false===$image=self::CreateImage($path))
		{
			$this->Mainclass->no_log=$no_log;
			throw new EE('Unable to create preview!',EE::INFO);
		}
		$this->Mainclass->no_log=$no_log;
		$w=$sizes[0];
		$h=$sizes[1];
		if($w<$width)
			return func_get_arg(0);
		$height=round($h*$width/$w);
		$result=imagecreatetruecolor($width,$height);
		imagecopyresampled($result,$image,0,0,0,0,$width,$height,$sizes[0],$sizes[1]);
		$type=strtolower(substr($path,strrpos($path,'.')+1));
		switch ($type)
		{
			case 'jpg':
			case 'jpeg':
				imagejpeg($result,$dest_path,100);
			break;
			case 'png':
				imagepng($result,$dest_path);
			break;
			case 'gif':
				imagegif($result,$dest_path);
			break;
			case 'bmp':
				imagewbmp($result,$dest_path);
			break;
		}
		imagedestroy($image);
		imagedestroy($result);
		return $im_link;
	}

	/*
		Функция служит ТОЛЬКО для загрузки файлов. Возвращает false в случае неудачи
	*/
	public function Upload($name,$to='',$new_name='')
	{
		if(!isset($_FILES[$name]) or $_FILES[$name]['size']>$this->Mainclass->vars['max_uploaded_file_size'])
			return false;
		if(!$new_name)
		{
			$new_name=$_FILES[$name]['name'];
			$new_name=preg_replace('#(^\.+|[\s\'"%\]\[/\\\\])+#','-',$new_name);
		}
		$to=$this->Mainclass->FormatPath(MainClass::UPLOADS_DIR.'/'.$to.'/'.$new_name);
		return move_uploaded_file($_FILES[$name]['tmp_name'],$to);
	}

	public function WaterMark($file_path)
	{
		if(!$this->Mainclass->vars['watermark'])
			return;
		if(!is_file($file_path))
			throw new EE('File not found!',EE::INFO);
		$allower_types=explode(',',$this->Mainclass->vars['watermark_types']);
		$type=strtolower(substr($file_path,strrpos($file_path,'.')+1));
		if(!in_array($type,$allower_types))
			return false;
		$alpha=(int)$this->Mainclass->vars['watermark_alpha']/100;
		$top=(int)$this->Mainclass->vars['watermark_top']/100;
		$left=(int)$this->Mainclass->vars['watermark_left']/100;
		if(false===$image=self::CreateImage($file_path))
			throw new EE('Unable to create image!',EE::INFO);
		$img_w=imagesx($image);
		$img_h=imagesy($image);
		if($this->Mainclass->vars['watermark_image'] and is_file($this->Mainclass->vars['watermark_image']))
		{
			if(false===$w_img=self::CreateImage($this->Mainclass->FormatPath($this->Mainclass->vars['watermark_image'])))
			{
				imagedestroy($image);
				return false;
			}
			$w_img_w=imagesx($w_img);
			$w_img_h=imagesy($w_img);
			$dest_x=round(($img_w-$w_img_w)*$left);
			$dest_y=round(($img_h-$w_img_h)*$top);
			for($y=0;$y<$img_h;$y++)
				for($x=0;$x<$img_w;$x++)
				{
					$watermark_x=$x-$dest_x;
					$watermark_y=$y-$dest_y;
					#Если пиксель лежит в области, которую мы определили.
					if($watermark_x>=0 and $watermark_x<$w_img_w and $watermark_y>=0 and $watermark_y<$w_img_h)
					{
						$main_rgb=imagecolorsforindex($image,imagecolorat($image,$x,$y));
						$watermark_rbg=imagecolorsforindex($w_img,imagecolorat($w_img,$watermark_x,$watermark_y));
						#Вычислим альфаканал в %
						$watermark_alpha=round((127-$watermark_rbg['alpha'])/127,2);
						$watermark_alpha=$watermark_alpha*$alpha;
						# расчет цвета в месте наложения картинок
						$avg_red=self::GetAverage($main_rgb['red'],$watermark_rbg['red'],$watermark_alpha);
						$avg_green=self::GetAverage($main_rgb['green'],$watermark_rbg['green'],$watermark_alpha);
						$avg_blue=self::GetAverage($main_rgb['blue'],$watermark_rbg['blue'],$watermark_alpha);
						$return_color=self::GetImageColor($image,$avg_red,$avg_green,$avg_blue);
						imagesetpixel($image,$x,$y,$return_color);
					}
				}
		}
		elseif($this->Mainclass->vars['watermark_string'])
		{
			$font=$this->Mainclass->root_path.'addons/fonts/arial.ttf';
			$rect=imageftbbox('15',0,$font,$this->Mainclass->vars['watermark_string']);
			$width=abs($rect[4]-$rect[0]);
			$height=abs($rect[1]-$rect[5]);
			if($width<$img_w and $height<$img_h)
			{
				$dest_x=round(($img_w-$width)*$left);
				$dest_y=round(($img_h-$height)*$top);
				$color=self::GetImageColor($image,1,1,1,$alpha*127);
				$text=$this->Mainclass->vars['watermark_string'];
				if(ELEANOR_CHARSET!='utf-8')
					$text=mb_convert_encoding($this->Mainclass->vars['watermark_string'],'utf-8',ELEANOR_CHARSET);
				imagettftext($image,'15',0,$dest_x,$dest_y,$color,$font,$text);
			}
			else
			{
				imagedestroy($image);
				return false;
			}
		}
		else
		{
			imagedestroy($image);
			return false;
		}
		switch($type)
		{
			case 'jpg':
			case 'jpeg':
				imagejpeg($image,$file_path,100);
			break;
			case 'png':
				imagepng($image,$file_path);
			break;
			case 'gif':
				imagegif($image,$file_path);
			break;
			case 'bmp':
				imagewbmp($image,$file_path);
			break;
		}
		imagedestroy($image);
		return true;
	}

	#Функции рейтинга
	public function ShowRating($total,$votes_real,$steps=5,$arr=array(),$unique='')
	{
		$id=uniqid('rat');
		$str_rat=$this->Mainclass->Template->Rating($id,$unique);
		$str_rat=trim($str_rat);
		if(preg_match('#^([0-9]+);([0-9]+)#',$str_rat,$matches)==0)
			return '';
		$width=$matches[1];
		$height=$matches[2];
		$str_rat=ltrim(substr($str_rat,strlen($matches[0])));
		$votes=$votes_real<=0 ? 1 : $votes_real;
		$persent=ceil($total/$votes/($steps==0 ? 1 : abs($steps))*100);
		if($persent>100)
			$persent=100;
		$addon_arr='{';
		foreach($arr as $k=>$v)
			$addon_arr.='\''.$k.'\':\''.$v.'\',';
		$addon_arr=rtrim($addon_arr,',');
		$addon_arr.='}';
		return $str_rat.'<script type="text/javascript">
		new Rating(\''.$id.'\','.$persent.','.($steps<0 ? 0 : (int)$steps).','.$width.','.$height.','.$this->Mainclass->GetModVal('id').','.$addon_arr.',\''.addslashes($this->RatingTitle($total,$votes_real)).'\');
		</script>';
	}

	public function RatingTitle($total,$votes)
	{
		return $this->Mainclass->lang['main']['average_mark'].round($total/($votes==0 ? 1 : $votes),2).$this->Mainclass->lang['main']['have_voted'].$votes;
	}
	/*
		Функция проверки голосований (рейтинга, голосований и тп.)
	*/
	public function PrepareVoting($ids,$mid=0)
	{static $delete=true;
		if($mid==0)
			$mid=$this->Mainclass->GetModVal('id');
		$uid=isset($this->Mainclass->Account) ? (int)$this->Mainclass->Account->GetValue('id') : 0;
		#Если пользователь - гость, значит мы можешь определить его только по IP
		if(!$uid)
			$uid=-1;
		if($delete)
		{
			$this->Mainclass->Db->Delete('check_voting','`time`<'.$this->Mainclass->MyTime(),__file__,__line__);
			$delete=false;
		}
		$this->votes=array();
		if($ids)
		{
			$this->Mainclass->Db->FQuery('SELECT `value` FROM {"0"} WHERE `mid`={"1"} AND `value`'.$this->Mainclass->Db->In($ids).' AND (`ip`={"2"} OR `uid`={"3"})',array('check_voting','i_'.$mid,'s_'.$this->Mainclass->ip,'i_'.$uid),__file__,__line__);
			while($temp=$this->Mainclass->Db->Fetch_row())
				$this->votes[]=$temp[0];
		}
	}

	/*
		Функция проверки голосований (рейтинга, голосований и тп.)
	*/
	public function CanVoting($id,$mid=0)
	{
		if($mid==0)
			$mid=$this->Mainclass->GetModVal('id');
		if(!is_array($this->votes))
			$this->PrepareVoting($id);
		if($this->Mainclass->GCookie($mid.'-'.$id)!==false)
			return false;
		elseif($this->votes)
			return !in_array($id,$this->votes);
		return true;
	}

	public function AddVoting($id,$t=3)
	{
		$t=(string)$t;
		if(ctype_digit($t))
			$expire=$t*86400;
		else
		{
			$a=substr($t,-1);
			switch(strtolower($a))
			{
				case 's':
					$expire=substr($t,0,-1);
				break;
				case 'm':
					$expire=substr($t,0,-1)*60;
				break;
				case 'h':
					$expire=substr($t,0,-1)*3600;
				break;
				default:
					return false;
			}
		}
		if(!$expire)
			return;
		$this->Mainclass->SCookie($this->Mainclass->GetModVal('id').'-'.$id,'1',$expire.'s');
		$uid=isset($this->Mainclass->Account) ? (int)$this->Mainclass->Account->GetValue('id') : 0;
		$this->Mainclass->Db->Delete('check_voting','`time`<'.$this->Mainclass->MyTime(),__file__,__line__);
		$expire+=$this->Mainclass->MyTime();
		$this->Mainclass->Db->Insert(
										'check_voting',
										array(
												'mid'	=>$this->Mainclass->GetModVal('id'),
												'value'	=>$id,
												'ip'	=>$this->Mainclass->ip,
												'time'	=>$expire,
												'uid'	=>$uid
										),
										__file__,
										__line__
		);
	}

	public function UpdateRating($table_name,$vote,$where,$addon=array(),$total='total',$votes='votes')
	{
		$this->Mainclass->Db->Update(
										$table_name,
										array(
												'!'.$total=>'`'.$total.'`+'.(int)$vote,
												'!'.$votes=>'`'.$votes.'`+1',
										)+$addon,
										$where,
										__file__,
										__line__
		);
	}

	/*
		Функция генерации RSS линков
	*/
	public function RssLink($links,$descr)
	{
		if(!is_array($links))
			return '<link rel="alternate" type="application/rss+xml" href="'.$links.'" title="'.$descr.'" />';
		if(!isset($this->Mainclass->RssUrl))
		{
			if(!isset($this->Mainclass->services[6]))
				return '';
			$this->Mainclass->RssUrl=new Url($this->Mainclass);
			$this->Mainclass->RssUrl->furl=false;
			$this->Mainclass->RssUrl->d_prefix=$this->Mainclass->services[6]['file'].'?';
		}
		$links=array('module'=>$this->Mainclass->GetModVal('name'))+$links;
		return '<link rel="alternate" type="application/rss+xml" href="'.$this->Mainclass->RssUrl->ConstructUrl($links).'" title="'.$descr.'" />';
	}

#confirmation - функции подтверждений
	public function ConfCreate($data,$hours=24)
	{
		$id=$this->Mainclass->Db->Insert(
										'confirmation',
										array(
												'hash'=>$hash=md5(uniqid(microtime(),true)),
												'!date'=>'NOW()',
												'!datef'=>'NOW() + INTERVAL '.(int)$hours.' HOUR',
												'data'=>(string)$data,
										),
										__file__,
										__line__
		);
		return array(
						'id'=>$id,
						'hash'=>$hash,
		);
	}

	public function ConfCheck($id,$hash,$del=true,$ret_date=false)
	{
		$this->Mainclass->Db->Delete('confirmation','`datef`<NOW()',__file__,__line__);
		$result=$this->Mainclass->Db->FQuery('SELECT `date`, `data` FROM {"0"} WHERE `id`={"1"} AND `hash`={"2"} LIMIT 1',array('confirmation','i_'.$id,'s_'.$hash),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()==0)
			return false;
		if($del)
			$this->ConfDel($id,$hash);
		if($ret_date)
			return $this->Mainclass->Db->Fetch_assoc($result);
		else
		{
			list(,$data)=$this->Mainclass->Db->Fetch_row($result);
			return $data;
		}
	}

	public function ConfDel($id,$hash)
	{
		$this->Mainclass->Db->Delete('confirmation','`id`='.(int)$id.' AND `hash`=\''.$this->Mainclass->Db->EscapeString($hash).'\'',__file__,__line__);
	}

	public function FixWinFileS($filename,$invert=false)
	{
		if($this->Mainclass->os=='w' and ELEANOR_CHARSET=='utf-8')
			$filename=$invert ? mb_convert_encoding($filename,ELEANOR_CHARSET,'cp1251') : mb_convert_encoding($filename,'cp1251',ELEANOR_CHARSET);
		return $filename;
	}
}
#Если не установлено дополнение bcmath
if(!function_exists('bcdiv'))
{
	function bcdiv($a,$b)
	{
		return ($a-$a%$b)/$b;
	}
}
#Если не установлено дополнение HASH Message Digest Framework
if(!function_exists('hash'))
{
	function hash($algo,$data)
	{
		switch($algo)
		{
			case 'md5':
				return md5($data);
			break;
			default:
				return false;
		}
	}
}
?>