<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class DbDriver_sqlite extends BaseClass implements DriverDB
{
	public
		$link_id=-1,
		$db='';
	protected
		$query_id=-1,
		$query=-1;
	public function Connect(array $params)
	{
		if (is_resource($this->link_id))
			return true;
		$id=sqlite_open($params['server']);
		if($id===false)
			return false;
		$this->link_id=$id;
		@sqlite_query('PRAGMA short_column_names=1',$id);
		return true;
	}

	public function Close()
	{
		if ($this->link_id===-1)
			return true;
		$this->current_query='';
		$res=sqlite_close($this->link_id);
		$this->query_id=$this->link_id=-1;
		return $res;
	}

	public function Free($qid)
	{
		return true;
	}

	public function Version()
	{
		return sqlite_libversion();
	}

	public function Escape($str)
	{
		return sqlite_escape_string($str);
	}

	public function Query($query)
	{
		$this->query=$query;
		return $this->query_id=sqlite_query($this->link_id,$query);
	}

	public function Error()
	{
		return sqlite_error_string(sqlite_last_error($this->link_id));
	}

	public function ErrorNo()
	{
		return sqlite_last_error($this->link_id);
	}

	public function Transaction($event)
	{
		switch ($event)
		{
			case 'BEGIN':
				return sqlite_query('BEGIN',$this->link_id);
			break;

			case 'COMMIT':
				return sqlite_query('COMMIT',$this->link_id);
			break;

			case 'ROLLBACK':
				return sqlite_query('ROLLBACK',$this->link_id);
			break;
		}
		return false;
	}

	public function AffectedRows()
	{
		return sqlite_changes($this->link_id);
	}

	public function FetchRow($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_fetch_array($qid,SQLITE_NUM);
	}

	public function FetchAssoc($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_fetch_array($qid,SQLITE_ASSOC);
	}

	public function FetchArray($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_fetch_array($qid,SQLITE_BOTH);
	}

	public function FetchObject($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_fetch_object($qid);
	}

	public function NumRows($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_num_rows($qid);
	}

	public function NumFields($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_num_fields($qid);
	}

	public function RowSeek($int,$qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return sqlite_seek($qid,$int);
	}

	public function InsertId()
	{
		return sqlite_last_insert_rowid($this->link_id);
	}
}
?>