<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
interface LoginClass //Интерфейс для создания медов авторизации
{
	/*
		Функция для авторизации по имени пользователя и паролю.
		Может быть пустым. В этом случае функция должна сама определить переменные из входящих.
	*/
	public function Login($user_name=null,$pass=null);

	/*
		Функция выполняет "автовход" пользователя. Фукнция кэширует результат, если $hard==false. Возвращает истину или ложь.
	*/
	public function IsUser($hard=false);

	/*
		Выход пользователя. Тут можно предусмотреть не только вытирание куков, но и переход на
		главную страницу сайта.
	*/
	public function Logout();

	/*
		Функция, которая должна возвращать ссылку на страницу о пользователей, либо false в случае, если пользователь не существует
	*/
	public function UserLink($user_name,$user_id=0);
}
/*
	Задача этого класса - создать некую "оболочку" для занесения, изменения и получения информации из БД пользователей портала.
	Естесственно, если авторизация внешняя, то эта обертка не пригодться. Кроме этого класс обслуживает базовые функции входа пользователя.
*/
class Account extends BaseClass
{
	public
		$error,#Ошибка, при авторизации NOT_FOUND, EMPTY_PASS
		$error_exp='',#Объяснение ошибки
		$session_addon='',#Дополнительная строка, которая будет писаться в таблицу сессий. Полезно для создания фичи во встроенных форумах: эту тему читают N пользователей
		$lang,
		$Plugin,
		$is_bot=false;#Посковый бот? Нет? - гость. Имя поискового бота
	protected
		$user=array(),#Массив с данными из полей БД конкретного юзера.
		$arr_permission=array(),#Часная переменная от функци Permissions
		$u_groups=array();#Частная переменная от фунции UserGroups

	public function __construct($Mainclass)
	{
		if(file_exists($Mainclass->root_path.'classes/login/integration.php'))
		{
			require $Mainclass->root_path.'classes/login/integration.php';
			$this->Plugin=new Integration($Mainclass);
		}
		$this->lang=$Mainclass->LoadLanguage('langs','','account-%');
	}

	function __get($name)
	{
		if($name=='Manage')
		{
			include $this->Mainclass->root_path.'classes/login/class_account_management.php';
			return $this->Manage=new AccountManagement($this->user);
		}
		else
			return parent::__get($name);
	}

	/*
		Функция позволяет пройти встоенную авторизацию системы с учетом брутов. Первая из функций входа.
		В случае успеха вернет true, нет - false.
	*/
	public function AuthByName($user_name,$pass,$already_md=false)
	{
		$this->Mainclass->Db->FQuery('SELECT `id`,`forum_id`,`name`,`email`,`group`,`other_group`,`login_keys`,`pass_salt`,`pass_hash`,`failed_logins`,`ip`,`ban_date`,`ban_explain`,`lang`,`theme`,`avatar_location`,`avatar_size`,`avatar_type`,`editor` FROM {"0"} INNER JOIN {"1"} USING(`id`) WHERE `l_name`=LOWER({"2"}) LIMIT 1',array('users','users_extra','s_'.$user_name),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()==0)
		{
			$this->error='NOT_FOUND';
			$this->error_exp=$this->lang['user_not_found'];
			$this->user=array();
			return false;
		}
		$this->user=$this->Mainclass->Db->Fetch_assoc();
		if($this->Mainclass->vars['login_antibrute'])
		{
			$failed_logins=$this->user['failed_logins'] ? unserialize($this->user['failed_logins']) : array();
			$attemps_cnt=empty($this->Mainclass->vars['login_antibrute_attemps_cnt']) ? 15 : (int)$this->Mainclass->vars['login_antibrute_attemps_cnt'];
			$attemps_time=empty($this->Mainclass->vars['login_antibrute_time']) ? 900 : (int)$this->Mainclass->vars['login_antibrute_time'];
			if($failed_logins)
			{
				usort($failed_logins,array(&$this,'SortFailedLogins'));
				if(isset($failed_logins[$attemps_cnt-1]))
				{
					$last_time=$failed_logins[$attemps_cnt-1][0];
					$last_time=$this->Mainclass->MyTime()-(int)$last_time;
					if($last_time<$attemps_time)
					{
						$this->error='LOCKED_TIME';
						$this->error_exp=sprintf($this->lang['account_locked'],round(($attemps_time-$last_time)/60));
						$this->user=array();
						return false;
					}
				}
			}
		}
		if($this->user['pass_hash']==Strings::PassHash($this->user['pass_salt'],$pass,$already_md))
		{
			if(is_object($this->Plugin) and method_exists($this->Plugin,'AuthByName') and !$this->Plugin->AuthByName($user_name,$pass,$this->user))
			{
				$this->error='INTEGRATION_ERROR';
				$this->error_exp=$this->Plugin->error;
				$this->user=array();
				return false;
			}
			$this->HardAuth($this->user['id'],$this->user['login_keys']);
			$this->error=$this->error_exp='';
			unset($this->user['failed_logins'],$this->user['pass_salt'],$this->user['pass_hash'],$this->user['login_keys']);
			return true;
		}
		else
		{
			if($this->Mainclass->vars['login_antibrute'])
			{
				if(count($failed_logins)>$attemps_cnt)
					array_splice($failed_logins,$attemps_cnt);
				array_unshift($failed_logins,array($this->Mainclass->MyTime(),$this->Mainclass->service,$this->Mainclass->MyGetEnv('HTTP_USER_AGENT'),$this->Mainclass->ip));
				$this->Mainclass->Db->Update('users',array('failed_logins'=>serialize($failed_logins)),'`id`='.$this->user['id'].' LIMIT 1',__file__,__line__);
			}
			$this->error='WRONG_PASS';
			$this->error_exp=$this->lang['wrong_pass'];
			$this->user=array();
			return false;
		}
	}

	/*
		Функция входа по ключу. Вторая и последняя функция входа.
	*/
	public function AuthByKey($id,$key,$check_expire=false)
	{
		if(!Strings::IsMd5($key))
			return false;
		$this->Mainclass->Db->FQuery('SELECT `id`,`forum_id`,`name`,`email`,`group`,`other_group`,`login_keys`,`ip`,`last_visit`,`ban_date`,`ban_explain`,`lang`,`theme`,`avatar_location`,`avatar_size`,`avatar_type`,`editor` FROM {"0"} INNER JOIN {"1"} USING(`id`) WHERE `id`='.(int)$id.' LIMIT 1',array('users','users_extra'),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()==0)
		{
			$this->user=array();
			return false;
		}
		else
		{
			$this->user=$this->Mainclass->Db->Fetch_assoc();
			if(strpos($this->user['login_keys'],$this->Mainclass->service_id.'='.$key.'=')===false)
			{
				$this->user=array();
				return false;
			}
			$login_keys=explode(',',$this->user['login_keys']);

			$service=$lkey=$expire='';
			foreach($login_keys as $akey=>$value)
			{
				list($service,$lkey,$expire)=explode('=',$value,3);
				if($service==$this->Mainclass->service_id and $lkey==$key)
				{
					unset($login_keys[$akey]);
					break;
				}
				$service=$lkey=$expire='';
			}
			$m_time=$this->Mainclass->MyTime();
			if(!$service or ($check_expire and (int)$expire<$m_time and $this->Mainclass->vars['login_session_time']>0))
			{
				$this->user=array();
				return false;
			}
			$this->user['login_key']=$lkey;
			if(is_object($this->Plugin) and method_exists($this->Plugin,'AuthByKey') and !$this->Plugin->AuthByKey($this->user))
				return false;
			#Обновляем данные в БД, только если последний визит был более времени последней сессии.
			if(($m_time-$this->user['last_visit'])>$this->Mainclass->vars['login_session_time'])
			{
				$login_keys[]=$this->Mainclass->service_id.'='.$lkey.'='.($this->Mainclass->vars['login_session_time']+$m_time);
				$this->Mainclass->Db->Update(
												'users',
												array(
														'login_keys'=>join(',',$login_keys),
														'last_visit'=>$m_time,
														'ip'=>$this->Mainclass->ip
												),
												'`id`='.$this->user['id'].' LIMIT 1',
												__file__,
												__line__
				);
			}
			unset($this->user['login_keys'],$this->user['last_visit']);
			return true;
		}
	}

	/*
		Жесткая авторизация, когда пользователь должен просто войти не смотря ни на что.
	*/
	public function HardAuth($id,$login_keys='')
	{
		if(!isset($this->user['id']))
		{
			$this->Mainclass->Db->FQuery('SELECT `id`,`forum_id`,`name`,`email`,`group`,`other_group`,`login_keys`,`ip`,`ban_date`,`ban_explain`,`lang`,`theme`,`avatar_location`,`avatar_size`,`avatar_type` FROM {"0"} INNER JOIN {"1"} USING(`id`) WHERE `id`='.(int)$id.' LIMIT 1',array('users','users_extra'),__file__,__line__);
			if($this->Mainclass->Db->Num_rows()==0)
			{
				$this->user=array();
				return false;
			}
			$this->user=$this->Mainclass->Db->Fetch_assoc();
			$login_keys=$this->user['login_keys'];
		}
		if($login_keys)
		{
			$login_keys=explode(',',$login_keys);
			foreach($login_keys as $k=>$serv)
			{
				$serv=(int)$serv;
				if($serv==$this->Mainclass->service_id or !isset($this->Mainclass->services[$serv]))
					unset($login_keys[$k]);
			}
		}
		else
			$login_keys=array();
		$this->user['login_key']=md5(uniqid($this->user['id']));
		$login_keys[]=$this->Mainclass->service_id.'='.$this->user['login_key'].'='.($this->Mainclass->vars['login_session_time']+$this->Mainclass->MyTime());
		$this->Mainclass->Db->Update(
										'users',
										array(
												'login_keys'=>join(',',$login_keys),
												'last_visit'=>$this->Mainclass->MyTime(),
												'ip'=>$this->Mainclass->ip
										),
										'`id`='.(int)$this->user['id'].' LIMIT 1',
										__file__,
										__line__
		);
		if(isset($this->Plugin) and method_exists($this->Plugin,'HardAuth'))
			$this->Plugin->HardAuth($this->user);
		$this->Mainclass->Db->Delete('sessions','`user_id`=0 AND `ip`=\''.$this->Mainclass->ip.'\'',__file__,__line__);
	}

	public function LogOut($all=true)
	{
		if(isset($this->user['id']) and $all)
		{
			if(is_object($this->Plugin) and method_exists($this->Plugin,'LogOut'))
				$this->Plugin->LogOut($this->user);
			$this->Mainclass->Db->Query('SELECT `login_keys` FROM `prefix_users` WHERE `id`='.$this->user['id'].' LIMIT 1',__file__,__line__);
			if($this->Mainclass->Db->Num_rows()>0)
			{
				$login_keys=$this->Mainclass->Db->Fetch_row();
				$login_keys=explode(',',$login_keys[0]);
				foreach($login_keys as $k=>$logink)
				{
					$logink=(int)$logink;
					if($logink==$this->Mainclass->service_id)
					{
						unset($login_keys[$k]);
						break;
					}
				}
				$this->Mainclass->Db->Update('users',array('login_keys'=>join(',',$login_keys)),'`id`='.$this->user['id'].' LIMIT 1',__file__,__line__);
				$this->Mainclass->Db->Delete('sessions','`user_id`='.$this->user['id'].' AND `service`=\''.$this->Mainclass->service.'\'',__file__,__line__);
			}
		}
		$this->arr_permission=$this->user=$this->u_groups=array();
	}

	/*
		Для защиты от дятлов, было решено сделать переменную $user недоступной из вне. Эта функция читает заданые параметры из переменной.
	*/
	public function GetValue($param,$html_safely=true)
	{
		if(!$this->user)
			return false;
		$pnew=$res=array();
		if(is_array($param))
		{
			foreach($param as &$v)
				if(isset($this->user[$v]))
					$res[$v]=$html_safely ? htmlspecialchars($this->user[$v]) : $this->user[$v];
				else
					$pnew[]=$v;
			if(!$pnew)
				return $res;
		}
		elseif(isset($this->user[$param]))
			return $html_safely ? htmlspecialchars($this->user[$param]) : $this->user[$param];
		else
			$pnew=array($param);
		$this->Mainclass->Db->FQuery('SELECT `'.join('`,`',$pnew).'` FROM {"0"} INNER JOIN {"1"} USING(`id`) WHERE `id`='.$this->user['id'].' LIMIT 1',array('users','users_extra'),__file__,__line__);
		$arr=$this->Mainclass->Db->Fetch_assoc();
		if(is_array($param))
		{
			foreach($arr as $k=>$v)
			{
				$this->user[$k]=$v;
				$res[$k]=$html_safely ? $v : $v;
			}
			return $res;
		}
		else
		{
			$k=key($arr);
			$v=current($arr);
			$this->user[$k]=$v;
			return $html_safely ? htmlspecialchars($this->user[$param]) : $this->user[$param];
		}
	}

	public function GetAvatar($user=false)
	{
		if($user===false)
			$user=&$this->user;
		elseif(!$user)
			return array('avatar'=>'','w'=>'','h'=>'','no'=>true);
		elseif(!is_array($user))
		{
			$this->Mainclass->Db->Query('SELECT `id`,`avatar_location`,`avatar_size`,`avatar_type` FROM `prefix_users_extra` WHERE `id`='.(int)$user.' LIMIT 1',__file__,__line__);
			$user=$this->Mainclass->Db->Fetch_assoc();
		}
		if(empty($user['avatar_location']))
			return array('avatar'=>$this->Mainclass->Template->GetImage($this->Mainclass->vars['noavatar']),'w'=>'auto','h'=>'auto','no'=>true);
		if(strpos($user['avatar_size'],'x')!==false)
		{
			$temp=explode('x',$user['avatar_size'],2);
			$width=$temp[0];
			$height=$temp[1];
		}
		else
			$width=$height='auto';
		switch($user['avatar_type'])
		{
			case 'local':
				$avatar='images/avatars/'.$user['avatar_location'];
			break;
			case 'upload':
				$avatar=Mainclass::UPLOADS_DIR.'/uploaded_avatars/'.$user['avatar_location'];
			break;
			case 'url':
				$avatar=$user['avatar_location'];
				$temp=explode('x',$user['avatar_size'],2);
			break;
			default:
				$avatar='';
			break;
		}
		return array('avatar'=>$avatar,'w'=>$width,'h'=>$height,'no'=>false);
	}

	/*
		А эта функция создана для занесения параметров от "левой" авторизации.
	*/
	public function SetUser($user)
	{
		if($this->user or !ctype_digit($user['id']) or !ctype_digit($user['group']) or !isset($user['name']))
			return false;
		$this->user=$user;
	}

	/*
		Функция проверяет, забанен ли пользователь. И, если забанен - показывает веселую страничку с надписью.
	*/
	public function CheckBanned()
	{
		if(empty($this->user['ban_date']) or $this->Mainclass->service_id==1)
			return;
		if(0>=$ban_time=strtotime($this->user['ban_date'])-$this->Mainclass->MyTime())
			return;
		throw new EE(sprintf($this->lang['banned'],ceil($ban_time/86400),($this->user['ban_explain'] ? $this->user['ban_explain'] : $this->lang['unknown'])),EE::BAN);
	}

	public function Permissions($ids,$param,$table='groups')
	{
		if(!$ids)
			return;
		$perm=&$this->arr_permission[$table];
		if(!is_array($perm))
			$perm=array();
		if(is_array($ids))
		{
			if(count($need_keys=array_diff($ids,array_keys($perm)))>0)
				$query=$this->Mainclass->Db->In($need_keys);
			else
			{
				$result=array();
				foreach($ids as &$v)
					$result[]=$perm[$v][$param];
				return $result;
			}
		}
		elseif(isset($perm[$ids]))
			return $perm[$ids][$param];
		else
			$query='=\''.$ids.'\'';
		$this->Mainclass->Db->Query('SELECT * FROM `prefix_'.$table.'` WHERE `id`'.$query,__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc())
		{
			$mass=array();
			$id=0;
			foreach($arr as $k=>$v)
				if($k=='id')
					$id=$v;
				else
					$mass[$k]=$v;
			if($id!=0)
				$perm[$id]=$mass;
		}
		if(is_array($ids))
		{
			$result=array();
			foreach($ids as $value)
				if(isset($perm[$value]))
					$result[$value]=$perm[$value][$param];
			return $result;
		}
		elseif(isset($perm[$ids]))
			return $perm[$ids][$param];
		else
			return;
	}

	public function GetPermission($str,$hard=false)
	{
		return $this->Permissions($this->GetUserGroups($hard),$str);
	}

	public function GetUserGroups($hard=false)
	{
		if($this->u_groups and !$hard)
			return $this->u_groups;
		$id=isset($this->user['id']) ? $this->user['id'] : 0;
		if($id)
			$arr=array_unique(array_merge(array($this->user['group']),$this->user['other_group'] ? explode(',',trim($this->user['other_group'],',')) : array()));
		elseif($this->is_bot)
			$arr=array($this->Mainclass->vars['bot_group']);
		else
			$arr=array($this->Mainclass->vars['guest_group']);
		return $this->u_groups=$arr;
	}

	public function SelectUserById($id,array $arr=array())
	{
		if($arr)
		{
			$query=array();
			foreach($arr as &$value)
				$query[]='`'.$value.'`';
			$query=join(',',$query);
		}
		else
			$query='*';
		$this->Mainclass->Db->Query('SELECT '.$query.' FROM `prefix_users` INNER JOIN `prefix_users_extra` USING(`id`) WHERE `id`='.(int)$id.' LIMIT 1',__file__,__line__);
		return $this->Mainclass->Db->Fetch_assoc();
	}

	public function GetUserIdByName($name)
	{
		$this->Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `l_name`=LOWER({"1"}) LIMIT 1',array('users','s_'.$name),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()>0)
		{
			list($id)=$this->Mainclass->Db->Fetch_row();
			return $id;
		}
		return false;
	}

	/*
		Функция записывае пользовательскую сессию с данными в базу. Используется для списка "кто онлайн".
	*/
	public function AddSession()
	{static $done=false;
		if($done)
			return;
		$done=true;
		$user_id=isset($this->user['id']) ? $this->user['id'] : 0;
		$enter_time=$this->Mainclass->MyTime();
		$browser=$this->Mainclass->MyGetEnv('HTTP_USER_AGENT');
		if(!$user_id and $this->Mainclass->vars['bots_enable'])
		{
			$name='';
			$bots=explode(',',$this->Mainclass->vars['bots_list']);
			foreach($bots as &$value)
				if(strpos($value,'=')!==false)
				{
					list($uagent,$name)=explode('=',$value,2);
					if(stripos($browser,$uagent)!==false)
					{
						$this->is_bot=$name;
						break;
					}
					$name='';
				}
			unset($bots,$this->Mainclass->vars['bots_list']);
		}
		else
			$name=(string)$this->GetValue('name',false);
		$this->KillSessions();
		$user_array=array(
							array('service',$this->Mainclass->service),
							array('go_from',htmlspecialchars($this->Mainclass->MyGetEnv('HTTP_REFERER'),ENT_QUOTES)),
							array('encodings',$this->Mainclass->MyGetEnv('HTTP_ACCEPT_CHARSET')),
							array('data_type',$this->Mainclass->MyGetEnv('HTTP_ACCEPT_ENCODING')),
		);
		if($this->Mainclass->ip_arr)
		{
			$ips='';
			foreach($this->Mainclass->ip_arr as $k=>&$v)
				$ips.=$k.'='.$v.', ';
			$user_array[]=array('ips',trim($ips,', '));
		}
		$this->Mainclass->Db->Insert(
										'sessions',
										array(
												'user_id'	=>$user_id,
												'enter_time'=>$enter_time,
												'ip'		=>$this->Mainclass->ip,
												'info'		=>serialize($user_array),
												'service'	=>$this->Mainclass->service,
												'browser'	=>htmlspecialchars($browser,ENT_QUOTES),
												'location'	=>htmlspecialchars($this->Mainclass->Url->DecodeParam($this->Mainclass->MyGetEnv('REQUEST_URI'))),
												'name'		=>$name,
												'addon'		=>$this->session_addon,
										),
										__file__,
										__line__
		);
		if(is_object($this->Plugin) and method_exists($this->Plugin,'AddSession'))
			$this->Plugin->AddSession($this->user);
	}
	/*
		Функция удаления старых сессий.
	*/
	public function KillSessions($kill_my=true)
	{
		$where=array();
		if($kill_my)
			$where[]=(isset($this->user['id']) ? '`ip`=\''.$this->Mainclass->ip.'\' AND `user_id`='.$this->user['id'] : '`ip`=\''.$this->Mainclass->ip.'\' AND `user_id`=0').' AND `service`=\''.$this->Mainclass->service.'\' ';
		$where_mass=explode(',',$this->Mainclass->vars['login_time_online']);
		$ttime=$this->Mainclass->MyTime();
		foreach($where_mass as $value)
		{
			$temp=explode('=',$value);
			if($temp[0]!=$this->Mainclass->service)
				continue;
			if(empty($temp[1]))
				$temp[1]=900;
			$temp[1]=$ttime-(int)$temp[1];
			$where[]=' `service`=\''.$temp[0].'\' AND `enter_time`<'.$temp[1].' ';
		}
		$this->Mainclass->Db->Delete('sessions',join('OR',$where),__file__,__line__);
	}

	public function DelCurrSession()
	{
		$this->Mainclass->Db->Delete('sessions', '`ip`=\''.$this->Mainclass->ip.'\' AND `service`=\''.$this->Mainclass->service.'\'',__file__,__line__);
	}

	#Функция проверки, является ли пользователь пользователеме другого сервиса.
	public function IsUserService($id)
	{static $servs=array();
		if(isset($servs[$id]))
			return $servs[$id];
		if(!isset($this->Mainclass->services[$id]))
			return false;
		if($id==$this->Mainclass->service_id)
			return $this->Mainclass->Login->IsUser();
		#Запомним идентификаторы текущего сервиса & логина
		$old_s=$this->Mainclass->service;
		$old_id=$this->Mainclass->service_id;
		$old_perm=$this->arr_permission;
		$old_gr=$this->u_groups;
		$old_u=$this->user;
		#Тепере очистим их
		$this->arr_permission=$this->user=$this->u_groups=array();
		$this->Mainclass->service=$this->Mainclass->services[$id]['name'];
		$this->Mainclass->service_id=$this->Mainclass->services[$id]['id'];
		#Загрузим логин
		$this->Mainclass->LoadLogin($this->Mainclass->services[$id]['login'],'Temp_login');
		$servs[$id]=$this->Mainclass->Temp_login->IsUser();
		unset($this->Mainclass->Temp_login);
		#Восстановим данные.
		$this->Mainclass->service=$old_s;
		$this->Mainclass->service_id=$old_id;
		$this->arr_permission=$old_perm;
		$this->u_groups=$old_gr;
		$this->user=$old_u;
		return $servs[$id];
	}

	public function IsStrongHold()
	{
		if(empty($this->Mainclass->vars['cookie_stronghold']))
			return true;
		if(!isset($this->user['id']))
			return false;
		return $this->GenStrongHold()==$this->Mainclass->GCookie('StrongHold-'.$this->Mainclass->service);
	}

	public function SetStrongHold()
	{
		if(empty($this->Mainclass->vars['cookie_stronghold']) or !isset($this->user['id']))
			return;
		$this->Mainclass->SCookie('StrongHold-'.$this->Mainclass->service, $this->GenStrongHold(),365,true);
	}

	public function GenStrongHold()
	{
		#Вместо MD5 можно использовать другие хеш-функции
		return md5($this->user['id'].ELEANOR_ANKEY.$this->user['login_key'].$this->Mainclass->vars['site_license_key']);
	}

	protected function SortFailedLogins($a,$b)
	{
		$a=(int)$a[0];
		$b=(int)$b[0];
		if($a==$b)
			return 0;
		return $a>$b ? -1 : 1;
	}
}
?>