<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class AccountManagement extends BaseClass
{
	protected
		$user;

	public function __construct(&$user)
	{
		$this->user=&$user;
	}

	public function AddUser($user_name,$pass,array $arr=array(),array $extra=array())
	{
		$this->Mainclass->Account->error=$this->Mainclass->Account->error_exp='';
		$this->Mainclass->LoadOptions(array('reg'),false);
		if(!$user_name or !$pass)
		{
			$this->Mainclass->Account->error='INCORRECT';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['incorrect'];
			return false;
		}
		if($this->IsNameBlocked($user_name))
		{
			$this->Mainclass->Account->error='NICK_BLOCKED';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['nick_blocked'];
			return false;
		}
		if(empty($arr['email']) or !Functions::CheckEmail($arr['email']))
		{
			$this->Mainclass->Account->error='EMAIL_ERROR';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['wrong_email'];
			return false;
		}
		if(!empty($this->Mainclass->vars['user_nick_length']) and mb_strlen($user_name,ELEANOR_CHARSET)>(int)$this->Mainclass->vars['user_nick_length'])
		{
			$this->Mainclass->Account->error='NICK_TOO_LONG';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['nik_too_long'];
			return false;
		}
		if($this->IsEmailBlocked($arr['email']))
		{
			$this->Mainclass->Account->error='EMAIL_BLOCKED';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['email_blocked'];
			return false;
		}
		$this->Mainclass->Db->FQuery('SELECT `l_name` FROM {"0"} WHERE `l_name`=LOWER({"1"}) LIMIT 1',array('users','s_'.$user_name),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()!=0)
		{
			$this->Mainclass->Account->error='NAME_EXISTS';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['user_exists'];
			return false;
		}
		unset($arr['id'],$arr['pass_salt'],$arr['pass_hash'],$arr['name'],$arr['l_name']);
		$arr['name']=$user_name;
		$arr['l_name']=mb_strtolower($user_name,ELEANOR_CHARSET);
		if(empty($arr['pass_salt']))
			$arr['pass_salt']=Strings::GenPass(5);
		$arr['pass_hash']=Strings::PassHash($arr['pass_salt'],$pass);
		if(empty($arr['register']) and empty($arr['!register']))
			$arr['!register']='NOW()';
		if(!isset($arr['group']))
			$arr['group']=2;#Группа пользователей
		if(isset($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'AddUser'))
		{
			$arr['forum_id']=$this->Mainclass->Account->Plugin->AddUser($arr+array('pass'=>$pass),$extra);
			if($arr['forum_id']===false)
			{
				$this->Mainclass->Account->error='INTEGRATION_ERROR';
				$this->Mainclass->Account->error_exp=$this->Mainclass->Account->Plugin->error;
				return false;
			}
		}
		$id=$this->Mainclass->Db->Insert('users',$arr,__file__,__line__);
		$extra['id']=$id;
		$this->Mainclass->Db->Insert('users_extra',$extra,__file__,__line__);
		if(!empty($this->Mainclass->vars['allow_bookmarks']))
			$this->Mainclass->Db->Query('INSERT INTO `prefix_bookmarks` (`uid`,`title`,`href`,`descr`,`imp`) SELECT \''.$id.'\' AS `uid`, `title`, `descr`, `href`, `imp` FROM `prefix_bookmarkspre` LEFT JOIN `prefix_bookmarkspre_l` USING(`id`) WHERE `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') ORDER BY `id` ASC',__file__,__line__);
		return $id;
	}

	public function ChangeName($new_name,$id=0)
	{
		$id=!$id ? $this->user['id'] : (int)$id;
		if(!$new_name)
		{
			$this->Mainclass->Account->error='EMPTY_NAME';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['empty_username'];
			return false;
		}
		$this->Mainclass->Db->FQuery('SELECT `l_name` FROM {"0"} WHERE `l_name`=LOWER({"1"}) AND `id`!='.$id.' LIMIT 1',array('users','s_'.$new_name),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()!=0)
		{
			$this->Mainclass->Account->error='NAME_EXISTS';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['user_exists'];
			return false;
		}
		if($this->IsNameBlocked($new_name))
		{
			$this->Mainclass->Account->error='NICK_BLOCKED';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['nick_blocked'];
			return false;
		}
		if(isset($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'ChangeName'))
		{
			if(isset($this->user['id']) and $this->user['id']==$id)
				$forum_id=$this->user['forum_id'];
			else
			{
				$this->Mainclass->Db->Query('SELECT `forum_id FROM `prefix_users` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				list($forum_id)=$this->Mainclass->Db->Fetch_row();
			}
			if($forum_id and $this->Mainclass->Account->Plugin->ChangeName($forum_id,$new_name)===false)
			{
				$this->Mainclass->Account->error='INTEGRATION_ERROR';
				$this->Mainclass->Account->error_exp=$this->Mainclass->Account->Plugin->error;
				return false;
			}
		}

		$this->Mainclass->Db->Update('users',array('name'=>$new_name,'l_name'=>mb_strtolower($new_name,ELEANOR_CHARSET)),'`id`='.$id.' LIMIT 1',__file__,__line__);
		if(isset($this->user['id']) and $this->user['id']==$id)
		{
			$this->user['name']=$new_name;
			$this->user['l_name']=mb_strtolower($new_name,ELEANOR_CHARSET);
		}
		return true;
	}

	public function UpdateUser(array $arr,$id=0)
	{
		$id=!$id ? $this->user['id'] : (int)$id;
		unset($arr['id'],$arr['pass_salt'],$arr['pass_hash'],$arr['name'],$arr['l_name']);
		if(!$id or !$arr)
			return;
		if(isset($this->user['id']) and $id==$this->user['id'])
			$this->user=$arr+$this->user;
		if(isset($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'UpdateUser'))
		{
			if(isset($this->user['id']) and $this->user['id']==$id)
				$forum_id=$this->user['forum_id'];
			else
			{
				$this->Mainclass->Db->Query('SELECT `forum_id` FROM `prefix_users` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				list($forum_id)=$this->Mainclass->Db->Fetch_row();
			}
			if((int)$forum_id and $this->Mainclass->Account->Plugin->UpdateUser($forum_id,$arr)===false)
			{
				$this->Mainclass->Account->error='INTEGRATION_ERROR';
				$this->Mainclass->Account->error_exp=$this->Mainclass->Account->Plugin->error;
				return false;
			}
		}
		$this->Mainclass->Db->Update('users',$arr,'`id`='.$id.' LIMIT 1',__file__,__line__);
		return true;
	}

	public function UpdateUserExtra(array $arr,$id=0)
	{
		$id=!$id ? $this->user['id'] : (int)$id;
		unset($arr['id']);
		if(!$id or !$arr)
			return;
		if(isset($this->user['id']) and $id==$this->user['id'])
			$this->user=$arr+$this->user;
		if(isset($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'UpdateUserExtra'))
		{
			if(isset($this->user['id']) and $this->user['id']==$id)
				$forum_id=$this->user['forum_id'];
			else
			{
				$this->Mainclass->Db->Query('SELECT `forum_id FROM `prefix_users` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				list($forum_id)=$this->Mainclass->Db->Fetch_row();
			}
			if((int)$forum_id and $this->Mainclass->Account->Plugin->UpdateUserExtra($forum_id,$arr)===false)
			{
				$this->Mainclass->Account->error='INTEGRATION_ERROR';
				$this->Mainclass->Account->error_exp=$this->Mainclass->Account->Plugin->error;
				return false;
			}
		}
		$this->Mainclass->Db->Update('users_extra',$arr,'`id`='.$id.' LIMIT 1',__file__,__line__);
		return true;
	}

	public function DeleteUser($ids)
	{
		$aroot=$this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'uploaded_avatars'.DIRECTORY_SEPARATOR;
		$result=$this->Mainclass->Db->Query('SELECT `id`,`name`,`avatar_location`,`avatar_type` FROM `prefix_users` INNER JOIN `prefix_users_extra` USING(`id`) WHERE `id`'.$this->Mainclass->Db->In($ids).' AND `avatar_type`=\'upload\'',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
		{
			$avatar=$aroot.$arr['avatar_location'];
			if(file_exists($avatar))
				@unlink($avatar);
		}
		if(isset($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'DeleteUser'))
		{
			$forum_ids=array();
			$this->Mainclass->Db->Query('SELECT `forum_id` FROM `prefix_users` WHERE `id`'.$this->Mainclass->Db->In($ids).' LIMIT 1',__file__,__line__);
			while($t=$this->Mainclass->Db->Fetch_assoc())
				$forum_ids[]=$t['forum_id'];;
			if($forum_ids)
				$this->Mainclass->Account->Plugin->DeleteUser($forum_ids);
		}
		#Комментарии помечаем как пользовательские.
		$this->Mainclass->LoadOptions('comments',false);
		$this->Mainclass->Db->FQuery('UPDATE {"0"} `c`,{"1"} `u` SET `c`.`name`=CONCAT({"2"},`u`.`name`) WHERE `c`.`uid`=`u`.`id` AND `u`.`id`'.$this->Mainclass->Db->In($ids),array('comments','users','s_'.$this->Mainclass->vars['comments_anonimus']),__file__,__line__);
		#Удаляем закладки
		$this->Mainclass->Db->Delete('bookmarks','`uid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
		#Удаляем экстру
		$this->Mainclass->Db->Delete('users_extra','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
		#Удаляем пользователей
		$q=$this->Mainclass->Db->Delete('users','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
		return $q;
	}

	public function MatchPass($pass,$id=0)
	{
		$id=!$id ? $this->user['id'] : (int)$id;
		$arr=$id==$this->user['id'] ? $this->Mainclass->Account->GetValue(array('pass_salt','pass_hash')) : $this->Mainclass->Account->SelectUserById($id,array('pass_salt','pass_hash'));
		if(!$arr)
			return false;
		return $arr['pass_hash']==Strings::PassHash($arr['pass_salt'],$pass);
	}

	public function ChangePass($pass,$id=0)
	{
		if($pass=='')
		{
			$this->Mainclass->Account->error='EMPTY_PASS';
			$this->Mainclass->Account->error_exp=$this->Mainclass->Account->lang['empty_pass'];
			return false;
		}
		if($id)
		{
			if(is_object($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'ChangePass'))
			{
				$user=$this->Mainclass->Account->SelectUserById($id,array('id','forum_id','name','email'));
				$this->Mainclass->Account->Plugin->ChangePass($user,$pass);
			}
		}
		else
		{
			$id=$this->user['id'];
			if(is_object($this->Mainclass->Account->Plugin) and method_exists($this->Mainclass->Account->Plugin,'ChangePass'))
				$this->Mainclass->Account->Plugin->ChangePass($this->user,$pass);
		}
		$salt=Strings::GenPass(5);
		$hash=Strings::PassHash($salt,$pass);
		$this->Mainclass->Db->Update(
										'users',
										array(
												'pass_salt'=>$salt,
												'pass_hash'=>$hash
										),
										'`id`='.$id.' LIMIT 1'
										,__file__
										,__line__
		);
		return true;
	}

	public function IsNameBlocked($name)
	{
		if(!empty($this->Mainclass->vars['blocked_nicks']))
		{
			$blocked=explode(',',strtolower(Strings::CleanForExplode($this->Mainclass->vars['blocked_nicks'],',')));
			foreach($blocked as $v)
			{
				$v=trim($v);
				if($v and Strings::MatchMask($v,$name))
					return true;
			}
		}
		return false;
	}

	public function IsEmailBlocked($email)
	{
		if(!empty($this->Mainclass->vars['blocked_emails']))
		{
			$blocked=explode(',',strtolower(Strings::CleanForExplode($this->Mainclass->vars['blocked_emails'])));
			foreach($blocked as $v)
				if(Strings::MatchMask($v,strtolower($email)))
					return true;
		}
		return false;
	}

}
?>