<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
error_reporting(E_ALL^E_NOTICE);
@set_magic_quotes_runtime(0);
set_error_handler('EleanorErrorHandle');
set_exception_handler('EleanorExceptionHandle');
function EleanorErrorHandle($num,$str,$file,$line)
{
	if(Mainclass::getInstance()->no_log or $num==E_STRICT)
		return;
	$arr_errors=array(
						E_ERROR=>'Error',
						E_WARNING=>'Warning',
						E_NOTICE=>'Notice'
	);
	$E=new EE((isset($arr_errors[$num]) ? $arr_errors[$num] : $num).': '.$str,EE::DEV,array('file'=>$file,'line'=>$line));
}

function EleanorExceptionHandle($e)
{
	if($e instanceof EE)
	{
		if(isset($e->uncatched['call']) and is_callable($e->uncatched['call']))
			call_user_func($e->uncatched['call'],$e);
		if($e->uncatched['log'])
			$e->LogIt($e->uncatched['lfile'],$e->getMessage(),$e->getFile(),$e->getLine());
		if($e->uncatched['mess'])
			EE::ShowDie($e->uncatched['mess']);
	}
	else
	{
		$E=new EE('',EE::INFO);
		$E->LogIt(Mainclass::getInstance()->vars['exceptions_log_file'],'Exception: '.$e->getMessage(),$e->getFile(),$e->getLine());
	}
}

function __autoload($c_name)
{
	$Mainclass=Mainclass::getInstance();
	if($Mainclass->no_autoload)
		return;
	$c_name=strtolower($c_name);
	if(file_exists($Mainclass->root_path.'classes/others/class_'.$c_name.'.php'))
		require $Mainclass->root_path.'classes/others/class_'.$c_name.'.php';
	elseif(class_exists('EE',false))
		throw new EE('Unable to load file '.$c_name,EE::FATAL);
	else
		trigger_error('Unable to load file '.$c_name,E_USER_ERROR);
}

abstract class BaseClass
{
	public static function __callStatic($name,$params)
	{
		$E=new EE('Called undefined method '.get_class().' :: '.$name,EE::DEV);
		return null;
	}
	function __call($name,$params)
	{
		$E=new EE('Called undefined method '.get_class($this).' -› '.$name,EE::DEV);
		return null;
	}
	function __toString()
	{
		$E=new EE('Trying to get string form class '.get_class($this),EE::DEV);
		return '';
	}
	function __invoke()
	{
		return null;
	}
	function __get($name)
	{
		if($name=='Mainclass')
			return $this->Mainclass=Mainclass::getInstance();
		$E=new EE('Trying to get value from the unknown variable <code><b>'.get_class($this).' -› '.$name.'</b></code>');
		return null;
	}
}

final class FilterArrays implements ArrayAccess
{
	private
		$varname;
	function __construct($varname)
	{
		$this->varname=$varname;
	}
	public function offsetSet($property,$value)
	{
		global ${$this->varname};
		${$this->varname}[$property]=$value;
	}

	public function offsetExists($property)
	{
		global ${$this->varname};
		return isset(${$this->varname}[$property]);
	}

	public function offsetUnset($property)
	{
		global ${$this->varname};
		unset($this->varname['property']);
	}

	public function offsetGet($property)
	{
		global ${$this->varname};
		return isset(${$this->varname}[$property]) ? $this->Filter(${$this->varname}[$property]) : null;
	}

	public static function Filter($value)
	{
		if(is_array($value))
		{
			$result=array();
			foreach($value as $k=>&$v)
				$result[$k]=self::Filter($v);
			return $result;
		}
		$value=htmlspecialchars($value,ENT_QUOTES);
		$from=$to=array();
		$from[]='/&amp;#([0-9]+);/si';
		$to[]='&#\1;';
		$from[]='/&#(\d+?)([^\d;])/';
		$to[]='&#\1;\2';
		$from[]='/&amp;(?:amp;)+/i';
		$to[]='&amp;';
		$value=preg_replace($from,$to,$value);
		return trim($value);
	}
}

class Mainclass extends BaseClass
{
	const
		UPLOADS_DIR='uploads';#Папка, где хранятся загружаемые файлы
	public
		$do_gzip_compress=null,#ЗЧ. Состояние GZIP сжатия. По-умолчанию определяется сам.
		$debug_arr=array(),#Сюда складируются данные отладки
		$content_type='text/html',
		$domain='',#Ч Домен, с которого мы загрузились.
		$site_path='',#Ч. Каталог сайта
		$error_callback='',#Функция ошибки, которая будет вызываться ВМЕСТО стандартной.
		$file_name='',#З. Название файла-сервиса, запускающего весь движок. Используется чаще всего для генерирования УРЛов, но не на прямую.
		$service,#З. Имя сервиса
		$service_id,#З. Ид сервиса (из БД берется).
		$decor_gen=false,#Ч. Флаг генерации оформления
		$lang=array(),#Массив с языковыми параметрами
		$lang_name='',#Иногда бывает, что нам "срать" на глобальные насройки и мы хотим жестко использовать этот язык.
		$get_lang,#Язык, полученный из строки запроса
		$module=array(),#З (файлом сервиса) и Ч (модулями и всем остальным). Массив, определяющий характеристики модуля.
		$module_gfc='',#З Функция, которая будет вызываться при запросе данных модуля
		$module_sfc='',#З Функция, которая будет вызываться при установке данных модуля
		$start_time,#З. Начало генерации страницы
		$vars=array(),#Переменные, взятые из конфига.
		$ip,#Ч. Адрес, откуда мы загрузились
		$ip_arr,#Ч. Массив со всеми айпишниками, присланными нам от пользователя.
		$on_begin_callback='',#З. Пользовательская функция, которая выполниться перед генерацией оформления.
		$on_end_callback='',#З. Пользовательская функция, которая выполниться после генерацией оформления.
		$root_path,#Ч. Путь для инклуда файлов. Берется из конструктора
		$decoration,#"Тело" оформления.
		$services=array(),#Данные всех сервисов
		$os='',#Тип системы, на которой стоит сайт u - *nix, w - windows
		$done=false,#Флаг, чтобы функция ShowDecoration() вызывалась только 1 раз
		$no_log=false,#Не логировать ошибки
		$no_autoload=false;#Выключить автолоад?
	private
		$decor_mainfile='';#Файл главной страницы
	private static
		$Instance;

	public static function getInstance($init_other_classes=true,$classes=array())
	{
		if(!isset(self::$Instance))
		{
			static $process=false;
			if($process)
				return false;
			$process=true;
			self::$Instance=new self($init_other_classes,$classes);
			if(isset(self::$Instance->Cache))
				self::$Instance->Cache->Init();
			if(isset(self::$Instance->Db))
			{
				self::$Instance->Db->Connect();
				self::$Instance->Db->Query('SELECT `id`,`name`,`file`,`theme`,`login` FROM `prefix_services`',__file__,__line__);
				while ($arr=self::$Instance->Db->Fetch_assoc())
					self::$Instance->services[$arr['id']]=$arr;
			}
		}
		return self::$Instance;
	}

	/*
		Кнструктор класса
		$init_other_classes [bool] - автоматическая загрузка остальные классы
		$classes [array] - если $init_other_classes=false, то в этом массиве содержатся имена
						классов (без префикса "class_"), которые следует загрузить, если же
						$init_other_classes=true, то тут содежаться имена классов, которые
						НЕ будут загружены.
	*/
	private function __construct($init_other_classes,$classes)
	{
		$this->root_path=dirname(dirname(__file__)).DIRECTORY_SEPARATOR;
		chdir($this->root_path);
		$this->IPDetect();
		$this->domain=$this->MyGetEnv('HTTP_HOST');
		$this->site_path=rtrim(dirname($this->MyGetEnv('PHP_SELF')),'/\\');
		define('SC',true);
		if(!defined('INSTALL'))
		{
			include $this->root_path.'config_general.php';
			mb_internal_encoding(ELEANOR_CHARSET);
			#А мы-то собственно, установлены или нет?
			if(!isset($general))
			{
				$location='http://'.$this->domain.$this->site_path.'/install/index.php';
				header('location: '.$location);
				die('System not installed! Redirecting to '.$location.' ...');
			}
			else
				foreach($general as $akey=>$value)
					if(!isset($this->$akey))
						$this->$akey=$value;
		}
		if(get_magic_quotes_gpc())
		{
			$func=create_function('&$v','if(is_string($v))$v=stripslashes($v);');
			array_walk_recursive($_GET,$func);
			array_walk_recursive($_POST,$func);
			array_walk_recursive($_COOKIE,$func);
		}
		if(ini_get('register_globals'))
		{
			foreach($_GET as $key=>&$value)
			{
				global $$key;
				unset($$key);
			}
			foreach($_POST as $key=>&$value)
			{
				global $$key;
				unset($$key);
			}
			foreach($_COOKIE as $key=>&$value)
			{
				global $$key;
				unset($$key);
			}
		}
		$this->POST=$_SERVER['REQUEST_METHOD']=='POST' ? new FilterArrays('_POST') : array();
		$farr=glob($this->root_path.'classes/class_*.php');
		foreach($farr as &$v)
		{
			preg_match('%class_(.+)\.php$%',$v,$m);
			if($classes and !($init_other_classes xor in_array($m[1],$classes)))
				continue;
			unset($not_create);
			if(!class_exists($m[1],false))
				require $v;
			if(isset($not_create))
				continue;
			$m[1]=ucfirst($m[1]);
			$this->$m[1]=new $m[1]($this);
		}
		$this->lang_name=ELEANOR_DEFAULT_LANGUAGE;
		$this->LoadLanguage('langs','main','main-%');
		$this->os=stripos(PHP_OS,'win')===0 ? 'w' : 'u';
	}

	/*
		Функция - загручик серсива. Загружает все необходимые данные + делает автозагрузку модулей.
	*/
	public function LoadService()
	{
		if($this->service_id)
			$arr=isset($this->services[$this->service_id]) ? $this->services[$this->service_id] : false;
		elseif($this->service)
		{
			$arr=false;
			foreach($this->services as &$v)
				if($v['name']==$this->service)
				{
					$arr=$v;
					break;
				}
		}
		else
			throw new EE('Unable to load service!');
		if($arr===false)
			throw new EE('The requested service is not in the database!');
		$this->service=$arr['name'];
		$this->service_id=$arr['id'];
		$this->Template->theme=$arr['theme'];
		if($arr['file']!=$this->file_name and $this->file_name)
			$this->Db->Update('services',array('file'=>$this->file_name),'`id`=\''.$arr['id'].'\'');
		elseif($this->file_name)
			$this->file_name=$arr['file'];
		if($arr['login'])
			$this->LoadLogin($arr['login']);
		$this->ModulesWalk();
	}

	/*
		Загрузка необходимых настроек
		$arr - перечень настроек (ключевое слово группы), которые мы должны загрузить.
		$return - признак того, что полученные настройки нужно возвратить а не внести в общий массив $Mainclass->vars

		return NULL || array
	*/
	public function LoadOptions($arr=array(),$return=false)
	{static $already=array(),
			$ba=false;
		if(!$arr)
			$arr=array('system','blocker','login','uncacheble_options');
		elseif(!is_array($arr))
			$arr=array((string)$arr);
		if($return)
		{
			$ret=array();
			$this->Cache->LoadOptions($arr,$ret);
			return $ret;
		}
		else
		{
			$arr=array_diff($arr,$already);
			if($arr)
			{
				$this->Cache->LoadOptions($arr,$this->vars);
				$already+=$arr;
			}
		}
		if($ba)
			return;
		$ba=true;
		if(isset($this->Url) and $this->Url->string=='-G-E-T-S-I-T-E-H-A-S-H-' and isset($this->vars['site_license_key']))
			die($this->vars['site_license_key'] ? hash('sha512') : 'no');
		if(isset($this->vars['locale']))
		{
			setlocale(LC_TIME,$this->vars['locale']);
			setlocale(LC_COLLATE,$this->vars['locale']);
			setlocale(LC_CTYPE,$this->vars['locale']);
		}
		if(isset($this->vars['time_zone']))
			date_default_timezone_set($this->vars['time_zone']);
		$this->do_gzip_compress=$this->vars['gzip'];
		if($this->vars['cookie_domain'])
			$this->vars['cookie_domain']=str_replace('*',preg_replace('#^www\.#i','',$this->domain),$this->vars['cookie_domain']);
		if($this->vars['site_hard_domain'] and $this->vars['site_domain'])
			$this->domain=$this->vars['site_domain'];
		#Заплатка для браузеров FF & IE, когда они не хотят воспринимать куки с доменов первого уровня аля localhost
		if(strpos($this->domain,'.')===false)
			$this->vars['cookie_domain']='';
		if($this->service_id==1 or !$this->vars['blocked_ips'])
			return;
		$ips=explode("\n",str_replace("\r",'',$this->vars['blocked_ips']));
		foreach($ips as &$b_ip)
		{
			if(strpos($b_ip,'=')!==false)
			{
				$message=substr($b_ip,strpos($b_ip,'=')+1);
				$b_ip=substr($b_ip,0,strpos($b_ip,'='));
			}
			else
				$message=$this->vars['blocked_message'];
			foreach($this->ip_arr as &$ip)
				if(Functions::IPMatchMask($ip,$b_ip))
					throw new EE($message,EE::BAN);
		}
	}

	public function SendHeaders($charset=ELEANOR_DISPLAYCHARSET)
	{
		if(headers_sent())
			return;
		header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		header('Last-Modified: '.date('r',$this->MyTime()-3600));
		header('Cache-Control: no-store, no-cache, must-revalidate');#HTTP/1.1
		header('Cache-Control: post-check=0, pre-check=0',false);
		header('Pragma: no-cache');#HTTP/1.0
		header('Content-Type: '.$this->content_type.'; charset='.$charset);
		header('Content-Encoding: '.($this->do_gzip_compress ? 'gzip' : 'none'));
	}

	/*
		Функция оформляет веб-страницу (шапка, верх, низ) с учетом вывода модуля.
		Как правило эту функцию вызывают в модулях перед вывоводом на экран.
		Параметр $now: - генерировать оформление ДО вывода на экран.
	*/
	public function ShowDecoration($now=true,$dec_file='index',$unique='')
	{
		if($this->done)
			return;
		if($this->do_gzip_compress===null)
			$this->do_gzip_compress=true;
		$this->do_gzip_compress=($this->do_gzip_compress and strpos($this->MyGetEnv('HTTP_ACCEPT_ENCODING'), 'gzip')!==false and extension_loaded('zlib'));
		if(is_callable($this->on_begin_callback))
			@call_user_func($this->on_begin_callback);
		if(!$dec_file)
		{
			$this->decor_gen=true;
			$this->decoration='{module}';
		}
		elseif($now)
		{
			$this->decoration=$this->Template->GetThemeFile($dec_file,array(),($this->GetModVal('general') and $unique=='') ? 'mainpage' : $unique,false);
			$this->decor_gen=true;
			$this->decoration=$this->Blocks->AddBlocks($this->decoration);
			$this->decoration=$this->Template->StaticReplace($this->decoration);
		}
		else
			$this->decor_mainfile=array($dec_file,$unique);
		#Вызовем вывод хедеров тут. Почему? Чтобы в случае необходимости модуль смог их заменить.
		$this->SendHeaders();
		ob_start();
		$this->done=true;
	}

	public function FinalPage($content,$status='')
	{
		$ds='';
		if($this->debug and $this->debug_arr)
			foreach($this->debug_arr as $v)
			{
				$v['l']=isset($v['l']) ? '['.$v['l'].']' : '';
				if(!isset($v['f']))
				{
					$v['f']=$this->lang['main']['unknown'];
					$v['l']='';
				}
				$ds.='<div class="debug"><b>'.$v['t'].'</b> - <span title="'.$v['f'].$v['l'].'">'.$v['e'].'</span></div>';
			}
		$content=str_replace(
								array(
										'{module}',
										'{page status}',
										'{debug}',
								),
								array(
										$content,
										$status,
										$ds
								),
								$this->decoration
		);
		if($this->do_gzip_compress)
		{
			$gzip_size=strlen($content);
			$gzip_crc=crc32($content);
			$content=gzcompress($content,$this->vars['gzip_level'] ? (int)$this->vars['gzip_level'] : 4);
			$content=substr($content,0,-4);
			$res ="\x1f\x8b\x08\x00\x00\x00\x00\x00";
			$res.=$content;
			$res.=pack('V',$gzip_crc);
			$res.=pack('V',$gzip_size);
			return $res;
		}
		else
			return $content;
	}

	public function LoadClass($path,$obj_name='',$class_name='',$nfile='',$nline='')
	{
		if(!$class_name)
		{
			$class_name=basename($path);
			$class_name=substr($class_name,0,strrpos($class_name,'.'));
			$class_name=ucfirst(str_ireplace('class_','',$class_name));
		}
		if(!$obj_name)
			$obj_name=$class_name;
		if(isset($this->$obj_name))
			if($this->$obj_name instanceof $class_name)
				return $this->$obj_name;
			else
				unset($this->$class_name);
		if(class_exists($class_name,false) or include($this->root_path.$path))
			return $this->$obj_name=new $class_name($this);
		else
			throw new EE('Can not find file <b>'.$path.'</b>. '.((!$nfile and !$nline) ? '' : 'Request from <b>'.$nfile.'<b>['.$nline.']'));
	}

	/*
		Функция загружает метод авторизации.
		Метод авторизации берется из папки classes/login/class_login_*.php (значение * нужно указывать в $name)
	*/
	public function LoadLogin($name,$login_name='Login',$class_name='')
	{
		if(!file_exists($this->root_path.'classes/login/class_login_'.$name.'.php'))
			throw new EE('Authorization <b>classes/login/class_login_'.$name.'.php</b> not found!');
		if(!isset($this->Account))
			$this->LoadClass('classes/login/class_account.php');
		#if(isset($this->$login_name) and is_object($this->$login_name) and $this->$login_name instanceof LoginClass and !($this->$login_name instanceof $class_name))
		#	throw new EE('Authorization <b>$Mainclass->'.$login_name.'.php</b> already exists!');
		if(!$class_name)
			$class_name=ucfirst($name);
		if(!class_exists($name,false))
			require $this->root_path.'classes/login/class_login_'.$name.'.php';
		if(!isset($this->$login_name) or !($this->$login_name instanceof $name))
			$this->$login_name=new $class_name($this);
		$this->LoadClass('classes/others/class_permission.php');
	}

	#Всякие служебные функции
	public function CheckSlash($path,$sl='/')
	{
		if($path)
		{
			if(substr($path,-1)!=$sl)
				$path.=$sl;
		}
		else
			$path=$sl;
		return $path;
	}
	/*
		$path - путь, который не может быть полностью серверным. Если он начинается с / - это означает, что к нему нужно прибавить root_path.
		$current_path - папка, которая может содержать либо полный серверный путь, либо быть пустой.
	*/
	public function FormatPath($path,$current_path='')
	{
		if(strpos($path,'/')===0 or !$current_path)
			return $this->root_path.ltrim($path,'/');
		else
			return (($this->os=='u' and strpos($current_path,'/')===0 or strpos($current_path,':')==1) ? '' : $this->root_path)
			.$this->CheckSlash($current_path,DIRECTORY_SEPARATOR).ltrim($path,'/\\');
	}

	public function SCookie($name,$value='',$t=0,$safe_cookie=false)
	{
		if($t==0)
			$t=isset($this->vars['cookie_save_time']) ? $this->vars['cookie_save_time'].'s' : 360;
		if(ctype_digit((string)$t))
			$expire=$t*86400;
		else
		{
			$a=strtolower(substr($t,-1));
			switch($a)
			{
				case 's':
					$expire=substr($t,0,-1);
				break;
				case 'm':
					$expire=substr($t,0,-1)*60;
				break;
				case 'h':
					$expire=substr($t,0,-1)*3600;
				break;
				default:
					return false;
			}
		}
		$expire+=$this->MyTime();
		$cookie_prefix=$this->vars['cookie_prefix'];
		$cookie_domain=$this->vars['cookie_domain'] ? $this->vars['cookie_domain'] : '';
		$cookie_path=$this->vars['cookie_path'] ? $this->vars['cookie_path'] : '';
		#Заплатка для PHP ниже 5.2.0
		$no_log=$this->no_log;
		$this->no_log=true;
		if(!$res=setcookie($cookie_prefix.$name,$value,$expire,$cookie_path,$cookie_domain,false,$safe_cookie))
			$res=setcookie($cookie_prefix.$name,$value,$expire,$cookie_path);
		$this->no_log=$no_log;
		return $res;
	}

	public function GCookie($name)
	{
		$cn=isset($this->vars['cookie_prefix']) ? $this->vars['cookie_prefix'] : '';
		$cn.=$name;
		return isset($_COOKIE[$cn]) ? $_COOKIE[$cn] : false;
	}

	public function MyTime()
	{
		return time()+(int)$this->vars['time_correction'];
	}

	public function MyGetEnv($name)
	{
		return isset($_SERVER[$name]) ? $_SERVER[$name] : getenv($name);
	}

	/*
		Функция загружает нужный язык.
		Структура языкового файла должна быть вида. Иногда допускаются define-ы.
		<?php
		$lang['param1']='value1';
		...
		$lang['param2']='value2';
		?>

		$global_name - если задано, то результат поместиться в общий массив языковых значений. Нет - функция вернет массив
		$file_name - имя файла, где вместо % система подставит языковое значение.
	*/
	public function LoadLanguage($path,$global_name='',$file_name='lang-%')
	{
		$path=$this->FormatPath('',$path);
		if(strpos($file_name,'.')===false)
			$file_name.='.php';
		$file_n=str_replace('%',$this->lang_name ? $this->lang_name : ELEANOR_DEFAULT_LANGUAGE,$file_name);
		do
		{
			if(file_exists($path.DIRECTORY_SEPARATOR.$file_n))
				break;
			$file_n=str_replace('%',ELEANOR_DEFAULT_LANGUAGE,$file_name);
			if(file_exists($path.DIRECTORY_SEPARATOR.$file_n))
				break;
			$file_n=str_replace('%','russian',$file_name);
			if(file_exists($path.DIRECTORY_SEPARATOR.$file_n))
				break;
			return false;
		}while(false);
		$lang=array();
		$Mainclass=&$this;
		require $path.DIRECTORY_SEPARATOR.$file_n;
		if(!$global_name)
			return $lang;
		else
			$this->lang[$global_name]=(isset($this->lang[$global_name]) and is_array($this->lang[$global_name])) ? $lang+$this->lang[$global_name] : $lang;
	}

#Набор функций, связанных с работой модульной системы
	/*
		Функция читает значение из массива служебных данных модуля - $module.
		$param - параметр, который надо прочитать.
		$hope_value - значение или значения (массивом) на которое "надеяться". В этом случае функция вернет true или false.

		Кроме этого, в экзотических случаях "модуль в модуле" существует возможность самостоетельно задать функцию обрабатывающую входящие данные.
		Будетье внимательно, потому что $hope_value может быть массивом.
	*/
	public function GetModVal($param,$hope_value=null)
	{
		if(is_callable($this->module_gfc))
			return call_user_func($this->module_gfc,$param,$hope_value);
		else
		{
			if($hope_value===null)
				return isset($this->module[$param]) ? $this->module[$param] : false;
			elseif(is_array($hope_value))
				return (isset($this->module[$param]) and in_array($this->module[$param],$hope_value));
			else
				return (isset($this->module[$param]) and $this->module[$param]==$hope_value);
		}
	}

	/*
		Функция устанавливает переменные-данные модуля. Из распространенных переменных, сейчас доступно:
	*/
	public function SetModVal($param, $value)
	{
		if(is_callable($this->module_sfc))
			call_user_func($this->module_sfc,$param,$value);
		else
			$this->module[$param]=$value;
	}

	/*
		Функция загружает модуль.
	*/
	public function LoadModule($path,$use_service=true,$load_file='index',$useclass=false)
	{
		$path=$this->root_path.$this->CheckSlash($path);
		if($use_service)
			$path.=$this->service.DIRECTORY_SEPARATOR;
		if(strpos($load_file,'.')===false)
			$load_file.='.php';
		$path.=$load_file;
		$Mainclass=&$this;
		if(!$result=file_exists($path) ? include $path : false or !$useclass)
			return $result;
		else
		{
			if(!isset($class_name))
				$class_name=$this->GetModVal('name');
			if(!class_exists($class_name,false))
				return false;
			$Obj=new $class_name($this);
			echo $Obj->OutPut();
		}
	}

	public function ModulesWalk($field='load')
	{
		if(!$this->vars['modules_autoload'])
			return;
		$this->Db->FQuery('SELECT `path`, `plugins` FROM {"0"} WHERE `pos_'.$field.'`>0 AND `plugins`!="" AND `services` LIKE "%,'.$this->service_id.',%" ORDER BY `pos_'.$field.'` ASC',array('modules'),__file__,__line__);
		while($arr=$this->Db->Fetch_row())
		{
			$file=$this->FormatPath($arr[1],$arr[0]);
			if(!include($file))
				continue;
			#В PHP 5.3.0 можно будет написать if(in_array('auto'.$field,$class_name::$abilities))
			if(in_array('auto'.$field,eval('return '.$class_name.'::$abilities;')))
			{
				$Plug=new $class_name($this);
				$Plug->{'DoAuto'.$field}();
				unset($Plug);
			}
		}
	}

#Набор функций, связанных с баном и определением IP адреса.
	public function IPDetect()
	{
		$server_vars=array(
							'HTTP_X_FORWARDED_FOR',
							'HTTP_X_FORWARDED',
							'HTTP_FORWARDED_FOR',
							'HTTP_FORWARDED',
							'HTTP_VIA',
							'HTTP_X_COMING_FROM',
							'HTTP_COMING_FROM',
							'HTTP_CLIENT_IP',
							'HTTP_X_CLUSTER_CLIENT_IP',
							'HTTP_PROXY_USER',
							'HTTP_XROXY_CONNECTION',
							'HTTP_PROXY_CONNECTION',
							'HTTP_USERAGENT_VIA'
		);
		$this->ip=$this->MyGetEnv('REMOTE_ADDR');
		$ip_arr=array();
		foreach($server_vars as &$server_var)
		{
			$proxy_ip=$this->MyGetEnv($server_var);
			if(!$proxy_ip and isset($_ENV[$server_var]))
				$proxy_ip=$_ENV[$server_var];
			if($proxy_ip!=$this->ip and $proxy_ip)
				$ip_arr[$server_var]=$proxy_ip;
		}
		$this->ip_arr=array_unique($ip_arr);
	}

#Конец набора функция связанных с IP адресом.
	function __destruct()
	{
		if(!$this->done)
			return;
		$zzz_='<a '.'hre'.'f="ht'.'tp:'.'//el'.'ean'.'or-'.'cm'.'s.';
		if(!$this->decor_gen)
		{
			$this->decoration=$this->Template->GetThemeFile($this->decor_mainfile[0],array(),$this->GetModVal('general') ? 'mainpage' : $this->decor_mainfile[1]);
			$this->decoration=$this->Blocks->AddBlocks($this->decoration);
			$this->decoration=$this->Template->StaticReplace($this->decoration);
		}
		$zzz_.='ru/" sty'.'le="text'.'-decoration'.':none" target';
		$this->ModulesWalk('unload');
		$zzz_do=md5(ELEANOR_VERSION.ELEANOR_ANKEY).$this->vars["s".'it'.'e'.'_'."do".'main'];
		$zzz_.='="_blank">CM'
		.'S Elea';
		if($this->vars['show_status']==2 or ($this->vars['show_status']==1 and isset($this->Login) and $this->Permission->IsAdmin()))
			$status=sprintf(
							$this->lang['main']['page_status'],
							round(array_sum(explode(' ',microtime()))-array_sum(explode(' ', $this->start_time)),3),
							(int)$this->Db->count_q,
							$this->do_gzip_compress ? $this->lang['main']['g_zip_on'].'.' : ''
			);
		else
			$status='';
		if($this->{'ser'.'vice_'.'id'}!=(3-2) and $this->vars["s".'it'.'e'.'_'."li".'cen'."se_".'key'] and $this->vars["s".'it'.'e'.'_'."li".'cen'."se_".'key']!=md5($zzz_do))
			ob_clean();
		$zzz_.='nor</a> © 2';
		if($this->service_id<3 and $this->vars['si'.'te'."_co"
		."pyri".'ghts'."_re"
		.'move']==md5($zzz_do.'_co'.'py') and strpos($this->{ "de".'cor'
		.'ati'."on"},$zzz_)===false and isset($this->{ "de".'cor'
		.'ati'."on"}[50]))
			ob_clean();
		$content=ob_get_contents();
		ob_end_clean();
		if(is_callable($this->on_end_callback))
			$content=call_user_func($this->on_end_callback,$content);
		echo $this->FinalPage($content,$status);
	}

	public function Mail($to,$message,$addon=array())
	{
		$this->LoadOptions('mailer');
		if(!isset($this->Email))
			$this->LoadClass('classes/others/class_email.php','','',__file__,__line__);
		$this->Email->to=$to;
		$this->Email->message=$message;
		foreach($addon as $k=>$v)
			$this->Email->$k=$v;
		$this->Email->Send();
	}

	public function StartSession($name='',$id='',$config=true)
	{
		if(isset($_SESSION))
			session_write_close();
		if($config)
			$this->ConfigSession();
		if($name)
			session_name(preg_replace('#[^a-z0-9\-]+#i','',$name));
		if($id)
			session_id(preg_replace('#[^a-z0-9\-]+#i','',$id));
		session_start();
	}

	public function ConfigSession($cookie=false,$links=false)
	{
		ini_set('session.use_cookies',$cookie ? '1' : '0');
		ini_set('session.use_trans_sid',$links ? '1' : '0');
	}
}
?>