<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='AddonFields';
if(!class_exists($class_name,false))
{
	class AddonFields extends BaseClass
	{
		public
			$table,#Таблица, в которой размещаются доп. поля
			$module_id,
			$unique='',
			$cache_ttl=7200,#Время в секундах, после которого кеш дополнительных полей устареет
			$post_name='addon_field',#Имя массива инпутов полей, которые будут выведены на странице.
			$lang=array();
		protected
			$navigation,
			$title;

		function __construct($Mainclass)
		{
			$this->lang=$Mainclass->LoadLanguage('langs','','addon_fields-%.php');
		}

		/*
			Функция получения данных полей для их редактирования.
			$saved - сохраненная строка
			$postvalues - означает, что значения полей нужно взять из POST запроса.
			Возвращает результат в виде
			array(
					array(
							'title'=>'Название',
							'descr'=>'Описание',
							'code'=>'Код, который должен быть вставлен на страницу'
							'req'=>true || false
							'tags'=>'теги'
					),...
			);
		*/
		public function FillFields($saved,$postvalues=false)
		{
			$this->Init();
			$result=array();
			$dump=$this->GetDump();
			if(!$postvalues)
			{
				$saved=$saved ? unserialize($saved) : array();
				if(!is_array($saved))
					$saved=array();
			}
			foreach($dump as &$input)
			{
				$error='';
				$param=array('title'=>$input['title'],'descr'=>$input['descr'],'tags'=>$input['tags'],'req'=>$input['req']);
				if($postvalues)
					$value=isset($_POST[$this->post_name][$input['name']]) ? $_POST[$this->post_name][$input['name']] : '';
				else
					$value=isset($saved[$input['name']]) ? $saved[$input['name']] : $input['default'];
				if($input['eval'] and !$postvalues)
				{
					$save=false;
					$Mainclass=&$this->Mainclass;
					$res=@eval($input['eval']);
					if($res===false)
						$error=$this->lang['err_code'];
				}
				switch ($input['type'])
				{
					default:
					case 'text':
						$control=Template::Text($this->post_name.'['.$input['name'].']',$value);
					break;
					case 'edit':
						$control=Template::Edit($this->post_name.'['.$input['name'].']',$value);
					break;
					case 'editor':
						$this->Mainclass->Loadclass('classes/others/class_editor.php');
						$control=$this->Mainclass->Editor->Area($this->post_name.'['.$input['name'].']',$value);
					break;
					case 'radio':
						$values=array();
						$n=0;
						if(is_array($input['extra']))
							foreach($input['extra'] as &$v)
							{
								$pos=strpos($v,'=');
								if($pos===false)
								{
									$name_=$n++;
									$value_=$v;
								}
								else
								{
									$name_=substr($v,0,$pos);
									$value_=substr($v,$pos+1);
								}
								$values[$name_]=$value_;
							}
						$control=Template::Radios($this->post_name.'['.$input['name'].']',$values,$value,'<br />');
					break;
					case 'check':
						$control=Template::Check($this->post_name.'['.$input['name'].']',$value);
					break;
					case 'select':
					case 'item':
					case 'items':
						$options='';
						$o_gr=$label='';
						if(is_array($input['extra']))
							foreach($input['extra'] as &$v)
							{
								$pos=strpos($v,'=');
								if($pos===0)
								{
									if($label)
										$o_gr=Template::Optgroup($label,$o_gr);
									$options.=$o_gr;
									$o_gr='';
									$label=trim(substr($v,1));
								}
								else
									$o_gr.=$pos===false ? Template::Option($v,'',is_array($value) ? in_array($v,$value) : $v==$value)
														: Template::Option(substr($v,$pos+1),$v_=substr($v,0,$pos),is_array($value) ? in_array($v_,$value) : $v_==$value);
							}
						if($label)
							$o_gr=Template::Optgroup($label,$o_gr);
						$options.=$o_gr;
						switch ($input['type'])
						{
							case 'select':
								$control=Template::Select($this->post_name.'['.$input['name'].']',$options);
							break;
							case 'item':
								$control=Template::Item($this->post_name.'['.$input['name'].']',$options);
							break;
							case 'items':
								$control=Template::Items($this->post_name.'['.$input['name'].'][]',$options);
							break;
						}
					break;
					case 'user':
						$this->Mainclass->Template->php_eval_values=array('value'=>$value);
						if(strpos($input['extra'],'{%PHP')!==false)
							$control=preg_replace_callback('#{%PHP(.+?)%}#s',array(&$this->Mainclass->Template,'DoPhp'),$input['extra']);
					break;
				}
				$param['error']=$error;
				$param['code']=$control;
				$result[$input['name']]=$param;
			}
			return $result;
		}

		/*
			Функция сохранения полей. Возвращает либо $saved (обычная строка для сохранения в базу).
			Может также выкинуть исключение в случае ошибочных данных.
			$notser - не серилизировать данные на выходе?
		*/
		public function SaveFields($notser=false)
		{
			$this->Init();
			$result=array();
			$dump=$this->GetDump();
			foreach($dump as &$input)
			{
				switch($input['type'])
				{
					case 'check':
						$value=isset($_POST[$this->post_name][$input['name']]) ? 1 : 0;
					break;
					case 'editor':
						$this->Mainclass->Loadclass('classes/others/class_editor.php');
						$value=$this->Mainclass->Editor->GetHtml(isset($_POST[$this->post_name][$input['name']]) ? $_POST[$this->post_name][$input['name']] : '',true);
					break;
					default:
						$value=isset($_POST[$this->post_name][$input['name']]) ? $_POST[$this->post_name][$input['name']] : '';
					break;
				}
				if(!is_array($value))
					$value=trim($value);
				if($input['req'] and $value=='')
					throw new EE(sprintf($this->lang['field_emp'],$input['title']),EE::INFO);
				if(in_array($input['type'],array('radio','select','item','items')))
				{
					$n=0;
					foreach($input['extra'] as $k=>$v)
					{
						if($pos=strpos($v,'='))
							$input['extra'][$k]=substr($v,0,$pos);
						elseif($input['type']=='radio')
							$input['extra'][$k]=$n++;
					}
					if(is_array($value))
					{
						if(count($value)>0 and count($value=array_intersect($value,$input['extra']))==0)
							throw new EE(sprintf($this->lang['err_incval'],$input['title']),EE::INFO);
					}
					elseif(!in_array($value,$input['extra']))
						throw new EE(sprintf($this->lang['err_incval'],$input['title']),EE::INFO);
				}
				if($input['eval'])
				{
					$error='';
					$Mainclass=&$this->Mainclass;
					$save=true;
					@eval($input['eval']);
					if($error)
						throw new EE(sprintf($this->lang['err_field'],$input['title'],$error),EE::INFO);
				}
				$result[$input['name']]=$value;
			}
			return $result ? ($notser ? $result : serialize($result)) : '';
		}

		/*
			Функция вывода содержимого дополнительных полей для пользователей сайта.
			$saved - строка, сохраненная
			$tags - теги, в том порядке, в каком их надо показывать. Если пустое - теги игнорируются.
			$toshow - массив с полями, которые показать.

			Возвращает в виде массива дополнительные поля
			array(
					array(
							'title'=>'Название',
							'descr'=>'Описание',
							'value'=>'Значение', может быть false, если человек не запонил его.
							'tags'=>'теги',
					),
			);
		*/
		public function OutPut($saved,array $tags=array(),array $toshow=array())
		{
			$this->Init();
			$result=array();
			$dump=$this->GetDump();
			$saved=$saved ? @unserialize($saved) : array();
			if(!is_array($saved))
				$saved=array();
			foreach($dump as &$input)
			{
				if($toshow and !in_array($input['name'],$toshow) or $tags and count(array_intersect($tags,$input['tags']))==0)
					continue;
				if(isset($saved[$input['name']]) and is_array($saved[$input['name']]))
					$saved[$input['name']]=implode(', ',$saved[$input['name']]);
				switch($input['type'])
				{
					case 'radio':
						$values=array();
						$n=0;
						if(is_array($input['extra']))
							foreach($input['extra'] as &$v)
							{
								$pos=strpos($v,'=');
								if($pos===false)
								{
									$name_=$n++;
									$value_=$v;
								}
								else
								{
									$name_=substr($v,0,$pos);
									$value_=substr($v,$pos+1);
								}
								$values[$name_]=$value_;
							}
						$saved[$input['name']]=isset($values[$saved[$input['name']]]) ? $values[$saved[$input['name']]] : '--';
					break;
					case 'check':
						$saved[$input['name']]=empty($saved[$input['name']]) ? $this->lang['no'] : $this->lang['yes'];
					break;
					case 'user':
						$value=empty($saved[$input['name']]) ? null : $saved[$input['name']];
						$this->Mainclass->Template->php_eval_values=array('value'=>$value);
						if(strpos($input['extra'],'{%PHP')!==false)
							$saved[$input['name']]=preg_replace_callback('#{%PHP(.+?)%}#s',array(&$this->Mainclass->Template,'DoPhp'),$input['extra']);
					break;
				}
				$result[$input['name']]=array(
								'title'=>$input['title'],
								'descr'=>$input['descr'],
								'value'=>isset($saved[$input['name']]) ? $saved[$input['name']] : false,
								'tags'=>$input['tags'],
				);
			}
			return $result;
		}

		protected function GetDump()
		{
			$result=$this->Mainclass->Cache->Get('af_'.$this->module_id.$this->unique.'_'.$this->Mainclass->lang_name,false);
			if($result===false)
			{
				$result=$this->CreateDump();
				$this->Mainclass->Cache->Put('af_'.$this->module_id.$this->unique.'_'.$this->Mainclass->lang_name,$result,$this->cache_ttl,false);
			}
			return $result;
		}

		protected function CreateDump()
		{
			$result=array();
			$this->Mainclass->Db->Query('SELECT `tags`,`type`,`name`,`default`,`eval`,`extra`,`req`,`title`,`descr` FROM `prefix_'.$this->table.'` INNER JOIN `prefix_'.$this->table.'_l` USING(`id`) WHERE `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\' AND `status`=1 AND `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') ORDER BY `position` ASC',__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
			{
				$arr['tags']=$arr['tags'] ? explode(',',Strings::CleanForExplode($arr['tags'])) : array();
				foreach($arr['tags'] as $k=>$v)
				{
					$v=trim($v);
					if(!$v)
						unset($arr['tags'][$k]);
				}
				if($arr['type']=='items')
					$arr['default']=explode(',',$arr['default']);
				if(in_array($arr['type'],array('radio','select','item','items')))
					$arr['extra']=explode('·',$arr['extra']);
				$result[]=$arr;
			}
			return $result;
		}

		protected function Init()
		{
			if(!isset($this->table))
				$this->table='addon_fields';
			if(!isset($this->module_id))
				$this->module_id=(int)$this->Mainclass->GetModVal('id');
		}
	}
}
?>