<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='AddonFieldsAdmin';
if(!class_exists($class_name,false))
{
	if(!class_exists('AddonFields',false))
		include dirname(__file__).'/class_addon_fields.php';
	$class_name='AddonFieldsAdmin';
	class AddonFieldsAdmin extends AddonFields
	{
		public
			$table,#Таблица, в которой размещаются доп. поля
			$module_id,
			$cache_ttl=7200,#Время в секундах, после которого кеш дополнительных полей устареет
			$post_name='addon_field',#Имя массива инпутов полей, которые будут выведены на странице.
			$lang=array();
		protected
			$navigation,
			$title;

		public function __construct($Mainclass)
		{
			$this->lang=$Mainclass->LoadLanguage('langs','','admin_addon_fields-%.php');
		}

		public function GetNavigation($pref=array())
		{
			if(!$this->navigation)
				$this->navigation=array(
										array($this->Mainclass->Url->ConstructUrl($pref+array('event'=>'add_field')),((isset($_GET['event']) and $_GET['event']=='add_field') ? '!' : '').$this->lang['addf']),
										array($this->Mainclass->Url->ConstructUrl($pref+array('event'=>'optimize')),$this->Mainclass->lang['main']['resort']),
										array($this->Mainclass->Url->ConstructUrl($pref+array('event'=>'clean_cache')),$this->lang['clean_cache']),
				);
			return $this->navigation;
		}

		/*
			Функция администрирования дополнительных полей
		*/
		public function Administration()
		{
			$this->GetNavigation();
			$this->Init();
			if(isset($_GET['edit']))
				return $this->AddEditField((int)$_GET['edit']);
			elseif(isset($_GET['save']))
				return $this->SaveField($_GET['save']=='new' ? true : (int)$_GET['save']);
			elseif(isset($_GET['delete']))
				return $this->DeleteField((int)$_GET['delete']);
			elseif(isset($_GET['moveup']))
				return $this->MoveFieldUp((int)$_GET['moveup']);
			elseif(isset($_GET['movedown']))
				return $this->MoveFieldDown((int)$_GET['movedown']);
			elseif(isset($_GET['swap']))
				return $this->SwapField((int)$_GET['swap']);
			elseif(isset($_GET['event']))
				switch($_GET['event'])
				{
					case 'add_field':
						return $this->AddEditField(true);
					break;

					case 'optimize':
						return $this->OptimizeFields();
					break;

					case 'clean_cache':
						$this->CleanCache();
						ExitBack();
						return;
					break;
				}
			if($this->CheckKey() and isset($_POST['op'])  and $_POST['mass'] and is_array($_POST['mass']))
			{
				switch($_POST['op'])
				{
					case 'd':
						$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_'.$this->table.'` WHERE `id`'.$this->Mainclass->Db->In($_POST['mass']).' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
						if($this->Mainclass->Db->Num_rows()>0)
						{
							$ids=array();
							while($t=$this->Mainclass->Db->Fetch_row())
								$ids[]=$t[0];
							$this->Mainclass->Db->Delete($this->table,'`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
							$this->Mainclass->Db->Delete($this->table.'_l','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
							$this->OptimizeFields(false);
						}
					break;
				}
				$this->CleanCache();
			}
			$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
			if($page<=0)
				$page=1;
			$per_page=30;
			$offset=abs(($page-1)*$per_page);
			if($offset>0)
			{
				$this->Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_'.$this->table.'` WHERE `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
				list($cnt)=$this->Mainclass->Db->Fetch_row();
			}
			$this->title=$this->lang['listf'];
			$content=$this->Mainclass->Template->GetClass('addon_fields')->AfListHead($this->title,$this->post_name,$this->lang,$page);
			$this->Mainclass->Db->Query('SELECT `id`,`tags`,`title`,`descr`,`type`,`name`,`position`,`status`,`req` FROM `prefix_'.$this->table.'` INNER JOIN `prefix_'.$this->table.'_l` USING(`id`) WHERE `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\' AND `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') ORDER BY `position` ASC LIMIT '.$offset.', '.$per_page,__file__,__line__);
			if(!isset($cnt))
				$cnt=$this->Mainclass->Db->Num_rows();
			if($cnt==0)
				$content.=$this->Mainclass->Template->GetClass('addon_fields')->AfListEmpty($this->lang);
			--$cnt;
			$n=0;
			while($arr=$this->Mainclass->Db->Fetch_assoc())
			{
				$buttons=($arr['position']>0 ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('moveup'=>$arr['id'])).'" title="'.$this->lang['moveup'].'"><img src="'.$this->Mainclass->Template->GetImage('up.png').'" alt="'.$this->lang['moveup'].'" style="margin: 0 1px;" /></a>' : '')
						.($arr['position']<$cnt ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('movedown'=>$arr['id'])).'" title="'.$this->lang['movedown'].'"><img src="'.$this->Mainclass->Template->GetImage('down.png').'" alt="'.$this->lang['movedown'].'" style="margin: 0 1px;" /></a>' : '')
						.($arr['status']>0 ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['deactivate'].'"><img src="'.$this->Mainclass->Template->GetImage('active.png').'" alt="'.$this->Mainclass->lang['main']['deactivate'].'" style="margin: 0 1px;" /></a>' : '<a href="'.$this->Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['activate'].'"><img src="'.$this->Mainclass->Template->GetImage('inactive.png').'" alt="'.$this->Mainclass->lang['main']['activate'].'" style="margin: 0 1px;" /></a>');
				$arr['descr']=Strings::Cutstr(strip_tags($arr['descr']),80);
				$content.=$this->Mainclass->Template->GetClass('addon_fields')->AfListRow($n++,$arr,$this->DecodeType($arr['type']),$buttons);
				$n++;
			}
			$op_list=Template::Option($this->Mainclass->lang['main']['delete'],'d');
			return $content.$this->Mainclass->Template->GetClass('addon_fields')->AfListFoot($this->post_name,$op_list).Strings::Pages($cnt,$per_page);
		}

		protected function SwapField($id)
		{
			if(!$this->CheckKey())
				return ExitBack();
			$this->Mainclass->Db->Update($this->table,array('!status'=>'NOT `status`'),'`id`='.$id.' LIMIT 1',__file__,__line__);
			$this->CleanCache();
			ExitBack();
		}

		protected function CheckKey()
		{
			return function_exists('CheckKey') ? CheckKey() : true;
		}

		protected function OptimizeFields($redirect=true)
		{
			$result=$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_'.$this->table.'` ORDER BY `position`',__file__,__line__);
			$cnt=0;
			while ($arr=$this->Mainclass->Db->Fetch_row($result))
				$this->Mainclass->Db->Update($this->table,array('position'=>$cnt++),'`id`='.$arr[0].' LIMIT 1',__file__,__line__);
			$this->CleanCache();
			if($redirect)
				ExitPrefix();
		}

		protected function MoveFieldUp($id)
		{
			if(!$this->CheckKey())
				return ExitPrefix();
			$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$this->Mainclass->Db->Fetch_row();
			$this->Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_'.$this->table.'` WHERE `position`=(SELECT MAX(`position`) FROM `prefix_'.$this->table.'` WHERE `position`<'.$posit.')',__file__,__line__);
			list($cnt)=$this->Mainclass->Db->Fetch_row();
			if($cnt>0)
			{
				if($cnt>1)
				{
					$this->OptimizeFields(false);
					$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					list($posit)=$this->Mainclass->Db->Fetch_row();
				}
				$posit--;
				$this->Mainclass->Db->Update($this->table, array('!position'=>'`position`+1'),'`position`='.$posit.' LIMIT 1',__file__,__line__);
				$this->Mainclass->Db->Update($this->table, array('!position'=>'`position`-1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
			}
			$this->CleanCache();
			ExitPrefix();
		}

		protected function MoveFieldDown($id)
		{
			if(!$this->CheckKey())
				return ExitPrefix();
			$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$this->Mainclass->Db->Fetch_row();
			$this->Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_'.$this->table.'` WHERE `position`=(SELECT MIN(`position`) FROM `prefix_'.$this->table.'` WHERE `position`>'.$posit.')',__file__,__line__);
			list($cnt)=$this->Mainclass->Db->Fetch_row();
			if($cnt>0)
			{
				if($cnt>1)
				{
					$this->OptimizeFields(false);
					$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					list($posit)=$this->Mainclass->Db->Fetch_row();
				}
				$posit++;
				$this->Mainclass->Db->Update($this->table, array('!position'=>'`position`-1'),'`position`='.$posit.' LIMIT 1',__file__,__line__);
				$this->Mainclass->Db->Update($this->table, array('!position'=>'`position`+1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
			}
			$this->CleanCache();
			ExitPrefix();
		}

		protected function AddEditField($id,$error='')
		{
			$this->Mainclass->Loadclass('classes/others/class_editor.php');
			$values=array();
			$multilang=array_combine(array_keys($this->Mainclass->langs),array_fill(0,count($this->Mainclass->langs),array('title'=>'','descr'=>'')));
			if($id===true)
			{
				$this->title=$this->lang['addf_'];
				$values['id']='new';
				$values['mid']=0;
				$values['status']=true;
				$values['type']='edit';
				$values['req']=false;
				$values['tags']=$values['name']=$values['eval']=$values['default']=$values['extra']=$values['position']='';
				$values['one_lang']=!$this->Mainclass->vars['multilang'];
			}
			else
			{
				if(!$error)
				{
					$this->Mainclass->Db->Query('SELECT * FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->Mainclass->Db->Num_rows()==0)
						ExitPrefix();
					$values=$this->Mainclass->Db->Fetch_assoc();
					$values['one_lang']=false;
					if(in_array($values['type'],array('radio','select','item','items')))
						$values['extra']=str_replace('·',"\r\n",$values['extra']);
					$this->Mainclass->Db->Query('SELECT `language`, `title`, `descr` FROM `prefix_'.$this->table.'_l` WHERE `id`='.$id,__file__,__line__);
					while($temp=$this->Mainclass->Db->Fetch_assoc())
						if(isset($multilang[$temp['language']]))
						{
							$multilang[$temp['language']]['title']=$temp['title'];
							$multilang[$temp['language']]['descr']=$temp['descr'];
						}
						elseif(!$temp['language'])
						{
							$multilang[$this->Mainclass->lang_name]['title']=$temp['title'];
							$multilang[$this->Mainclass->lang_name]['descr']=$temp['descr'];
							$values['one_lang']=true;
							break;
						}
					$values['id']=(int)$values['id'];
				}
				else
					$values['id']=(int)$id;
				$this->title=$this->lang['editf'];
			}
			if($error)
			{
				$values['mid']=isset($_POST['mid']) ? (int)$_POST['mid'] : '';
				$values['status']=isset($_POST['status']);
				$values['type']=isset($_POST['type']) ? $_POST['type'] : '';
				$values['req']=isset($_POST['req']);
				$values['name']=isset($_POST['name']) ? $_POST['name'] : '';
				$values['tags']=isset($_POST['tags']) ? $_POST['tags'] : '';
				$values['eval']=isset($_POST['eval']) ? $_POST['eval'] : '';
				$values['default']=isset($_POST['default']) ? $_POST['default'] : '';
				$values['extra']=isset($_POST['extra']) ? $_POST['extra'] : '';
				$values['position']=isset($_POST['position']) ? $_POST['position'] : '';;
				$values['one_lang']=isset($_POST['one_lang']);
				foreach($multilang as $k=>$v)
					if($this->Mainclass->lang_name==$k)
					{
						if(isset($_POST['title']))
							$multilang[$k]['title']=$_POST['title'];
						if(isset($_POST['descr']))
							$multilang[$k]['descr']=$this->Mainclass->Editor->GetHTML('descr');
					}
					else
					{
						if(isset($_POST['title_'.$k]))
							$multilang[$k]['title']=$_POST['title_'.$k];
						if(isset($_POST['descr_'.$k]))
							$multilang[$k]['descr']=$this->Mainclass->Editor->GetHTML('descr_'.$k);
					}
			}
			$arr_types=array('text','edit','radio','check','select','item','items','editor','user',);
			$types='';
			foreach($arr_types as &$v)
				$types.=Template::Option($this->DecodeType($v),$v,$v==$values['type']);
			return $this->Mainclass->Template->GetClass('addon_fields')->AddEdit($error,$this->title,$this->lang,$values,$multilang,$types);
		}

		protected function SaveField($id)
		{
			if(!$this->CheckKey())
				return ExitPrefix();
			$title=trim(isset($_POST['title']) ? $this->Mainclass->POST['title'] : '');
			$this->Mainclass->Loadclass('classes/others/class_editor.php');
			$type=isset($_POST['type']) ? $_POST['type'] : '';
			$extra=isset($_POST['extra']) ? $_POST['extra'] : '';
			$name=isset($_POST['name']) ? $_POST['name'] : '';
			if(preg_match('#^\w+$#',$name)==0)
				return $this->AddEditField($id,$this->lang['err_name']);
			if(in_array($type,array('radio','select','item','items')))
				$extra=str_replace(array('·',"\r\n"),array('','·'),$extra);
			if(!$title or !$name)
				return $this->AddEditField($id,$this->lang['err_compl']);
			$q_and=$id===true ? '' : ' AND `id`!='.$id;
			$this->Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `name`={"1"} AND `mid`='.$this->module_id.$q_and.' AND `unique`={"2"} LIMIT 1',array($this->table,'s_'.$name,'s_'.$this->unique),__file__,__line__);
			if($this->Mainclass->Db->Num_rows()>0)
				return $this->AddEditField($id,$this->lang['name_ex']);
			$arr_values=array(
								'mid'=>$this->module_id,
								'unique'=>$this->unique,
								'tags'=>isset($_POST['tags']) ? $this->Mainclass->POST['tags'] : '',
								'type'=>$type,
								'name'=>$name,
								'default'=>isset($_POST['default']) ? $_POST['default'] : '',
								'eval'=>isset($_POST['eval']) ? trim($_POST['eval']) : '',
								'extra'=>$extra,
								'position'=>(int)$_POST['position'],
								'status'=>isset($_POST['status']),
								'req'=>isset($_POST['req']),
			);
			if($this->Mainclass->vars['multilang'] and !isset($_POST['one_lang']))
			{
				$langs=(empty($_POST['lang']) or !is_array($_POST['lang'])) ? array() : $_POST['lang'];
				$langs=array_intersect(array_keys($this->Mainclass->langs),$langs);
				if(!$langs)
					$langs=array($this->Mainclass->lang_name);
			}
			else
				$langs=array('');
			if(is_int($id))
			{
				$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\' LIMIT 1',__file__,__line__);
				list($position)=$this->Mainclass->Db->Fetch_row();
				if($position!=$arr_values['position'])
				{
					$this->Mainclass->Db->Update($this->table,array('!position'=>'`position`-1'),'`position`>'.$position.' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
					$this->Mainclass->Db->Update($this->table,array('!position'=>'`position`+1'),'`position`>='.$arr_values['position'].' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
				}
				$this->Mainclass->Db->Update($this->table,$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
				$this->Mainclass->Db->Delete($this->table.'_l','`id`='.$id.' AND `language`'.$this->Mainclass->Db->In($langs,true),__file__,__line__);
				foreach($langs as &$v)
				{
					if(!$v or $this->Mainclass->lang_name==$v)
						$values=array(
										'title'=>$title,
										'descr'=>$this->Mainclass->Editor->GetHTML('descr'),
						);
					else
						$values=array(
										'title'=>$_POST['title_'.$v],
										'descr'=>$this->Mainclass->Editor->GetHTML('descr_'.$v),
						);
					$cnt=$this->Mainclass->Db->Update($this->table.'_l',$values,'`id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
					if($cnt==0)
					{
						$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_'.$this->table.'_l` WHERE `id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
						if($this->Mainclass->Db->Num_rows()==0)
							$this->Mainclass->Db->Insert($this->table.'_l',$values+array('id'=>$id,'language'=>$v),__file__,__line__);
					}
				}
			}
			else
			{
				if($_POST['position']=='')
				{
					$this->Mainclass->Db->Query('SELECT MAX(`position`) FROM `prefix_'.$this->table.'` WHERE `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
					list($position)=$this->Mainclass->Db->Fetch_row();
					$arr_values['position']=$position ? (int)$position+1 : 0;
				}
				else
					$this->Mainclass->Db->Update($this->table,array('!position'=>'`position`+1'),'`position`>='.$arr_values['position'].' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\'',__file__,__line__);
				$id=$this->Mainclass->Db->Insert($this->table,$arr_values,__file__,__line__);
				$values=array('id'=>array(),'language'=>array(),'title'=>array(),'descr'=>array());
				foreach($langs as &$v)
				{
					$values['id'][]=$id;
					$values['language'][]=$v;
					if(!$v or $this->Mainclass->lang_name==$v)
					{
						$values['title'][]=$title;
						$values['descr'][]=$this->Mainclass->Editor->GetHTML('descr');
					}
					else
					{
						$values['title'][]=$this->Mainclass->POST['title_'.$v];
						$values['descr'][]=$this->Mainclass->Editor->GetHTML('descr_'.$v);
					}
				}
				$this->Mainclass->Db->Insert($this->table.'_l',$values,__file__,__line__);
			}
			$this->CleanCache();
			if(empty($_POST['back']))
				ExitPrefix();
			else
				Functions::Redirect(base64_decode($_POST['back']));
		}

		protected function DeleteField($id)
		{
			if(!$this->CheckKey())
				return ExitPrefix();
			$this->Mainclass->Db->Query('SELECT `position` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\' LIMIT 1',__file__,__line__);
			if($this->Mainclass->Db->Num_rows()>0)
			{
				list($position)=$this->Mainclass->Db->Fetch_row();
				$this->Mainclass->Db->Update($this->table,array('!position'=>'`position`-1'),'`position`>'.$position.' AND `mid`='.$this->module_id.' AND `unique`=\''.$this->unique.'\' LIMIT 1',__file__,__line__);
				$this->Mainclass->Db->Delete($this->table,'`id`='.$id,__file__,__line__);
			}
			$this->CleanCache();
			ExitPrefix();
		}

		public function GetTitle()
		{
			return $this->title;
		}

		protected function DecodeType($type)
		{
			switch($type)
			{
				case 'text':
					return $this->lang['text'];
				case 'edit':
					return $this->lang['edit'];
				case 'radio':
					return $this->lang['radio'];
				case 'check':
					return $this->lang['check'];
				case 'select':
					return $this->lang['select'];
				case 'item':
					return $this->lang['item'];
				case 'items':
					return $this->lang['items'];
				case 'editor':
					return $this->lang['editor'];
				case 'user':
					return $this->lang['user'];
			}
		}

		/*
			Функция очистки кеша.
			$update - обновление кеша
		*/
		public function CleanCache($update=true)
		{
			$this->Init();
			$this->Mainclass->Cache->CleanCacheByTag('af_'.$this->module_id.$this->unique);
			if($update)
				$this->Mainclass->Cache->Put('af_'.$this->module_id.$this->unique.'_'.$this->Mainclass->lang_name,$this->CreateDump(),$this->cache_ttl,false);
		}
	}
}
?>