<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class Categories extends BaseClass
{
	public
		$table_name='',#Таблица с категориями
		$images_folder='images/categories',#Папка с изображениями к категориям
		$addon=array(),#Дополнительные поля: Название поля в БД; Массив (Заголовок, тип, значение по-умолчанию, extra, Описание
		$defis=' / ',#Строка которая будет отделять родителей друг от друга: Cat / SubCat / SubSubCat
		$delete_func_callback,#Функция, которая будет вызвана при удалении категорий. Первым параметром в виде массиве буду переданы ИДы всех удаленных категорий.
		$url_ending='',#Окончание УРЛа, которое будет использоваться для категорий.
		$def_show_image='',#Путь к картинки, которая будет показываться пользователю по-умолчанию
		$dump=array(),#Дамп БД категорий. Ведь очень часто приходиться выстраивать их в каком-то определенном порядке.
		$Url='';#Объект для доступа к Url классу.
	protected
		$lang,
		$categ_urls=array();#Данные для функции CategoryUrl
	public function Init($reinit=true)
	{
		$this->images_folder=$this->Mainclass->CheckSlash($this->images_folder);
		if(!is_object($this->Url))
			$this->Url=&$this->Mainclass->Url;
		if(!$this->table_name and false==$this->table_name=$this->Mainclass->GetModVal('categories_table') and $this->Mainclass->GetModVal('name')!==false)
			$this->Mainclass->SetModVal('categories_table',$this->table_name=$this->Mainclass->GetModVal('name').'_categories');
		if($reinit)
			$this->MakeDump();
	}
	/*
		Функция возвращает список категорий в виде option-ов, для select-a
		<option value="ID" selected="selected">VALUE</option>
		$sel - пункты, которые будут отмечены (массив, но может быть и число).
		$parent - начальная категория
		$no - ИДы исключаемых категорий (не попадут и их дети). Может быть массивом, но может быть и числом.
	*/
	public function GetCatOptions($sel=array(),$parent=0,$no=array())
	{
		if(!$this->dump)
			$this->MakeDump();
		if(!is_array($no))
			$no=array($no);
		if(!is_array($sel))
			$sel=array($sel);
		$options='';
		$h=$nol=$nor=0;
		if($parent)
		{
			foreach($this->dump as &$v)
				if($v['id']==$parent)
				{
					$l=$v['l'];
					$r=$v['r'];
					break;
				}
			if(!isset($r))
				return '';
		}
		$h=array();
		foreach($this->dump as &$v)
		{
			if($nol>0 and $nol<$v['l'] and $nor>$v['r'])
				continue;
			else
				$nol=$nor=0;
			if(in_array($v['id'],$no))
			{
				$nol=$v['l'];
				$nor=$v['r'];
				continue;
			}
			if($parent)
			{
				if($v['l']>$r)
					break;
				if($v['l']<=$l)
					continue;
			}
			if($v['parent']==0)
				$h[$v['id']]=0;
			else
				$h[$v['id']]=isset($h[$v['parent']]) ? $h[$v['parent']]+1 : 1;
			$options.=Template::Option(str_repeat('&nbsp;&nbsp;&nbsp;',$h[$v['id']]).'›&nbsp;'.$v['title'],$v['id'],in_array($v['id'],$sel));
		}
		return $options;
	}

	public function CategoryUrl($id,$table_name='',$prefix='',$ending=true,$work_d=false)
	{
		if(!is_object($this->Url))
			$this->Url=$this->Mainclass->Url;
		if($ending and $this->url_ending)
		{
			$old_ending=$this->Url->ending;
			$this->Url->ending=$this->url_ending;
		}
		if(!$ending and !$this->Url->furl and !$work_d)
			return $this->Url->Prefix(false,false);
		if($table_name or !$this->dump)
		{
			$this->MakeDump($this->table_name=$table_name);
			$this->categ_urls=array();
		}
		if(isset($this->categ_urls[$this->table_name][$id]))
			$result=$this->categ_urls[$this->table_name][$id];
		else
		{
			if(!$dump=$this->GetDump($id))
				return $this->Url->Prefix(false,false,$ending);
			$result='';
			if($this->Url->furl)
			{
				foreach($this->dump as &$v)
					if($v['l']<$dump['l'] and $v['r']>$dump['r'])
						$result.=$this->Url->ConstructUrl(array(array($v['url'],'cid'=>$v['id'])),false,false).$this->Url->GetDel();
			}
			$result.=$this->Url->ConstructUrl(array(array($dump['url'],'cid'=>$dump['id'])),false,false);
			$this->categ_urls[$this->table_name][$id]=$result;
		}
		if($prefix!==false)
			$result=($prefix ? $prefix.$this->Url->GetDel() : $this->Url->Prefix(false, false)).$result;
		if($this->Url->furl and $ending)
			$result.=$this->Url->ending;
		elseif(!$ending)
			$result.=$this->Url->GetDel();
		if(isset($old_ending))
			$this->Url->ending=$old_ending;
		return $result;
	}

	public function MakeDump($table_name='',$hard=false)
	{
		if(!$table_name)
			$table_name=$this->table_name;
		if(!$table_name)
		{
			$this->dump=array();
			return;
		}
		$cache=$this->Mainclass->Cache->Get('dump_'.$table_name.'_',false);
		if($cache===false or $hard)
		{
			$this->dump=array();
			$this->Mainclass->Db->Query('SELECT * FROM `prefix_'.$table_name.'` ORDER BY `l` ASC',__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
				$this->dump[]=$arr;
			$this->Mainclass->Cache->Put('dump_'.$table_name.'_',$this->dump,3600,false);
		}
		else
			$this->dump=$cache;
	}

	/*
		Функция возвращает одну запись для категории
	*/
	public function GetDump($id,$url_trace=array(),$table_name='')
	{
		if($table_name or !$this->dump)
			$this->MakeDump($table_name);
		if($id)
		{
			foreach($this->dump as &$v)
				if($v['id']==$id)
					return $v;
		}
		else
		{
			if(!is_array($url_trace))
			{
				$url_trace=array($url_trace);
				$cnt=0;
			}
			else
				$cnt=count($url_trace)-1;
			$parent=0;
			$curr=array_shift($url_trace);
			foreach($this->dump as &$v)
				if($v['parent']==$parent and strcasecmp($v['url'],$curr)==0)
				{
					if($cnt==0)
						return $v;
					$curr=array_shift($url_trace);
					--$cnt;
					$parent=$v['id'];
				}
		}
		return false;
	}

	public function CatWay($parent)
	{
		$arr=array();
		while ($parent>0)
		{
			$old_par=$parent;
			foreach ($this->dump as &$v)
				if($v['id']==$parent)
				{
					$arr[]='<a href="'.$this->CategoryUrl($v['id']).'" title="'.strip_tags($v['description']).'">'.$v['title'].'</a>';
					$parent=(int)$v['parent'];
					break;
				}
			if($old_par==$parent)
				break;
		}
		return array_reverse($arr);
	}

	public function UserInterface($cat_dump=null,$columns=3,$show_subs=true)
	{
		$cathead='';
		if($cat_dump)
		{
			$image=false;
			if($cat_dump['image'] and is_file($this->Mainclass->root_path.$cat_dump['image']))
				$image=$this->images_folder.$cat_dump['image'];
			elseif($this->def_show_image)
				$image=$this->def_show_image;
			$cathead=$this->Mainclass->Template->GetThemeFile(
																'CategoryHeader',
																array(
																		'catway'=>$cat_dump['parent'] ? $this->Mainclass->lang['main']['category'].': '.implode($this->defis,$this->CatWay($cat_dump['parent'])) : '',
																		'image'=>$image ? '<img src="'.$image.'" alt="'.$cat_dump['title'].'" />' : '',
																		'link'=>$cat_dump['title'],
																		'descr'=>$cat_dump['description']
																)
			);
			$cid=$cat_dump['id'];
		}
		else
			$cid=0;
		$tdwidth=floor(100/$columns);
		$trs=$this->Mainclass->Template->GetThemeFile('CategoryTableTr');
		$tds=$this->Mainclass->Template->GetThemeFile('CategoryTableTd',array('width'=>$tdwidth));
		$sub=$show_subs ? $this->Mainclass->Template->GetThemeFile('CategoryTableSubCats') : '';
		$num=0;
		$content='';
		foreach ($this->dump as &$v)
			if($v['parent']==$cid)
			{
				if($num==0 and $content)
					$content.=$trs;
				$image='';
				if($v['image'] and is_file($this->Mainclass->root_path.$this->images_folder.$v['image']))
					$image=$this->images_folder.$v['image'];
				elseif($this->def_show_image)
					$image=$this->def_show_image;
				$sub_cats='';
				if($show_subs)
					foreach($this->dump as &$val)
						if($val['parent']==$v['id'])
							$sub_cats.=str_replace('{link}','<a href="'.$this->CategoryUrl($val['id']).'" title="'.strip_tags($val['description']).'">'.$val['title'].'</a>',$sub);
				$num++;
				$content.=$this->Mainclass->Template->ReplaceAll(
																	$tds,
																	array(
																			'image'=>$image ? '<a href="'.$this->CategoryUrl($v['id']).'" title="'.$v['title'].'"><img src="'.$image.'" alt="'.$v['title'].'" title="'.$v['title'].'" /></a>' : '',
																			'link'=>'<a href="'.$this->CategoryUrl($v['id']).'"><strong>'.$v['title'].'</strong></a>',
																			'descr'=>$v['description'],
																			'subcats'=>$sub_cats
																	),
																	true
				);
				if($num==$columns)
					$num=0;
			}
		if($num>0)
			for (;$num<$columns;$num++)
				$content.='<td></td>';
		return $cathead.($content ? $this->Mainclass->Template->GetThemeFile('CategoryTableBegin').$content.$this->Mainclass->Template->GetThemeFile('CategoryTableEnd') : '');
	}
}
?>