<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
if(!class_exists('Categories',false))
	include dirname(__file__).'/class_categories.php';
$class_name='Categories_admin';
$obj_name='Categories';
class Categories_admin extends Categories
{
	public
		$navigation=array(),
		$title,
		$jscripts=array();
	public function GetNavigation($pref=array())
	{
		$this->lang=$this->Mainclass->LoadLanguage('langs','','admin_categories-%');
		if(!$this->navigation)
			$this->navigation=array(
									array($this->Mainclass->Url->ConstructUrl($pref+array('event'=>'add')),((isset($_GET['event']) and $_GET['event']=='add') ? '!' : '').$this->lang['add_cat']),
									array($this->Mainclass->Url->ConstructUrl($pref+array('event'=>'restore')),((isset($_GET['event']) and $_GET['event']=='restore') ? '!' : '').$this->Mainclass->lang['main']['resort']),
			);
		return $this->navigation;
	}

	public function AdminInit()
	{
		$this->GetNavigation();
		$this->Init();
		if(isset($_GET['save']))
			return $this->SaveCategory($_GET['save']=='new' ? true : (int)$_GET['save']);
		elseif(isset($_GET['edit']))
			return $this->AddEditCategory((int)$_GET['edit']);
		elseif(isset($_GET['delete']))
			return $this->DeleteCategory((int)$_GET['delete']);
		elseif(isset($_GET['moveup']))
			$this->MoveCatUp((int)$_GET['moveup']);
		elseif(isset($_GET['movedown']))
			$this->MoveCatDown((int)$_GET['movedown']);
		elseif(isset($_GET['event']))
			switch(strtolower($_GET['event']))
			{
				case 'add':
					return $this->AddEditCategory(true);
				break;
				case 'restore':
					return $this->Optimize();
				break;
				default:
					return $this->AdminCategories();
			}
		else
			return $this->AdminCategories();
	}

	protected function AdminCategories()
	{
		$this->title=$this->Mainclass->lang['main']['cats_manag'];
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$per_page=30;
		$offset=abs(($page-1)*$per_page);
		$arr=$values=$tosort=array();
		$last=true;
		$this->Mainclass->Db->Query('SELECT `id`,`title`,`url`,`parent`,`pos` FROM `prefix_'.$this->table_name.'` ORDER BY `parent` DESC, `pos` DESC',__file__,__line__);
		while($temp=$this->Mainclass->Db->Fetch_assoc())
		{
			$values[$temp['id']]=$temp;
			if($temp['parent']==0)
			{
				if($last)
				{
					$values[$temp['id']]+=array('last'=>true);
					$last=false;
				}
				$tosort[$temp['id']]=$temp['pos'];
			}
			else
				$arr[]=array('id'=>$temp['id'],'parent'=>$temp['parent']);
		}
		asort($tosort,SORT_NUMERIC);
		$keys=array_keys($tosort);
		unset($tosort);
		$len=0;
		$last=array();
		while (count($arr)!=$len)
		{
			$len=count($arr);
			foreach ($arr as $k=>$v)
				if(false!==$id=array_search($v['parent'],$keys))
				{
					$values[$v['id']]['title']=$values[$v['parent']]['title'].$this->defis.$values[$v['id']]['title'];
					if(!in_array($v['parent'],$last))
					{
						$values[$v['id']]['last']=true;
						$last[]=$v['parent'];
					}
					array_splice($keys,$id+1,0,array((int)$v['id']));
					unset($arr[$k]);
				}
		}
		$content=$this->Mainclass->Template->GetClass('categories')->CatsListHead($this->title);
		$n=0;
		if($values)
		{
			$pages=count($keys);
			$keys=array_slice($keys,$offset,$per_page);
			foreach($keys as &$v)
			{
				$position=(int)$values[$v]['pos'];
				$updown=($position>0 ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('moveup'=>$v)).'" title="'.$this->lang['move_up'].'"><img src="'.$this->Mainclass->Template->GetImage('up.png').'" alt="'.$this->lang['move_up'].'" style="margin: 0 1px;" /></a>' : '')
						.(empty($values[$v]['last']) ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('movedown'=>$v)).'" title="'.$this->lang['move_down'].'"><img src="'.$this->Mainclass->Template->GetImage('down.png').'" alt="'.$this->lang['move_down'].'" style="margin: 0 1px;" /></a>' : '');
				$content.=$this->Mainclass->Template->GetClass('categories')->CatsListRow($n++,$v,$values[$v],$updown);
			}
		}
		else
		{
			$pages=0;
			$content.='<tr><td colspan="4" align="center"><b>'.$this->lang['no_categories'].'</b></td></tr>';
		}
		$this->Mainclass->ShowDecoration();
		return $content.'</table>'.Strings::Pages($pages,$per_page);

	}

	protected function AddEditCategory($id,$error='')
	{
		$this->jscripts[]='js/eleanor_tooltip.js';
		$this->navigation[0]=array($this->Mainclass->Url->ConstructUrl(array('event'=>'add')),((isset($_GET['event']) and $_GET['event']=='add') ? '!' : '').$this->lang['add_cat']);
		$this->Mainclass->Loadclass('classes/others/class_editor.php');
		if($id===true)
		{
			$this->title=$this->lang['adding_cat'];
			$values['id']='new';
			$values['pos']=$values['title']=$values['image']=$values['descr']=$values['url']=$values['s_descr']='';
			$values['parent']=0;
			$arr_params=array();
			if($this->addon)
				foreach($this->addon as $k=>$v)
					$arr_params[$k]=$v[2];
		}
		else
		{
			if(!$error)
			{
				$this->Mainclass->Db->Query('SELECT * FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				if($this->Mainclass->Db->Num_rows()==0)
					ExitPrefix();
				$arr=$this->Mainclass->Db->Fetch_assoc();
				foreach($arr as $k=>$v)
					switch ($k)
					{
						case 'id':
							$values['id']=(int)$v;
						break;
						case 'title':
							$values['title']=$v;
						break;
						case 'description':
							$values['descr']=$v;
						break;
						case 'url':
							$values['url']=$v;
						break;
						case 'image':
							$values['image']=$v;
						break;
						case 'parent':
							$values['parent']=$v;
						break;
						case 'pos':
							$values['pos']=$v;
						break;
						case 's_descr':
							$values['s_descr']=$v;
						break;
						default:
							$arr_params[$k]=$v;
					}
			}
			else
				$values['id']=(int)$id;
			$this->title=$this->lang['editing_cat'];
		}
		if($error)
		{
			$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
			$values['descr']=$this->Mainclass->Editor->GetHTML('descr');
			$values['image']=isset($_POST['image']) ? basename($_POST['image']) : '';
			$values['parent']=isset($_POST['parent']) ? (int)$_POST['parent'] : 0;
			$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
			$values['pos']=isset($_POST['pos']) ? $_POST['pos'] : '';
			$values['s_descr']=isset($_POST['s_descr']) ? $_POST['s_descr'] : '';
			foreach($this->addon as $k=>$v)
				if(isset($_POST[$k]))
					$arr_params[$k]=strcasecmp($v[1],'editor')==0 ? $this->Mainclass->Editor->GetHTML($k) : $_POST[$k];
				else
					$arr_params[$k]='';
		}
		$image_list=array();
		$hdir=opendir($this->Mainclass->FormatPath($this->images_folder));
		while($entry=readdir($hdir))
			if(preg_match('/\.(?:gif|jpe?g|png|bmp)$/i',$entry)>0 and stripos($entry,'none')!==0)
				$image_list[$entry]=Template::Option($entry,$this->images_folder.ltrim($entry,'/\\'),$entry==$values['image']);
		$values['image']=$this->images_folder.'/'.$values['image'];
		closedir($hdir);
		ksort($image_list,SORT_STRING);
		$addon='';
		foreach($this->addon as $k=>$v)
		{
			if(!is_array($v))
			{
				$addon.=$this->Mainclass->Template->GetClass('categories')->AddonInfo($v);
				continue;
			}
			$mn=false;
			switch(strtolower($v[1]))
			{
				case 'user':
					if(!is_callable($v[3]))
						continue 2;
					$value=call_user_func($v[3],$error ? 'loadpost' : 'load',$arr_params[$k],$v[5]);
				break;
				case 'editor':
					$value=$this->Mainclass->Editor->Area($k,$arr_params[$k],5);
				break;
				case 'radios':
					$value=Template::Radios($k,$v[3],$arr_params[$k],'<br />',$v[5]);
				break;
				case 'edit':
				case 'text':
					$value=Template::$v[1]($k,$arr_params[$k],$v[5],!empty($v[6]));
				break;
				case 'items':
					$arr_params[$k]=explode(',',$arr_params[$k]);
				case 'item':
					$mn=true;
				case 'select':
					$value='';
					foreach($v[3] as $k_=>$v_)
						$value.=Template::Option($v_,$k_,is_array($arr_params[$k]) ? in_array($k_,$arr_params[$k]) : $arr_params[$k]==$k_);
					$arr_params[$k]=$value;
					if($mn)
					{
						$value=Template::$v[1]($k,$arr_params[$k],10,$v[5]);
						break;
					}
				default:
					$value=Template::$v[1]($k,$arr_params[$k],$v[5]);
			}
			$addon.=$this->Mainclass->Template->GetClass('categories')->AddonRow($v[0],$v[4],$value);
		}
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		$content=$this->Mainclass->Template->GetClass('categories')->AddEditCat($error,$this->title,$this->lang,$values,$addon,$image_list,$this->GetCatOptions($values['parent'],'',is_int($id) ? $id : ''));
		$this->Mainclass->ShowDecoration();
		return $content;
	}

	protected function SaveCategory($id)
	{
		if($_SERVER['REQUEST_METHOD']!='POST')
			return $this->AddEditCategory($id);
		if(!CheckKey())
			return ExitPrefix();
		$this->Mainclass->Loadclass('classes/others/class_editor.php');
		$title=isset($_POST['title']) ? trim($this->Mainclass->POST['title']) : '';
		if(!$title)
			return $this->AddEditCategory($id,$this->lang['empty_title']);
		$url=$this->Mainclass->Url->UrlString(isset($_POST['url']) ? $_POST['url'] : '');
		if(empty($url))
			$_POST['url']=$url=isset($_POST['title']) ? $this->Mainclass->Url->UrlString($_POST['title']) : '';
		$parent=isset($_POST['parent']) ? (int)$_POST['parent'] : 0;
		$q_and=$id===true ? '' : ' AND `id`!='.$id;
		$this->Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"} AND `parent`='.$parent.$q_and.' LIMIT 1',array($this->table_name,'s_'.$url),__file__,__line__);
		if($this->Mainclass->Db->Num_rows()>0)
			return $this->AddEditCategory($id,$this->lang['url_exists']);
		$image=isset($_POST['image']) ? basename($_POST['image']) : '';
		if(!is_file($this->Mainclass->root_path.$this->images_folder.'/'.$image))
			$image='';
		$arr_values=array(
							'url'=>$url,
							'title'=>$title,
							'description'=>$this->Mainclass->Editor->GetHTML('descr'),
							'image'=>$image,
							's_descr'=>isset($_POST['s_descr']) ? $this->Mainclass->POST['s_descr'] : '',
							'parent'=>$parent,
							'pos'=>''
		);
		foreach($this->addon as $k=>$v)
			if(is_array($v))
				switch(strtolower($v[1]))
				{
					case 'user':
						if(!is_callable($v[3]))
							continue 2;
						$arr_values[$k]=call_user_func($v[3],'save',null,$v[5]);
					break;
					case 'editor':
						$arr_values[$k]=$this->Mainclass->Editor->GetHTML($k);
					break;
					case 'check':
						$arr_values[$k]=isset($_POST[$k]);
					break;
					default:
						if(empty($_POST[$k]))
							$arr_values[$k]='';
						else
							$arr_values[$k]=is_array($_POST[$k]) ? ','.implode(',',$_POST[$k]).',' : (empty($v[6]) ? $this->Mainclass->POST[$k] : $_POST[$k]);
				}
		$this->Mainclass->Db->Transaction('BEGIN');
		if(is_int($id))
		{
			$arr_values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
			$this->Mainclass->Db->Query('SELECT `l`,`r`,`parent`,`pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($l,$r,$parent,$pos)=$this->Mainclass->Db->Fetch_row();
			if($pos!=$arr_values['pos'] or $parent!=$arr_values['parent'])
			{
				$this->Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_'.$this->table_name.'` WHERE `pos`='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
				if($old=$this->Mainclass->Db->Fetch_assoc())
				{
					#Смещение категории, на место которой мы ставим текущую
					$offset_a=$old['r']-$old['l']+1;
					#Смещение текущей категории на новое место
					$offset_b=$r-$l+1;
					if($r>$old['r'])
					{
						$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
						$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
					}
					else
					{
						$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
						$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
					}
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
				}
				$this->Mainclass->Db->Update($this->table_name,array('!pos'=>'`pos`-1'),'`pos`>'.$pos.' AND `parent`='.$parent,__file__,__line__);
				$this->Mainclass->Db->Update($this->table_name,array('!pos'=>'`pos`+1'),'`pos`>='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'],__file__,__line__);
			}
			if($parent!=$arr_values['parent'])
			{
				$r=(int)$r;
				$l=(int)$l;
				$this->Mainclass->Db->Query('SELECT `r` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
				if($this->Mainclass->Db->Num_rows()==0)
				{
					#$rp=0;
					$this->Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_'.$this->table_name.'` WHERE `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
					list($rp)=$this->Mainclass->Db->Fetch_row();
				}
				else
					list($rp)=$this->Mainclass->Db->Fetch_row();
				if($rp>$l and $rp<$r)
					$arr_values['parent']=$parent;
				else
				{
					$rp=(int)$rp;
					$cnt=$r-$l+1;
					$this->Mainclass->Db->Update($this->table_name,array('!l'=>'-1*`l`','!r'=>'-1*`r`'),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$cnt),'`r`>'.$r,__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!l'=>'`l`-'.$cnt),'`l`>'.$r,__file__,__line__);
					if($rp>$r)
						$rp-=$cnt;
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`+'.$cnt),'`r`>='.$rp,__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!l'=>'`l`+'.$cnt),'`l`>'.$rp,__file__,__line__);
					if($rp==0)
						$rp=1;
					$this->Mainclass->Db->Update($this->table_name,array('!l'=>'`l`*-1-'.$l.'+'.$rp,'!r'=>'`r`*-1-'.$l.'+'.$rp),'`l`<0',__file__,__line__);
					unset($arr_values['l'],$arr_values['r']);
				}
			}
			$this->Mainclass->Db->Update($this->table_name,$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
		}
		else
		{
			$arr_values['pos']=isset($_POST['pos']) ? $_POST['pos'] : 0;
			if($arr_values['pos']=='')
			{
				$this->Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_'.$this->table_name.'` WHERE `parent`='.$arr_values['parent'],__file__,__line__);
				list($position)=$this->Mainclass->Db->Fetch_row();
				$arr_values['pos']=$position===null ? 0 : $position+1;
			}
			else
				$this->Mainclass->Db->Update($this->table_name,array('!pos'=>'`pos`+1'),'`pos`>='.(int)$arr_values['pos'].' AND `parent`='.$arr_values['parent'],__file__,__line__);
			if($arr_values['parent']==0)
				$this->Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_'.$this->table_name.'`',__file__,__line__);
			else
				$this->Mainclass->Db->Query('SELECT `r` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$arr_values['parent'],__file__,__line__);
			if($this->Mainclass->Db->Num_rows()==0)
				return ExitPrefix();
			list($r)=$this->Mainclass->Db->Fetch_row();
			$this->Mainclass->Db->Update($this->table_name,array('!l'=>'`l`+2'),'`l`>'.(int)$r,__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`+2'),'`r`>='.(int)$r,__file__,__line__);
			$arr_values['l']=$r++;
			$arr_values['r']=$r;
			$this->Mainclass->Db->Insert($this->table_name,$arr_values,__file__,__line__);
		}
		$this->Mainclass->Db->Transaction('COMMIT');
		$this->Mainclass->Cache->CleanCacheByTag('categories');
		$this->MakeDump('',true);
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}

	protected function DeleteCategory($id)
	{
		if(!CheckKey())
			return ExitPrefix();
		$this->Mainclass->Db->Query('SELECT `title`,`parent`,`l`,`r`,`pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if($this->Mainclass->Db->Num_rows()==0)
			ExitBack();
		list($ctitle,$parent,$l,$r,$pos)=$this->Mainclass->Db->Fetch_row();
		if(isset($_POST['ok']) and $_POST['ok']=='ok')
		{
			$this->Mainclass->Db->Transaction('BEGIN');
			$to_kill=array($id);
			$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_'.$this->table_name.'` WHERE `l`>'.$l.' AND `r`<'.$r,__file__,__line__);
			while($t=$this->Mainclass->Db->Fetch_row())
				$to_kill[]=$t[0];
			$cnt=$this->Mainclass->Db->Delete($this->table_name,'`id`'.$this->Mainclass->Db->In($to_kill),__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$cnt),'`r`>'.$l,__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$cnt,'!l'=>'`l`-'.$cnt),'`l`>'.$l,__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name,array('!pos'=>'`pos`-1'),'`pos`>'.$pos.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
			if(is_callable($this->delete_func_callback))
				call_user_func($this->delete_func_callback,$to_kill);
			$this->Mainclass->Db->Transaction('COMMIT');
			$this->Mainclass->Cache->CleanCacheByTag('categories');
			if(empty($_POST['back']))
				ExitPrefix();
			else
				Functions::Redirect(base64_decode($_POST['back']));
		}
		else
		{
			$this->title=$this->lang['del_confirm'];
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
			$this->Mainclass->ShowDecoration(false);
			return $this->Mainclass->Template->GetThemeFile(
															'Confirm',
															array(
																	'url'=>$this->Mainclass->Url->ConstructUrl(array('delete'=>$id)),
																	'message'=>sprintf($this->lang['deleting'],$ctitle).($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
															)
			);
		}
	}

	protected function MoveCatUp($id)
	{
		if(!CheckKey())
			return ExitPrefix();
		$this->Mainclass->Db->Query('SELECT `parent`,`l`,`r`,`pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($parent,$l,$r,$posit)=$this->Mainclass->Db->Fetch_row();
		$this->Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_'.$this->table_name.'` WHERE `pos`=(SELECT MAX(`pos`) FROM `prefix_'.$this->table_name.'` WHERE `pos`<'.$posit.' AND `parent`='.$parent.') AND `parent`='.$parent,__file__,__line__);
		list($cnt)=$this->Mainclass->Db->Fetch_row();
		if($cnt>0)
		{
			if($cnt>1)
			{
				$this->Optimize(false);
				$this->Mainclass->Db->Query('SELECT `pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				list($posit)=$this->Mainclass->Db->Fetch_row();
			}
			$this->Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_'.$this->table_name.'` WHERE `pos`='.--$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
			if($old=$this->Mainclass->Db->Fetch_assoc())
			{
				#Смещение категории, на место которой мы ставим текущую
				$offset_a=$old['r']-$old['l']+1;
				#Смещение текущей категории на новое место
				$offset_b=$r-$l+1;
				if($r>$old['r'])
				{
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				}
				else
				{
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
				}
				$this->Mainclass->Db->Update($this->table_name,array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
				$this->MakeDump('',true);
			}
			$this->Mainclass->Db->Update($this->table_name, array('!pos'=>'`pos`+1'),'`pos`='.$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name, array('!pos'=>'`pos`-1'),'`id`='.$id.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		}
		ExitPrefix();
	}

	protected function MoveCatDown($id)
	{
		if(!CheckKey())
			return ExitPrefix();
		$this->Mainclass->Db->Query('SELECT `parent`,`l`,`r`,`pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($parent,$l,$r,$posit)=$this->Mainclass->Db->Fetch_row();
		$this->Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_'.$this->table_name.'` WHERE `pos`=(SELECT MIN(`pos`) FROM `prefix_'.$this->table_name.'` WHERE `pos`>'.$posit.' AND `parent`='.$parent.') AND `parent`='.$parent,__file__,__line__);
		list($cnt)=$this->Mainclass->Db->Fetch_row();
		if($cnt>0)
		{
			if($cnt>1)
			{
				$this->Optimize(false);
				$this->Mainclass->Db->Query('SELECT `pos` FROM `prefix_'.$this->table_name.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
				list($posit)=$this->Mainclass->Db->Fetch_row();
			}
			$this->Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_'.$this->table_name.'` WHERE `pos`='.++$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
			if($old=$this->Mainclass->Db->Fetch_assoc())
			{
				#Смещение категории, на место которой мы ставим текущую
				$offset_a=$old['r']-$old['l']+1;
				#Смещение текущей категории на новое место
				$offset_b=$r-$l+1;
				if($r>$old['r'])
				{
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				}
				else
				{
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
					$this->Mainclass->Db->Update($this->table_name,array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
				}
				$this->Mainclass->Db->Update($this->table_name,array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
				$this->MakeDump('',true);
			}
			$this->Mainclass->Db->Update($this->table_name, array('!pos'=>'`pos`-1'),'`pos`='.$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
			$this->Mainclass->Db->Update($this->table_name, array('!pos'=>'`pos`+1'),'`id`='.$id.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		}
		ExitPrefix();
	}

	public function Optimize($redirect=true)
	{
		$result=$this->Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_'.$this->table_name.'` ORDER BY `parent` ASC, `pos` ASC',__file__,__line__);
		$cnt=0;
		$parent=-1;
		while ($arr=$this->Mainclass->Db->Fetch_assoc($result))
		{
			if($parent!=$arr['parent'])
			{
				$parent=$arr['parent'];
				$cnt=0;
			}
			if($arr['pos']!=$cnt)
				$this->Mainclass->Db->Update($this->table_name,array('pos'=>$cnt),'`id`='.$arr['id'].' LIMIT 1',__file__,__line__);
			++$cnt;
		}
		$this->RestoreRLByParent();
		if($redirect)
			ExitPrefix();
	}

	public function RestoreRLByParent($table_name='')
	{
		#http://blog.azazel.org.ua/wp-content/uploads/2008/01/nastedsetclass1.phps
		#http://web-notes.ru/2005/01/nested_sets/
		if(!$table_name)
			$table_name=$this->table_name;
		$tree_=$tree=$tosort=$dump=array();
		$this->Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_'.$table_name.'` ORDER BY `pos` DESC',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc())
			if($arr['parent']==0)
			{
				$tree_[$arr['id']]=array('id'=>$arr['id'],'parent'=>0,'nest'=>0);
				$tosort[$arr['id']]=$arr['pos'];
			}
			else
				$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
		asort($tosort,SORT_NUMERIC);
		$tosort=array_keys($tosort);
		foreach($tosort as &$v)
			$tree[]=$tree_[$v];
		unset($tree_);
		$len=0;
		while(count($dump)!=$len)
		{
			$len=count($dump);
			foreach($dump as $k=>&$v)
				if(false!==$id=array_search($v['parent'],$tosort))
				{
					array_splice($tree,$id+1,0,array(array('id'=>(int)$v['id'],'parent'=>(int)$v['parent'],'nest'=>$tree[$id]['nest']+1)));
					array_splice($tosort,$id+1,0,array($v['id']));
					unset($dump[$k]);
				}
		}
		unset($tosort);
		$onest=-1;
		$ids=array();
		$n=1;
		foreach($tree as $k=>&$v)
		{
			if($v['nest']>$onest)
				$tree[$k]['l']=$n;
			else
			{
				$id=array_pop($ids);
				$tree[$id]['r']=$n;
				$q=$tree[$id]['nest']-$v['nest'];
				for(;$q>0;--$q)
					if(null!==$id=array_pop($ids))
						$tree[$id]['r']=++$n;
				$tree[$k]['l']=++$n;
			}
			$ids[]=$k;
			$onest=$v['nest'];
			++$n;
		}
		while(null!==$id=array_pop($ids))
			$tree[$id]['r']=$n++;
		foreach($tree as &$v)
			$this->Mainclass->Db->Update($table_name,array('r'=>$v['r'],'l'=>$v['l']),'`id`='.(int)$v['id'].' LIMIT 1',__file__,__line__);
		$this->MakeDump($table_name,true);
	}
}
?>