<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');

class Comments extends BaseClass
{
	public
		$view=1,#Просмотр комментариев: 1 - обратный порядок, 2 - прямой, 3 - дерево.
		$per_page=10,#Количество комментариев на страницу
		$allow_post=true,#Разрешить добавление комментариев
		$time_limit=600,#Лимит времени, за которое можно оставить 1 комментарий. Указывается в секундах.
		$allow_karma=true,#Разрешить изменения кармы
		$captcha=true,#Показывать капчу гостям
		$moder=false,#Может редактировать/удалять комментарии (и чужие)
		$show_ip=true,#Показывать модератору IP адрес
		$own=true,#Может редактировать/удалять свои комментарии
		$own_time=86400,#Лимит времени, в период которого после публикации коммента учасник может его отредактировать. 0 - отключено. Модер может всегда
		$guest_avatar='guest.gif',#Аватар гостя
		$noavatar='noavatar.gif',#Пользователь без аватар
		$anonimus='Гость_',#Префикс гостя
		$table='comments',#Таблица комментариев
		$new_status=1,#Статус новых комментариев.
		$mark_spam=false,
		$lang=array();
	protected

		$u,
		$users=array();#Пользователи для функции FormatPosts & FormatUsers

	public function __construct($Mainclass)
	{
		$Mainclass->LoadClass('classes/others/class_editor.php');
		$Mainclass->LoadOptions('reg',false);
		$Mainclass->LoadOptions('comments',false);
		if(isset($Mainclass->vars['comments_view']))
			$this->view=$Mainclass->vars['comments_view'];
		if(isset($Mainclass->vars['comments_per_page']))
			$this->per_page=$Mainclass->vars['comments_per_page'];
		if(isset($Mainclass->vars['comments_time_limit']))
			$this->time_limit=$Mainclass->vars['comments_time_limit'];
		$this->captcha=$Mainclass->vars['comments_captcha'];
		$this->allow_karma=$Mainclass->vars['comments_karma'];
		$this->own=$Mainclass->vars['comments_own'];
		$this->own_time=isset($Mainclass->vars['comments_own']) ? (int)$Mainclass->vars['comments_own'] : 0;
		$this->anonimus=$Mainclass->vars['comments_anonimus'];
		$this->guest_avatar=$this->Mainclass->Template->GetImage($Mainclass->vars['comments_guest']);
		$this->noavatar=$this->Mainclass->Template->GetImage($Mainclass->vars['noavatar']);
		$this->lang=$this->Mainclass->LoadLanguage('langs','','comments-%');
		if($Mainclass->Login->IsUser())
			$this->captcha=false;
	}

	public function Show($value,$ajax=false)
	{
		if(!$ajax)
		{
			$this->u='c_'.($mid=$this->Mainclass->GetModVal('id')).'_'.$value;
			$content='<a name="comments" id="comments" style="font-size: 0px; line-height: 0px"></a>'.Strings::AddJS('js/eleanor_comments.js');
		}
		else
		{
			$mid=$this->Mainclass->GetModVal('id');
			$content='';
		}
		$this->moder|=$this->Mainclass->Permission->IsAdmin();
		$status=$this->moder ? '' : ' AND `status`>0';
		$this->Mainclass->Db->FQuery('SELECT COUNT(`id`) FROM {"0"} WHERE `mid`={"1"} AND `m_value`={"2"}'.$status,array($this->table,'i_'.$mid,'s_'.$value),__file__,__line__);
		list($cnt)=$this->Mainclass->Db->Fetch_row();
		$pages=ceil($cnt/$this->per_page);
		if(isset($_GET['findcomment']))
		{
			$comm_id=$_GET['findcomment'];
			$this->Mainclass->Db->FQuery('SELECT COUNT(`id`) FROM {"0"} WHERE `id`<={"3"} AND `mid`={"1"} AND `m_value`={"2"}'.$status.' LIMIT 1',array($this->table,'i_'.$mid,'s_'.$value,'i_'.$comm_id),__file__,__line__);
			list($comm_cnt)=$this->Mainclass->Db->Fetch_row();
			if($comm_cnt==0)
				return ExitPrefix();
			if($this->view==3)
				Functions::Redirect(ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/'.$this->Mainclass->Url->Prefix().'#comment'.$comm_id);
			else
			{
				$page=$pages-floor($comm_cnt/$this->per_page);
				if($page==$pages)
					$page=0;
				else
					$page=$pages-$page;
				Functions::Redirect(ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/'.htmlspecialchars_decode($this->Mainclass->Url->ConstructUrl(array(array('page'=>$page)))).'#comment'.$comm_id);
			}
			die;
		}
		if($cnt==0)
			$content.=($ajax ? '' : '<div id="d_'.$this->u.'">').'<div align="center"><span class="option">'.$this->lang['no_comments'].'</span></div>'.($ajax ? '' : '</div>')
					.($ajax ? '' : Strings::JsVars(array($this->u=>'!_ new Comments('.$mid.',\''.$value.'\',\''.$this->u.'\',\''.$this->Mainclass->Url->Prefix(false,false).'\',\''.$this->Mainclass->Url->ending.'\',0,0,'.$this->view.',0,0)')));
		else
		{
			if($this->view==3 and !$ajax and !$this->moder and !$this->Mainclass->Login->IsUser())
			{
				$cache=$this->Mainclass->Cache->Get($this->u,false);
				if($cache!==false)
					return $cache;
			}
			if($this->view!=3)
			{
				$page=isset($_GET['page']) ? (int)$_GET['page'] : 0;
				if(($this->view!=2 or $ajax) and $page==0)
					$page=$pages;
				if($page<=0)
					$page=1;
				if($page>$pages)
					$page=$pages;
				$offset=abs(($page-1)*$this->per_page);
				$comm_n=$offset+($this->view==2 ? 1 : min($this->per_page,$cnt-$offset));
			}
			else
			{
				$values=$dump=$tosort=array();
				$last=true;
				$page=$pages=$comm_n=1;
			}
			$nesting=$ids=$uids=$ips=$dates=$names=$texts=$karma=$parents=$statuses=$whspam=array();
			$this->Mainclass->Db->FQuery('SELECT `id`,`date`,`name`,`uid`,`ip`,`parent`,`text`,`karma`,LOCATE(\','.$this->Mainclass->Account->GetValue('id').',\',`karma_ids`) `who`,`status`,`who_m_spam` FROM {"0"} WHERE `mid`={"1"} AND `m_value`={"2"}'.$status.' ORDER BY `id` '.($this->view%2 ? 'DESC' : 'ASC').($this->view==3 ? '' : ' LIMIT '.$offset.', '.$this->per_page),array($this->table,'i_'.$mid,'s_'.$value),__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
			{
				$arr['text']='<div id="'.$this->u.'_t'.$arr['id'].'">'.$arr['text'].'</div>';
				$arr['date']=substr($arr['date'],0,-3); #Убираем секунды
				if($arr['name'])
					$arr['name']=preg_replace('#&[^;]+$#i','',$arr['name']);
				if($this->view==3)
				{
					$arr['karma']=$this->Karma($arr['karma'],$arr['who'],$arr['id'],$arr['uid']);
					$arr['nesting']=0;
					unset($arr['who']);
					$values[$arr['id']]=$arr;
					if($arr['parent']==0)
					{
						if($last)
						{
							$values[$arr['id']]+=array('last'=>true);
							$last=false;
						}
						$tosort[$arr['id']]=$arr['id'];
					}
					else
						$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
				}
				else
				{
					$ids[]		=$arr['id'];
					$uids[]		=$arr['uid'];
					$ips[]		=$arr['ip'];
					$dates[]	=$arr['date'];
					$parents[]	=0;
					$names[]	=$arr['name'];
					$texts[]	=$arr['text'];
					$karma[]	=$this->Karma($arr['karma'],$arr['who'],$arr['id'],$arr['uid']);
					$statuses[]	=$arr['status'];
					$whspam[]	=$arr['who_m_spam'];#Кто пометил пост спамным
				}
			}
			if($this->view==3)
			{
				asort($tosort,SORT_NUMERIC);
				$keys=array_keys($tosort);
				unset($tosort);
				$len=0;
				$last=array();
				while (count($dump)!=$len)
				{
					$len=count($dump);
					foreach ($dump as $k=>$v)
						if(false!==$id=array_search($v['parent'],$keys))
						{
							$values[$v['id']]['nesting']=$values[$v['parent']]['nesting']+1;
							if(!in_array($v['parent'],$last))
							{
								$values[$v['id']]['last']=true;
								$last[]=$v['parent'];
							}
							array_splice($keys,$id+1,0,array((int)$v['id']));
							unset($dump[$k]);
						}
				}
				foreach($keys as &$v)
				{
					$ids[]		=$values[$v]['id'];
					$uids[]		=$values[$v]['uid'];
					$ips[]		=$values[$v]['ip'];
					$dates[]	=$values[$v]['date'];
					$parents[]	=$values[$v]['parent'];
					$names[]	=$values[$v]['name'];
					$texts[]	=$values[$v]['text'];
					$karma[]	=$values[$v]['karma'];
					$nesting[]	=$values[$v]['nesting'];
					$statuses[]	=$values[$v]['status'];
					$whspam[]	=$values[$v]['who_m_spam'];#Кто пометил пост спамным
				}
				$pages_list='';
			}
			else
			{
				$nesting=&$parents;
				$this->Mainclass->Url->hash='comments';
				$pages_list=Strings::Pages($cnt,$this->per_page,array(),false,$this->view==2 ? $page : -1*$page,$this->u.'.GoToPage(\'{page}\')');
				$this->Mainclass->Url->hash='';
			}
			$content.=($ajax ? '' : '<div id="d_'.$this->u.'">').$this->TempHeadComment().($this->view==3 ? '<ul class="com-list">' : '').$this->FormatPosts($ids,$uids,$ips,$dates,$names,$texts,$karma,$nesting,$comm_n,$statuses,$whspam).($this->view==3 ? '</ul>' : '').$this->TempFootComment().$pages_list.($ajax ? '' : '</div>')
					.($ajax ? '' : Strings::JsVars(array($this->u=>'!_ new Comments('.$mid.',\''.$value.'\',\''.$this->u.'\',\''.$this->Mainclass->Url->Prefix(false,false).'\',\''.$this->Mainclass->Url->ending.'\','.$page.','.(int)($this->view==1 ? reset($ids) : end($ids)).','.$this->view.','.(int)$pages.','.($comm_n+($this->view==1 ? 0 : count($ids)-1)).')')));
		}
		if(!$ajax)
			$content.=/*'<div align="center"><a href="#" onclick="return '.$this->u.'.Update();" class="link-button" style="width=180px"><b>'.$this->lang['load_new_posts'].'</b></a></div>'.*/$this->Editor();
		if($this->view==3 and !$ajax and !$this->moder)
			$this->Mainclass->Cache->Put($this->u,$content,7200,false);
		return ($ajax ? array('comments'=>$content,'pages'=>$pages,'last'=>(int)($this->view==1 ? reset($ids) : end($ids)),'page'=>$page,'comm_n'=>$comm_n+($this->view==1 ? 0 : count($ids)-1)) : $content);
	}

	public function DeleteComments($v,$mid=-1)
	{
		if($mid==-1)
			$mid=$this->Mainclass->GetModVal('id');
		return $v ? $this->Mainclass->Db->Delete($this->table,'`mid`='.(int)$mid.' AND `m_value`'.$this->Mainclass->Db->In($v),__file__,__line__) : true;
	}

	/*
		Функция получения типа события. Возвращает результат в виде строки. Возможные значения:
		POST - публикация комментария
		EDIT - редактирование комментария
		SAVE - сохранение комментария
		KARMA - изменение кармы
	*/
	public function GetType()
	{
		if(!isset($_REQUEST['comments']) or !is_array($_REQUEST['comments']))
			return false;
		switch ($_REQUEST['comments']['type'])
		{
			case 'add':
				return 'ADD';
			break;
			case 'edit':
				return 'EDIT';
			break;
			case 'save':
				return 'SAVE';
			break;
			case 'karma':
				return 'KARMA';
			break;
			case 'page':
				return 'PAGE';
			break;
			case 'delete':
				return 'DELETE';
			break;
			case 'mark_spam':
				return 'MARK_SPAM';
			break;
			case 'unmark_spam':
				return 'UNMARK_SPAM';
			break;
			case 'set_status':
				return 'SET_STATUS';
			break;
			case 'new_posts':
				return 'NEW_POSTS';
			break;
			default:
				return false;
			break;
		}
	}

	/*
		Функция выполнения внутренних событий комментариев
	*/
	public function DoEvents($error='')
	{
		if(!isset($_REQUEST['comments']) or !is_array($_REQUEST['comments']))
			return false;
		$this->moder|=$this->Mainclass->Permission->IsAdmin();
		$error_n=false;
		if(!$error)
		{
			if(isset($_REQUEST['comments']['v']))
				$v=$_REQUEST['comments']['v'];
			if(isset($_REQUEST['comments']['u']))
				$this->u=$_REQUEST['comments']['u'];
			if(isset($_REQUEST['comments']['view']))
				$this->view=(int)$_REQUEST['comments']['view'];
			if(isset($_REQUEST['comments']['link']))
				$this->Mainclass->Url->SetPrefix($_REQUEST['comments']['link']);
			if(isset($_REQUEST['comments']['end_l']))
				$this->Mainclass->Url->ending=$_REQUEST['comments']['end_l'];
			switch ($_REQUEST['comments']['type'])
			{
				case 'add':
					do
					{
						if(!$this->allow_post)
						{
							$error=$this->lang['comments_not_allowed'];
							break;
						}
						$email=(isset($_REQUEST['comments']['email']) and !$this->Mainclass->Login->IsUser()) ? $_REQUEST['comments']['email'] : '';
						if($email and !Functions::CheckEmail($email))
						{
							$error=$this->lang['wrong_email'];
							break;
						}
						if($this->captcha)
						{
							$this->Mainclass->LoadClass('classes/captcha/class_captcha.php');
							if(!isset($_REQUEST['comments']['check']))
								$_REQUEST['comments']['check']='';
							$this->Mainclass->Captcha->SetPost('check_c',$_REQUEST['comments']['check'],$_REQUEST['comments']['sess_id'],$this->u);
							if(!$this->Mainclass->Captcha->PostCheck('check_c',$this->u))
							{
								$error=$this->lang['wrong_protect_code'];
								$this->Mainclass->Captcha->Destroy();
								$error_n=2;#Неверная капча
								break;
							}
						}
						$text=isset($_REQUEST['comments']['text']) ? trim($_REQUEST['comments']['text']) : '';
						$text=$this->Mainclass->Editor->GetHtml($text,true);
						if(!$text or (strlen(strip_tags($text))<5 and stripos($text,'img')===false))
						{
							$error=$this->lang['comment_not_entered'];
							break;
						}
						if(false===$name=$this->Mainclass->Account->GetValue('name'))
						{
							$name=isset($_REQUEST['comments']['name']) ? trim($this->Mainclass->AJAX['comments']['name']) : false;
							if(!$name)
							{
								$error=$this->lang['enter_your_name'];
								break;
							}
							$uid=0;
						}
						else
							$uid=$this->Mainclass->Account->GetValue('id');
						$parent=isset($_REQUEST['comments']['parent']) ? (int)$_REQUEST['comments']['parent'] : 0;
						if($this->view==3 and $parent>0)
						{
							$status=$this->moder ? '' : ' AND `status`>0';
							$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_'.$this->table.'` WHERE `id`='.$parent.' AND `m_value`=\''.$this->Mainclass->Db->EscapeString($v).'\' AND `mid`=\''.(int)$this->Mainclass->GetModVal('id').'\''.$status,__file__,__line__);
							if($this->Mainclass->Db->Num_rows()==0)
							{
								$error=$this->lang['comment2ans_not_found'];
								break;
							}
						}
						else
							$parent=0;
						if($this->time_limit>0)
						{
							$this->Mainclass->Functions->PrepareVoting($this->u);
							if(!$this->Mainclass->Functions->CanVoting($this->u))
							{
								$error=sprintf($this->lang['time_limit_text'],$this->time_limit);
								break;
							}
							$this->Mainclass->Functions->AddVoting($this->u,$this->time_limit.'s');
						}
						if(!$error)
						{
							$arr=array(
										'mid'		=>$this->Mainclass->GetModVal('id'),
										'm_value'	=>$v,
										'date'		=>date('Y-m-d H:i:s'),
										'uid'		=>$uid,
										'name'		=>$name,
										'ip'		=>$this->Mainclass->ip,
										'parent'	=>$parent,
										'text'		=>$text,
										'status'	=>$this->moder ? 1 : $this->new_status,
										'email'		=>$email,
										'karma_ids'=>','
							);
							$id=$this->Mainclass->Db->Insert($this->table,$arr,__file__,__line__);
							if(empty($_REQUEST['comments']['load']))
							{
								$result=array('type'=>'ok');
								$result['lastid']=$id;
							}
							else
							{
								$this->comm_n=$this->last_id=0;
								$last=isset($_REQUEST['comments']['last']) ? (int)$_REQUEST['comments']['last'] : 0;
								$comm_n=isset($_REQUEST['comments']['comm_n']) ? (int)$_REQUEST['comments']['comm_n'] : 0;
								$result=$this->LoadNewComments($v,$last,$comm_n);
								if(!$result)
									$result=array('type'=>'ent','comments'=>'','message'=>$this->Mainclass->Template->Message($this->lang['mod_check'],'info'));
								elseif($last==0)
								{
									if(is_array($result))
										$result=implode('',$result);
									if($this->view==3)
										$result='<ul class="com-list">'.$result.'</ul>';
									$result=array('type'=>'ent','comments'=>$this->TempHeadComment().$result.$this->TempFootComment());
								}
								else
									$result=array('type'=>$this->view==3 ? 'arr' : 'str','comments'=>$result);
								$result['comm_n']=$comm_n+$this->comm_n;
								$result['lastid']=$this->last_id;
							}
						}
						else
							$result=array();
						if($this->view==3)
							$this->Mainclass->Cache->Delete($this->u,false);
					}while(false);
				break;
				case 'page':
					$_GET['page']=isset($_REQUEST['comments']['page']) ? (int)$_REQUEST['comments']['page'] : 1;
					$result=$this->Show($v,true);
				break;
				case 'new_posts':
					$this->last_id=0;
					$this->comm_n=0;
					$last=isset($_REQUEST['comments']['last']) ? (int)$_REQUEST['comments']['last'] : 0;
					$comm_n=isset($_REQUEST['comments']['comm_n']) ? (int)$_REQUEST['comments']['comm_n'] : 0;
					$result=$this->LoadNewComments($v,$last,$comm_n);
					if($result===false)
						$result=array('no'=>1);
					elseif($last==0)
					{
						if(is_array($result))
							$result=implode('',$result);
						if($this->view==3)
							$result='<ul class="com-list">'.$result.'</ul>';
						$result=array('type'=>'ent','comments'=>$this->TempHeadComment().$result.$this->TempFootComment());
					}
					else
						$result=array('type'=>$this->view==3 ? 'arr' : 'str','comments'=>$result);
					$result['comm_n']=$comm_n+$this->comm_n;
					$result['lastid']=$this->last_id;
				break;
				case 'delete':
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$this->Mainclass->Db->Query('SELECT `id`,`uid`,UNIX_TIMESTAMP(`date`) `date`,`status` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->Mainclass->Db->Num_rows()==0)
						return Result('ok');
					$arr=$this->Mainclass->Db->Fetch_assoc();
					$uid=-1;
					if($this->Mainclass->Login->IsUser())
						$uid=$this->Mainclass->Account->GetValue('id');
					$time=$this->Mainclass->MyTime();
					$can=$this->moder or $this->own and ($this->own_time==0 or ($time-$this->own_time)<$arr['date']) and $uid==$arr['uid'] and $uid>0 and $arr['status']>0;
					$this->count_delete=0;
					if(!$can)
					{
						Error($this->lang['delete_not_allowed']);
						break;
					}
					$ids=array($id);
					$this->GetSubs($v,$id,$ids);
					$this->Mainclass->Db->Delete($this->table,'`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
					$this->count_delete=count($ids);
					if($this->view==3)
						$this->Mainclass->Cache->Delete($this->u,false);
					Result('ok',false);
					return empty($error_n);
				break;
				case 'edit':
					if($error)
					{
						Error($error);
						break;
					}
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$this->Mainclass->Db->Query('SELECT `id`,`uid`,UNIX_TIMESTAMP(`date`) `date`,`text`,`status` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->Mainclass->Db->Num_rows()==0)
					{
						Error($this->lang['comment_not_exists']);
						break;
					}
					$arr=$this->Mainclass->Db->Fetch_assoc();
					$uid=-1;
					if($this->Mainclass->Login->IsUser())
						$uid=$this->Mainclass->Account->GetValue('id');
					$time=$this->Mainclass->MyTime();
					$can=$this->moder or $this->own and ($this->own_time==0 or ($time-$this->own_time)<$arr['date']) and $uid==$arr['uid'] and $uid>0 and $arr['status']>0;
					if(!$can)
						Error($this->lang['edit_not_allowed']);
					else
						$result['html']=$this->Mainclass->Editor->Area($this->u.'_edit'.$id,$arr['text'],7).'<div align="center" style="padding-top: 15px">'
						.Template::Button(EL_LANG_SAVE,'button','onclick="'.$this->u.'.Save('.$id.');"').Template::Button($this->lang['cancel'],'button','onclick="'.$this->u.'.Cancel('.$id.');"').'</div>';
				break;
				case 'save':
					$text=isset($_REQUEST['comments']['text']) ? trim($_REQUEST['comments']['text']) : false;
					if(!$text)
					{
						Error($this->lang['comment_not_entered']);
						break;
					}
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$this->Mainclass->Db->Query('SELECT `id`,`uid`,UNIX_TIMESTAMP(`date`) `date` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->Mainclass->Db->Num_rows()==0)
					{
						Error($this->lang['comment_not_exists']);
						break;
					}
					$arr=$this->Mainclass->Db->Fetch_assoc();
					$uid=-1;
					if($this->Mainclass->Login->IsUser())
						$uid=$this->Mainclass->Account->GetValue('id');
					$time=$this->Mainclass->MyTime();
					$can=$this->moder or $this->own and ($this->own_time==0 or ($time-$this->own_time)<$arr['date']) and $uid==$arr['uid'] and $uid>0 and $arr['status']>0;
					if(!$can)
					{
						Error($this->lang['edit_not_allowed']);
						break;
					}
					$text=$this->Mainclass->Editor->GetHTML($text,true);
					$result['html']=Strings::ParseOwnBB($text);
					$this->Mainclass->Db->Update($this->table,array('text'=>$text),'`id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->view==3)
						$this->Mainclass->Cache->Delete($this->u,false);
				break;
				case 'karma':
					if(!$this->allow_karma or !$this->Mainclass->Login->IsUser())
					{
						Error($this->lang['karma_not_allowed']);
						break;
					}
					$uid=$this->Mainclass->Account->GetValue('id');
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$this->Mainclass->Db->Query('SELECT `uid`,`karma`,LOCATE(\','.$uid.',\',`karma_ids`) `who` FROM `prefix_'.$this->table.'` WHERE `id`='.$id.' AND `status`>0 LIMIT 1',__file__,__line__);
					if($this->Mainclass->Db->Num_rows()==0)
					{
						Error($this->lang['comment_not_exists']);
						break;
					}
					$arr=$this->Mainclass->Db->Fetch_assoc();
					if(!$arr['who'])
					{
						$n=isset($_REQUEST['comments']['n']) ? (int)$_REQUEST['comments']['n'] : 1;
						$n=$n>-1 ? 1 : -1;
						$arr['karma']+=$n;
						$this->Mainclass->Db->Update($this->table,array('karma'=>$arr['karma'],'!karma_ids'=>'CONCAT(`karma_ids`,\','.$uid.',\')'),'`id`='.$id.' LIMIT 1',__file__,__line__);
						if($this->view==3)
							$this->Mainclass->Cache->Delete($this->u,false);
					}
					$result['html']=$arr['karma'];
				break;
				case 'mark_spam':
					if(!$this->Mainclass->Login->IsUser() or !$this->mark_spam)
					{
						Error();
						break;
					}
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$whomark=$this->Mainclass->Account->GetValue('id').','.$this->Mainclass->Account->GetValue('name');
					$this->Mainclass->Db->Update($this->table,array('status'=>2,'who_m_spam'=>$whomark),'`id`='.$id.' AND `status`=1 LIMIT 1',__file__,__line__);
					if($this->view==3)
						$this->Mainclass->Cache->Delete($this->u,false);
					return Result('ok');
				break;
				case 'unmark_spam':
					if(!$this->Mainclass->Login->IsUser() or !$this->mark_spam)
					{
						Error();
						break;
					}
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$this->Mainclass->Db->Query('SELECT `who_m_spam` FROM `prefix_'.$this->table.'` WHERE`id`='.$id.' AND `status`=2 LIMIT 1',__file__,__line__);
					if(list($whoms)=$this->Mainclass->Db->Fetch_row())
					{
						$whoms=(int)$whoms;
						if($whoms!=$this->Mainclass->Account->GetValue('id'))
						{
							Error();
							break;
						}
					}
					else
					{
						Error();
						break;
					}
					$this->Mainclass->Db->Update($this->table,array('status'=>1,'who_m_spam'=>''),'`id`='.$id.' AND `status`=2 LIMIT 1',__file__,__line__);
					if($this->view==3)
						$this->Mainclass->Cache->Delete($this->u,false);
					return Result('ok');
				break;
				case 'set_status':
					if(!$this->moder)
					{
						Error();
						break;
					}
					$id=isset($_REQUEST['comments']['id']) ? (int)$_REQUEST['comments']['id'] : 0;
					$status=isset($_REQUEST['comments']['status']) ? (int)$_REQUEST['comments']['status'] : 1;
					if($status<-2 or $status>3)
						$status=1;
					$upd=array('status'=>$status);
					if($status=1)
						$upd['who_m_spam']='';
					$this->Mainclass->Db->Update($this->table,$upd,'`id`='.$id.' LIMIT 1',__file__,__line__);
					if($this->view==3)
						$this->Mainclass->Cache->Delete($this->u,false);
					return Result('ok');
				break;
				default:
					Error();
			}
		}
		if($error and !$error_n)
			$error_n=1;
		if($error)
			$result['message']=$this->Mainclass->Template->Message($error,'error');
		$result['error_n']=$error_n;
		Result($result,false);
		return empty($error_n);
	}

	protected function Editor()
	{
		if(!$this->allow_post)
			return $this->Mainclass->Template->Message($this->lang['comments_not_allowed']);
		$this->Mainclass->Loadclass('classes/others/class_editor.php');
		if($this->captcha)
		{
			$this->Mainclass->LoadClass('classes/captcha/class_captcha.php');
			$captcha=$this->Mainclass->Captcha->GetCode(array('captcha'=>$this->u,'noprefix'=>1),$this->u);
		}
		else
			$captcha=false;
		return $this->Mainclass->Template->OpenTable()
			.$this->Mainclass->Template->GetClass('Comments')->Editor($this->lang,$this->u,$captcha,$this->view==3 ? Template::Control('parent','hidden','0','id="'.$this->u.'_parent"') : false)
			.$this->Mainclass->Template->CloseTable();
	}

	/*
		Функция форматирует карму комментария
	*/
	protected function Karma($k,$who,$id,$user_id)
	{static $uid=-1;
		if(!$this->allow_karma or !$this->Mainclass->Login->IsUser())
			return $this->lang['karma'].$k;
		if($uid==-1)
			$uid=$this->Mainclass->Account->GetValue('id');
		return $this->lang['karma'].(($who or $user_id==$uid) ? $k : '<span id="k_'.$this->u.'_'.$id.'"><a href="#" onclick="return '.$this->u.'.AddKarma('.$id.',1);" title="'.$this->lang['plus'].'">+</a> '.$k.' <a href="#" onclick="return '.$this->u.'.AddKarma('.$id.',-1);" title="'.$this->lang['minus'].'">-</a></span>');
	}

	protected function FormatUsers($uids)
	{
		$users=array_diff($uids,$this->users);
		if(!$users)
			return;
		$result=$this->Mainclass->Db->Query('SELECT `id`,`name`,`register`,`icq`,`aim`,`website`,`yahoo`,`msn`,`location`,`signature`,`avatar_location`,`avatar_size`,`avatar_type` FROM `prefix_users` INNER JOIN `prefix_users_extra` USING(`id`) WHERE `id`'.$this->Mainclass->Db->In($users),__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
		{
			$arr['signature']=Strings::ParseOwnBb($arr['signature']);
			$this->users[$arr['id']]=$arr;
		}

	}
	/*
		Функция, которая форматирует тело комментария, добавляя к нему данные пользователя, полученные на основе входящих данных:
		$ids - ИДы комментариев
		$uids - ИДы пользователей
		$ips - IP адреса пользователей
		$dates - даты комментариев
		$names - имена гостей, оставивших комментарий
		$textx - тексты комментариев
		$karma - карма коммента
		$nesting - уровни вложения друг в друга
		$status - статусы
		$whspam - кто пометил спамом ID,Title
		Может обрабатывать данные как в виде массива, так и в виде текстовых данных
	*/
	protected function FormatPosts($ids,$uids,$ips,$dates,$names,$texts,$karma,$nesting,$comm_n,$status,$whspam)
	{
		if(!is_array($ids))
		{
			$ids=array($ids);
			$uids=array($uids);
			$ips=array($ips);
			$dates=array($dates);
			$names=array($names);
			$texts=array($texts);
			$karma=array($karma);
		}
		$content='';
		$n=0;
		$this->FormatUsers($uids);
		$time=$this->Mainclass->MyTime();
		$uid=-1;
		if($this->Mainclass->Login->IsUser())
			$uid=$this->Mainclass->Account->GetValue('id');
		$temp=explode(' ',$this->Mainclass->vars['avatar_size'],2);
		$sys_a_h=$temp[1];
		$sys_a_w=$temp[0];
		foreach($ids as $k=>&$v)
		{
			$register=$profile=$icq=$aim=$website=$yahoo=$msn=$location=$signature=$width=$height='';
			if(empty($uids[$k]) or !isset($this->users[$uids[$k]]))
			{
				$name=(strncmp($names[$k],$this->anonimus,min(strlen($this->anonimus),$names[$k]))==0 ? '' : $this->anonimus).$names[$k];
				$avatar=$this->guest_avatar;
			}
			else
			{
				$user=$this->users[$uids[$k]];
				$profile=$this->Mainclass->Login->UserLink($user['name'],$uids[$k]);
				$user['name']=htmlspecialchars($user['name']);
				if(strpos($user['avatar_size'],'x')!==false)
				{
					$temp=explode('x',$user['avatar_size'],2);
					$width=$temp[0];
					$height=$temp[1];
				}
				$name=$user['name'];
				switch($user['avatar_type'])
				{
					case 'local':
					default:
						$avatar=$user['avatar_location'] ? 'images/avatars/'.$user['avatar_location'] : $this->noavatar;
					break;
					case 'upload':
						$avatar=$user['avatar_location'] ? Mainclass::UPLOADS_DIR.'/uploaded_avatars/'.$user['avatar_location'] : $this->noavatar;
					break;
					case 'url':
						$avatar=$user['avatar_location'] ? $user['avatar_location'] : $this->noavatar;
					break;
				}
				if($user['icq'])
					$icq='<img src="http://status.icq.com/online.gif?icq='.$user['icq'].'&amp;img=5" alt="'.$user['icq'].'" title="'.$user['icq'].'" />';
				if($user['aim'])
					$aim='<img src="images/aim.gif" width="16" height="16" border="0" alt="'.$user['aim'].'" title="'.$user['aim'].'" />';
				if($user['website'])
					$website='<a href="go.php?'.$user['website'].'">'.$user['website'].'</a>';
				if($user['yahoo'])
					$yahoo='<img src="images/yim.gif" width="16" height="16" border="0" alt="'.$user['aim'].'" title="'.$user['aim'].'" />';
				if($user['msn'])
					$msn='<img src="images/msn.gif" width="16" height="16" border="0" alt="'.$user['msn'].'" title="'.$user['msn'].'" />';
				if($location)
					$location=$this->lang['where_from'].$user['location'];
				$signature=$user['signature'];
				$register=$this->lang['register'].$user['register'];
			}
			if($this->view==3)
			{
				if($n>$nesting[$k])
				{
					$q=$n-$nesting[$k];
					$content.=str_repeat('</li></ul>',$q).'</li><li id="'.$this->u.'_l'.$v.'" class="com-tree-item">';
					$n-=$q;
				}
				elseif($n<$nesting[$k])
				{
					$content.='<ul class="com-tree"><li id="'.$this->u.'_l'.$v.'" class="com-tree-item">';
					$n++;
				}
				elseif($n==$nesting[$k])
					$content.=$content ? '</li><li id="'.$this->u.'_l'.$v.'" class="com-tree-item">' : '<li id="'.$this->u.'_l'.$v.'" class="com-tree-item">';
			}
			$can_edit=$this->moder or $this->own and ($this->own_time==0 or ($time-$this->own_time)<strtotime($dates[$k])) and $uid==$uids[$k] and $uid>0;
			$answer_to=$this->view==3;
			$ip=($this->moder and $this->show_ip) ? 'IP: <a href="http://eleanor-cms.ru/whois/'.$ips[$k].'">'.$ips[$k].'</a>' : '';
			switch($this->view)
			{
				case 3:
					$view='tree';
				break;
				case 2:
					$view='direct';
				break;
				default:
					$view='undirect';
			}
			$ms=$ums=false;
			if(!$this->moder and $this->mark_spam and $uid>0)
			{
				$ms=$status[$k]==1;
				$muid=(int)$whspam[$k];
				if($uid==$muid and $status[$k]==2)
				{
					$ms=false;
					$ums=true;
				}
			}
			$carr=array(
						'name'		=>$name,
						'can_edit'	=>$can_edit,
						'answer_to'	=>$answer_to,
						'location'	=>$location,
						'msn'		=>$msn,
						'yahoo'		=>$yahoo,
						'website'	=>$website,
						'aim'		=>$aim,
						'icq'		=>$icq,
						'avatar'	=>$avatar,
						'a_width'	=>(ctype_digit($width) and $width>$sys_a_w) ? $sys_a_w : '',
						'a_height'	=>(ctype_digit($height) and $height>$sys_a_h) ? $sys_a_h : '',
						'dates'		=>$dates[$k],
						'karma'		=>$karma[$k],
						'ip'		=>$ip,
						'profile'	=>$profile,
						'n'			=>$comm_n,
						'signature'	=>$signature,
						'comment_id'=>$v,
						'status'	=>$status[$k],
						'mark_spam'	=>$ms,
						'unmark_spam'=>$ums,
						'who_m_spam'=>$whspam[$k],
			);
			$content.=$this->Mainclass->Template->GetClass('Comments')->Post($view,$this->moder,$this->lang,$this->u,$carr,Strings::ParseOwnBB($texts[$k]),$this->Mainclass->Url->ConstructUrl(array(array('findcomment'=>$v))));
			if($this->view==1)
				$comm_n--;
			else
				$comm_n++;
		}
		if($this->view==3)
			$content.='</li>'.str_repeat('</ul></li>',$n);
		return $content;
	}

	protected function LoadNewComments($v,$last,$comm_n)
	{
		$status=$this->moder ? '' : ' AND `status`>0';
		$this->Mainclass->Db->FQuery('SELECT COUNT(`id`) FROM {"0"} WHERE `mid`={"1"} AND `m_value`={"2"} AND `id`>{"3"}'.$status,array($this->table,'i_'.($mid=$this->Mainclass->GetModVal('id')),'s_'.$v,'i_'.$last),__file__,__line__);
		list($cnt)=$this->Mainclass->Db->Fetch_row();
		if($cnt==0)
			return false;
		$this->comm_n+=$cnt;
		$values=$dump=$tosort=array();
		$this->Mainclass->Db->FQuery('SELECT `id`,`date`,`name`,`uid`,`ip`,`parent`,`text`,`karma`,LOCATE(\','.$this->Mainclass->Account->GetValue('id').',\',`karma_ids`) `who`,`status`,`who_m_spam` FROM {"0"} WHERE `mid`={"1"} AND `m_value`={"2"} AND `id`>{"3"}'.$status.' ORDER BY'.($this->view==3 ? '`parent` ASC,' : '').' `id` '.($this->view%2 ? 'DESC' : 'ASC'),array($this->table,'i_'.$mid,'s_'.$v,'i_'.$last),__file__,__line__);
		$nesting=array();
		$last=true;
		while($arr=$this->Mainclass->Db->Fetch_assoc())
		{
			$arr['text']='<div id="'.$this->u.'_t'.$arr['id'].'">'.$arr['text'].'</div>';
			$arr['date']=substr($arr['date'],0,-3);
			$uids[]=$arr['uid'];
			if($this->view==3)
			{
				$arr['karma']=$this->Karma($arr['karma'],$arr['who'],$arr['id'],$arr['uid']);
				$arr['nesting']=0;
				$values[$arr['id']]=$arr;
				if($arr['parent']==0)
				{
					if($last)
					{
						$values[$arr['id']]+=array('last'=>true);
						$last=false;
					}
					$tosort[$arr['id']]=$arr['id'];
				}
				else
					$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
			}
			else
			{
				$ids[]=$arr['id'];
				$ips[]=$arr['ip'];
				$dates[]=$arr['date'];
				$names[]=$arr['name'];
				$texts[]=$arr['text'];
				$statuses[]=$arr['status'];
				$whspam[]=$arr['who_m_spam'];
				$karma[]=$this->Karma($arr['karma'],$arr['who'],$arr['id'],$arr['uid']);
			}
		}
		if($this->view==1)
			$comm_n+=count($ids);
		else
			$comm_n++;
		if($this->view==3)
		{
			asort($tosort,SORT_NUMERIC);
			$keys=array_keys($tosort);
			unset($tosort);
			$len=0;
			$last=array();
			while(count($dump)!=$len)
			{
				$len=count($dump);
				foreach($dump as $k=>$v)
					if(false!==$id=array_search($v['parent'],$keys))
					{
						$values[$v['id']]['nesting']=$values[$v['parent']]['nesting']+1;
						if(!in_array($v['parent'],$last))
						{
							$values[$v['id']]['last']=true;
							$last[]=$v['parent'];
						}
						array_splice($keys,$id+1,0,array((int)$v['id']));
						unset($dump[$k]);
					}
			}
			if(count($values)>count($keys))
				$keys=array_merge($keys,array_diff(array_keys($values),$keys));
			$this->FormatUsers($uids);
			$pdata=array();
			foreach($keys as &$v)
			{
				$pdata[$values[$v]['parent']]['id'][]=$values[$v]['id'];
				$pdata[$values[$v]['parent']]['ip'][]=$values[$v]['ip'];
				$pdata[$values[$v]['parent']]['date'][]=$values[$v]['date'];
				$pdata[$values[$v]['parent']]['ip'][]=$values[$v]['ip'];
				$pdata[$values[$v]['parent']]['names'][]=$values[$v]['name'];
				$pdata[$values[$v]['parent']]['texts'][]=$values[$v]['text'];
				$pdata[$values[$v]['parent']]['status'][]=$values[$v]['status'];
				$pdata[$values[$v]['parent']]['whspam'][]=$values[$v]['who_m_spam'];
				$pdata[$values[$v]['parent']]['karma'][]=$values[$v]['karma'];
				$pdata[$values[$v]['parent']]['nesting'][]=$values[$v]['nesting'];
			}
			unset($keys,$values);
			$this->last_id=0;
			foreach($pdata as $k=>&$value)
			{
				$max=max($value['id']);
				if($max>$this->last_id)
					$this->last_id=$max;
				$pdata[$k]=$this->FormatPosts($value['id'],$uids,$value['ip'],$value['date'],$value['names'],$value['texts'],$value['karma'],$value['nesting'],$comm_n,$value['status'],$value['whspam']);
				if($k>0)
					$pdata[$k]='<ul class="com-tree">'.$pdata[$k].'</ul>';
				$comm_n+=count($value['id']);
			}
			return $pdata;
		}
		else
		{
			$this->last_id=max($ids);
			return $this->FormatPosts($ids,$uids,$ips,$dates,$names,$texts,$karma,$nesting,$comm_n,$statuses,$whspam);
		}
	}

	protected function GetSubs($v,$id,&$result)
	{static $dump;
		if(!isset($dump))
		{
			$this->Mainclass->Db->Query('SELECT `id`,`parent` FROM `prefix_'.$this->table.'` WHERE `mid`='.(int)$this->Mainclass->GetModVal('id').' AND `m_value`=\''.$this->Mainclass->Db->EscapeString($v).'\'',__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
				$dump[]=$arr;
		}
		foreach ($dump as $k=>$v)
			if($v['parent']==$id)
			{
				$result[]=$v['id'];
				$this->GetSubs($v,$v['id'],$result);
			}
	}

	#Вспомагательные функции, выполняющие смысл темы.
	protected function TempHeadComment()
	{
		return '<div align="center"><span class="option">'.$this->lang['visitors_comments'].'</span><br /><hr /></div><div id="posts_'.$this->u.'">';
	}

	protected function TempFootComment()
	{
		return '</div>';
	}
}
?>