<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class Editor extends BaseClass
{
	public
		$type=1,#Тип редактора, выбор - см конструктор класса.
		$bb_addon='',#Дополнительные кнопки для bb редактора
		$bb_detail=false,#Показывать кнопку "Основная часть" внизу редактора
		$own_bb=true,#Разрешить использование своих ББ кодов? Полезно отключать, когда при помощи ББ редактора формируется письмо на отправку
		$correct_check=true,#Проверять корректность ссылок, мыл и т.п. Это полезно отключать, когда Вы хотите сохранить, допустим, формат письма. А потом просто заменять переменными текст.
		$anti_dlink,#Защита от прямых ссылок
		$editors=array(),#Названия редакторов. Задается в конструкторе
		$disabled_tags=array(),#Запрещенные теги! Они будут вырезаны после парсинга!
		$enabled_tags=array(),#Разрешенные теги! Все остальные будут вырезаны!

		$check_tags=array(),#Специальный массив для функции CheckTag
		$without_tags=array();#Специальный массив для функции ReplaceWithOutTag
	protected
		$notparsed,
		$lang;

	/*
		Функция парсинга контейнера
		Простой пример. Есть текст: '[quote]Первая цитатая [quote]Цитата в цитате[/quote][/quote]';
		Если мы будем пытаться отпарсить этот текст при помощи регулярки '#\[quote([^\]]*)\](.*)\[/quote\]#Use'	=>	'$this->DoQuote(\'\2\',\'\1\')',
		то полчим мягко говоря херню:

			    |------------Первая цитатая------------------|
			    |                     |-----Вторая цитата----|-------|
			'[quote]Первая цитатая [quote]Цитата в цитате[/quote][/quote]';

		Эта фукнция позволяет получить нормальный парсинг текста, чтобы было:

			    |------------Первая цитатая--------------------------|
			    |                     |-----Вторая цитата----|       |
			'[quote]Первая цитатая [quote]Цитата в цитате[/quote][/quote]';

		$str - входящая строка
		$be - начало цитаты
		$eb - конец цитаты
		$callback - функция которой будет передана строка для обработки. Первым параметром - текст цитаты
		$ret_beg - Возвращать начало цитаты?
		$reg_end - возвращать конец цитаты?
	*/

	public static function ParseContainer($str,$be,$en,$callback,$ret_beg=false,$ret_end=false)
	{
		if(!is_callable($callback))
			return $str;
		$b_l=strlen($be);
		$e_l=strlen($en);
		for(;;)
		{
			if(false===$beg_pos=strpos($str,$be) or false===$end_pos=strpos($str,$en,$beg_pos+1+$b_l))
				break;
			$beg_r_pos=strrpos(mb_substr($str,0,$end_pos-$beg_pos+1,ELEANOR_CHARSET),$be);
			if($beg_r_pos>$beg_pos)
				$beg_pos=$beg_r_pos;
			$new_str=mb_substr($str,$beg_pos+($ret_beg ? 0 : $b_l),$end_pos-$beg_pos-($ret_beg ? 0 : $b_l)+($ret_end ? $e_l : 0),ELEANOR_CHARSET);
			$new_str=call_user_func($callback,$new_str);
			$str=substr_replace($str,$new_str,$beg_pos,$end_pos-$beg_pos+$e_l);
		}
		return $str;
	}

	public function __construct($Mainclass)
	{
		$this->editors=array(
								$Mainclass->lang['main']['no'],
								'Eleanor BB Editor',
								'CKEditor',
								'TinyMCE',
		);
		$Mainclass->LoadOptions(array('editor'),false);
		if(isset($Mainclass->vars['editor_type'],$this->editors[$Mainclass->vars['editor_type']]))
			$this->type=$Mainclass->vars['editor_type'];
		$type=$Mainclass->GetModVal('editor');
		if($type===false)
			$type=$Mainclass->Account->GetValue('editor');
		if($type!==false and isset($this->editors[$type]))
			$this->type=$type;
		$this->anti_dlink=$this->Mainclass->vars['anti_directlink'];
	}

	/*
		Функция, которая покажет наше текстовое поле в зависимости от настроек
	*/
	public function Area($name,$text='',$rows=10,$addon='',$force=false)
	{
		$this->lang=$this->Mainclass->LoadLanguage('langs','','editor-%');
		if($this->own_bb)
			$text=$this->UnDoSmiles($text);
		if($this->anti_dlink)
			$text=preg_replace('#(<[^>]+href=")go\.php\?([a-z]{3,7}://[^>]*>)#','\1\2',$text);
		$text=preg_replace('#<span class="(?:wbr|smile)">(.+?)</span>#s','\1',$text);
		$text=str_replace(array('<span class="smile">','<span class="wbr">'),'',$text);
		$this->Mainclass->LoadClass('classes/others/class_ownbb.php','Own','OwnBbCodes');
		$text=$this->Mainclass->Own->ParseAll($text,OwnBbCodes::EDIT);
		$id=preg_replace('#\W+#','',$name);
		switch ($this->type)
		{
			case 0:#Без редактора
				$html=Template::Text($name,$text,'id="'.$id.'" rows="'.$rows.'" cols="50"'.$addon).'
<script type="text/javascript">//<![CDATA[
EDITOR.NewEditor(
					"'.$name.'",
					function(text){Id("'.$id.'").value+=text},
					function(text){Id("'.$id.'").value=text},
					function(){return Id("'.$id.'").value}
);
Id("'.$id.'").onfocus=function(){EDITOR.ActivateEditor("'.$id.'")};
//]]></script>';
			break;
			case 1:#Родной ББ
			default:
				static $use_bb=false;
				$html='';
				if(!$use_bb or $force)
				{
					$html.=Strings::AddJs('js/eleanor_bb.js');
					$use_bb=true;
				}
				$text=$this->Mainclass->Own->StoreNotParsed($text,OwnBbCodes::SAVE);
				$text=$this->LoadBb($text);
				$text=$this->Mainclass->Own->ParseNotParsed($text,false);
				$html.=$this->Mainclass->Template->GetThemeFile(
																'BBeditor',
																array(
																		'id'=>$id,
																		'name'=>$name,
																		'rows'=>$rows,
																		'value'=>$text,
																		'lang'=>$this->lang,
																),
																$addon
				);
			break;
			case 2:#CKeditor
				static $use_ckeditor=false;
				$html='';
				if(!$use_ckeditor or $force)
				{
					$html.=Strings::AddJS('addons/ckeditor/ckeditor.js');
					$use_ckeditor=true;
				}
				$html.=Template::Text($name,$text,'id="'.$id.'" rows="'.$rows.'"').'
<script type="text/javascript">//<![CDATA[
(function()
{
	var editor=CKEDITOR.replace("'.$id.'");
	EDITOR.NewEditor(
						editor.name,
						function(text){editor.insertHtml(text)},
						function(text){editor.setData(text)},
						function(){return editor.getData()}
	);
	editor.on("focus",function(){EDITOR.ActivateEditor(this.name)});
}
)();
//]]></script>';
			break;
			case 3:#Tiny MCE
				static $use_tiny=false;
				$html='';
				if(!$use_tiny or $force)
				{
					$html.=Strings::AddJs('addons/tiny_mce/tiny_mce.js').Strings::AddJS('addons/tiny_mce/tiny_config.js');
					$use_tiny=true;
				}
				$html.=Template::Text($name,$text,'id="'.$id.'" rows="'.$rows.'" class="tiny_mce_editor"');
			break;

		}
		unset($this->Mainclass->Own);
		if($this->own_bb)
		{
			$smiles=$this->GetSmiles(true);
			foreach($smiles as $sm=>&$smile)
				$smiles[$sm]='<a href="#" style="background: transparent url('.$smile.') no-repeat 50% 50%;" onclick="EDITOR.Insert(\' '.$sm.' \',\''.$id.'\');return false;"></a>';
			$smiles=join('',$smiles);
			$under_edit='<div class="bb_footpanel">'.($this->bb_detail ? '<strong><a href="#" onclick="if(EDITOR.GetValue(\''.$id.'\').indexOf(\'[separator]\')==-1) EDITOR.Insert(\'[separator]\',\''.$id.'\'); else alert(\''.$this->lang['sep_exist'].'\'); return false;" class="bbf_more" '.$this->lang['bb_detail'].'</a></strong>' : '').'<b><a href="#" class="bbf_smiles" id="'.$id.'_smiles" rel="'.$id.'_smiles_div">'.$this->lang['smiles'].'</a></b></div><div id="'.$id.'_smiles_div" class="bb_smiles" style="position:absolute;display:none;">'.$smiles.'</div><script type="text/javascript">EDITOR.'.$id.'sm=DropDown("#'.$id.'_smiles","left-top","click");</script><div class="bb_yourpanel">';
			$bbcodes=$this->Mainclass->Cache->Get('ownbbcodes',true);
			$ug=$this->Mainclass->Account->GetUserGroups();
			foreach($bbcodes as &$bb)
				if($bb['sb'] and (!$bb['gr_use'] or count(array_intersect(explode(',',$bb['gr_use']),$ug))>0))
					$under_edit.='<a href="#" class="bbe_ytext" onclick="EDITOR.Insert(\'['.$bb['tag'].']'.($bb['single'] ? '' : '[/'.$bb['tag'].']').'\',\''.$id.'\'); return false;"'.(isset($this->lang['ownbb_'.$bb['tag']]) ? 'title="'.$this->lang['ownbb_'.$bb['tag']].'"' : '').'><span>['.$bb['tag'].']</span></a>';
			$under_edit.='<div class="clr"></div></div>';
			$html.=$under_edit;
		}
		return $html;
	}
	/*
		Функция получения самое формы текстового поле. Если $is_value==true, то значение переменной $name принимается как само значение
		$save - признак того, что мы сохраняем свои ББ коды.
	*/
	public function GetHTML($name,$is_value=false,$save=true)
	{
		if(!$is_value and !isset($_POST[$name]))
			return '';
		$text=$is_value ? $name : $_POST[$name];
		$text=$this->CensorFilter($text);
		if($this->own_bb)
			$this->Mainclass->LoadClass('classes/others/class_ownbb.php','Own','OwnBbCodes');
		switch($this->type)
		{
			case 1:#ББ редактор
				if($this->own_bb)
					$text=$this->Mainclass->Own->StoreNotParsed($text,$save ? OwnBbCodes::SAVE : OwnBbCodes::SHOW);
				$text=htmlspecialchars($text,ENT_NOQUOTES);
				#Fix для noparse своих ББ кодов
				$text=preg_replace('#&lt;!\-\- NP (\d+) \-\-&gt;#','<!-- NP \1 -->',$text);
				$text=$this->SaveBb($text);
			break;
			case 0:#Без ББ редактора
				$text=htmlspecialchars($text,ENT_NOQUOTES);
			default:
				if($this->own_bb)
					$text=$this->Mainclass->Own->StoreNotParsed($text,$save ? OwnBbCodes::SAVE : OwnBbCodes::SHOW);
		}
		$text=$this->SafeHtml($text);
		if($this->own_bb)
		{
			$text=$this->Mainclass->Own->ParseBbCodes($text,$save ? OwnBbCodes::SAVE : OwnBbCodes::SHOW);
			$text=$this->Mainclass->Own->ParseNotParsed($text,$save ? OwnBbCodes::SAVE : OwnBbCodes::SHOW);
			unset($this->Mainclass->Own);
		}
		return $text;
	}

	/*
		Функция должна попытаться обезопасть входящий HTML от XSS атак.
	*/
	public function SafeHtml($text)
	{
		$text=$this->StoreNotParsed($text);
		#Убираем любые пустые конструкции типа <b>           </b>
		$reg_rep_k[]='#<(b|i|u|em|strong|noindex|li|ul|ol|legend|a|q)[^>]*>\s*</\1>#i';
		$reg_rep[]='';
		#Убираем ненужные теги
		$reg_rep_k[]='#<span class="(?:wbr|smile)">(.+?)</span>#s';
		$reg_rep[]='\1';
		#Убираем чередование тегов <<<< -> < и >>>> -> >
		$reg_rep_k[]='#<+#';
		$reg_rep[]='<';
		$reg_rep_k[]='#>+#';
		$reg_rep[]='>';
		/*Убираем < в конце строки (разрыв). > - браузеры просто выводят, поэтому он нас не беспокоит.

		А эта регулярка должна была убирать > в начале строки. Но почему-то падает при большом объеме данных :(
		$reg_rep_k[]='#^([^<]*)(?<!--)>#m';#
		$reg_rep[]='\1&gt;';
		*/
		$reg_rep_k[]='#<(?!!--)([^>]*)$#m';#
		$reg_rep[]='&lt;\1';
		$text=preg_replace($reg_rep_k,$reg_rep,$text);
		unset($reg_rep_k,$reg_rep);
		#Проверим все теги:
		$text=preg_replace_callback('#<([^>]+)>#',array(&$this,'CheckTag'),$text);
		if(isset($this->check_tags['op']))
		{
			$opened=&$this->check_tags['op'];
			$n=&$this->check_tags['n'];
			for(;$n>0;--$n)
				$text.='</'.$opened[$n].'>';
		}
		$this->check_tags=array();
		#Заменим смайлы и пропарсим УРЛы.
		$text=preg_replace_callback('#(?<=>|^)([^<]+)(</[a-z]>)?#',array(&$this,'ReplaceWithOutTags'),$text);#Приставка (</[a-z]>) необходима, чтобы узнать какой тег мы парсим
		if($this->anti_dlink)
			$text=preg_replace('#(<[^>]+href=")([a-z]{3,7}://[^>]*>)#','\1go.php?\2',$text);
		$len_to_br=(int)$this->Mainclass->vars['max_word_length'];
		if($len_to_br>50)
		{
			$len=mb_strlen($text,ELEANOR_CHARSET);
			$chars_cnt=$cur_pos=$dovesok=0;
			$seps=array("\t","\r","\n",' ');
			$no_br=array('textarea');#,'script'
			$in_tag=false;
			$br_len=mb_strlen('<span class="wbr"></span>',ELEANOR_CHARSET);
			while($cur_pos<$len)
			{
				if(mb_substr($text,$cur_pos,1,ELEANOR_CHARSET)=='<')
				{
					$in_tag=true;
					++$cur_pos;
				}
				if(mb_substr($text,$cur_pos,1,ELEANOR_CHARSET)=='>')
				{
					$in_tag=false;
					++$cur_pos;
					continue;
				}
				if($in_tag)
				{
					if(in_array($tag=mb_substr($text,$cur_pos,min(strpos($text,' ',$cur_pos),strpos($text,'>',$cur_pos))-$cur_pos,ELEANOR_CHARSET),$no_br))
					{
						$dovesok=$chars_cnt=0;
						$cur_pos=stripos($text,'</'.$tag .'>',$cur_pos)+mb_strlen($tag,ELEANOR_CHARSET)+3;
						$in_tag=false;
					}
					else
					{
						$new_pos=mb_strpos($text,'>',$cur_pos,ELEANOR_CHARSET);
						$dovesok-=$chars_cnt;
						$cur_pos=$new_pos+1;
						$in_tag=false;
					}
					continue;
				}
				if(in_array(mb_substr($text,$cur_pos,1,ELEANOR_CHARSET),$seps))
				{
					$dovesok=$chars_cnt=0;
					++$cur_pos;
					continue;
				}
				if(mb_substr($text,$cur_pos,6,ELEANOR_CHARSET)=='&nbsp;')
				{
					$dovesok=$chars_cnt=0;
					$cur_pos+=6;
					continue;
				}
				if(mb_substr($text,$cur_pos,1,ELEANOR_CHARSET)=='&')
				{
					$temp=0;
					do
					{
						++$temp;
					}
					while(mb_substr($text,$cur_pos+$temp,1,ELEANOR_CHARSET)!=';' and $temp<7);

					$cur_pos+=$temp<7 ? $temp : 1;
					$dovesok+=$temp<7 ? $temp : 0;
				}
				++$chars_cnt;
				if($chars_cnt>=$len_to_br)
				{
					$part=mb_substr($text,$cur_pos-$chars_cnt-$dovesok+1,$chars_cnt+$dovesok,ELEANOR_CHARSET);
					$text=substr_replace($text,'<span class="wbr">'.$part.'</span>',$cur_pos-$chars_cnt-$dovesok+1,$chars_cnt+$dovesok);
					$dovesok=$chars_cnt=0;
					$cur_pos+=$br_len;
					$len+=$br_len;
				}
				++$cur_pos;
			}
		}
		$text=$this->RestoreNotParsed($text);
		return $text;
	}

	public function CensorFilter($text)
	{
		if($this->Mainclass->vars['bad_words'])
		{
			$c_list=explode(',',trim($this->Mainclass->vars['bad_words'],','));
			$repl=array();
			foreach($c_list as &$v)
			{
				$v=trim($v);
				if(!$v)
					continue;
				$repl[]='#(?<![\w<])'.preg_quote($v,'#').'(?!\w)#i';
			}
			$text=preg_replace($repl,$this->Mainclass->vars['bad_words_replace'],$text);
		}
		return $text;
	}

	protected function StoreNotParsed($text)
	{
		$text=str_replace('<!-- NP2 ','<!-- ',$text);
		$store_arr=array(
		#Сначала идут комментарии, а только потом CDATA, потому что мы заменяем текст на комментарии!
							array(
									'<!-- ',#И не вздумайте убирать пробелы! Вы же не хотите XSS типа <!--[if gte IE 4]>\br<SCRIPT>alert('XSS');</SCRIPT>\br<![endif]-->
									' -->'
							),
							array(
									'<![CDATA[',
									']]>'
							),
		);
		$n=0;
		$this->notparsed=array();
		foreach($store_arr as &$stored)
		{
			$oldcurpos=-1;
			$curpos=0;
			while(false!==$curpos=stripos($text,$stored[0],$curpos) and false!==$length=stripos($text,$stored[1],$curpos))
			{
				if($curpos==$oldcurpos)
				{
					++$curpos;
					continue;
				}
				$beglen=strlen($stored[0]);
				$endlen=strlen($stored[1]);
				$length-=$curpos-$endlen;
				$replace='<!-- NP2 '.$n++.' -->';
				$tostore=substr($text,$curpos,$length);
				if(strpos($tostore,'<!-- NP ')===0)#Это же комментарий из своих ББ кодов!
				{
					++$curpos;
					continue;
				}
				$text=substr_replace($text,$replace,$curpos,$length);
				$this->notparsed[]=array(
											'find'=>$replace,
											'text'=>$tostore,
				);
				$oldcurpos=$curpos;
			}
		}
		return $text;
	}

	public function RestoreNotParsed($text)
	{
		if($this->notparsed)
			foreach($this->notparsed as &$v)
				$text=str_replace($v['find'],$v['text'],$text);
		$this->notparsed=array();
		return $text;
	}

	public function ReplaceWithOutTags($text)
	{
		#Для корректной обработки своего тега URL
		if(!isset($text[2]))
			$text[2]='';
		$a=$text[2]=='</a>';
		$text=$text[1].$text[2];
		if(!$a and $this->Mainclass->vars['autoparse_urls'])
		{
			$text=preg_replace('#(^|\s|>|\](?<!\[url\]))([a-z]{3,7}://[\w\./\-&=\?:]+)#i','\1[url]\2[/url]',$text);
			$text=preg_replace('#(\[url[^\]]*\])\s*(?:\[url[^\]]*\]+)#i','\1',$text);
			$text=preg_replace('#(\[/url\])\s*(?:\[/url\])+#i','\1',$text);
		}
		if($this->own_bb)
		{
			#Заменяем смайлы...
			if(!isset($this->without_tags['smiles']))
			{
				$this->without_tags['smiles']=$this->GetSmiles();
				$this->without_tags['sm_cnt']=0;
			}
			$smiles=&$this->without_tags['smiles'];
			$sm_cnt=&$this->without_tags['sm_cnt'];
			$stop_near=Strings::ALL_CYR.'abcdefghijklmnopuqstuvwxyzABCDEFGHIJKLMNOPUQSTUVWXYZ0123456789"\'';
			/*Закомментрирован алогритм, позволяющий не применять смайлы на определенном участке. Алгоритм устарел, поэтому и закомментрирован.
			$arr_dovesok=$no_smiles=$no_smilese=array();
			$no_sm_text=array(
								'<!-- NOSMILE -->',
								'<!-- /NOSMILE -->',
			);
			$limit=count($no_sm_text);
			for($i=0;$i<$limit;$i+=2)
			{
				$nsm_pos=-$nsm_len=mb_strlen($no_sm_text[$i],ELEANOR_CHARSET);
				$nsm_pos2=-$nsm_len2=mb_strlen($no_sm_text[$i+1],ELEANOR_CHARSET);
				while(false!==$nsm_pos=strpos($text,$no_sm_text[$i],$nsm_pos+$nsm_len))
					if(false!==$nsm_pos2=strpos($text,$no_sm_text[$i+1],max($nsm_pos,$nsm_pos2+$nsm_len2)) and !in_array($nsm_pos,$no_smiles))
					{
						$no_smiles[]=$nsm_pos;
						$no_smilese[]=$nsm_pos2+$nsm_len2;
					}
			}
			$no_log=$this->Mainclass->no_log;
			$this->Mainclass->no_log=true;
			asort($no_smiles);*/
			foreach($smiles as $k=>$v)
			{
				$sm_pos=0;
				while(false!==$position=strpos($text,$k,$sm_pos))
				{
					/*$dovesok=0;
					$i_near=$near_value=-1;
					foreach($no_smiles as $i=>$nos)
					{
						if(isset($arr_dovesok[$i]))
							$dovesok+=$arr_dovesok[$i];
						$near=($nos+$dovesok)-$position;
						if($near>0 and ($near_value==-1 or $near_value>$near))
						{
							$near_value=$near;
							$i_near=$i;
						}
						if($near<0 and $position<($no_smilese[$i]+$dovesok))
						{
							$sm_pos=$no_smilese[$i]+$dovesok;
							continue 2;
						}
					}*/
					$klen=mb_strlen($k,ELEANOR_CHARSET);
					$sm_pos=$position;
					if(($position===0 or strpos($stop_near,mb_substr($text,$position-1,1,ELEANOR_CHARSET))===false) and (mb_substr($text,$position+$klen,1)=='') or strpos($stop_near,mb_substr($text,$position+$klen,1))===false)
					{
						$text=substr_replace($text,$v,$position,$klen);
						$vlen=mb_strlen($v,ELEANOR_CHARSET)-$klen;
						$sm_pos+=$vlen;
						/*$arr_dovesok[$i_near]=($i_near>0 and isset($arr_dovesok[$i_near])) ? $arr_dovesok[$i_near]+$vlen : $vlen;*/
						++$sm_cnt;
					}
					else
						$sm_pos+=$klen;
				}
			}
			/*
				if($sm_cnt>100)
					thow new EE('Слишком много смайлов!',EE::INFO);
			*/
		}
		return $text;
	}

	public function UnDoSmiles($text)
	{
		$arr=$this->GetSmiles();
		$text=str_replace($arr,array_keys($arr),$text);
		if(strpos($text,'<span class="smile"><img src="')!==false)
			$text=preg_replace('#<span class="smile"><img src="[^"]+" alt="([^"]+)" /></span>#','\1',$text);
		return $text;
	}

	public function GetSmiles($ret_dump=false)
	{
		$arr=$this->Mainclass->Cache->Get('smiles',false);
		if($arr===false)
		{
			$arr=array();
			$this->Mainclass->Db->Query('SELECT `path`,`emotion` FROM `prefix_smiles` ORDER BY `pos` ASC',__file__,__line__);
			while($temp=$this->Mainclass->Db->Fetch_row())
				if($temp[0] and $temp[1])
					$arr[$temp[1]]=$temp[0];
			$this->Mainclass->Cache->Put('smiles',$arr,0,false);
		}
		if($ret_dump)
			return $arr;
		foreach($arr as $k=>$v)
			$arr[$k]='<span class="smile"><img src="'.$v.'" alt="'.htmlspecialchars($k,ENT_QUOTES).'" /></span>';
		return $arr;
	}

	/*
		Эта функция не валидизирует код полностью! Т.е. она НЕ обезопасивает Вас от ошибок типа <table>ТЕКСТ</table>
		Эта функция всего-лишь пытается убрать ошибочные теги
	*/
	protected function CheckTag($tag)
	{
		#Наши комментарии мы не трогаем вообще
		if(strpos($tag[1],'!-- NP')===0)
			return $tag[0];
		$tag=trim($tag[1]);
		$tag=rtrim($tag,' /');
		if(!$tag)
			return '';
		if($closed=$tag[0]=='/')
			$tag=substr($tag,1);
		$tag=str_replace(array("\t","\n"),' ',$tag);
		if(preg_match('#^([a-z0-9]+)#',$tag,$tag_name)==0)
			return '';
		$tag_name=$tag_name[1];
		if($tag_name==$tag or $closed)
			$options='';
		else
			$options=substr($tag,strlen($tag_name)+1);
		unset($tag);
		$tag_name=strtolower($tag_name);
		#Далее идет список тегов и характериистика их вложенности. Конечно, это не все теги. Незачем засорять память :)
		#Список запрещенных тегов
		$disabled=array('meta','link','html','body','style','head','script','iframe','frame','frameset','base','!doctype','embed');#Последние теги - неприменимы к XHTML
		#Список одиночных тегов
		$single=array('input','hr','br','img','image','param','area','br');
		#Специальные теги, которые не могут просто-так находится на странице.
		$special=array('th','td','tbody','thead','tfoot','li','caption','col','colgroup','optgroup','option','legend','area');
		#Строчные теги
		$inline=array('a','span','i','b','u','s','em','strong','q','big','small','sup','sub','var','tt','cite','code','input','select','br','img');#Еще - см. ниже тег а
		#Накладывает ограничения на вложенность тегов. Теги, не указанные в массиве справа, вложенные в тег слева, будут игнорироваться как неправильно вложенные.
		$children=array(
						'button'=>&$inline,
						'caption'=>&$inline,
						'th'=>&$inline,
						'col'=>array(),
						'colgroup'=>array('col'),
						'li'=>array(true),
						'table'=>array('caption','col','colgroup','tbody','thead','tfoot','tr'),
						'thead'=>array('tr'),
						'tfoot'=>array('tr'),
						'tbody'=>array('tr'),
						'tr'=>array('td','th'),
						'td'=>array(true),
						'textarea'=>array(),
						'ul'=>array('li'),
						'ol'=>array('li'),
						'object'=>array('param'),
						'select'=>array('option','optgroup'),
						'fieldset'=>array('legend',true),
						'a'=>array('span','i','b','u','em','strong','q','big','small','sup','sub','var','tt','cite','code','input','select','br','img'),
						'map'=>array('area'),
		);
		if(in_array($tag_name,$disabled) or in_array($tag_name,$this->disabled_tags) or ($this->enabled_tags and !in_array($tag_name,$this->enabled_tags)) or $closed and in_array($tag_name,$single))
			return '';
		$opened=&$this->check_tags['op'];
		$allowed=&$this->check_tags['al'];
		$n=&$this->check_tags['n'];
		if($n===null)
		{
			$n=0;
			$allowed[0]=array(true);
			$opened[0]='';
		}
		if($closed)
		{
			#Если передыдущий открытый тег оказался таким как этот - благополучно все закрываем.
			if($opened[$n]==$tag_name)
			{
				unset($opened[$n]);
				unset($allowed[$n--]);
				return '</'.$tag_name.'>';
			}
			$ret='';
			for($i=$n-1;$i>0;--$i)
				if($opened[$i]==$tag_name)
				{
					for($j=$n;$j>=$i;--$j)
						$ret.='</'.$opened[$j].'>';
					break;
				}
			return $ret;
		}
		if(in_array($tag_name,$disabled) or $in=in_array(true,$allowed[$n],true) and in_array($tag_name,$special) or !$in and !in_array($tag_name,$allowed[$n]))
			return '';
		if($options)
		{
			$options=Strings::ParseParams($options);
			$options=array_change_key_case($options,CASE_LOWER);
			$op_filtered='';
			foreach($options as $k=>$v)
			{
				#Вырежем все события
				if(substr($k,0,2)=='on' or preg_match('#^([a-z0-9]+)#',$k)==0)
					continue;
				if($k=='style')
				{
					while(preg_match('#/\*.*?\*/#s',$v)>0)
						$v=preg_replace('#/\*.*?\*/#s','',$v);
					#@import, url и expression не разрешены в тегах style!
					$v=str_ireplace(array('expression','url','@import'),'not_allowed',$v);
				}
				if($this->correct_check and ($k=='href' or $k=='src') and $v!='#' and !Strings::XssCheckUrl($v))
					return '';
				$v=str_replace('"','&quot;',$v);
				$v=str_ireplace('javascript:','j&#97;v&#97;script:',$v);
				$op_filtered.=' '.$k.'="'.$v.'"';
			}
			$options=$op_filtered;
		}
		if(in_array($tag_name,$single))
			return '<'.$tag_name.$options.' />';
		++$n;
		if(in_array($tag_name,$inline) and !isset($children[$tag_name]))
			$allowed[$n]=$inline;
		else
			$allowed[$n]=isset($children[$tag_name]) ? $children[$tag_name] : array(true);
		$opened[$n]=$tag_name;
		return '<'.$tag_name.$options.'>';
		/*Список всех событий
		$events=array('abort','activate','afterprint','afterupdate','beforeactivate','beforecopy','beforecut','beforedeactivate','beforeeditfocus',
		'beforepaste','beforeprint','beforeunload','begin','blur','bounce','cellchange','change','click','contextmenu','controlselect','copy',
		'cut','dataavailable','datasetchanged','datasetcomplete','dblclick','deactivate','drag','dragdrop','dragend','dragenter','dragleave',
		'dragover','drop','end','error','errorupdate','filterchange','finish','focus','focusin','focusout','help','keydown','keypress','keyup',
		'layoutcomplete','load','losecapture','mediacomplete','mediaerror','mousedown','mouseenter','mouseleave','mousemove','mouseout','mouseover',
		'mouseup','mousewheel','move','moveend','movestart','outofsync','paste','pause','progress','propertychange','readystatechange','repeat','reset',
		'resize','resizeend','resizestart','resume','reverse','rowdelete','rowexit','rowinserted','rowsenter','scroll','seek','select','selectionchange',
		'selectstart','start','stop','submit','syncrestored','timeerror','trackchange','unload','urlflip','zfocus');*/
	}

	public function SaveBb($text)
	{
		$text=self::ParseContainer($text,'[ul','[/ul]',array(&$this,'BBDoList'),true);
		$text=self::ParseContainer($text,'[ol','[/ol]',array(&$this,'BBDoList'),true);
		$rep_reg_k[]='#\[img([^\]]*?)\](.+?)\[/img\]#ie';
		$rep_reg[]='$this->BBDoImage(\'\2\',\'\1\')';

		$rep_reg_k[]='#\[url( self)?\](.+?)\[/url\]#ie';
		$rep_reg[]='$this->BuildUrl(\'\2\',\'\',\'\1\')';
		$rep_reg_k[]='#\[url=(?:&quot;)?(.+?)(?:&quot;)?( self)?\](.+?)\[\/url\]#ie';
		$rep_reg[]='$this->BuildUrl(\'\1\',\'\3\',\'\2\')';

		$rep_reg_k[]='#\[email\]([\.\w\-]+\@[\.\w\-]+\.[\w\-]+)\[/email\]#ie';
		$rep_reg[]='Functions::CheckEmail(\'\1\') ? \'<a href="mailto:\1">\1</a>\' : \'\'';
		$rep_reg_k[]='#\[email=(?:&quot;)?([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)(?:&quot;)?\](.+?)\[/email\]#ie';
		$rep_reg[]='Functions::CheckEmail(\'\1\') ? \'<a href="mailto:\1">\2</a>\' : \'\'';

		$rep_reg_k[]='#\[(left|right|center|justify)\](.+?)\[/\1\]#is';
		$rep_reg[]='<div align="\1">\2</div>';

		$rep_reg_k[]='#\[h([1-6])\](.+?)\[/h\1\]#is';
		$rep_reg[]='<h\1>\2</h\1>';

		$rep_reg_k[]='#\[size=(\d{1,}|xx-small|x-small|small|medium|large|x-large|xx-large)\](.+?)\[/size\]#ies';
		$rep_reg[]='$this->BBFontAttr(\'size\',\'\1\',\'\2\')';

		$rep_reg_k[]='#\[background=([^\]]+)\](.+?)\[/background\]#ies';
		$rep_reg[]='$this->BBFontAttr(\'background\',\'\1\',\'\2\')';

		$rep_reg_k[]='#\[color=([^\]]+)\](.+?)\[/color\]#ies';
		$rep_reg[]='$this->BBFontAttr(\'color\',\'\1\',\'\2\')';

		$rep_reg_k[]='#\[font=([^\]]+)\](.+?)\[/font\]#ies';
		$rep_reg[]='$this->BBFontAttr(\'font\',\'\1\',\'\2\')';

		$rep_reg_k[]='#&amp;(amp;)+#i';
		$rep_reg[]='&amp;';

		$rep_reg_k[]='/&amp;#(\d+?);/i';
		$rep_reg[]='&#\1;';

		$rep_reg_k[]='/&#(\d+?)([^\d;])/';
		$rep_reg[]='&#\1;\2';
		$text=preg_replace($rep_reg_k,$rep_reg,$text);
		unset($rep_reg,$rep_reg_k);

		$rep_str_k[]='[c]';
		$rep_str[]='&copy;';
		$rep_str_k[]='[tm]';
		$rep_str[]='&#153;';
		$rep_str_k[]='[r]';
		$rep_str[]='&reg;';
		$rep_str_k[]='[hr]';
		$rep_str[]='<hr />';
		$rep_str_k[]='[b]';
		$rep_str[]='<b>';
		$rep_str_k[]='[/b]';
		$rep_str[]='</b>';
		$rep_str_k[]='[q]';
		$rep_str[]='<q>';
		$rep_str_k[]='[/q]';
		$rep_str[]='</q>';
		$rep_str_k[]='[em]';
		$rep_str[]='<em>';
		$rep_str_k[]='[/em]';
		$rep_str[]='</em>';
		$rep_str_k[]='[strong]';
		$rep_str[]='<strong>';
		$rep_str_k[]='[/strong]';
		$rep_str[]='</strong>';
		$rep_str_k[]='[u]';
		$rep_str[]='<u>';
		$rep_str_k[]='[/u]';
		$rep_str[]='</u>';
		$rep_str_k[]='[i]';
		$rep_str[]='<i>';
		$rep_str_k[]='[/i]';
		$rep_str[]='</i>';
		$rep_str_k[]='[s]';
		$rep_str[]='<s>';
		$rep_str_k[]='[/s]';
		$rep_str[]='</s>';
		$rep_str_k[]='[big]';
		$rep_str[]='<big>';
		$rep_str_k[]='[/big]';
		$rep_str[]='</big>';
		$rep_str_k[]='[small]';
		$rep_str[]='<small>';
		$rep_str_k[]='[/small]';
		$rep_str[]='</small>';
		$rep_str_k[]='[sub]';
		$rep_str[]='<sub>';
		$rep_str_k[]='[/sub]';
		$rep_str[]='</sub>';
		$rep_str_k[]='[sup]';
		$rep_str[]='<sup>';
		$rep_str_k[]='[/sup]';
		$rep_str[]='</sup>';
		$rep_str_k[]='[p]';
		$rep_str[]='<p>';
		$rep_str_k[]='[/p]';
		$rep_str[]='</p>';
		$rep_str_k[]="\t";
		$rep_str[]='&nbsp;&nbsp;&nbsp;&nbsp;';
		$text=str_replace($rep_str_k,$rep_str,$text);
		$text=nl2br($text);
		return trim($text);
	}

	public function LoadBb($text)
	{
		$text=self::ParseContainer($text,'<ul','</ul>',array(&$this,'BBUnDoList'),true);
		$text=self::ParseContainer($text,'<ol','</ol>',array(&$this,'BBUnDoList'),true);

		#Удалить потом этот рудимент
		$rep_reg_k[]='#<a href="/?go\.php\?int=([a-f0-9]+)"([^>]*)?>(.+?)</a>#ie';
		$rep_reg[]='\'[url=\'.Strings::Hex2Text(\'\1\').(stripos(\'\2\',\'target="_blank"\')===false ? \' self\' : \'\').\']\3[/url]\'';

		$rep_reg_k[]='#<a href="([a-z]{3,7}://)?([^"]+)"([^>]*)?>(.+?)</a>#ie';
		$rep_reg[]='\'[url=\1\2\'.((stripos(stripslashes(\'\3\'),\'target="_blank"\')===false and \'\1\') ? \' self\' : \'\').\']\'.stripslashes(\'\4\').\'[/url]\'';

		$rep_reg_k[]='#<a href="mailto:(.+?)">(.+?)</a>#i';
		$rep_reg[]='[email=\1]\2[/email]';

		$rep_reg_k[]='#<div align="(left|right|center|justify)">(.+?)</div>#si';
		$rep_reg[]='[\1]\2[/\1]';

		$rep_reg_k[]='#<h([1-6])[^>]*>(.+?)</h\1>#si';
		$rep_reg[]='[h\1]\2[/h\1]';

		$rep_reg_k[]='#<(p|div) style="text-align:\s*(left|right|center|justify);">(.+?)</\1>#si';
		$rep_reg[]='[\2]\3[/\2]';

		$rep_reg_k[]="#(<br>|<br />)[\r\n]*#i";
		$rep_reg[]="\n";

		$rep_reg_k[]='#<span style="font-size:\s*(\d{1,}|xx-small|x-small|small|medium|large|x-large|xx-large)(?:px|pt)?;(?:line-height:100%)?">(.+?)</span>#s';
		$rep_reg[]='[size=\1]\2[/size]';

		$rep_reg_k[]='#<span style="font-family:\s*(.+?)">(.+?)</span>#s';
		$rep_reg[]='[font=\1]\2[/font]';

		$rep_reg_k[]='#<span style="color:\s*([^"]+?)">(.+?)</span>#s';
		$rep_reg[]='[color=\1]\2[/color]';

		$rep_reg_k[]='#<span style="background-color:\s*(.+?)">(.+?)</span>#s';
		$rep_reg[]='[background=\1]\2[/background]';

		$rep_reg_k[]='#<img([^>]+?)>#e';
		$rep_reg[]='$this->BBUnDoImage(\'\1\')';
		$text=preg_replace($rep_reg_k,$rep_reg,$text);
		unset($rep_reg_k,$rep_reg);

		$rep_str_k[]='&copy;';
		$rep_str[]='[c]';
		$rep_str_k[]='&#153;';
		$rep_str[]='[tm]';
		$rep_str_k[]='&quot;';
		$rep_str[]='"';
		$rep_str_k[]='&#39;';
		$rep_str[]="'";
		$rep_str_k[]='&reg;';
		$rep_str[]='[r]';
		$rep_str_k[]='<hr />';
		$rep_str[]='[hr]';
		$rep_str_k[]='<b>';
		$rep_str[]='[b]';
		$rep_str_k[]='</b>';
		$rep_str[]='[/b]';
		$rep_str_k[]='<strong>';
		$rep_str[]='[strong]';
		$rep_str_k[]='</strong>';
		$rep_str[]='[/strong]';
		$rep_str_k[]='<u>';
		$rep_str[]='[u]';
		$rep_str_k[]='</u>';
		$rep_str[]='[/u]';
		$rep_str_k[]='<em>';
		$rep_str[]='[em]';
		$rep_str_k[]='</em>';
		$rep_str[]='[/em]';
		$rep_str_k[]='<i>';
		$rep_str[]='[i]';
		$rep_str_k[]='</i>';
		$rep_str[]='[/i]';
		$rep_str_k[]='<s>';
		$rep_str[]='[s]';
		$rep_str_k[]='</s>';
		$rep_str[]='[/s]';
		$rep_str_k[]='<q>';
		$rep_str[]='[q]';
		$rep_str_k[]='</q>';
		$rep_str[]='[/q]';
		$rep_str_k[]='<sub>';
		$rep_str[]='[sub]';
		$rep_str_k[]='</sub>';
		$rep_str[]='[/sub]';
		$rep_str_k[]='<sup>';
		$rep_str[]='[sup]';
		$rep_str_k[]='</sup>';
		$rep_str[]='[/sup]';
		$rep_str_k[]='<p>';
		$rep_str[]='[p]';
		$rep_str_k[]='</p>';
		$rep_str[]='[/p]';
		$rep_str_k[]='<big>';
		$rep_str[]='[big]';
		$rep_str_k[]='</big>';
		$rep_str[]='[/big]';
		$rep_str_k[]='<small>';
		$rep_str[]='[small]';
		$rep_str_k[]='</small>';
		$rep_str[]='[/small]';

		$rep_str_k[]='&nbsp;&nbsp;&nbsp;&nbsp;';
		$rep_str[]="\t";
		$text=str_replace($rep_str_k,$rep_str,$text);
		return $text;
	}

	public function BuildUrl($url_href,$text='',$self=false)
	{
		$text=stripslashes($text);
		$url_href=stripslashes($url_href);
		if($this->correct_check)
			$url_href=str_replace(' ','%20',$url_href);
		/*
		if($this->correct_check and preg_match('#^[a-z]{3,7}://#',$url_href)==0 and preg_match('#^([a-z0-9а-я](?:[\.\-a-z0-9а-я][a-z0-9а-я])*)+\.[a-z]{2,6}#',$url_href)>0)
			$url_href='http://'.$url_href;
		*/
		if(!$text)
		{
			$text=$url_href;
			if(strlen($text)>55)
				$text=substr($text,0,35).'...'.substr($text,-15);
		}
		$self=$self ? '' : ' target="_blank"';
		if($this->correct_check and stripos($url_href,ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/')===0)
			$url_href=substr($url_href,strlen(ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/'));
		return '<a href="'.$url_href.'"'.$self.'>'.$text.'</a>';
	}


	protected function BBDoImage($url,$params)
	{
		$url=stripslashes($url);
		$params=stripslashes($params);
		$params=Strings::ParseParams($params,'url');
		$params_img=array('class'=>' class="posted-image"','alt'=>' alt=""');
		foreach($params as $k=>$v)
			switch(strtolower($k))
			{
				case 'border':
					$v=abs((int)$v);
					if($v>5)
						$v=5;
					$params_img['border']=' border="'.$v.'"';
				break;
				case 'alt':
					$params_img['alt']=' alt="'.$v.'" title="'.$v.'"';
				break;
				case 'width':
					$params_img['width']=' width="'.$v.'"';
				break;
				case 'height':
					$params_img['height']=' height="'.$v.'"';
				break;
				case 'class':
					$params_img['class']=' class="'.$v.'"';
				break;
				case 'url':
					$params_img['alt']=' alt="'.$url.'" title="'.$url.'"';
					$url=$v;
				break;
				case 'align':
					$params_img['align']=' align="'.$v.'"';
				break;
			}
		if($this->correct_check and !Strings::XssCheckUrl($url))
			return '';
		return '<img src="'.$url.'"'.join('',$params_img).' />';
	}

	protected function BBDoList($text)
	{
		if(preg_match('#^\[(ul|ol)([^\]]*)\](.+)$#is',$text,$m)==0)
			return '';
		$type=strtolower($m[1]);
		$params=$m[2];
		$text=trim($m[3]);
		$params_list=array();
		$params=Strings::ParseParams($params);
		foreach($params as $k=>$v)
			switch(strtolower($k))
			{
				case 'class';
					$params_list['class']=' class="'.$v.'"';
				break;
				case 'style';
					$params_list['style']=' style="'.$v.'"';
				break;
			}
		if(strpos($text,'[*]')==0)
		{
			$text=str_replace('[*]','</li><li>',$text);
			$text=preg_replace('#^</li>#','',$text);
			$text=preg_replace("#(\r)?(\n)?</li>#",'</li>',$text.'</li>');
		}
		else
			$text='<li>'.$text.'</li>';
		return '<'.$type.join('',$params_list).'>'.$text.'</'.$type.'>';
	}

	protected function BBFontAttr($param,$value,$text)
	{
		$text=stripslashes($text);
		if($this->correct_check)
			$value=preg_replace('/[^a-z0-9\-]/i','',$value);
		if($param=='size')
		{
			$value=(int)$value;
			if($value>32)
				$value=32;
			return '<span style="font-size:'.$value.'pt;line-height:100%">'.$text.'</span>';
		}
		if($param=='background')
			return '<span style="background-color:'.$value.'">'.$text.'</span>';
		if($param=='color')
			return '<span style="color:'.$value.'">'.$text.'</span>';
		if($param=='font')
			return '<span style="font-family:'.$value.'">'.$text.'</span>';
	}

	protected function BBUnDoImage($params)
	{
		$params=stripslashes($params);
		$params=Strings::ParseParams($params);
		$params_img=array();
		foreach($params as $k=>$v)
			switch(strtolower($k))
			{
				case 'border':
					$v=(int)$v;
					if($v>5)
						$v=5;
					if($v>0)
						$params_img['border']=' border='.$v;
				break;
				case 'alt':
				case 'title':
					if(!empty($v))
						$params_img['alt']=' alt='.(strpos($v,'"')===false ? '"'.$v.'"' : "'".$v."'");
				break;
				case 'width':
					$params_img['width']=' width="'.$v.'"';
				break;
				case 'align':
					$params_img['align']=' align="'.$v.'"';
				break;
				case 'height':
					$params_img['height']=' height="'.$v.'"';
				break;
				case 'class':
					if($v!='posted-image')
						$params_img['class']=' class="'.$v.'"';
				break;
				case 'align':
					$params_img['align']=' align="'.$v.'"';
				break;
			}
		return '[img'.join('',$params_img).']'.$params['src'].'[/img]';
	}

	protected function BBUnDoList($text)
	{
		if(preg_match('#^<(ul|ol)([^>]*)>(.+)$#is',$text,$m)==0)
			return '';
		$type=strtolower($m[1]);
		$params=$m[2];
		$text=trim($m[3]);
		$params=Strings::ParseParams($params);
		$params_list=array();
		foreach($params as $k=>$v)
			switch(strtolower($k))
			{
				case 'class':
					$params_list['class']=' class="'.$v.'"';
				break;
			}
		$text=str_replace(array('<li>','</li>'),array("\n[*]",''),stripslashes($text));
		return '['.$type.join('',$params_list).']'.$text."\n[/".$type.']';
	}
}
?>