<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');
class EE extends exception
{
	const
		FATAL=1,#Работать дальше невозможно в принципе. Логируем и умираем.
		CRITICAL=2,#Работать дальше, как и в предыдущем варианте невозможно, но логировать ошибку нет смысла. Поэтому, умираем но не логируем
		INFO=3,#Информационная ошибка: когда некорректно заполнена форма или некорректна любая другая информация от пользователя. Не логируем, не умираем.
		ACCESS=4,#Ошибка доступа. Когда пользователь не может получить доступ туда, куда он ломится (403 или 404 ошибка)
		BAN=5,#Ошибка бана, когда пользователю показываются страница ban.html, извещающего пользователя о том, что он забанен. Не логируем, умираем.
		DEV=6,#Ошибки разработчика: обращение к неинициализированной переменной, свойству, методу. Логируем, но не умираем.
		ENV=7,#Ошибки среды: когда нет доступа для записи в файл и т.п. Логируем. Если не словили - умираем.
		ALT=8;#Альтернативные ошибки: если словили - ничего не делаем, если не словили - логируем, отображаем ошибку и умираем. На эти параметры можно влиять через

	public
		$uncatched=array('log'=>false,'mess'=>false);#Массив с инструкциями что делать, если исключение не поймали. Ключи: log -признак логирования, lfile - файл куда логировать, mess - ошибка, которая будет показана пользователю

	public function __construct($mess,$code=self::FATAL,$addon=array())
	{
		parent::__construct($mess);
		if(isset($addon['file']))
			$this->file=$addon['file'];
		if(isset($addon['line']))
			$this->line=$addon['line'];
		$Mainclass=Mainclass::getInstance();
		switch($code)
		{
			case self::FATAL:
				self::LogIt($Mainclass->vars['errors_log_file'],$mess,$this->getFile(),$this->getLine());
			case self::CRITICAL:
				self::ShowDie($mess);
			break;
			case self::BAN:
				self::ShowBan($mess);
			break;
			case self::DEV:
				self::LogIt($Mainclass->vars['errors_log_file'],$mess,$this->getFile(),$this->getLine());
			break;
			case self::ENV:
				self::LogIt($Mainclass->vars['errors_log_file'],$mess,$this->getFile(),$this->getLine());
			break;
			case self::ALT:
				$this->uncatched=$addon+array('log'=>true,'lfile'=>$Mainclass->vars['errors_log_file'],'mess'=>$mess);
			case self::ACCESS:
				#ToDo! Пока не придумал что сюда написать.
			case self::INFO:
			default:
		}
	}

	public static function ShowDie($error)
	{
		$Mainclass=Mainclass::getInstance();
		if(is_callable($Mainclass->error_callback))
			return @call_user_func($Mainclass->error_callback,$error);
		if(isset($Mainclass->vars['errors_show_critical']) and !$Mainclass->vars['errors_show_critical'] and $Mainclass->domain)
		{
			if(!headers_sent())
				Functions::Redirect(ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path);
			exit;
		}
		if(!headers_sent())
		{
			$Mainclass->do_gzip_compress=false;
			$Mainclass->SendHeaders();
			header('HTTP/1.1 503 Service Temporarily Unavailable');
			header('Retry-After: 7200');
		}
		if(ob_get_contents()!==false)
			ob_clean();
		$rep=array(
					'charset'=>ELEANOR_DISPLAYCHARSET,
					'title'=>$Mainclass->lang['main']['error_happened'],
					'error'=>$error,
					'message'=>isset($Mainclass->vars['errors_critical_message']) ? $Mainclass->vars['errors_critical_message'] : '',
					'bhref'=>ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
		);
		$string=file_get_contents($Mainclass->root_path.'templates/error.html');
		if($Mainclass->done)
		{
			preg_match('#<body[^>]*>(.*)</body>#is',$string,$match);
			$string=$match[1];
		}
		die($Mainclass->Template->ReplaceAll($string,$rep));
	}

	public static function ShowBan($text)
	{
		$Mainclass=Mainclass::getInstance();
		if(!headers_sent())
		{
			$Mainclass->do_gzip_compress=false;
			$Mainclass->SendHeaders();
		}
		if(ob_get_contents()!==false)
			ob_clean();
		$rep=array(
					'title'=>$Mainclass->lang['main']['you_are_banned'],
					'message'=>$text ? Strings::ParseOwnBB($text) : $Mainclass->vars['blocked_message'],
					'charset'=>ELEANOR_DISPLAYCHARSET,
					'bhref'=>ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
		);
		$string=file_get_contents($Mainclass->root_path.'templates/ban.html');
		if($Mainclass->done)
		{
			preg_match('#<body[^>]*>(.*)</body>#is',$string,$match);
			$string=$match[1];
		}
		die($Mainclass->Template->ReplaceAll($string,$rep));
	}

	public function LogIt($file_name,$message,$file='',$line='')
	{
		if(!$file_name)
			return;
		$Mainclass=Mainclass::getInstance();
		if($Mainclass->no_log)
			return;
		$path=$Mainclass->FormatPath($file_name);
		if(!is_writeable(dirname($path)))
			die('File '.$file_name.' is write-protected!');
		if($Mainclass->vars['errors_file_max_size'] and is_file($path) and @filesize($path)>(int)$Mainclass->vars['errors_file_max_size'])
		{
			clearstatcache();
			if(Functions::CompressFile($path,substr($path,0,strrpos($path,'.')).'_'.date('Y-m-d_H-i')))
				@unlink($path);
		}
		if($fhandle=fopen($path,'a'))
		{
			$date_time=date('Y-m-d H:i:s');
			$url=$Mainclass->MyGetEnv('REQUEST_URI');
			if(isset($Mainclass->Url))
				$url=$Mainclass->Url->DecodeParam($url);
			flock($fhandle,LOCK_EX);
			fwrite($fhandle,$message.($file ? ' Line: '.$line.' in file '.$file."\r\n" : '').' URL: '.$url."\r\n".' Date: '.$date_time."\r\n".' IP: '.$Mainclass->ip."\r\n\r\n");
			flock($fhandle,LOCK_UN);
			fclose($fhandle);
		}
	}
}
?>