<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class Email extends BaseClass
{
	public
		$from,#От кого.
		$to,#Кому (может быть строкой или массивом)
		$subject,#Тема сообщения
		$message,#Сообщение
		$pr,#Уровень важности от 1 (самый важный) до 5 (самый неважный)
		$html=false,#Письмо в формате ХТМЛ?
		$bcc=array(),#Копия (может быть строкой или массивом)
		$cc=array(),#Скрытая (может быть строкой или массивом)
		$reply_enabled,#Посылать заголовки "Ответ"
		$reply='',
		$notification_enabled=false,
		$notification='',#Мыло, куда будет отправляться подверждение
		$add_tags=true,#Закрывать $this->from, $to, $bcc, $cc в квадратные скробки. Было sender@mail.com, станет <sender@mail.com>
		$mailer;#Идентификатор маилера
	protected
		$method='mail',
		$smtp_port=25,
		$smtp_host,
		$smtp_user,
		$smtp_pass,
		$smtp_fp=false,
		$boundary,
		$lang,
		$files=array();

	public function __construct($Mainclass)
	{
		$this->Mainclass=$Mainclass;
		$this->lang=$Mainclass->LoadLanguage('langs','','mailer-%');
		$this->LoadConfig();
	}

	public function LoadConfig()
	{
		if($this->Mainclass->vars['mail_method']=='smtp')
		{
			$this->method='smtp';
			if(isset($this->Mainclass->vars['mail_smtp_port']))
				$this->smtp_port=(int)$this->Mainclass->vars['mail_smtp_port'];
			$this->smtp_host=$this->Mainclass->vars['mail_smtp_host'] ? $this->Mainclass->vars['mail_smtp_host'] : 'localhost';
			$this->smtp_user=$this->Mainclass->vars['mail_smtp_user'];
			$this->smtp_pass=$this->Mainclass->vars['mail_smtp_pass'];
		}
		$this->from=$this->Mainclass->vars['mail_from'];
		$this->pr=$this->Mainclass->vars['mail_priority'];
		$this->reply_enabled=$this->Mainclass->vars['mail_reply_enabled'];
		$this->reply=$this->Mainclass->vars['mail_reply'];
		$this->notification_enabled=$this->Mainclass->vars['mail_notification_enabled'];
		$this->notification=$this->Mainclass->vars['mail_notification'];
		$this->mailer=$this->Mainclass->vars['mail_mailer'];
		$this->boundary='_'.md5($this->Mainclass->file_name);
	}

	public function AddFile($name,$file,$load=true)
	{
		$content=chunk_split(base64_encode($load ? $file : file_get_contents($this->Mainclass->FormatPath($file))));
		$this->files[]=array('name'=>$name,'type'=>Functions::FileMimeType($name),'content'=>$content);
	}

	public function FlushFiles()
	{
		$this->files=array();
	}

	public function Send($headers=false)
	{
		if(!$this->subject)
			$this->subject=$this->lang['without_subject'];
		if($this->from and $this->to and Functions::CheckEmail($this->from) and Functions::CheckEmail($this->to))
		{
			$from=$this->AddTags($this->from);
			$to=$this->AddTags($this->to);
			if(!$headers)
			{
				$multi=!empty($this->files);
				$d="\r\n";
				$notification=$this->notification ? $this->AddTags($this->notification) : $from;
				$reply=$this->reply ? $this->AddTags($this->reply) : $from;
				$headers='MIME-Version: 1.0'.$d.'Date: '.date('r').$d
						.'From: "'.$this->Mainclass->vars['site_name'].'" '.$from.$d;
				if($multi)
					$headers.='Content-Type: multipart/mixed;'."\t".'boundary="'.$this->boundary.'"'.$d;
				if($this->method=='smtp')
					$headers.='To: '.$to.$d.'Subject: =?'.ELEANOR_DISPLAYCHARSET.'?B?'.base64_encode($this->subject).'=?='.$d;
				$headers.='Return-Path: '.$from.$d.($this->reply_enabled ? 'Reply-To: '.$reply.$d : '').'Return-Receipt-To: '.$from.$d.($this->notification_enabled ? 'Disposition-Notification-To: '.$notification.$d : '').'X-Priority: '.$this->pr.$d.'X-Mailer: '.$this->mailer.$d;
				if($this->bcc)
					$headers.='Bcc: '.$this->AddTags($this->bcc).$d;
				if($this->cc)
					$headers.='Cc: '.$this->AddTags($this->cc).$d;
				if($multi)
					$headers.='--'.$this->boundary.$d;
				$headers.='Content-Transfer-Encoding: 8bit'.$d.'Content-type: text/'.($this->html ? 'html' : 'plain').'; charset='.ELEANOR_DISPLAYCHARSET.$d;
				if($multi or $this->method=='smtp')
				{
					$headers.=$d.$this->message.$d;
					if($multi)
						$headers.='--'.$this->boundary.$d;
				}
				if($multi)
					foreach($this->files as $v)
						$headers.='Content-Type: '.$v['type'].';	name="'.$v['name'].'";'.$d
								.'Content-Disposition: attachment;	filename="'.$v['name'].'";'.$d
								.'Content-Transfer-Encoding: base64'.$d.$d
								.$v['content'].'--'.$this->boundary.$d;
			}
			#SMTP
			if($this->method=='smtp')
			{
				if(!$socket=fsockopen($this->smtp_host,$this->smtp_port,$errno,$errstr,30))
					throw new EE($errno.'-'.$errstr,EE::INFO);
				if(!$this->Parse($socket,'220'))
					return false;
				fputs($socket,($this->smtp_user ? 'EHLO ' : 'HELO ').$this->smtp_host."\n");
				if(!$this->Parse($socket,250))
				{
					fclose($socket);
					throw new EE($this->lang['err_helo'],EE::INFO);
				}
				if($this->smtp_user)
				{
					fputs($socket,"AUTH LOGIN\n");
					if(!$this->Parse($socket,'334'))
					{
						fclose($socket);
						throw new EE($this->lang['err_auth'],EE::INFO);
					}
					fputs($socket,base64_encode($this->smtp_user)."\n");
					if(!$this->Parse($socket,334))
					{
						fclose($socket);
						throw new EE($this->lang['err_login'],EE::INFO);
					}
					if($this->smtp_pass)
					{
						fputs($socket,base64_encode($this->smtp_pass)."\r\n");
						if(!$this->Parse($socket,235))
						{
							fclose($socket);
							throw new EE($this->lang['err_pass'],EE::INFO);
						}
					}
				}
				fputs($socket,'MAIL FROM: '.$from."\n");
				if(!$this->Parse($socket,250))
				{
					fclose($socket);
					throw new EE($this->lang['err_mail_from'],EE::INFO);
				}
				fputs($socket,'RCPT TO: '.$to."\n");
				if(!$this->Parse($socket,250))
				{
					fclose($socket);
					throw new EE($this->lang['err_rcpt'],EE::INFO);
				}
				fputs($socket,"DATA\n");
				if(!$this->Parse($socket,354))
				{
					fclose($socket);
					throw new EE($this->lang['err_data'],EE::INFO);
				}
				fputs($socket,$headers."\n.\n");
				if(!$this->Parse($socket,'250'))
				{
					fclose($socket);
					throw new EE($this->lang['err_body'],EE::INFO);
				}
				fputs($socket,"QUIT\n");
				fclose($socket);
			}
			else
			#PHP
			{
				$message=$this->files ? '' : $this->message;
				if(ini_get('safe_mode')==1 ? !mail($to,$this->subject,$message,$headers) : !mail($to,$this->subject,$message,$headers))
				{
					throw new EE($this->lang['error_sending'],EE::ENV);
					return false;
				}
			}
		}
		else
		{
			throw new EE($this->lang['fields_empty'],EE::INFO);
			return false;
		}
		return true;
	}

	private function Parse($socket,$response)
	{
		while($server_response=fgets($socket,256))
		{
			if(substr($server_response,0,3)==$response)
				return true;
		}
		return false;
	}

	private function AddTags($str)
	{
		if($this->add_tags)
		{
			if(is_array($str))
			{
				$new_str=array();
				foreach($str as $k=>$v)
					$new_str[]=(is_int($k) ? '' : $k).'<'.trim($v,'<>').'>';
				$str=$new_str;
			}
			else
				$str='<'.trim($str,'<>').'>';
		}
		return is_array($str) ? implode(',',$str) : str_replace(array("\t",' '),'',$str);
	}
}
?>