<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
final class Permission extends BaseClass
{
	private
		$is_admin=null,
		$insert_html=null,
		$use_files=null,
		$delete_files=null,
		$max_upload=null,
		$banned=null;
	public function CleanAll()
	{
		$this->is_admin=$this->insert_html=$this->use_files=$this->delete_files=$this->max_upload=$this->banned=null;
	}

	public function IsAdmin($hard=false)
	{
		if($this->is_admin===null or $hard)
		{
			$arr=$this->Mainclass->Account->GetPermission('access_cp',$hard);
			$this->is_admin=is_array($arr) ? in_array(1,$arr) : false;
		}
		return $this->is_admin;
	}

	public function UseFiles()
	{
		if($this->IsAdmin())
			return true;
		if($this->use_files===null)
		{
			$arr=$this->Mainclass->Account->GetPermission('use_files');
			$this->use_files=is_array($arr) ? in_array(1,$arr) : false;
		}
		return $this->use_files;
	}

	public function DeleteFiles()
	{
		if($this->IsAdmin())
			return true;
		if($this->delete_files===null)
		{
			$arr=$this->Mainclass->Account->GetPermission('del_files');
			$this->delete_files=is_array($arr) ? in_array(1,$arr) : false;
		}
		return $this->delete_files;
	}

	/*
		Функция используется для определения максимального размера загружаемого файла. Возвращает:
		true - нет ограничений
		false - нельзя загружать файлы
		(int) - числов в байтах
	*/
	public function MaxUpload()
	{
		if($this->IsAdmin())
			return true;
		if($this->max_upload===null)
		{
			$arr=$this->Mainclass->Account->GetPermission('max_upload');
			if(in_array('0',$arr))
				return $this->max_upload=true;
			sort($arr,SORT_NUMERIC);
			$bytes=(int)end($arr);
			return $this->max_upload=($bytes<0 ? false : $bytes*1024);
		}
		return $this->max_upload;
	}

	public function IsBanned($hard=false)
	{
		if($this->IsAdmin())
			return false;
		if($this->banned===null or $hard)
		{
			$arr=$this->Mainclass->Account->GetPermission('banned',$hard);
			$this->banned=is_array($arr) ? in_array(1,$arr) : false;
		}
		return $this->banned;
	}
}
?>