<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
/*
	Класс не требует создания многих экземпляров ради создания нескольких полей аплоада. Для этого достаточно всего лишь вызвать нужное количество раз
	функцию Show(). Остальное класс сделает за вас.
	Самостоятельное разделение класса на нужные части сделано на основе того, что большинство его действий производятся на AJAX
*/
class Uploader extends BaseClass
{
	const FILENAME='Filedata';
	public
		$addon_post=array(),#Дополнительные POST параметры, передаваемые аплоадером
		$error='',#Ошибки в процессе показа файлов
		$new_folder='new',#имя новой папки
		$per_page=20,#Количество файлов на страницу.
		$watermark_on=true,#Включен ли ватермарк?
		$allow_use,#Разрешить использование аплоадера?
		$allow_walk=true,#Позволить "гулять" по папкам
		$allow_delete=true,#Позволить удалять файлы и папки
		$watermark=null,#true - всегда ставить, false - всегда не ставить, null - выбирает пользователь
		$allow_lock=true,#позволить "открывать"-"закрывать" папки
		$allow_new=true,#разрешить создавать новые папки
		$allowed_types=array(),#Типы файлов, разрешенные для аплоада
		$current_path='',#В случае, если ходить где-то запрещено
		$max_size,#Максимальный размер файла. Поставьте в false, если не хотите, чтобы пользователь мог загружать файлы.
		$max_size_all=true,#если true, то под максимальным размером файла нужно понимать сумму размеров всех залитых файлов.
		$max_files=0,#Максимальное число файлов, которые пользователь может загрузить.
		$preview=array(),#Создавать превьюшки? Если да, укажите типы файлов, для которых создавать
		$uniq=false;#Уникальный опциальный идентификатор, позволяющий сэкономить память
	protected
		$lang,
		$current_size=0,#Текущий размер файлов
		$files_cnt=0;#Текущее количество файлов
	/*
		Функция конвертирует значения размеров из конфигурации PHP в байтовое представление
	*/
	public static function ConvertBytes($value)
	{
		if(ctype_digit($value))
			return $value/1024;
		else
		{
			$letter=strtolower(substr($value,-1));
			$value=(int)$value;
			switch($letter)
			{
				case 'k':
					$value*=1024;
				break;
				case 'm':
					$value*=1048576;
				break;
				case 'g':
					$value*=1073741824;
				break;
			}
			return $value;
		}
	}

	public function __construct($Mainclass)
	{
		$Mainclass->LoadOptions(array('files'),false);
		$this->lang=$Mainclass->LoadLanguage('langs','','uploader-%');
		$this->max_size=$Mainclass->Permission->MaxUpload();
		$this->allow_new=$this->allow_delete=$Mainclass->Permission->DeleteFiles();
		$this->allow_use=$Mainclass->Permission->UseFiles();
		if($Mainclass->vars['img_preview'])
			$this->preview=explode(',',Strings::CleanForExplode($Mainclass->vars['img_preview_types']));
		if(!$this->Mainclass->vars['watermark'])
			$this->watermark=false;
	}
	/*
		Главная функция :)
	*/
	public function Show($start_folder,$create_new=false,$title='')
	{
		if($this->allow_use)
		{
			$null_uniq=true;
			if(!isset($_SESSION))
			{
				if($this->uniq===false)
					$this->Mainclass->StartSession();
				else
				{
					$this->Mainclass->StartSession('',$this->Mainclass->GCookie('up_session_'.$this->uniq));
					$this->Mainclass->SCookie('up_session'.$this->uniq,session_id());
					$null_uniq=false;
				}
			}
			if($this->uniq===false)
				$this->uniq=uniqid();
			$max_upload=self::ConvertBytes(ini_get('upload_max_filesize'));
			if($this->max_size===true)
			{
				$this->current_size=true;
				$this->max_size_all=false;
				$this->max_size=$max_upload;
			}
			if($this->max_size_all or $this->max_files>0)
				$this->allow_new=$this->allow_walk=false;
			$upload=$this->max_size ? $this->ShowUpload(min($this->max_size,$max_upload)) : '';
			if(!$this->max_size)
				$this->watermark=false;
			$this->new_folder='/'.$this->new_folder;
			$r='<div class="uploadbox"><div class="uploadhead"><h2>'.($title ? $title : $this->lang['file_manag']).'</h2><a href="#" onclick="return ChangeUploaderVisible(\'upl_'.$this->uniq.'\',\''.$this->lang['hide'].'\',\''.$this->lang['show'].'\',this)" style="text-decoration:none"><b>'.$this->lang['show'].'</b></a></div><div class="uploader" style="display:none" id="upl_'.$this->uniq.'"><div class="uppanel">'.$upload.$this->ShowFiles($start_folder,$create_new).'</div></div>';
			$this->SaveOptions();
			if($null_uniq)
				$this->uniq=false;
			return $r;
		}
		else
			return $this->lang['files_denied'];
	}

	/*
		Функция переименовывает NEW папки в нужное имя
	*/
	public function RenameNew($start_folder,$to)
	{
		$path=$this->DirPath($start_folder);
		if(!$this->new_folder or !$to or $this->error or preg_match('~["\':*\?<>|]~',$to)>0)
			return false;
		$to=$this->Mainclass->Functions->FixWinFileS(mb_strtolower($this->Mainclass->FormatPath($to,$path),ELEANOR_CHARSET));
		$path.='/'.$this->Mainclass->Functions->FixWinFileS($this->new_folder);
		if(!file_exists($path) or file_exists($to))
			return false;
		$no_log=$this->Mainclass->no_log;
		$this->Mainclass->no_log=true;
		$files=glob($path.'/*');
		if(!$files)
			$r=Functions::RmDir($path);
		else
			$r=rename($path,$to);
		$this->Mainclass->no_log=$no_log;
		return $r;
	}

	/*
		Функция удаление файла
	*/
	public function DeleteFile($start_folder,$what)
	{
		if(!$this->allow_delete or !$what)
			return false;
		$path=$this->DirPath($start_folder,$what);
		if($this->error)
			return false;
		if($this->current_size!==true and is_file($path))
		{
			$this->current_size-=filesize($path);
			if($this->current_size<0)
				$this->current_size=0;
			$this->SaveOptions();
		}
		$type=strtolower(substr($path,strrpos($path,'.')+1));
		if(in_array($type,$this->preview) and is_file($path))
		{
			$prev=substr_replace($path,'_preview',strrpos($path,'.'),0);
			if(is_file($prev))
				Functions::RmDir($prev);
			elseif(preg_match('#_preview\.[a-z0-9_]+$#',$path)>0)
				Functions::RmDir(preg_replace('#_preview(\.[a-z0-9_]+)$#','\1',$path));
		}
		$res=Functions::RmDir($path);
		return $res;
	}

	/*
		Функция для сервиса upload.php
	*/
	public function DoUpload()
	{
		if(!isset($_POST['session']))
			return false;
		$this->Mainclass->StartSession('',$_POST['session']);
		$file_name=$this->Mainclass->Url->DecodeParam($_FILES[self::FILENAME]['name']);
		if($this->Mainclass->vars['trans_url'])
			$file_name=Strings::Translit($file_name);
		$file_type=strpos($file_name,'.')===false ? '' : substr($file_name,strrpos($file_name,'.')+1);
		$file_size=$_FILES[self::FILENAME]['size'];
		$watermark=isset($_POST['watermark']) ? $_POST['watermark'] : false;
		$folder=$this->Mainclass->Url->DecodeParam(isset($_POST['folder']) ? $_POST['folder'] : '');
		$this->uniq=isset($_POST['uniq']) ? $_POST['uniq'] : '';
		if(!$this->LoadOptions())
			return false;
		if($file_size>$this->max_size or $this->current_size!==true and ($this->current_size+$file_size)>$this->max_size or $this->max_files>0 and $this->files_cnt>=$this->max_files)
			return false;
		$folder=$this->DirPath($folder);
		if($this->error)
			return false;
		#Заменяем все [ и ] потому что они криво вставляются в тег [attach]
		$file_name=preg_replace('#[\s\'"%\]\[/\\\-]+#',$this->Mainclass->Url->rep_space,trim($file_name,' .'));
		$folder.='/'.$this->Mainclass->Functions->FixWinFileS(mb_strtolower($file_name,ELEANOR_CHARSET));
		if($this->CanUploadType($file_type) and move_uploaded_file($_FILES[self::FILENAME]['tmp_name'],$folder))
		{
			if($this->watermark!==false and ($this->watermark or $watermark))
				$this->Mainclass->Functions->WaterMark($folder);
			if(in_array(mb_strtolower(substr($folder,strrpos($folder,'.')+1),ELEANOR_CHARSET),$this->preview))
				try
				{
					$this->Mainclass->Functions->CreateImagePreview($folder,$this->Mainclass->vars['img_preview_width']);
				}
				catch(EE $e){}
			if($this->current_size!==true)
			{
				$this->current_size+=$file_size;
				$this->SaveOptions();
			}
			echo 'Ok';
			return true;
		}
		return false;
	}

	/*
		Функция для сервиса ajax.php
	*/
	public function DoAjax()
	{
		$this->uniq=isset($_REQUEST['uniq']) ? $_REQUEST['uniq'] : '';
		if(isset($_REQUEST['session']))
			$this->Mainclass->StartSession('',$_REQUEST['session']);
		$start_folder=isset($_REQUEST['start_folder']) ? $_REQUEST['start_folder'] : '';
		if(!$this->LoadOptions())
			Error($this->lang['lost_session']);
		else
			switch($_REQUEST['goal'])
			{
				case 'get_files':
					$destination=isset($_REQUEST['destination']) ? $_REQUEST['destination'] : '';
					$page=isset($_REQUEST['page']) ? (int)$_REQUEST['page'] : 1;
					$arr=$this->GetFiles($start_folder,$destination,$page);
					$arr['eval']='f_'.$this->uniq.'.WaterMark();';
					Result($arr);
				break;
				case 'new_folder':
					$folder=isset($_REQUEST['folder']) ? $_REQUEST['folder'] : '';
					$res=$this->NewFolder($start_folder,$folder);
					if(!$res)
						Result('ok');
					else
						Error($res);
				break;
				case 'rename':
					$what=isset($_REQUEST['file']) ? $_REQUEST['file'] : '';
					$to=isset($_REQUEST['to']) ? $_REQUEST['to'] : '';
					$res=$this->Rename($start_folder,$what,$to);
					if($res)
						Result('ok');
					else
						Error($this->lang['not_renamed']);
				break;
				case 'delete':
					$what=isset($_REQUEST['file']) ? $_REQUEST['file'] : '';
					$res=$this->DeleteFile($start_folder,$what);
					if($res)
						Result('ok');
					else
						Error($this->lang['not_deleted']);
				break;
				case 'lock_folder':
					$res=$this->LockFolder($start_folder);
					if($res!==false)
					{
						$res=array('lock'=>$res);
						$res['eval']='f_'.$this->uniq.'.WaterMark();';
						Result($res);
					}
					else
						Error($res);
				break;
			}
	}

	protected function LoadOptions()
	{
		if(!$this->uniq)
			return false;
		if(isset($_SESSION['u_walk'.$this->uniq]))
			$this->allow_walk=$_SESSION['u_walk'.$this->uniq];
		if(isset($_SESSION['u_current_path'.$this->uniq]))
		{
			$this->current_path=$_SESSION['u_current_path'.$this->uniq];
			if(!$this->current_path)
				$this->allow_walk=true;
		}
		if(isset($_SESSION['u_delete'.$this->uniq]))
			$this->allow_delete=$_SESSION['u_delete'.$this->uniq];
		if(isset($_SESSION['u_lock'.$this->uniq]))
			$this->allow_lock=$_SESSION['u_lock'.$this->uniq];
		if(isset($_SESSION['u_allow_new'.$this->uniq]))
			$this->allow_new=$_SESSION['u_allow_new'.$this->uniq];
		if(isset($_SESSION['u_new_folder'.$this->uniq]))
			$this->new_folder=$_SESSION['u_new_folder'.$this->uniq];
		if(isset($_SESSION['u_watermark'.$this->uniq]))
			$this->watermark=$_SESSION['u_watermark'.$this->uniq];
		if(isset($_SESSION['u_a_types'.$this->uniq]) and is_array($_SESSION['u_a_types'.$this->uniq]))
			$this->allowed_types=$_SESSION['u_a_types'.$this->uniq];
		if(isset($_SESSION['u_watermark_on'.$this->uniq]))
			$this->watermark_on=$_SESSION['u_watermark_on'.$this->uniq];
		if(isset($_SESSION['u_max_size'.$this->uniq]))
			$this->max_size=$_SESSION['u_max_size'.$this->uniq];
		if(isset($_SESSION['u_max_size_all'.$this->uniq]))
			$this->max_size_all=$_SESSION['u_max_size_all'.$this->uniq];
		if(isset($_SESSION['u_max_files'.$this->uniq]))
			$this->max_files=$_SESSION['u_max_files'.$this->uniq];
		if(isset($_SESSION['u_current_s'.$this->uniq]))
			$this->current_size=$_SESSION['u_current_s'.$this->uniq];
		if(isset($_SESSION['u_preview'.$this->uniq]))
			$this->preview=$_SESSION['u_preview'.$this->uniq];
		if(isset($_SESSION['u_files_cnt'.$this->uniq]))
			$this->files_cnt=$_SESSION['u_files_cnt'.$this->uniq];
		return isset($_SESSION['u_current_path'.$this->uniq]);
	}

	protected function SaveOptions()
	{
		$_SESSION['u_walk'.$this->uniq]=$this->allow_walk;
		$_SESSION['u_delete'.$this->uniq]=$this->allow_delete;
		$_SESSION['u_lock'.$this->uniq]=$this->allow_lock;
		$_SESSION['u_new_folder'.$this->uniq]=$this->new_folder;
		$_SESSION['u_allow_new'.$this->uniq]=$this->allow_new;
		$_SESSION['u_watermark'.$this->uniq]=$this->watermark;
		$_SESSION['u_watermark_on'.$this->uniq]=$this->watermark_on;
		$_SESSION['u_a_types'.$this->uniq]=$this->allowed_types;
		$_SESSION['u_max_size'.$this->uniq]=$this->max_size;
		$_SESSION['u_max_size_all'.$this->uniq]=$this->max_size_all;
		$_SESSION['u_current_s'.$this->uniq]=$this->current_size;
		$_SESSION['u_max_files'.$this->uniq]=$this->max_files;
		$_SESSION['u_preview'.$this->uniq]=$this->preview;
		$_SESSION['u_files_cnt'.$this->uniq]=$this->files_cnt;
	}

	/*
		Функция создает новую папку
	*/
	protected function NewFolder($start_folder,$folder)
	{
		if(!$this->allow_new)
			return false;
		$folder=mb_strtolower($folder,ELEANOR_CHARSET);
		if($folder=='')
			return $this->lang['type_folder_name'];
		if(preg_match('%[\s#"\'\\/:*\?<>|]+%',$folder)>0)
			return $this->lang['incorrect_folder_name'];
		$path=$this->DirPath($start_folder);
		if($this->error)
			return $this->error;
		$path.='/'.$this->Mainclass->Functions->FixWinFileS($folder);
		if(!is_dir($path))
			mkdir($path);
		return is_dir($path) ? false : $this->lang['folder_mistakes'];
	}

	/*
		Функция создает/удаляет в папке файл .htaccess с текстом allow from all
		$lock: true - удалить файл, false - создать файл
	*/
	protected function LockFolder($start_folder)
	{
		if(!$this->allow_lock)
			return false;
		$path=$this->DirPath($start_folder);
		if($this->error)
			return false;
		$path.='/.htaccess';
		$result=is_file($path) ? unlink($path) : file_put_contents($path,'allow from all');
		if($result)
		{
			$result='';
			if($this->Mainclass->Permission->MaxUpload()!==false and !is_bool($this->watermark))
				$result.='<a class="active" href="#" onclick="return f_'.$this->uniq.'.WaterMark(this);" title="Watermark" id="watermark_'.$this->uniq.'"><img style="background-image: url(images/uploader/watermark.gif);" src="'.$this->Mainclass->Template->GetImage('spacer.png').'" alt="Watermark" /></a>';
			if($this->allow_new)
				$result.='<a href="#" onclick="return f_'.$this->uniq.'.AddFolder();" title="'.$this->lang['add_folder'].'"><img src="images/uploader/add_folder.png" alt="'.$this->lang['add_folder'].'" /></a>';
			$result.=(is_file($path) and stripos(trim(file_get_contents($path)),'allow from all')===0)
					? '<a href="#" onclick="return f_'.$this->uniq.'.Lock(false);" title="'.$this->lang['close_f_access'].'"><img src="images/uploader/open_access_folder.png" alt="'.$this->lang['close_f_access'].'" /></a>'
					: '<a href="#" onclick="return f_'.$this->uniq.'.Lock(true);" title="'.$this->lang['open_f_access'].'"><img src="images/uploader/close_access_folder.png" alt="'.$this->lang['open_f_access'].'" /></a>';
			$result.='<a href="#" onclick="return f_'.$this->uniq.'.Update();" title="'.$this->Mainclass->lang['main']['update'].'"><img src="images/uploader/refresh.png" alt="'.$this->Mainclass->lang['main']['update'].'" /></a>';
		}
		return $result;
	}

	protected function Rename($start_folder,$what,$to)
	{
		$what=$this->Mainclass->Functions->FixWinFileS($what);
		$to=$this->Mainclass->Functions->FixWinFileS($to);
		if($what=='' or $to=='' or $to==$what)
			return false;
		$path=$this->DirPath($start_folder);
		if($this->error or !file_exists($path.'/'.$what) or preg_match('%[\s#"\'\\/:*\?<>|]+%',$to)>0 or file_exists($path.'/'.$to))
			return false;
		$type=strtolower(substr($what,strrpos($what,'.')+1));
		$to=$path.'/'.$to;
		$path.='/'.$what;
		if(in_array($type,$this->preview) and is_file($path))
		{
			$prev=substr_replace($path,'_preview',strrpos($path,'.'),0);
			if(is_file($prev))
				rename($prev,substr_replace($to,'_preview',strrpos($to,'.'),0));
			elseif(preg_match('#_preview\.[a-z0-9_]+$#',$path)>0)
				rename(preg_replace('#_preview(\.[a-z0-9_]+)$#','\1',$path),preg_replace('#_preview(\.[a-z0-9_]+)$#','\1',$to));
		}
		return rename($path,$to);
	}

	protected function GetFiles($start_folder,$move='',$page=1)
	{
		$path=$this->DirPath($start_folder,$move);
		$short_path=substr($path,strlen($this->Mainclass->root_path.Mainclass::UPLOADS_DIR)+1);
		if($this->Mainclass->os=='w')
			$short_path=$this->Mainclass->Functions->FixWinFileS(str_replace(DIRECTORY_SEPARATOR,'/',$short_path),true);
		$dirs=array();
		$files=glob($path.'/*',GLOB_MARK | GLOB_NOSORT);
		$cnt_tot=count($files);
		if($this->max_size_all)
			$this->current_size=0;
		foreach($files as $k=>&$v)
		{
			$v=$this->Mainclass->Functions->FixWinFileS($v,true);
			if(substr($v,-1)==DIRECTORY_SEPARATOR)
			{
				$dirs[]=basename($v);
				unset($files[$k]);
			}
			else
			{
				if($this->max_size_all)
					$this->current_size+=filesize($v);
				$files[$k]=basename($v);
			}
		}
		$this->files_cnt=count($files);
		natsort($dirs);
		natsort($files);
		#Превьюшки...
		$previews=array();
		if($this->preview)
		{
			$oldk='';
			foreach($files as $k=>&$v)
			{
				if($oldk=='')
				{
					$oldk=$k;
					continue;
				}
				if(preg_match('#^(.+?)_preview(\.[a-z0-9_]+)$#',$v,$m) and $files[$oldk]==$m[1].$m[2])
				{
					$previews[]=$files[$oldk];
					unset($files[$k]);
				}
				$oldk=$k;
			}
		}
		if($page<1)
			$page=1;
		if($this->per_page<$cnt_tot and $page<=ceil($cnt_tot/$this->per_page))
		{
			$cnt_dir=count($dirs);
			$offset=($page-1)*$this->per_page;
			if(($offset+$this->per_page)<=$cnt_dir)
			{
				$dirs=array_slice($dirs,$offset,$this->per_page);
				$files=array();
			}
			elseif($offset<$cnt_dir)
			{
				$dirs=array_slice($dirs,$offset,$this->per_page);
				$files=array_slice($files,0,$this->per_page-count($dirs));
			}
			else
			{
				$dirs=array();
				$files=array_slice($files,$offset-$cnt_dir,$this->per_page);
			}
			$result['pages']=Strings::Pages($cnt_tot,$this->per_page,'#',false,$page,'f_'.$this->uniq.'.Go(\'\',\'{page}\')');
			$result['page']=$page;
		}
		else
		{
			$result['pages']='';
			$result['page']=1;
		}
		if($short_path and $this->allow_walk)
		{
			$arr=explode('/',$short_path);
			$temp=array();
			$cnt=count($arr)-1;
			for($i=0;$i<$cnt;++$i)
				$temp[]='<a href="#" onclick="return f_'.$this->uniq.'.Go(\''.rtrim(str_repeat('../',$cnt-$i),'/').'\')">'.$arr[$i].'</a>';
			$temp[]=end($arr);
			$walk='<li><a href="#" onclick="return f_'.$this->uniq.'.Go(\'..\');" title="'.$this->lang['go_up'].'"><img class="typeicon" src="images/uploader/folder_up.gif" alt="'.$this->lang['go_up'].'" style="width: 25px; height: 16px;" /></a><b>/'.implode('/',$temp).'</b></li>';
		}
		foreach($files as &$entry)
		{
			$mtime=date('Y-m-d H:i:s',filemtime($path.'/'.$entry));
			$size=filesize($path.'/'.$entry);
			$preview=$tip='';
			$path.'/'.
			$type=strtolower(substr($entry,strrpos($entry,'.')+1));
			$slentry=str_replace('\'','\\\'',$entry);
			if(in_array($type,array('jpeg','jpg','png','bmp','gif','tiff','ico','psd')))
			{
				if(!file_exists($this->Mainclass->root_path.'images/uploader/file_types/'.$type.'.png'))
					$type='type_image';
				$tip=' onmouseover="var sw=Math.round(screen.width*0.7);Tip(\'&lt;span class=&quot;frdatethm&quot;&gt;'.$mtime.'&nbsp;&nbsp;&nbsp;&nbsp;'.round($size/1024,2).' KB&lt;/span&gt;&lt;br /&gt;&lt;img src=&quot;'.Mainclass::UPLOADS_DIR.'/'.$short_path.'/'.$slentry.'&quot; alt=&quot;&quot; style=&quot;max-width:\'+sw+\'px&quot; /&gt;\',BGCOLOR,\'#ffffff\')" onmouseout="UnTip()"';
			}
			else
				$tip=' onmouseover="Tip(\'&lt;span class=&quot;frdatethm&quot;&gt;'.$mtime.'&nbsp;&nbsp;&nbsp;&nbsp;'.round($size/1024,2).' KB&lt;/span&gt;\',BGCOLOR,\'#ffffff\')" onmouseout="UnTip()"';
			if(in_array($entry,$previews))
				$preview=substr_replace($entry,'_preview',strrpos($slentry,'.'),0);
			$entry='<li><span><a href="#" onclick="return f_'.$this->uniq.'.InsertAttach(\''.$slentry.'\',\''.$preview.'\');" title="'.$this->lang['insert_attach'].'"><img src="images/uploader/paste_object.png" alt="'.$this->lang['insert_attach'].'" style="width: 16px; height: 16px;" /></a> <a href="#" onclick="return f_'.$this->uniq.'.InsertLink(\''.$slentry.'\');" title="'.$this->lang['insert_file'].'"><img src="images/uploader/paste_link.png" alt="'.$this->lang['insert_file'].'" style="width: 16px; height: 16px;" /></a> <a href="#" onclick="return f_'.$this->uniq.'.Rename(\''.$slentry.'\')" title="'.$this->lang['rename'].'"><img src="images/uploader/rename.png" alt="'.$this->lang['rename'].'" style="width: 16px; height: 16px;" /></a>'
				.($this->allow_delete ? ' <a href="#" onclick="return f_'.$this->uniq.'.DeleteFile(\''.$slentry.'\');" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="images/uploader/delete.png" alt="'.$this->Mainclass->lang['main']['delete'].'" style="width: 16px; height: 16px;" /></a>' : '')
				.'</span><img'.$tip.' onclick="f_'.$this->uniq.'.Open(\''.$slentry.'\');" class="typeicon" src="'.(file_exists($this->Mainclass->root_path.'images/uploader/file_types/'.$type.'.png') ? 'images/uploader/file_types/'.$type.'.png' : 'images/uploader/type_file.png').'" alt="'.$this->lang['open_file'].'" style="width: 16px;height:16px;cursor:pointer" />'.$entry.'</li>';

		}
		foreach($dirs as &$entry)
		{
			$slentry=str_replace('\'','\\\'',$entry);
			$entry='<li><span><a href="#" onclick="return f_'.$this->uniq.'.Go(\''.$slentry.'\');" title="'.$this->lang['open_folder'].'"><img src="images/uploader/open_folder.png" alt="'.$this->lang['open_folder'].'" style="width: 16px; height: 16px;" /></a><a href="#" onclick="return f_'.$this->uniq.'.Rename(\''.$slentry.'\')" title="'.$this->lang['rename'].'"><img src="images/uploader/rename.png" alt="'.$this->lang['rename'].'" style="width: 16px; height: 16px;" /></a>'
			.($this->allow_delete ? ' <a href="#" onclick="return f_'.$this->uniq.'.DeleteFile(\''.$slentry.'\');" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="images/uploader/delete.png" alt="'.$this->Mainclass->lang['main']['delete'].'" style="width: 16px; height: 16px;" /></a>' : '')
			.'</span><a href="#" onclick="return f_'.$this->uniq.'.Go(\''.$slentry.'\');"><img class="typeicon" src="images/uploader/type_folder.png" alt="'.$this->lang['folder'].'" style="width: 16px; height: 16px;" /><b>'.$entry.'</b></a></li>';
		}
		$files=array_merge($dirs,$files);
		unset($dirs);
		if(isset($walk))
			array_unshift($files,$walk);
		$result['icons']='';
		if($this->Mainclass->Permission->MaxUpload()!==false and !is_bool($this->watermark))
			$result['icons'].='<a class="'.($this->watermark_on ? '' : 'de').'active" href="#" onclick="return f_'.$this->uniq.'.WaterMark(this);" title="Watermark" id="watermark_'.$this->uniq.'"><img style="background-image: url(images/uploader/watermark.gif);" src="'.$this->Mainclass->Template->GetImage('spacer.png').'" alt="Watermark" /></a>';
		if($this->allow_new)
			$result['icons'].='<a href="#" onclick="return f_'.$this->uniq.'.AddFolder();" title="'.$this->lang['add_folder'].'"><img src="images/uploader/add_folder.png" alt="'.$this->lang['add_folder'].'" /></a>';
		if($this->allow_lock)
			$result['icons'].=(is_file($path.'/.htaccess') and stripos(trim(file_get_contents($path.'/.htaccess')),'allow from all')===0)
					? '<a href="#" onclick="return f_'.$this->uniq.'.Lock(false);" title="'.$this->lang['close_f_access'].'"><img src="images/uploader/open_access_folder.png" alt="'.$this->lang['close_f_access'].'" /></a>'
					: '<a href="#" onclick="return f_'.$this->uniq.'.Lock(true);" title="'.$this->lang['open_f_access'].'"><img src="images/uploader/close_access_folder.png" alt="'.$this->lang['open_f_access'].'" /></a>';
		$result['icons'].='<a href="#" onclick="return f_'.$this->uniq.'.Update();" title="'.$this->Mainclass->lang['main']['update'].'"><img src="images/uploader/refresh.png" alt="'.$this->Mainclass->lang['main']['update'].'" /></a>';
		$result['files']=implode('',$files);
		$result['folder']=$short_path ? $short_path : '';#'/';
		$result['files_cnt']=$this->files_cnt;
		$result['upload']=true;
		if($this->current_size===true)
			$result['info']=sprintf($this->lang['maxu_unl'],round($this->max_size/1048576,2));
		else
		{
			$max_upload=self::ConvertBytes(ini_get('upload_max_filesize'));
			$result['upload']=($freesize=$this->max_size-$this->current_size)>0;
			if($freesize<0)
				$freesize=0;
			$result['info']=sprintf($this->lang['maxu_lim'],round(min($max_upload,$freesize)/1048576,2),round($freesize/1024,2));
		}
		if($this->max_files)
		{
			$result['info'].=sprintf($this->lang['lim_files'],$this->max_files-$this->files_cnt);
			$result['upload']&=($this->max_files-$this->files_cnt)>0;
		}
		if($this->error)
			$result['error']=$this->error;
		$this->SaveOptions();
		return $result;
	}

	protected function ShowUpload($bytes)
	{global $jscripts,$head_addon;
		$jscripts[]='addons/swfupload/swfupload.js';
		$jscripts[]='addons/swfupload/swfupload.queue.js';
		$jscripts[]='addons/swfupload/fileprogress.js';
		$jscripts[]='addons/swfupload/handlers.js';
		$head_addon.='<link type="text/css" rel="stylesheet" href="addons/swfupload/css.css" />';
		$addon_post='';
		foreach($this->addon_post as $k=>$v)
			$addon_post.=',\''.$k.'\':\''.$v.'\'';
		return '<div class="divloading" id="loading_'.$this->uniq.'" align="center"></div>
		<div style="float:left;"><span id="swf_upl'.$this->uniq.'"></span></div><span id="info_'.$this->uniq.'" style="float:left;font-size:10px;line-height:125%"></span><a class="btn" href="#" onclick="swf_'.$this->uniq.'.cancelQueue(); return false;" id="cancel_'.$this->uniq.'" style="display:none;text-decoration:none">'.$this->lang['cancel_upload'].'</a>
		<script type="text/javascript">//<![CDATA[
		var swf_'.$this->uniq.';
		swf_'.$this->uniq.' = new SWFUpload({
				flash_url : "addons/swfupload/swfupload.swf",
				upload_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/upload.php",
				post_params: {\'session\':\''.session_id().'\',\'watermark\':\'1\',\'uniq\':\''.$this->uniq.'\''.$addon_post.'},
				file_size_limit : "'.$bytes.'",
				file_types : "'.($this->allowed_types ? '*.'.join(';*.',$this->allowed_types) : '*.*').'",
				file_types_description : "'.$this->lang['all_files'].'",
				file_upload_limit : 100,
				file_queue_limit : 0,
				custom_settings : {
					progressTarget : "loading_'.$this->uniq.'",
					cancelButtonId : "cancel_'.$this->uniq.'",
					infoid : "info_'.$this->uniq.'",
					uniq : "'.$this->uniq.'"
				},
				button_placeholder_id: "swf_upl'.$this->uniq.'",
				button_image_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/images/uploader/uploadbtn.png",
				button_text: \'<span class="upbtntext">'.$this->lang['upload_file'].'</span>\',
				button_text_style: ".upbtntext { font-size: 11px; color: #6D6A65; font-family: Tahoma, Arial, sans-serif; font-weight: bold; }",
				button_text_left_padding: 16,
				button_text_top_padding: 4,
				button_width: 129,
				button_height: 27,
				button_cursor: SWFUpload.CURSOR.HAND,
				debug: false,
				file_queued_handler : fileQueued,
				file_queue_error_handler : fileQueueError,
				file_dialog_complete_handler : fileDialogComplete,
				upload_start_handler : uploadStart,
				upload_progress_handler : uploadProgress,
				upload_error_handler : uploadError,
				upload_success_handler : uploadSuccess,
				upload_complete_handler : uploadComplete,
				swfupload_loaded_handler:function(){if(f_'.$this->uniq.') f_'.$this->uniq.'.Update()}
			});
		//]]></script>';

	}

	protected function ShowFiles($start_folder,$create_new)
	{global $head_addon;
	 static $header_done;
		if(!isset($header_done))
		{
			$head_addon.='<link rel="stylesheet" type="text/css" href="templates/'.$this->Mainclass->Template->theme.'/style/uploader.css" media="screen" />';
			$header_done=true;
		}
		$start_folder=trim($start_folder,'/');
		$path=$this->Mainclass->Functions->FixWinFileS($this->Mainclass->FormatPath(Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.$start_folder));
		$this->new_folder=$this->Mainclass->Functions->FixWinFileS($this->new_folder);
		$no_log=$this->Mainclass->no_log;
		$this->Mainclass->no_log=true;
		if(!is_dir($path))
			mkdir($path);
		if($create_new)
		{
			$start_folder.=$this->new_folder;
			$path.=$this->new_folder;
			if(!is_dir($path))
				mkdir($path);
		}
		$this->Mainclass->no_log=$no_log;
		$_SESSION['u_current_path'.$this->uniq]=$this->Mainclass->os=='w' ? str_replace('/','\\',$path) : $path;
		return Strings::AddJS('js/eleanor_uploader.js').Strings::AddJS('js/wz_tooltip.js')
		.'<div class="uppanel_ricons" id="icons_'.$this->uniq.'"></div>
			<div class="clr"></div>
		</div>
		<ul class="uppanel_files" id="files_'.$this->uniq.'"><li>'.$this->lang['uploading'].'</li></ul>
		<div id="pages_'.$this->uniq.'" style="display:none"></div>
		<script type="text/javascript">//<![CDATA[
		var f_'.$this->uniq.'=new EleanorUploader("'.$this->uniq.'",'.($this->watermark_on ? 'true' : 'false').',"'.session_id().'");
			f_'.$this->uniq.'.start_folder="'.$start_folder.'";
			f_'.$this->uniq.'.service="'.$this->Mainclass->service_id.'";
			f_'.$this->uniq.'.uploads_dir="'.Mainclass::UPLOADS_DIR.'";
		'.($this->max_size===false ? 'f_'.$this->uniq.".Update();\r\n" : '')
		.'//]]></script>';
	}

	/*
		Форматирует путь к папке.
	*/
	public function DirPath($start_folder,$move='')
	{
		$this->error='';
		$start_folder=str_replace(array('..','/.','%'),'',$start_folder);
		$start_folder=$this->Mainclass->Functions->FixWinFileS($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.trim($start_folder,'/'));
		if(!is_dir($start_folder))
		{
			$this->error=$this->lang['folder_not_exists'];
			return $this->Mainclass->root_path.Mainclass::UPLOADS_DIR;
		}
		if($move!='')
			$move='/'.$this->Mainclass->Functions->FixWinFileS($move);
		$destination=realpath($m=$start_folder.$move);
		if($destination===false)
		{
			$this->error=sprintf($this->lang['folder_not_found'],$m);
			return $start_folder;
		}
		if(!$this->allow_walk and $this->current_path and strncmp($destination,$this->current_path,strlen($this->current_path))!=0)
		{
			$this->error=$this->lang['folder_follows_out'];
			return $this->current_path;
		}
		if(strncmp($destination,$this->Mainclass->root_path.Mainclass::UPLOADS_DIR,strlen($this->Mainclass->root_path.Mainclass::UPLOADS_DIR))!=0)
		{
			$this->error=$this->lang['folder_follows_out2'];
			return $start_folder;
		}
		return $destination;
	}

	protected function CanUploadType($type)
	{
		if(!$this->allowed_types)
			return true;
		$type=mb_strtolower($type,ELEANOR_CHARSET);
		return in_array($type,$this->allowed_types);
	}
}
?>