<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum.Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/

if(!defined('INSTALL'))
	die('Попытка взлома?');

function OutPut()
{global $Mainclass;
	$Mainclass->SendHeaders();
}

class Install
{
	/*
		Функция проверки возможности установить Eleanor CMS. Проверяется:
			-Прав записи в папки
				/uploads
				/addons/logs
				/cache
		Возвращает либо TRUE, либо массив с ошибками.
	*/
	static function CheckAbilityInstall($check_wr_conf=true)
	{global $Mainclass;
		$result=array();
		if (!defined('UPDATE') and file_exists($Mainclass->root_path.'install/install.lock'))
			$result[]=$Mainclass->lang['install']['install.lock'];
		else
		{
			if(version_compare(PHP_VERSION,'5.1.6','<'))
				$result[]=sprintf($Mainclass->lang['install']['low_php'],PHP_VERSION);
			if(!function_exists('imagefttext'))
				$result[]=$Mainclass->lang['install']['err_gd'];
			if(!function_exists('mb_detect_encoding'))
				$result[]=$Mainclass->lang['install']['err_mb'];
			if(!function_exists('mysql_connect') and !function_exists('mysqli_connect') and !function_exists('pg_connect'))
				$result[]=$Mainclass->lang['install']['no_db_driver'];
			$w1=!is_writeable($Mainclass->root_path.'uploads');
			$w2=!is_writeable($Mainclass->root_path.'addons/logs');
			$w3=!is_writeable($Mainclass->root_path.'cache');
			$w4=(!is_writeable($Mainclass->root_path.'install') and !defined('UPDATE'));
			$w5=(!is_writeable($Mainclass->root_path.'config_general.bak') and $check_wr_conf);
			if($w1 or $w2 or $w3 or $w4 or $w5)
			{
				$s=$Mainclass->lang['install']['must_writeable'].'<br />
				<span style="color:'.($w1 ? 'red' : 'green').'">'.$Mainclass->lang['install']['must_writeable_uploads'].'</span><br />
				<span style="color:'.($w2 ? 'red' : 'green').'">'.$Mainclass->lang['install']['must_writeable_logs'].'</span><br />
				<span style="color:'.($w3 ? 'red' : 'green').'">'.$Mainclass->lang['install']['must_writeable_cache'].'</span><br />
				<span style="color:'.($w4 ? 'red' : 'green').'">'.$Mainclass->lang['install']['must_writeable_install'].'</span><br />
				<span style="color:'.($w5 ? 'red' : 'green').'">'.$Mainclass->lang['install']['must_writeable_config'].'</span>';
				$result[]=$s;
			}
		}
		return empty($result) ? true : $result;
	}

	/*
		Функция проверяет версию MySQLa. (не ниже 5.0.18)
	*/
	static function CheckMySQLVersion()
	{global $Mainclass;
		return version_compare($Mainclass->Db->Version(),'5.0.18','>=');
	}

	/*
		Функция проверяет, существует ли возможность записи в файл config_general.php
	*/
	static function IsWriteableConfig()
	{global $Mainclass;
		return is_writeable($Mainclass->FormatPath('config_general.bak'));
	}

	static function InitDb($data)
	{global $Mainclass;
		$Mainclass->LoadClass('classes/class_db.php');
		$Mainclass->Db->Connect($data);
	}

	static function IncludeDb($fix=false)
	{global $Mainclass;
		@include($Mainclass->root_path.'config_general.php');
		foreach($general as $akey=>$value)
			if(!isset($Mainclass->$akey))
			{
				$akey=strtolower($akey);
				$Mainclass->$akey=$value;
			}
		$Mainclass->LoadClass('classes/class_db.php');
		$Mainclass->Db->Connect();
		if (!$fix)
			return;
	}
}

interface UpdateClass
{
	public function DoUpdate($step='');
}
/*
class Update_1 extends BaseClass implements UpdateClass
{
	public function DoUpdate($step='')
	{
		#Тут - события.
		return array(
						'text'=>'Текст, что к чему',
						'errors'=>array('Массив ошибок. Пуст - значит все в норме'),
						'url'=>'Следующий шаг. УРЛ после substep=...',
						'done'=>true,// true или false (шаг отработан или нет)
						'rtime'=>5,//Время редиректа в секундах. По-умолчанию 5.
		);
	}
}
*/
?>