<?php
$queries[]="CREATE TABLE IF NOT EXISTS `{$prefix}blogs` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(50) NOT NULL,
`crdate` datetime NOT NULL,
`author` varchar(30) NOT NULL,
`author_id` int(11) unsigned NOT NULL,
`title` varchar(100) NOT NULL,
`descr` varchar(300) NOT NULL,
`logo` varchar(100) NOT NULL,
`per_page` int(11) unsigned NOT NULL,
`last_cid` int(11) unsigned NOT NULL,
`last_id` int(11) unsigned NOT NULL,
`last_url` varchar(100) NOT NULL,
`last_title` varchar(100) NOT NULL,
`last_date` datetime NOT NULL,
`last_author` varchar(100) NOT NULL,
`last_author_id` int(11) unsigned NOT NULL,
`type` enum('personal','public') NOT NULL,
`categs` tinyint(1) NOT NULL,
`status` tinyint(1) NOT NULL,
`posts` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `url` (`url`),
KEY `author_id` (`author_id`),
KEY `last_date` (`last_date`),
KEY `crdate` (`crdate`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE IF NOT EXISTS `{$prefix}blogs_bt` (
`pid` int(11) unsigned NOT NULL,
`tid` int(11) unsigned NOT NULL,
KEY `pid` (`pid`),
KEY `tid` (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE IF NOT EXISTS `{$prefix}blogs_categories` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(50) NOT NULL,
`title` varchar(100) NOT NULL,
`descr` varchar(300) NOT NULL,
`bid` int(11) unsigned NOT NULL,
`posts` int(11) unsigned NOT NULL,
`logo` varchar(100) NOT NULL,
`pos` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `bid` (`bid`),
KEY `pos` (`pos`),
KEY `url` (`url`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE IF NOT EXISTS `{$prefix}blogs_posts` (
`id` int(11) unsigned NOT NULL auto_increment,
`bid` int(11) unsigned NOT NULL,
`cid` int(11) unsigned NOT NULL,
`cats` varchar(50) NOT NULL,
`date` datetime NOT NULL,
`url` varchar(100) NOT NULL,
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
`author` varchar(30) NOT NULL,
`author_id` int(11) unsigned NOT NULL,
`comments` tinyint(1) NOT NULL,
`reads` int(11) unsigned NOT NULL,
`allow_comm` tinyint(1) NOT NULL,
`show_sokr` tinyint(1) NOT NULL,
`total` int(11) unsigned NOT NULL,
`votes` int(11) unsigned NOT NULL,
`editdate` datetime NOT NULL,
`tags` varchar(50) NOT NULL,
`status` tinyint(1) NOT NULL,
PRIMARY KEY  (`id`),
KEY `cid` (`cid`),
KEY `cats` (`cats`),
KEY `url` (`url`),
KEY `bid` (`bid`),
KEY `status` (`status`),
KEY `date` (`date`),
KEY `author_id` (`author_id`),
FULLTEXT KEY `text` (`text`),
FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE IF NOT EXISTS `{$prefix}blogs_tags` (
`id` int(11) unsigned NOT NULL auto_increment,
`bid` int(11) unsigned default NULL,
`name` varchar(30) NOT NULL,
PRIMARY KEY  (`id`),
KEY `bid` (`bid`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE `{$prefix}own_bbcodes` (
`id` int(11) unsigned NOT NULL auto_increment,
`pos` int(11) unsigned NOT NULL,
`active` tinyint(1) NOT NULL,
`tag` varchar(50) NOT NULL,
`aliases` varchar(250) NOT NULL,
`single` tinyint(1) unsigned NOT NULL,
`no_parse` tinyint(1) unsigned NOT NULL,
`special` tinyint(1) unsigned NOT NULL,
`file` varchar(100) NOT NULL,
`sp_tags` varchar(250) NOT NULL,
`gr_use` varchar(250) NOT NULL,
`gr_see` varchar(250) NOT NULL,
`options` varchar(250) NOT NULL,
`sb` BOOL NOT NULL,
PRIMARY KEY  (`id`),
KEY `pos` (`pos`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;
$queries[]="INSERT INTO `{$prefix}own_bbcodes` VALUES
(1, 0, 1, 'url', 'href,link', 0, 0, 0, '', '', '', '', '', 0),
(2, 1, 1, 'nobb', '', 0, 1, 0, '', '', '', '', '', 0),
(3, 2, 1, 'code', '', 0, 1, 0, '', 'csel', '', '', '', 1),
(4, 4, 1, 'hide', '', 0, 0, 0, '', '', '', '1,4,2', '', 1),
(5, 5, 1, 'quote', '', 0, 0, 0, '', '', '', '', '', 1),
(6, 6, 1, 'script', '', 0, 1, 0, '', '', '1', '', '', 1),
(7, 7, 1, 'php', '', 0, 1, 0, '', '', '1', '', '', 1),
(8, 8, 1, 'dohtml', '', 0, 1, 0, '', '', '1', '', '', 1),
(9, 9, 1, 'attach', '', 1, 1, 0, '', '', '', '', '', 0),
(10, 3, 1, 'csel', '', 0, 0, 1, '', '', '', '', '', 1),
(11, 10, 1, 'video', '', 0, 0, 0, '', '', '', '', '', 1)";

$queries[]="CREATE TABLE `{$prefix}config_l` (
`id` INT( 11 ) UNSIGNED NOT NULL ,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` VARCHAR( 200 ) NOT NULL ,
`descr` TEXT NOT NULL ,
`value` text NOT NULL,
`default` text NOT NULL,
`eval` text NOT NULL,
`extra` text NOT NULL,
`start_group` varchar(100) NOT NULL,
KEY `id` (`id`),
KEY `language` (`language`),
FULLTEXT KEY `title` (`title`),
FULLTEXT KEY `descr` (`descr`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE `{$prefix}config_groups_l` (
`id` INT( 11 ) UNSIGNED NOT NULL ,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` VARCHAR( 200 ) NOT NULL ,
`descr` TEXT NOT NULL ,
KEY `id` (`id`),
KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="ALTER TABLE `{$prefix}voting` DROP `one_lang`";
$queries[]="UPDATE `{$prefix}voting` SET `answers`=REPlACE(`answers`,'§','·')";
$queries[]="UPDATE `{$prefix}voting_l` SET `variants`=REPlACE(`variants`,'§','·')";

$queries[]="CREATE TABLE `{$prefix}voting` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(100) NULL,
`cid` int(11) unsigned NOT NULL,
`answers` text NOT NULL,
`date` date NOT NULL,
`date_f` date NULL,
`type` tinyint(1) unsigned NOT NULL,
`numans` int(11) unsigned NOT NULL,
`cnt` int(11) unsigned NOT NULL,
`status` tinyint(1) NOT NULL,
`comments` int(11) unsigned NOT NULL,
`allow_comm` tinyint(1) unsigned default '1',
`who` text NOT NULL,
`only_users` tinyint(1) unsigned NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `cid` (`cid`),
KEY `date` (`date`),
KEY `date_f` (`date_f`),
KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE `{$prefix}voting_categories` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) unsigned NOT NULL,
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE `{$prefix}voting_categories_l` (
`id` int(11) unsigned NOT NULL,
`language` varchar(15) NOT NULL,
`title` varchar(50) NOT NULL,
`description` text,
KEY `id` (`id`),
KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="CREATE TABLE `{$prefix}voting_l` (
`id` int(11) unsigned NOT NULL,
`language` varchar(15) NOT NULL,
`title` varchar(150) NOT NULL,
`text` text NOT NULL,
`variants` text NOT NULL,
KEY `id` (`id`),
KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="ALTER TABLE `{$prefix}users` CHANGE `ban_date` `ban_date` DATE NULL DEFAULT NULL, ADD `editor` TINYINT(1) NOT NULL DEFAULT '-1'";
$queries[]="DELETE FROM `{$prefix}modules` WHERE `name` IN ('users','blocks','groups','services','modules','sitemap','smiles','database','themes_editor')";
$queries[]="UPDATE `{$prefix}modules` SET `protected`=1 WHERE `name` IN ('errors','page')";
$queries[]="ALTER TABLE `{$prefix}menu` DROP `one_lang`, ADD `l` INT( 11 ) NOT NULL, ADD `r` INT( 11 ) NOT NULL";
$queries[]="ALTER TABLE `{$prefix}addon_fields` DROP `one_lang`";
$queries[]="ALTER TABLE `{$prefix}bookmarkspre` DROP `one_lang`";
$queries[]="ALTER TABLE `{$prefix}errors` DROP `one_lang`, CHANGE `url` `url` VARCHAR(100) NULL";
$queries[]="ALTER TABLE `{$prefix}static` DROP `one_lang`, CHANGE `url` `url` VARCHAR(100) NULL, ADD `r` INT(11) NOT NULL,ADD `l` INT(11) NOT NULL ,ADD `parent` INT(11) UNSIGNED NOT NULL,ADD `pos` INT(11) UNSIGNED NOT NULL,ADD `status` tinyint(1) NOT NULL, ADD INDEX (`l`), ADD INDEX (`pos`)";
$queries[]="ALTER TABLE `{$prefix}faq` DROP `one_lang`, CHANGE `url` `url` VARCHAR(100) NULL";
$queries[]="ALTER TABLE `{$prefix}files` DROP `one_lang`, CHANGE `date` `date` DATETIME NOT NULL, CHANGE `url` `url` VARCHAR(100) NULL";
$queries[]="ALTER TABLE `{$prefix}news` ADD `tags` VARCHAR(100) NOT NULL, DROP `one_lang`, ADD UNIQUE (`url`),CHANGE `date` `date` DATETIME NOT NULL, CHANGE `url` `url` VARCHAR( 100 ) NULL";
$queries[]="ALTER TABLE `{$prefix}faq_categories` ADD INDEX(`l`), DROP `one_lang`, ADD `pos` INT(11) UNSIGNED NOT NULL,ADD INDEX(`pos`)";
$queries[]="ALTER TABLE `{$prefix}news_categories` ADD INDEX(`l`), DROP `one_lang`, ADD `pos` INT(11) UNSIGNED NOT NULL,ADD INDEX(`pos`)";
$queries[]="ALTER TABLE `{$prefix}news_tags` ADD INDEX (`name`)";
$queries[]="ALTER TABLE `{$prefix}files_categories` ADD INDEX(`l`), DROP `one_lang`, ADD `pos` INT(11) UNSIGNED NOT NULL,ADD INDEX(`pos`)";
$queries[]="ALTER TABLE `{$prefix}groups` DROP `insert_html`";
$queries[]="ALTER TABLE `{$prefix}news_nt` ADD INDEX (`tag`)";
$queries[]="ALTER TABLE `{$prefix}services` DROP `url`";
$queries[]="ALTER TABLE `{$prefix}sessions` ADD `addon` VARCHAR( 100 ) NOT NULL";
$queries[]="ALTER TABLE `{$prefix}faq_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}addon_fields_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}blocks` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}bookmarkspre_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}errors_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}faq_categories_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}faq_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}menu_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}news_categories_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}news_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}static_l` CHANGE `language` `language` VARCHAR(15) NOT NULL DEFAULT ''";
$queries[]="ALTER TABLE `{$prefix}config` ADD `multilang` TINYINT( 1 ) UNSIGNED NOT NULL";
$queries[]="INSERT INTO `{$prefix}config_l` (`id`,`title`,`descr`,`value`,`default`,`eval`,`extra`,`start_group`) SELECT `id` ,`title`,`descr`,`value`,`default`,`eval`,`extra`,`start_group` FROM `{$prefix}config`";
$queries[]="INSERT INTO `{$prefix}config_groups_l` (`id`,`title`,`descr`) SELECT `id`,`title`,`descr` FROM `{$prefix}config_groups`";
$queries[]="ALTER TABLE `{$prefix}config` DROP `title`, DROP `descr`, DROP `value`, DROP `default`, DROP `eval`, DROP `extra`, DROP `start_group`";
$queries[]="ALTER TABLE `{$prefix}config_groups` DROP `title`, DROP `descr`";

$queries[]="UPDATE `{$prefix}news` SET `tags`='0'";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=CONCAT(`sokr_text`,'[separator]',`text`)";
$queries[]="ALTER TABLE `{$prefix}news_l` DROP `sokr_text`";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=CONCAT(`sokr_text`,'[separator]',`text`)";
$queries[]="ALTER TABLE `{$prefix}files_l` DROP `sokr_text`";

$queries[]="ALTER TABLE `{$prefix}modules` CHANGE `class_file` `is_class` tinyint(1) NOT NULL";
$queries[]="ALTER TABLE `{$prefix}addon_fields` ADD `unique` VARCHAR( 10 ) NOT NULL AFTER `mid`, ADD INDEX(`unique`)";
$queries[]="ALTER TABLE `{$prefix}comments` ADD `email` VARCHAR( 50 ) NOT NULL, ADD `status` TINYINT NOT NULL, ADD INDEX(`status`), ADD `who_m_spam` VARCHAR( 50 ) NOT NULL";
$queries[]="UPDATE `{$prefix}comments` SET `status`=1";
$queries[]="UPDATE `{$prefix}static` SET `status`=1";
$Mainclass->Db->Query('SELECT `id` FROM `prefix_modules` WHERE `name`=\'files\' LIMIT 1',__file__,__line__);
$ins_f=$Mainclass->Db->Num_rows()==0;
$Mainclass->Db->Query('SELECT `id` FROM `prefix_modules` WHERE `name`=\'voting\' LIMIT 1',__file__,__line__);
$ins_v=$Mainclass->Db->Num_rows()==0;
$Mainclass->Db->Query('SELECT `id` FROM `prefix_modules` WHERE `name`=\'blogs\' LIMIT 1',__file__,__line__);
$ins_b=$Mainclass->Db->Num_rows()==0;
if($Mainclass->lang_name=='russian')
{
	if($ins_f)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'files', 'Файлы', 'Управление файловым архивом проекта', 0, 'modules/files', 1, 'index.php', '', '', 'files-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
	if($ins_v)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'voting', 'Опросы', 'Управление опросами проекта', 0, 'modules/voting', 1, 'index.php', '', '', 'voting-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
	if($ins_b)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'blogs', 'بلاگ ها', 'Управление блогами на проекте', 0, 'modules/blogs', 1, 'index.php', '', '', 'blogs-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
}
else
{
	if($ins_f)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'files', 'Files', 'Management files your site', 0, 'modules/files', 1, 'index.php', '', '', 'news-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
	if($ins_v)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'voting', 'Voting', 'Management of voting', 0, 'modules/voting', 1, 'index.php', '', '', 'voting-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
	if($ins_b)
		$queries[]="INSERT INTO `{$prefix}modules` (`id`, `services`, `name`, `title`, `descr`, `protected`, `path`, `multiservice`, `file`, `is_class`, `resources`, `image`, `active`, `user_groups`, `blocks`, `pos_load`, `pos_unload`, `editor`, `plugins`) VALUES (NULL, ',1,3,6,2,', 'blogs', 'Blogs', 'Management blogs on project', 0, 'modules/blogs', 1, 'index.php', '', '', 'blogs-%.png', 1, '', '', 0, 0, -1, 'plugins.php')";
}
if($ins_v)
{
	$queries[]="INSERT INTO `{$prefix}voting` VALUES (NULL, 'test', 1, '0·0·0·0·0', '2009-11-18', NULL, 0, 1, 0, 1, 0, 1, ',1,', 0)";
	$queries[]="INSERT INTO `{$prefix}voting_categories` VALUES (1, 'test', 'images/categories/bomb.png', 0, 0, 1, '', 0)";
	if($Mainclass->lang_name=='russian')
	{
		$queries[]="INSERT INTO `{$prefix}voting_categories_l` VALUES (1, 'russian', 'Тестовая категория', '')";
		$queries[]="INSERT INTO `{$prefix}voting_l` VALUES (1, 'russian', 'Тестовый опрос', '', 'вариант 1·вариант 2·вариант 3·вариант 4·вариант 5')";
	}
	else
	{
		$queries[]="INSERT INTO `{$prefix}voting_categories_l` VALUES (1, 'english', 'Test category', '')";
		$queries[]="INSERT INTO `{$prefix}voting_l` VALUES (1, 'english', 'Test voting', '', 'variant 1·variant 2·variant 3·variant 4·variant 5')";
	}
}
$queries[]="UPDATE `{$prefix}blocks` SET `vars`='menuid=1',`file`='addons/menus/multiline.php' WHERE `id`=9 AND `vars`='menuid=1·format=<li>{a}<b>{text}</b></a></li>'";
$queries[]="UPDATE `{$prefix}blocks` SET `unique`='menu' WHERE `service`=1 AND `unique`='navigation'";
$queries[]="INSERT INTO `{$prefix}blocks` (`service`,`cont_type`,`title`,`file`,`type`,`active`,`free`) VALUES (1,'file','Меню','addons/adminka/blocks/block_menu.php','left',1,1)";

$queries[]="
CREATE TABLE IF NOT EXISTS `{$prefix}files` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`main_cat` int(11) UNSIGNED NOT NULL,
`cats` varchar(100) NOT NULL,
`author` varchar(25) NOT NULL,
`author_id` int(11) UNSIGNED NOT NULL,
`groups` varchar(100) NOT NULL,
`icons` text NOT NULL,
`show_sokr` tinyint(1) UNSIGNED NOT NULL,
`date` DATETIME NOT NULL,
`files` text NOT NULL,
`images` text NOT NULL,
`size` varchar(20) NOT NULL,
`version` varchar(20) NOT NULL,
`license` varchar(50) NOT NULL,
`total` int(11) UNSIGNED NOT NULL,
`votes` int(11) UNSIGNED NOT NULL,
`status` tinyint(1) NOT NULL,
`comments` int(11) UNSIGNED NOT NULL,
`allow_comm` tinyint(1) UNSIGNED default '1',
`s_descr` varchar(250) NOT NULL,
`s_title` varchar(100) NOT NULL,
`pinned` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `main_cat` (`main_cat`),
KEY `cats` (`cats`),
KEY `date` (`date`),
KEY `pinned` (`pinned`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="
CREATE TABLE IF NOT EXISTS `{$prefix}files_categories` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) UNSIGNED NOT NULL,
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="
CREATE TABLE IF NOT EXISTS `{$prefix}files_categories_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(50) NOT NULL,
`description` text,
KEY `id` (`id`),
KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="
CREATE TABLE IF NOT EXISTS `{$prefix}files_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`),
KEY `language` (`language`),
FULLTEXT KEY `title` (`title`),
FULLTEXT KEY `text` (`text`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$queries[]="
CREATE TABLE IF NOT EXISTS `{$prefix}qmenu` (
`id` int(11) unsigned NOT NULL auto_increment,
`aid` int(11) unsigned NOT NULL,
`pos` int(10) unsigned NOT NULL,
`mid` int(11) unsigned NOT NULL,
`title` varchar(50) NOT NULL,
`icon` varchar(50) NOT NULL,
`href` varchar(100) NOT NULL,
`eval_url` varchar(250) NOT NULL,
`link_id` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `aid` (`aid`,`pos`),
KEY `pos` (`pos`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

#Замена старых ББ кодов на новые.
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- HTML -->','[dohtml]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- /HTML -->','[/dohtml]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- NOBB -->','[nobb]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- /NOBB -->','[/nobb]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- CODE -->','[code]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- /CODE -->','[/code]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- QUOTE -->','[quote]')";
$queries[]="UPDATE `{$prefix}news_l` SET `text`=REPLACE(`text`,'<!-- /QUOTE -->','[/quote]')";

$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- HTML -->','[dohtml]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- /HTML -->','[/dohtml]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- NOBB -->','[nobb]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- /NOBB -->','[/nobb]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- CODE -->','[code]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- /CODE -->','[/code]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- QUOTE -->','[quote]')";
$queries[]="UPDATE `{$prefix}files_l` SET `text`=REPLACE(`text`,'<!-- /QUOTE -->','[/quote]')";

$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- HTML -->','[dohtml]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- /HTML -->','[/dohtml]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- NOBB -->','[nobb]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- /NOBB -->','[/nobb]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- CODE -->','[code]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- /CODE -->','[/code]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- QUOTE -->','[quote]')";
$queries[]="UPDATE `{$prefix}static_l` SET `text`=REPLACE(`text`,'<!-- /QUOTE -->','[/quote]')";

$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- HTML -->','[dohtml]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- /HTML -->','[/dohtml]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- NOBB -->','[nobb]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- /NOBB -->','[/nobb]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- CODE -->','[code]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- /CODE -->','[/code]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- QUOTE -->','[quote]')";
$queries[]="UPDATE `{$prefix}blocks` SET `content`=REPLACE(`content`,'<!-- /QUOTE -->','[/quote]')";
?>