<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum.Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
class Update_4 extends BaseClass implements UpdateClass
{
	public function DoUpdate($step=0)
	{
		$done=false;
		$text='';
		$this->Mainclass->LoadClass('classes/class_url.php');
		switch($step)
		{
			case 0:
				$this->DoSettings();
				$text='Настройки... / Settings...';
			break;
			case 1:
				$this->RenameNews();
				$text='Переименование uploads новостей... / Renaming news uploads...';
			break;
			case 2:
				$this->RenameFiles();
				$text='Переименование uploads файлов... / Renaming files uploads...';
			break;
			case 3:
				$this->RenameStatic();
				$text='Переименование uploads статических страниц... / Renaming static uploads...';
			break;
			case 4:
			default:
				$this->DoMenuAndBlocks();
				$text=sprintf($this->Mainclass->lang['install']['update_to_complete'],'RC5');
				$done=true;
			break;
		}

		return array(
						'text'=>$text,
						'errors'=>array(),
						'url'=>++$step,
						'done'=>$done,
		);
	}

	private function RenameNews()
	{
		$result=$this->Mainclass->Db->Query('SELECT `id`,`url` FROM `prefix_news`',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
			if(is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'news'.DIRECTORY_SEPARATOR.$arr['url']))
			{
				rename($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'news'.DIRECTORY_SEPARATOR.$arr['url'],$this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'news'.DIRECTORY_SEPARATOR.$arr['id']);
				$this->Mainclass->Db->Update('news_l',array('!text'=>'REPLACE(`text`,\''.$this->Mainclass->Db->EscapeString(Mainclass::UPLOADS_DIR.'/news/'.$this->Mainclass->Url->EncodeParam($arr['url'])).'\',\''.Mainclass::UPLOADS_DIR.'/news/'.$arr['id'].'\')'),'`id`='.$arr['id'],__file__,__line__);
			}
	}

	private function RenameFiles()
	{
		if(!is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'files'))
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'files');
		if(!is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'temp_files'))
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'temp_files');
		$result=$this->Mainclass->Db->Query('SELECT `id`,`url` FROM `prefix_files`',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
			if(is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'files'.DIRECTORY_SEPARATOR.$arr['url']))
			{
				rename($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'files'.DIRECTORY_SEPARATOR.$arr['url'],$this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'files'.DIRECTORY_SEPARATOR.$arr['id']);
				$this->Mainclass->Db->Update('files_l',array('!text'=>'REPLACE(`text`,\''.$this->Mainclass->Db->EscapeString(Mainclass::UPLOADS_DIR.'/files/'.$this->Mainclass->Url->EncodeParam($arr['url'])).'\',\''.Mainclass::UPLOADS_DIR.'/files/'.$arr['id'].'\')'),'`id`='.$arr['id'],__file__,__line__);
			}
	}

	private function RenameStatic()
	{
		if(!is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'static'))
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'static');
		$result=$this->Mainclass->Db->Query('SELECT `id`,`url` FROM `prefix_static`',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
			if(is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'static'.DIRECTORY_SEPARATOR.$arr['url']))
			{
				rename($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'static'.DIRECTORY_SEPARATOR.$arr['url'],$this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'static'.DIRECTORY_SEPARATOR.$arr['id']);
				$this->Mainclass->Db->Update('static_l',array('!text'=>'REPLACE(`text`,\''.$this->Mainclass->Db->EscapeString(Mainclass::UPLOADS_DIR.'/static/'.$this->Mainclass->Url->EncodeParam($arr['url'])).'\',\''.Mainclass::UPLOADS_DIR.'/static/'.$arr['id'].'\')'),'`id`='.$arr['id'],__file__,__line__);
			}
	}

	private function DoMenuAndBlocks()
	{
		#Меню
		$tosort=$tree=$tree_=$dump=array();
		$this->Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_menu` ORDER BY `pos` DESC',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc())
			if($arr['parent']==0)
			{
				$tree_[$arr['id']]=array('id'=>$arr['id'],'parent'=>0,'nest'=>0);
				$tosort[$arr['id']]=$arr['pos'];
			}
			else
				$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
		asort($tosort,SORT_NUMERIC);
		$tosort=array_keys($tosort);
		foreach($tosort as &$v)
			$tree[]=$tree_[$v];
		unset($tree_);
		$len=0;
		while(count($dump)!=$len)
		{
			$len=count($dump);
			foreach($dump as $k=>&$v)
				if(false!==$id=array_search($v['parent'],$tosort))
				{
					array_splice($tree,$id+1,0,array(array('id'=>(int)$v['id'],'parent'=>(int)$v['parent'],'nest'=>$tree[$id]['nest']+1)));
					array_splice($tosort,$id+1,0,array($v['id']));
					unset($dump[$k]);
				}
		}
		unset($tosort);
		$onest=-1;
		$ids=array();
		$n=1;
		foreach($tree as $k=>&$v)
		{
			if($v['nest']>$onest)
				$tree[$k]['l']=$n;
			else
			{
				$id=array_pop($ids);
				$tree[$id]['r']=$n;
				$q=$tree[$id]['nest']-$v['nest'];
				for(;$q>0;--$q)
					if(null!==$id=array_pop($ids))
						$tree[$id]['r']=++$n;
				$tree[$k]['l']=++$n;
			}
			$ids[]=$k;
			$onest=$v['nest'];
			++$n;
		}
		while(null!==$id=array_pop($ids))
			$tree[$id]['r']=$n++;
		foreach($tree as &$v)
			$this->Mainclass->Db->Update('menu',array('r'=>$v['r'],'l'=>$v['l']),'`id`='.(int)$v['id'].' LIMIT 1',__file__,__line__);
		#Блоки
		$result=$this->Mainclass->Db->Query('SELECT `id`,`blocks` FROM `prefix_modules` WHERE `blocks`!=\'\'',__file__,__line__);
		while($arr=$this->Mainclass->Db->Fetch_assoc($result))
		{
			$arr['blocks']=@unserialize($arr['blocks']);
			if(!$arr['blocks'] or !is_array($arr['blocks']))
				$arr['blocks']='';
			else
				$arr['blocks']=join(',',$arr['blocks']);
			$this->Mainclass->Db->Update('modules',array('blocks'=>$arr['blocks']),'`id`='.$arr['id'].' LIMIT 1',__file__,__line__);
		}
		#Еще одно действие...
		$this->Mainclass->Db->Update('news_categories',array('!image'=>'SUBSTRING_INDEX(`image`,\'/\',-1)'),'',__file__,__line__);
		$this->Mainclass->Db->Update('files_categories',array('!image'=>'SUBSTRING_INDEX(`image`,\'/\',-1)'),'',__file__,__line__);
		$this->Mainclass->Db->Update('faq_categories',array('!image'=>'SUBSTRING_INDEX(`image`,\'/\',-1)'),'',__file__,__line__);
		#И еще одно...
		if(!is_dir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs'))
		{
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs');
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs'.DIRECTORY_SEPARATOR.'blogs_logo');
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs'.DIRECTORY_SEPARATOR.'cats_logo');
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs'.DIRECTORY_SEPARATOR.'posts');
			mkdir($this->Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'blogs'.DIRECTORY_SEPARATOR.'temp_posts');
		}
	}

	private function DoSettings()
	{
		$s='<delete>
<option>editor_bb_anti_direct_link</option>
<option>login_antibrute_history_cnt</option>
<option>mail_php_extra</option>
<option>errors_types</option>
<option>exceptions_enabled</option>
<option>errors_log_enabled</option>
<option>db_errors_enabled</option>
</delete>
<ogroup>
	<title>Редактор</title>
	<name>editor</name>
	<descr>Настройки редактора</descr>
	<protected>1</protected>
	<keyword>editor</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title>Настройки модуля "Новости"</title>
	<descr></descr>
	<name>module_news</name>
	<protected>0</protected>
	<keyword>module_news</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title>Модуль "Опросы"</title>
	<name>module_voting</name>
	<descr></descr>
	<protected>0</protected>
	<keyword>module_voting</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title>Модуль "Файлы"</title>
	<descr></descr>
	<name>module_files</name>
	<protected>0</protected>
	<keyword>module_files</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title language="russian">Комментарии</title>
	<descr language="russian"></descr>
	<title language="english">Comments</title>
	<descr language="english"></descr>
	<title language="ukrainian">Коментарі</title>
	<descr language="ukrainian"></descr>
	<name>comments</name>
	<protected>1</protected>
	<keyword>comments</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>Разрешить помечать как спам?</title>
	<descr></descr>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>comments_spam</name>
	<group>comments</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Включить защиту от прямых ссылок?</title>
	<name>anti_directlink</name>
	<descr>
		z/DoIOLq6/735e3o6CD98u7pIO7v9ujoLCDi8eUg4u3l+O3o5SDx8fvr6ugg4fPk8/I=
	</descr>
	<group>editor</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Включить автопарсинг URL?</title>
	<name>autoparse_urls</name>
	<descr>
		z/DoIOLq6/735e3o6CD98u7pIO7v9ujoLCDi8eUg8fH76+roIO7v8+Hr6Oru4uDt7fvlIOrg6iDy
		5erx8iAtIOHz5PPyIO7h8ODh7vLg7fsg6uDqIPHx++vq6C4=
	</descr>
	<group>editor</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Разделитель параметров</title>
	<name>url_static_delimeter</name>
	<descr>
		xOv/IOLi7uTgIOTu7/Px6uD+8vH/IOv+4fvlIM3F4fPq4uXt7fvlIPHo7OLu6/su
	</descr>
	<group>general options</group>
	<type>edit</type>
	<value>
		Lw==
	</value>
	<default>
		Lw==
	</default>
	<eval>
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvWycuU3RyaW5nczo6QUxMLiddL2knLCR2YWx1ZSk+
		MCkNCiRlcnJvcj0nxOv/IOLi7uTgIOTu7/Px6uD+8vH/INLOy9zKziDNxeHz6uLl7e375SDx6Ozi
		7uv7ISc7
	</eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Включить ЧПУ?</title>
	<name>furl</name>
	<descr></descr>
	<group>general options</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group>Статические URL</start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Транслитерировать URL-ы?</title>
	<name>trans_url</name>
	<descr>
		z/DoIOLq6/735e3o6CD98u7pIO7v9ujoLCBVUkwt+yDt7uLu8fLl6Swg9ODp6+7iIOgg5PDz4+j1
		IOzu5PPr5ekg4fPk8/Ig4OLy7uzg8uj35fHq6CDy8ODt8evo8uXw6PDu4uDy/PH/Lg==
	</descr>
	<group>general options</group>
	<type>check</type>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Файлов на страницу</title>
	<descr language="russian"></descr>
	<value language="russian">
		MTA=
	</value>
	<default language="russian">
		MTA=
	</default>
	<eval language="russian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian">Основные</start_group>
	<title language="english">Файлов на страницу</title>
	<descr language="english"></descr>
	<value language="english">
		MTA=
	</value>
	<default language="english">
		MTA=
	</default>
	<eval language="english">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="english"></extra>
	<start_group language="english">Основные</start_group>
	<title language="ukrainian">Файлов на страницу</title>
	<descr language="ukrainian"></descr>
	<value language="ukrainian">
		MTA=
	</value>
	<default language="ukrainian">
		MTA=
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian">Основные</start_group>
	<name>m_files_per_page</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Файлов на главной странице</title>
	<descr language="russian">
		3fLgIO7v9uj/IOHz5OXyIOTl6fHy4u7i4PL8LCDl8evoIOzu5PPr/CAi9ODp6/siIOHz5OXyIO7y
		7uHw4Obg8vzx/yDt4CDj6+Di7e7pIPHy8ODt6PblIPHg6fLgLg==
	</descr>
	<value language="russian">
		NQ==
	</value>
	<default language="russian">
		NQ==
	</default>
	<eval language="russian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Файлов на главной странице</title>
	<descr language="english">
		3fLgIO7v9uj/IOHz5OXyIOTl6fHy4u7i4PL8LCDl8evoIOzu5PPr/CAi9ODp6/siIOHz5OXyIO7y
		7uHw4Obg8vzx/yDt4CDj6+Di7e7pIPHy8ODt6PblIPHg6fLgLg==
	</descr>
	<value language="english">
		NQ==
	</value>
	<default language="english">
		NQ==
	</default>
	<eval language="english">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Файлов на главной странице</title>
	<descr language="ukrainian">
		3fLgIO7v9uj/IOHz5OXyIOTl6fHy4u7i4PL8LCDl8evoIOzu5PPr/CAi9ODp6/siIOHz5OXyIO7y
		7uHw4Obg8vzx/yDt4CDj6+Di7e7pIPHy8ODt6PblIPHg6fLgLg==
	</descr>
	<value language="ukrainian">
		NQ==
	</value>
	<default language="ukrainian">
		NQ==
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_per_page_general</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Файлов на страницу в RSS</title>
	<descr language="russian"></descr>
	<value language="russian">
		MzA=
	</value>
	<default language="russian">
		MzA=
	</default>
	<eval language="russian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Файлов на страницу в RSS</title>
	<descr language="english"></descr>
	<value language="english">
		MzA=
	</value>
	<default language="english">
		MzA=
	</default>
	<eval language="english">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Файлов на страницу в RSS</title>
	<descr language="ukrainian"></descr>
	<value language="ukrainian">
		MzA=
	</value>
	<default language="ukrainian">
		MzA=
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTw9MCkNCiRlcnJv
		cj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_rss_per_page</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Отключить кеширование на главной?</title>
	<descr language="russian">
		zvLq6/736PL8IOrl+Ojw7uLg7ejlIPTg6evu4iDt4CDj6+Di7e7pLg==
	</descr>
	<value language="russian"></value>
	<default language="russian"></default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Отключить кеширование на главной?</title>
	<descr language="english">
		zvLq6/736PL8IOrl+Ojw7uLg7ejlIPTg6evu4iDt4CDj6+Di7e7pLg==
	</descr>
	<value language="english"></value>
	<default language="english"></default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Отключить кеширование на главной?</title>
	<descr language="ukrainian">
		zvLq6/736PL8IOrl+Ojw7uLg7ejlIPTg6evu4iDt4CDj6+Di7e7pLg==
	</descr>
	<value language="ukrainian"></value>
	<default language="ukrainian"></default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_ncg</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Добавление файлов</title>
	<descr language="russian">
		xODy/CDi7ufs7ubt7vHy/CDv7vHl8ujy5ev/7CDx4Ony4CDk7uHg4uv/8vwg9ODp6/s/
	</descr>
	<value language="russian">
		MQ==
	</value>
	<default language="russian">
		MQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Добавление файлов</title>
	<descr language="english">
		xODy/CDi7ufs7ubt7vHy/CDv7vHl8ujy5ev/7CDx4Ony4CDk7uHg4uv/8vwg9ODp6/s/
	</descr>
	<value language="english">
		MQ==
	</value>
	<default language="english">
		MQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Добавление файлов</title>
	<descr language="ukrainian">
		xODy/CDi7ufs7ubt7vHy/CDv7vHl8ujy5ev/7CDx4Ony4CDk7uHg4uv/8vwg9ODp6/s/
	</descr>
	<value language="ukrainian">
		MQ==
	</value>
	<default language="ukrainian">
		MQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_add</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Включить загрузку файлов на сервер?</title>
	<descr language="russian">
		xfHr6CDk4O3t4P8g7u/26P8g4urr/vfl7eAsIPLuIO/w6CDk7uHg4uvl7ejoIPTg6evu4iCXIO/u
		6/zn7uLg8uXr6CDx7O7j8/Ig5+Dr6OLg8vwg9ODp6/sg8fDg5/Mg6iDC4Owg7eAg8eXw4uXwLg==
	</descr>
	<value language="russian">
		MQ==
	</value>
	<default language="russian">
		MQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Включить загрузку файлов на сервер?</title>
	<descr language="english">
		xfHr6CDk4O3t4P8g7u/26P8g4urr/vfl7eAsIPLuIO/w6CDk7uHg4uvl7ejoIPTg6evu4iCXIO/u
		6/zn7uLg8uXr6CDx7O7j8/Ig5+Dr6OLg8vwg9ODp6/sg8fDg5/Mg6iDC4Owg7eAg8eXw4uXwLg==
	</descr>
	<value language="english">
		MQ==
	</value>
	<default language="english">
		MQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Включить загрузку файлов на сервер?</title>
	<descr language="ukrainian">
		xfHr6CDk4O3t4P8g7u/26P8g4urr/vfl7eAsIPLuIO/w6CDk7uHg4uvl7ejoIPTg6evu4iCXIO/u
		6/zn7uLg8uXr6CDx7O7j8/Ig5+Dr6OLg8vwg9ODp6/sg8fDg5/Mg6iDC4Owg7eAg8eXw4uXwLg==
	</descr>
	<value language="ukrainian">
		MQ==
	</value>
	<default language="ukrainian">
		MQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_upload</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Включить дополнительные поля?</title>
	<descr language="russian"></descr>
	<value language="russian">
		MQ==
	</value>
	<default language="russian">
		MQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Включить дополнительные поля?</title>
	<descr language="english"></descr>
	<value language="english">
		MQ==
	</value>
	<default language="english">
		MQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Включить дополнительные поля?</title>
	<descr language="ukrainian"></descr>
	<value language="ukrainian">
		MQ==
	</value>
	<default language="ukrainian">
		MQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_af</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Временная пауза поиска</title>
	<descr language="russian">
		wvDl7P8g4iDx5erz7eTg9SDs5ebk8yDo8e/u6/zn7uLg7ejl7CDv7ujx6uAuIMLi5eTo8uUgMCDk
		6/8g7vLq6/735e3o/yDu7/bo6A==
	</descr>
	<value language="russian">
		MzA=
	</value>
	<default language="russian">
		MzA=
	</default>
	<eval language="russian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTwwKQ0KJGVycm9y
		PSfC4uXk5e3uIO3l5O7v8/Hy6Ozu5SDn7eD35e3o5SEnOw0KfQ==
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Временная пауза поиска</title>
	<descr language="english">
		wvDl7P8g4iDx5erz7eTg9SDs5ebk8yDo8e/u6/zn7uLg7ejl7CDv7ujx6uAuIMLi5eTo8uUgMCDk
		6/8g7vLq6/735e3o/yDu7/bo6A==
	</descr>
	<value language="english">
		MzA=
	</value>
	<default language="english">
		MzA=
	</default>
	<eval language="english">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTwwKQ0KJGVycm9y
		PSfC4uXk5e3uIO3l5O7v8/Hy6Ozu5SDn7eD35e3o5SEnOw0KfQ==
	</eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Временная пауза поиска</title>
	<descr language="ukrainian">
		wvDl7P8g4iDx5erz7eTg9SDs5ebk8yDo8e/u6/zn7uLg7ejl7CDv7ujx6uAuIMLi5eTo8uUgMCDk
		6/8g7vLq6/735e3o/yDu7/bo6A==
	</descr>
	<value language="ukrainian">
		MzA=
	</value>
	<default language="ukrainian">
		MzA=
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPShpbnQpJHZhbHVlOw0KaWYgKCR2YWx1ZTwwKQ0KJGVycm9y
		PSfC4uXk5e3uIO3l5O7v8/Hy6Ozu5SDn7eD35e3o5SEnOw0KfQ==
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_search</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Окончание ЧПУ для категории</title>
	<descr language="russian">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CE=
	</descr>
	<value language="russian">
		Lw==
	</value>
	<default language="russian">
		Lw==
	</default>
	<eval language="russian">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEgzcXh8+ri5e3t
		7uPuIPHo7OLu6+AhJzs=
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian">ЧПУ</start_group>
	<title language="english">Окончание ЧПУ для категории</title>
	<descr language="english">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CE=
	</descr>
	<value language="english">
		Lw==
	</value>
	<default language="english">
		Lw==
	</default>
	<eval language="english">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEgzcXh8+ri5e3t
		7uPuIPHo7OLu6+AhJzs=
	</eval>
	<extra language="english"></extra>
	<start_group language="english">ЧПУ</start_group>
	<title language="ukrainian">Окончание ЧПУ для категории</title>
	<descr language="ukrainian">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CE=
	</descr>
	<value language="ukrainian">
		Lw==
	</value>
	<default language="ukrainian">
		Lw==
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEgzcXh8+ri5e3t
		7uPuIPHo7OLu6+AhJzs=
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian">ЧПУ</start_group>
	<name>m_files_category_ending</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Окончание ЧПУ для файлов</title>
	<descr language="russian">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CDoIO3lIOzu5uXyIPHu4u/g5ODy/CDxIO7q7u334O3o5ewg6uDy5ePu
		8OjoLCDo7eD35SDh8+Tz8iDy7uvx8vvlIO746OHq6CE=
	</descr>
	<value language="russian">
		Lmh0bWw=
	</value>
	<default language="russian">
		Lmh0bWw=
	</default>
	<eval language="russian">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEg7eUg4fPq4uXt
		7e7j7iDx6Ozi7uvgISc7
	</eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Окончание ЧПУ для файлов</title>
	<descr language="english">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CDoIO3lIOzu5uXyIPHu4u/g5ODy/CDxIO7q7u334O3o5ewg6uDy5ePu
		8OjoLCDo7eD35SDh8+Tz8iDy7uvx8vvlIO746OHq6CE=
	</descr>
	<value language="english">
		Lmh0bWw=
	</value>
	<default language="english">
		Lmh0bWw=
	</default>
	<eval language="english">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEg7eUg4fPq4uXt
		7e7j7iDx6Ozi7uvgISc7
	</eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Окончание ЧПУ для файлов</title>
	<descr language="ukrainian">
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CDoIO3lIOzu5uXyIPHu4u/g5ODy/CDxIO7q7u334O3o5ewg6uDy5ePu
		8OjoLCDo7eD35SDh8+Tz8iDy7uvx8vvlIO746OHq6CE=
	</descr>
	<value language="ukrainian">
		Lmh0bWw=
	</value>
	<default language="ukrainian">
		Lmh0bWw=
	</default>
	<eval language="ukrainian">
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEg7eUg4fPq4uXt
		7e7j7iDx6Ozi7uvgISc7
	</eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_ending</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Длинный URL с учетом всех категорий</title>
	<descr language="russian"></descr>
	<value language="russian">
		MQ==
	</value>
	<default language="russian">
		MQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Длинный URL с учетом всех категорий</title>
	<descr language="english"></descr>
	<value language="english">
		MQ==
	</value>
	<default language="english">
		MQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Длинный URL с учетом всех категорий</title>
	<descr language="ukrainian"></descr>
	<value language="ukrainian">
		MQ==
	</value>
	<default language="ukrainian">
		MQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_long_url</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Включить рейтинг</title>
	<descr language="russian"></descr>
	<value language="russian">
		MQ==
	</value>
	<default language="russian">
		MQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian">Настройки рейтинга</start_group>
	<title language="english">Включить рейтинг</title>
	<descr language="english"></descr>
	<value language="english">
		MQ==
	</value>
	<default language="english">
		MQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english">Настройки рейтинга</start_group>
	<title language="ukrainian">Включить рейтинг</title>
	<descr language="ukrainian"></descr>
	<value language="ukrainian">
		MQ==
	</value>
	<default language="ukrainian">
		MQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian">Настройки рейтинга</start_group>
	<name>m_files_rating</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Период между голосованиями</title>
	<descr language="russian">
		z+Xw6O7kIOIg5O3/9Swg7+7x6+Ug6u7y7vDu4+4g7+7r/Ofu4uDy5ev8IPHs7ubl8iDx7e7i4CDu
		9uXt6PL8IPTg6es=
	</descr>
	<value language="russian">
		Mw==
	</value>
	<default language="russian">
		Mw==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Период между голосованиями</title>
	<descr language="english">
		z+Xw6O7kIOIg5O3/9Swg7+7x6+Ug6u7y7vDu4+4g7+7r/Ofu4uDy5ev8IPHs7ubl8iDx7e7i4CDu
		9uXt6PL8IPTg6es=
	</descr>
	<value language="english">
		Mw==
	</value>
	<default language="english">
		Mw==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Период между голосованиями</title>
	<descr language="ukrainian">
		z+Xw6O7kIOIg5O3/9Swg7+7x6+Ug6u7y7vDu4+4g7+7r/Ofu4uDy5ev8IPHs7ubl8iDx7e7i4CDu
		9uXt6PL8IPTg6es=
	</descr>
	<value language="ukrainian">
		Mw==
	</value>
	<default language="ukrainian">
		Mw==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_voting_time</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Количество ступенек в рейтинге</title>
	<descr language="russian">
		wu3o7ODt6OUhIMjn7OXt5e3o5SD98u7pIO7v9ujoIO/w6OLl5OXyIOog7eXv8ODi6Ov87e7s8yDu
		8u7h8ODm5e3o/iDw5eny6O3j4CDzIPTg6evu4iwg6u7y7vD75SDz5uUg7vbl7eji4OvoLg==
	</descr>
	<value language="russian">
		NQ==
	</value>
	<default language="russian">
		NQ==
	</default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Количество ступенек в рейтинге</title>
	<descr language="english">
		wu3o7ODt6OUhIMjn7OXt5e3o5SD98u7pIO7v9ujoIO/w6OLl5OXyIOog7eXv8ODi6Ov87e7s8yDu
		8u7h8ODm5e3o/iDw5eny6O3j4CDzIPTg6evu4iwg6u7y7vD75SDz5uUg7vbl7eji4OvoLg==
	</descr>
	<value language="english">
		NQ==
	</value>
	<default language="english">
		NQ==
	</default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Количество ступенек в рейтинге</title>
	<descr language="ukrainian">
		wu3o7ODt6OUhIMjn7OXt5e3o5SD98u7pIO7v9ujoIO/w6OLl5OXyIOog7eXv8ODi6Ov87e7s8yDu
		8u7h8ODm5e3o/iDw5eny6O3j4CDzIPTg6evu4iwg6u7y7vD75SDz5uUg7vbl7eji4OvoLg==
	</descr>
	<value language="ukrainian">
		NQ==
	</value>
	<default language="ukrainian">
		NQ==
	</default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_rating_steps</name>
	<group>module_files</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title language="russian">Оценка только при просмотре</title>
	<descr language="russian">
		0ODn8OX46PL8IO725e3o4uDy/CD04Onr+yDy7uv86u4g7/DoIO/u5PDu4e3u7CDv8O7x7O7y8OU/
	</descr>
	<value language="russian"></value>
	<default language="russian"></default>
	<eval language="russian"></eval>
	<extra language="russian"></extra>
	<start_group language="russian"></start_group>
	<title language="english">Оценка только при просмотре</title>
	<descr language="english">
		0ODn8OX46PL8IO725e3o4uDy/CD04Onr+yDy7uv86u4g7/DoIO/u5PDu4e3u7CDv8O7x7O7y8OU/
	</descr>
	<value language="english"></value>
	<default language="english"></default>
	<eval language="english"></eval>
	<extra language="english"></extra>
	<start_group language="english"></start_group>
	<title language="ukrainian">Оценка только при просмотре</title>
	<descr language="ukrainian">
		0ODn8OX46PL8IO725e3o4uDy/CD04Onr+yDy7uv86u4g7/DoIO/u5PDu4e3u7CDv8O7x7O7y8OU/
	</descr>
	<value language="ukrainian"></value>
	<default language="ukrainian"></default>
	<eval language="ukrainian"></eval>
	<extra language="ukrainian"></extra>
	<start_group language="ukrainian"></start_group>
	<name>m_files_vote_general</name>
	<group>module_files</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Отключить кеширование на главной?</title>
	<descr>
		zvLq6/736PL8IOrl+Ojw7uLg7ejlIO3u4u7x8uXpIO3gIOPr4OLt7uku
	</descr>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_news_ncg</name>
	<group>module_news</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Опросов на страницу</title>
	<name>m_voting_per_page</name>
	<descr></descr>
	<group>module_voting</group>
	<type>edit</type>
	<value>
		MTA=
	</value>
	<default>
		MTA=
	</default>
	<eval>
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPWludHZhbCgkdmFsdWUpOw0KaWYgKCR2YWx1ZTw9MCkNCiRl
		cnJvcj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra></extra>
	<start_group>Основные</start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Опросов на главной странице</title>
	<name>m_voting_per_page_general</name>
	<descr>
		3fLgIO7v9uj/IOHz5OXyIOTl6fHy4u7i4PL8LCDl8evoIOzu5PPr/CAi7u/w7vH7IiDh8+Tl8iDu
		8u7h8ODm4PL88f8g7eAg4+vg4u3u6SDx8vDg7ej25SDx4Ony4C4=
	</descr>
	<group>module_voting</group>
	<type>edit</type>
	<value>
		NQ==
	</value>
	<default>
		NQ==
	</default>
	<eval>
		aWYgKCRzYXZlKQ0Kew0KJHZhbHVlPWludHZhbCgkdmFsdWUpOw0KaWYgKCR2YWx1ZTw9MCkNCiRl
		cnJvcj0nwuLl5OXt7iDt5eTu7/Px8ujs7uUg5+3g9+Xt6OUhJzsNCn0=
	</eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Период между голосованиями</title>
	<name>m_voting_time</name>
	<descr>
		z+Xw6O7kIOIg5O3/9Swg7+7x6+Ug6u7y7vDu4+4g7+7r/Ofu4uDy5ev8IPHs7ubl8iDx7e7i4CDv
		8O7j7uvu8e7i4PL8
	</descr>
	<group>module_voting</group>
	<type>edit</type>
	<value>
		Mw==
	</value>
	<default>
		Mw==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Добавление опросов</title>
	<name>m_voting_add</name>
	<descr>
		xODy/CDi7ufs7ubt7vHy/CDv7vHl8ujy5ev/7CDx4Ony4CDk7uHg4uv/8vwg7u/w7vH7Pw==
	</descr>
	<group>module_voting</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Окончание ЧПУ для категории</title>
	<name>m_voting_category_ending</name>
	<descr>
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIM3F4fPq
		4uXt7e7j7iDx6Ozi7uvgIQ==
	</descr>
	<group>module_voting</group>
	<type>edit</type>
	<value>
		Lw==
	</value>
	<default>
		Lw==
	</default>
	<eval>
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEgzcXh8+ri5e3t
		7uPuIPHo7OLu6+AhJzs=
	</eval>
	<extra></extra>
	<start_group>URL</start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Окончание ЧПУ для опроса</title>
	<name>m_voting_ending</name>
	<descr>
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIM3F4fPq
		4uXt7e7j7iDx6Ozi7uvgISDIIO3lIOzu5uXyIPHu4u/g5ODy/CDxIO7q7u334O3o5ewg6uDy5ePu
		8OjoLCDo7eD35SDh8+Tz8iDy7uvx8vvlIO746OHq6CE=
	</descr>
	<group>module_voting</group>
	<type>edit</type>
	<value>
		Lmh0bWw=
	</value>
	<default>
		Lmh0bWw=
	</default>
	<eval>
		aWYgKCRzYXZlIGFuZCBwcmVnX21hdGNoKCcvXlsnLlN0cmluZ3M6OkFMTC4nXS9pJywkdmFsdWUp
		PjApICRlcnJvcj0nxODt7e7lIOft4Pfl7ejlIOTu6+bt7iDt4Pfo7eDy/PH/IPEgzcXh8+ri5e3t
		7uPuIPHo7OLu6+AhJzs=
	</eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Длинный URL с учетом всех категорий</title>
	<name>m_voting_long_url</name>
	<descr></descr>
	<group>module_voting</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<ogroup>
	<title language="russian">Модуль "Обратная связь"</title>
	<descr language="russian"></descr>
	<title language="english">Module "Feedback"</title>
	<descr language="english"></descr>
	<title language="ukrainian">Модуль "Обратная связь"</title>
	<descr language="ukrainian"></descr>
	<name>module_contacts</name>
	<protected>0</protected>
	<keyword>module_contacts</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>E-mail, куда отправлять сообщения:</title>
	<descr>
		PGRpdiBhbGlnbj0ibGVmdCI+z+4g7uTt7uzzIPEg7e7i7ukg8fLw7uroLiDF8evoIOPg6+736uAg
		7ejm5SDx8u7o8iwg8u4g7O7m7e4g5O7h4OLr//L8IO7v6PHg7ej/LiDE6/8g/fLu4+4sIO/l8OXk
		IGUtbWFpbCDk7uHg4vzy5SDu7+jx4O3o5SDoICZxdW90Oz0mcXVvdDsuIM3g7/Do7OXwOjxiciAv
		Pg0KQWRtaW49YWRtaW5Ac2l0ZS5jb208L2Rpdj4=
	</descr>
	<value>
		c3NAc3MucnU=
	</value>
	<default>
		c3NAc3MucnU=
	</default>
	<eval>
		aWYgKCRzYXZlKXtpZiAoIUZ1bmN0aW9uczo6Q2hlY2tlTWFpbCgkdmFsdWUpKSAkZXJyb3I9J83l
		7/Dg4ujr/O3uIPPq4Ofg7SBlLW1haWwg4OTw5fEhJzsgfQ==
	</eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_contacts_email</name>
	<group>module_contacts</group>
	<type>text</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Позволить выборать получателя?</title>
	<descr>
		xfHr6CDj4Ovu9+rgIO7y7OX35e3gLCDv7uv85+7i4PLl6/wg8ezu5uXyIOL74fDg8vwg7+7r8/fg
		8uXr/yDv6PH87OAuIMXx6+gg7eXyIC0g7+jx/OzuIOHz5OXyIO7y7/Dg4uvl7e4g7eAg4vHlIODk
		8OXx4CDx8ODn8y4=
	</descr>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_contacts_sel</name>
	<group>module_contacts</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<ogroup>
	<title language="russian">Пользователи и система аккаунтов</title>
	<descr language="russian">Настройка системы аккаунтов, сессий, логина и регистрации пользователей.</descr>
	<title language="english">Users and system accounts</title>
	<descr language="english">Setting system of accounts, sessions, login and user registration.</descr>
	<title language="ukrainian">Користувачі і система акаунтів</title>
	<descr language="ukrainian">Налаштування системы акаунтів, сесій, логіна і реєстрації користувачів.</descr>
	<name>accounting</name>
	<protected>1</protected>
	<keyword>login</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>Позволить выбор шаблона?</title>
	<descr>
		0+rg5ujy5SD44OHr7u37LCDq7vLu8PvlIO/u6/zn7uLg8uXr6CDx7O7j8/Ig4vvh6PDg8vwg4iDq
		4Pfl8fLi5SDu9O7w7Ovl7ej/IPHg6fLgLg==
	</descr>
	<value>
		YToyOntpOjA7czo2OiJNdW5pZWwiO2k6MTtzOjU6IlVuaWVsIjt9
	</value>
	<default></default>
	<eval>
		aWYoJHNhdmUpDQp7DQoJJHZhbHVlPShpc3NldCgkX1BPU1RbJ3RlbXBsYXRlcyddKSBhbmQgaXNf
		YXJyYXkoJF9QT1NUWyd0ZW1wbGF0ZXMnXSkpID8gJF9QT1NUWyd0ZW1wbGF0ZXMnXSA6IGFycmF5
		KCk7DQoJJHZhbHVlPSR2YWx1ZSA/IHNlcmlhbGl6ZSgkdmFsdWUpIDogJyc7DQp9DQplbHNlDQoJ
		JHZhbHVlPUB1bnNlcmlhbGl6ZSgkdmFsdWUpOw==
	</eval>
	<extra>
		eyVQSFANCiRmdW5jPWNyZWF0ZV9mdW5jdGlvbignJE1haW5jbGFzcycsJyR0aGVtZXM9YXJyYXko
		KTskYXJyPWdsb2IoJE1haW5jbGFzcy0+cm9vdF9wYXRoLiRNYWluY2xhc3MtPlRlbXBsYXRlLT50
		aGVtZV9wYXRoLiIvKiIsR0xPQl9PTkxZRElSKTsNCglmb3JlYWNoKCRhcnIgYXMgJiR2KQ0KCXsN
		CgkJJG5hbWU9ZmFsc2U7DQoJCSRzZXJ2aWNlPWFycmF5KCk7DQoJCWlmKGZpbGVfZXhpc3RzKCR2
		LiIucGhwIikpDQoJCQlpbmNsdWRlICR2LiIucGhwIjsNCgkJaWYoJHNlcnZpY2UgYW5kIGlzX2Fy
		cmF5KCRzZXJ2aWNlKSBhbmQgIWluX2FycmF5KDIsJHNlcnZpY2UpKQ0KCQkJY29udGludWU7DQoJ
		CSR0cGw9YmFzZW5hbWUoJHYpOw0KCQlpZighJG5hbWUpDQoJCQkkbmFtZT0kdHBsOw0KCQkkdGhl
		bWVzWyR0cGxdPSRuYW1lOw0KCX0NCmFzb3J0KCR0aGVtZXMsU09SVF9TVFJJTkcpOw0KCXJldHVy
		biAkdGhlbWVzOycpOw0KJGFycj0kZnVuYygkTWFpbmNsYXNzKTsNCmlmKCFpc19hcnJheSgkdmFs
		dWUpKQ0KJHZhbHVlPWFycmF5KCk7DQokb3B0cz0nJzsNCmZvcmVhY2goJGFyciBhcyAkaz0+JHYp
		DQoJCSRvcHRzLj1UZW1wbGF0ZTo6T3B0aW9uKCR2LCRrLGluX2FycmF5KCRrLCR2YWx1ZSkpOw0K
		CWVjaG8gVGVtcGxhdGU6Okl0ZW1zKCd0ZW1wbGF0ZXMnLCRvcHRzLDUpOw0KJX0=
	</extra>
	<start_group></start_group>
	<name>templates</name>
	<group>accounting</group>
	<type>user</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>

<ogroup>
	<title language="russian">Модуль "Блоги"</title>
	<descr language="russian"></descr>
	<title language="english">Module "بلاگ ها"</title>
	<descr language="english"></descr>
	<title language="ukrainian">Модуль "Блоги"</title>
	<descr language="ukrainian"></descr>
	<name>module_blogs</name>
	<protected>0</protected>
	<keyword>module_blogs</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>Создание блогов:</title>
	<descr></descr>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra>
		MD3H4O/w5fLo8vy3MT3Q4Ofw5fjo8vy3LTE90SDv8O7i5fDq7ukg4OTs6O3o8fLw4PLu8OA=
	</extra>
	<start_group>Создание блогов</start_group>
	<name>m_blogs_bcr</name>
	<group>module_blogs</group>
	<type>select</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Максимальное число блогов пользователя:</title>
	<descr>
		MCAtIO7j8ODt6Pfl7ejpIO3l8g==
	</descr>
	<value></value>
	<default></default>
	<eval>
		JHZhbHVlPShpbnQpJHZhbHVlOw==
	</eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_blim</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Окончание ЧПУ для категории:</title>
	<descr>
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CE=
	</descr>
	<value>
		Lw==
	</value>
	<default>
		Lw==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group>ЧПУ</start_group>
	<name>m_blogs_cat_ending</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Окончание ЧПУ для записи блога:</title>
	<descr>
		zuHw4PLo8uUg4u3o7ODt6OUsIPfy7iDt4Pfo7eDy/PH/IP3y7iDv7uvlIOTu6+bt7iDxIO3lIOHz
		6uLl7e3u4+4g8ejs4u7r4CDoIO3lIOzu5uXyIPHu4u/g5ODy/CDxIO7q7u334O3o5ewg6uDy5ePu
		8OjoLCDo7eD35SDh8+Tz8iDy7uvx8vvlIO746OHq6CEJ
	</descr>
	<value>
		Lmh0bWw=
	</value>
	<default>
		Lmh0bWw=
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_ending</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Количество контента по-умолчанию:</title>
	<descr>
		yu7r6Pfl8fLi7iDn4O/o8eXpIOHr7uPu4iDv8Ogg5+Dv8O7x5SDn4O/o8eXpIOfgIO7v8OXk5evl
		7e3z/iDk4PLzLCDq7uvo9+Xx8uLuIOfg7+jx5ekg7/DoIO/u6PHq5SDoIPIu7y4=
	</descr>
	<value>
		MTA=
	</value>
	<default>
		MTA=
	</default>
	<eval>
		JHZhbHVlPShpbnQpJHZhbHVlOw==
	</eval>
	<extra></extra>
	<start_group>Отображение</start_group>
	<name>m_blogs_per_page</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Количество записей на главной:</title>
	<descr>
		3fLgIO7v9uj/IOHz5OXyIOTl6fHy4u7i4PL8LCDl8evoIOzu5PPr/CAi4evu4+giIOHz5OXyIO7y
		7uHw4Obg8vzx/yDt4CDj6+Di7e7pIPHy8ODt6PblIPHg6fLgLg==
	</descr>
	<value>
		NQ==
	</value>
	<default>
		NQ==
	</default>
	<eval>
		JHZhbHVlPShpbnQpJHZhbHVlOw==
	</eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_ppgen</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Пользовательское количество страниц:</title>
	<descr>
		z/DoIPHu5+Tg7ejoL/Dl5ODq8ujw7uLg7ejoIOHr7uPgLCDv7uv85+7i4PLl6+gg8eDs6CDx7O7j
		8/Ig8+rg5+Dy/CDq4Oru5SDq7uvo9+Xx8uLuIOfg7+jx5ekg7u3oIPXu8v/yIOLo5OXy/CDzIPHl
		4f8g4iDh6+7j5S4g0+rg5/vi4Ony5SD35fDl5yDn4O//8vP+IOHl5yDv8O7h5evu4i4=
	</descr>
	<value>
		MTAsMTUsMjAsMjUsMzA=
	</value>
	<default>
		MTAsMTUsMjAsMjUsMzA=
	</default>
	<eval>
		aWYoJHNhdmUpDQp7DQogICAkdmFsdWU9U3RyaW5nczo6Q2xlYW5Gb3JFeHBsb2RlKCR2YWx1ZSk7
		DQogICBpZihwcmVnX21hdGNoKCcjXltcZCxdKyQjJywkdmFsdWUpPT0wKQ0KICAgICAgICAkZXJy
		b3I9J83l6u7w8OXq8u3u5SDn4O/u6+3l7ejlISc7DQp9
	</eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_userpp</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Включить рейтинг:</title>
	<descr></descr>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group>Рейтинг</start_group>
	<name>m_blogs_rating</name>
	<group>module_blogs</group>
	<type>check</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Период между голосованиями:</title>
	<descr>
		z+Xw6O7kIOIg5O3/9Swg7+7x6+Ug6u7y7vDu4+4g7+7r/Ofu4uDy5ev8IPHs7ubl8iDx7e7i4CDu
		9uXt6PL8IO3u4u7x8vw=
	</descr>
	<value>
		Mw==
	</value>
	<default>
		Mw==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_voting_time</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Количество ступенек в рейтинге:</title>
	<descr>
		wu3o7ODt6OUhIMjn7OXt5e3o5SD98u7pIO7v9ujoIO/w6OLl5OXyIOog7eXv8ODi6Ov87e7s8yDu
		8u7h8ODm5e3o/iDw5eny6O3j4CDzIO3u4u7x8uXpLCDq7vLu8PvlIPPm5SDu9uXt6OLg6+gu
	</descr>
	<value>
		NQ==
	</value>
	<default>
		NQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_rating_steps</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Оценка только при просмотре:</title>
	<descr>
		0ODn8OX46PL8IO725e3o4uDy/CDt7uLu8fLoIPLu6/zq7iDv8Ogg7+7k8O7h7e7sIO/w7vHs7vLw
		5T8=
	</descr>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_vote_general</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Записей на страницу в RSS:</title>
	<descr></descr>
	<value>
		MzA=
	</value>
	<default>
		MzA=
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_rss_per_page</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
<option>
	<title>Временная пауза поиска:</title>
	<descr>
		wvDl7P8g4iDx5erz7eTg9SDs5ebk8yDo8e/u6/zn7uLg7ejl7CDv7ujx6uAuIMLi5eTo8uUgMCDk
		6/8g7vLq6/735e3o/yDu7/bo6A==
	</descr>
	<value>
		MzA=
	</value>
	<default>
		MzA=
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<name>m_blogs_search</name>
	<group>module_blogs</group>
	<type>edit</type>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<multilang>0</multilang>
	<onexists>full update</onexists>
</option>
';
		if (!isset($this->Mainclass->Settings))
			$this->Mainclass->LoadClass('classes/others/class_settings.php');
		if (!isset($this->Mainclass->Cache))
		{
			$this->Mainclass->LoadClass('classes/class_cache.php');
			$this->Mainclass->Cache->Init();
		}
		$r=$this->Mainclass->Settings->ProcessImport($s);
	}
}
?>