/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
function ChangeTypes(id)
{
	var service=Id("service").value;
	Id("type").setAttribute("disabled",1);
	Id('modules').innerHTML=loading;
	Ajax(
			'',
			{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'gettypes',
				'service':service,
				'id':id
			},
			function(result)
			{
				Id('type').innerHTML=result['types'];
				Id('modules').innerHTML=result['modules'];
				Id("type").removeAttribute("disabled");
				UpdateRules();
			},
			false
	);
}

function UpdateRules(id)
{
	var modules='';
	var inputs=Id('modules').getElementsByTagName('input');
	var service=Id("service").value;
	Id('modules_rules').innerHTML=loading;
	for (var i=0;i<inputs.length;i++)
	{
		var input=inputs.item(i);
		if (input.getAttribute('type')!='checkbox')
			continue;
		if (input.checked)
			modules+=','+input.value;
	}
	Ajax(
			'',
			{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'rules',
				'service':service,
				'id':id,
				'modules':modules
			},
			function(result)
			{
				Id('tr_modules_rules').style.display=result['tr'];
				Id('modules_rules').innerHTML=result['rules'];
			},
			false
	);
}

function AddType()
{
	var type=Id("name");
	var descr=Id("descr");
	if (!Trim(type.value) || !Trim(descr.value))
	{
		alert(el_lang['filled_not_all_fields']);
		return false;
	}
	var box=Id("services");
	var k=box.childNodes.length;
	var services='';
	for (var i=0;i<k;i++)
		if (box.childNodes[i].selected)
			services+=box.childNodes[i].value+',';
	if (!services)
		services='';
	return Ajax(
				'',
				{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'add',
				'name':type.value,
				'descr':descr.value,
				'services':services
				},
				function(result)
				{
					$(result).appendTo('#types');
					type.value=descr.value="";
				},
				false
	);
}

function EditType(name)
{
	if (!name)
		return;
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'edit',
					'name':name
				},
				function (result)
				{
					$('#ed_services').html(result['services']);
					Id('ed_name').value=name;
					Id('ed_descr').value=result['descr'];
					Id('edit').value=name;
					$('#ed_type').show();
					$('#ed_d_type').hide();
					countries.expandit(1);
				},
				false
	);
}

function SaveType()
{
	var type=Id("ed_name");
	var descr=Id("ed_descr");
	if (!Trim(type.value) || !Trim(descr.value))
	{
		alert(el_lang['filled_not_all_fields']);
		return false;
	}
	var box=Id("ed_services");
	var k=box.childNodes.length;
	var services='';
	for (var i=0;i<k;i++)
	{
		if (box.childNodes[i].selected)
			services+=box.childNodes[i].value+',';
	}
	if (!services)
		services='';
	var old=Id('edit').value;
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'save',
					'name':type.value,
					'descr':descr.value,
					'services':services,
					'old':old
				},
				function(result)
				{
					$('#t_'+old).html(result);
					$('#ed_type').hide();
					$('#ed_d_type').show();
				},
				false
	);
}

function DeleteType(name)
{
	if (!confirm(el_lang['are_you_sure_to_delete_type']+name+'"?') || !name)
		return;
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'delete',
					'name':name
				},
				function (result)
				{
					if (result=='ok')
						$('#t_'+name).remove();
				},
				false
	);
}

function ScanTheme()
{
	Ajax(
			'',
			{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'scan',
				'theme':Id("theme").value
			},
			function (result)
			{
				Id('result').innerHTML = result;
			},
			false
	);
}

function AddArr()
{
	var frm = document.checks;
	var types = "";
	for (var i=0;i<frm.elements.length;i++)
	{
		var elmnt = frm.elements[i];
		if (elmnt.type=='checkbox' && elmnt.checked)
			types += ","+elmnt.value;
	}
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'addarr',
					'types':types
				},
				function (result)
				{
					$(result).appendTo('#types');
					Id('result').innerHTML='';
				},
				false
	);
}

function MoveBlockUp(bid,sid)
{
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'up',
					'id':bid,
					'sid':sid,
					'key':key
				},
				function (result)
				{
					Id('ser_tab'+sid).innerHTML=result;
				},
				false
	);
}

function MoveBlockDown(bid,sid)
{
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'down',
					'id':bid,
					'sid':sid,
					'key':key
				},
				function (result)
				{
					Id('ser_tab'+sid).innerHTML=result;
				},
				false
	);
}

function SwapBlock(bid,sid)
{
	return Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'swap',
					'id':bid,
					'sid':sid,
					'key':key
				},
				function (result)
				{
					Id('ser_tab'+sid).innerHTML=result;
				},
				false
	);
}

function EditTitle(obj)
{
	obj.tempstore=obj.innerHTML;
	obj.innerHTML='<input type="text" id="text_'+obj.id+'" value="'+obj.innerHTML+'" />';
	Id("text_"+obj.id).focus();
	Id("text_"+obj.id).onblur=function()
	{
		obj.innerHTML=obj.tempstore;
		obj.onclick = function()
		{
			EditTitle(obj)
		}
	};
	Id("text_"+obj.id).onkeypress=function(e)
	{
		e=e ? e : event;
		if (e.keyCode==13 || e.keyCode==10)
		{
			if (obj.tempstore!=this.value)
				SaveTitle(obj,this.value);
			else
				obj.innerHTML=obj.tempstore;
			return false;
		}
	}
	obj.onclick = function(){}
}

function SaveTitle(obj,text)
{
	Ajax(
			'',
			{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'new_title',
				'title':text,
				'id':obj.id,
				'key':key
			},
			function (result)
			{
				if (result=='ok')
					obj.innerHTML = text;
			},
			false
	);
	obj.onclick = function()
	{
		EditTitle(obj)
	}
}
var type_content=false;
function ChangeContentType()
{
	var ctype=Id('sel_c_type');
	if (!ctype)
		return;
	var ctype=ctype.value;
	$('#type_file').hide();
	$('#type_content').hide();
	if (type_content && ctype!='plugin')
	{
		$('tr.plugin').remove();
		type_content=false;
	}
	else if(!type_content && ctype=='plugin')
	{
		$(pluginloading).addClass('loading').appendTo('#b_main_table');
		$('#sel_c_type').attr('disabled','disabled');
		Ajax(
				'',
				{
					'direct':'admin',
					'module':'',
					'file':'blocks',
					'event':'plugins',
					'id':block_id
				},
				function (result)
				{
					$('#sel_c_type').removeAttr('disabled');
					$('tr.loading').remove();
					$(result).addClass('plugin').appendTo('#b_main_table');
					GetPluginContent();
				},
				false
		);
		type_content=true;
	}
	switch(ctype)
	{
		case 'file':
			$('#type_file').show();
		break;
		case 'content':
			$('#type_content').show();
		break;
	}
}

function GetPluginContent(params)
{
	var module=Id('plug_module').value;
	$('tr.plugincontent').remove();
	if (module==0)
		return;
	if (!params)
		params=[];
	$('#plug_module').attr('disabled','disabled');
	$('#sel_c_type').attr('disabled','disabled');
	$(pluginloading).addClass('loading').appendTo('#b_main_table');
	Ajax(
			'',
			{
				'direct':'admin',
				'module':'',
				'file':'blocks',
				'event':'load_plugin',
				'bid':block_id,
				'id':module,
				'params':params
			},
			function (result)
			{
				$('#sel_c_type').removeAttr('disabled');
				$('#plug_module').removeAttr('disabled');
				$('tr.loading').remove();
				$(result).addClass('plugincontent').addClass('plugin').appendTo('#b_main_table');
			},
			false
	);

}
