/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/

function One4AllCheckboxes(parent,main_ch,names)
{
	parent=Id(parent);
	if (!parent)
		return;
	var checks=parent.getElementsByTagName('input');
	for (var i=0;i<checks.length;i++)
	{
		var check=checks[i];
		if (check.getAttribute("type")!="checkbox" || (names && check.getAttribute("name")!=names))
			continue;
		check.marked=true;
		if(typeof check.onclick!='function')
		{
			check.onclick=function()
			{
				MassClick();
				return true;
			}
		}
	}
	var main=Id(main_ch);
	if (!main)
		return;
	main.onclick=function()
	{
		MainClick();
		return true;
	}
	function MassClick()
	{
		var checked=false;
		for (var i=0;i<checks.length;i++)
		{
			var check=checks[i];
			if (!check.marked)
				continue;
			checked|=check.checked;//Только в этой строке различие между функциями
		}
		main.checked=checked;
	}
	function MainClick()
	{
		for (var i=0;i<checks.length;i++)
		{
			var check=checks[i];
			if (!check.marked)
				continue;
			check.checked=main.checked;
		}
	}
}

function DoMultiLangChecks()
{
	var checks=document.getElementsByTagName('input');
	for (var i=0;i<checks.length;i++)
	{
		var check=checks[i];
		if (check.getAttribute("type")!="checkbox" || check.getAttribute("name")!='one_lang' && check.getAttribute("name")!='lang[]')
			continue;
		check.marked=true;
		if(check.getAttribute("name")!='one_lang')
			check.onclick=LangClick;
		else
		{
			var lc=$('#lang_checks,#langs_tab');
			if(check.checked)
				lc.fadeOut(200);
			else
				lc.fadeIn(200);
			check.onclick=function()
			{
				if(this.checked)
					$('#lang_checks').hide(200);
				else
					$('#lang_checks').show(200);
				LangClick();
				return true;
			}
		}
	}

	function LangClick()
	{
		if(this.value && Id('lang_'+this.value))
			if(this.checked)
				$('#lang_'+this.value).show();
			else
				$('#lang_'+this.value).hide();
		var general, others=false;
		for(var i=0;i<checks.length;i++)
		{
			var check=checks[i];
			if (!check.marked)
				continue;
			if (check.value==site_lang)
				general=checks[i];
			else if ($(check).attr('name')!='one_lang')
				others|=checks[i].checked;
			else if (check.checked)
			{
				$('#langs_tab').hide();
				return;
			}
		}
		if(!others)
		{
			general.disabled=general.checked=true;
			$('#langs_tab').hide();
			return;
		}
		general.disabled=false;
		$('#langs_tab').show();
	}
	LangClick();
}